/*
1    a0peysza                                 A T O M I C   M A S S   A D J U S T M E N T
0                                                     DATE 18 Nov 2003 TIME 14:12
0        *********************                               A=   0 TO 293
         * file : mass.mas03 *
         *********************

   This is one file out of a series of 3 files published in:
       "The Ame2003 atomic mass evaluation (II)"  by G.Audi, A.H.Wapstra and C.Thibault
           Nuclear Physics A729 p. 337-676, December 22, 2003.
                       for files : mass.mas03  atomic masses
                                   rct1.mas03  react and sep energies,  part 1
                                   rct2.mas03  react and sep energies,  part 2

   A fourth file  is the "Rounded" version of the atomic mass table (the first file)
                                   mass.mas03round  atomic masses "Rounded" version

   All files are 3179 lines long with 124 character per line.
       Headers are 39 lines long.

   Values in the files 1, 2 and 3 are exact (unrounded) copy of the published ones
   Values in the files 4          are exact             copy of the published ones

   col 1     :  Fortran character control: 1 = page feed  0 = line feed
   format    :  a1,i3,i5,i5,i5,1x,a3,a4,1x,f13.5,f11.5,f11.3,f9.3,1x,a2,f11.3,f9.3,1x,i3,1x,f12.5,f11.3,1x
                cc NZ  N  Z  A    el  o     mass  unc binding unc     B  beta  unc    atomic_mass   unc
   Warnings  :  this format is not identical to the one used in Ame1993 and Ame1995
                      in particular "Mass Excess" and "Atomic Mass" values are given now, when necessary,
				  with 5 digits after decimaisisl point.
                      also, the "Binding Energy" column is replaced by a "Binding Energy per A" one.
                decimal point is replaced by # for (non-experimental) estimated values.
                * in place of value : not calculable

....+....1....+....2....+....3....+....4....+....5....+....6....+....7....+....8....+....9....+...10....+...11....+...12....

                                                               MASS LIST
                                                             for analysis

1N-Z    N    Z   A  EL    O     MASS EXCESS           BINDING ENERGY/A    BETA-DECAY ENERGY         ATOMIC MASS
                                   (keV)                    (keV)                (keV)                (micro-u)
*/
/*
 N    Z   A  EL    O     MASS EXCESS           BINDING ENERGY/A    BETA-DECAY ENERGY         ATOMIC MASS
                           (keV)                    (keV)                (keV)                (micro-u)
*/

// to be different from 0 
#define STAR 1e-6 
#define STAR  1e-6 

#include "isotopes.h"

isotope isotopes[]={	
	{  1  ,  0 ,   1, " n","     ",    8071.31710 ,   0.00053  ,    0.0   ,   0.0   ,   782.347,    0.001,   1.00866491574,    0.00056},
	{  0  ,  1 ,   1, "H ","     ",    7288.97050 ,   0.00011  ,    0.0   ,   0.0   , STAR     , STAR    ,   1.00782503207,    0.00010},
	{  1  ,  1 ,   2, "H ","     ",   13135.72158 ,   0.00035  , 1112.283 ,   0.000 , STAR     , STAR    ,   2.01410177785,    0.00036},
	{  2  ,  1 ,   3, "H ","     ",   14949.80600 ,   0.00231  , 2827.266 ,   0.001 ,    18.591,    0.001,   3.01604927767,    0.00247},
	{  1  ,  2 ,   3, "He","     ",   14931.21475 ,   0.00242  , 2572.681 ,   0.001 ,-13736.   , 2000.   ,   3.01602931914,    0.00260},
	{  0  ,  3 ,   3, "Li","  -pp",   28667.      ,2000.       ,-2267.    , 667.    , STAR     , STAR    ,   3.030775     , 2147.     },
	{  3  ,  1 ,   4, "H ","   -n",   25901.518   , 103.286    , 1400.351 ,  25.821 , 23476.602,  103.286,   4.027806424  ,  110.881  },
	{  2  ,  2 ,   4, "He","     ",    2424.91565 ,   0.00006  , 7073.915 ,   0.000 ,-22898.270,  212.132,   4.00260325415,    0.00006},
	{  1  ,  3 ,   4, "Li","   -p",   25323.185   , 212.132    , 1153.761 ,  53.033 , STAR     , STAR    ,   4.027185558  ,  227.733  },
	{  4  ,  1 ,   5, "H ","  -nn",   32892.440   , 100.000    , 1336.360 ,  20.000 , 21506.207,  111.803,   5.035311488  ,  107.354  },
	{  3  ,  2 ,   5, "He","   -n",   11386.233   ,  50.000    , 5481.132 ,  10.000 ,  -292.653,   70.711,   5.012223624  ,   53.677  },
	{  2  ,  3 ,   5, "Li","   -p",   11678.886   ,  50.000    , 5266.132 ,  10.000 ,-26317.   , 3996.   ,   5.012537800  ,   53.677  },
	{  1  ,  4 ,   5, "Be","    x",   37996.      ,3996.       , -154.    , 799.    , STAR     , STAR    ,   5.040790     , 4290.     },
	{  5  ,  1 ,   6, "H ","  -3n",   41863.757   , 264.906    ,  963.633 ,  44.151 , 24268.651,  264.908,   6.044942594  ,  284.388  },
	{  4  ,  2 ,   6, "He","     ",   17595.106   ,   0.755    , 4878.017 ,   0.126 ,  3508.313,    0.755,   6.018889124  ,    0.810  },
	{  3  ,  3 ,   6, "Li","     ",   14086.793   ,   0.015    , 5332.345 ,   0.002 , -4288.154,    5.448,   6.015122794  ,    0.016  },
	{  2  ,  4 ,   6, "Be","    -",   18374.947   ,   5.448    , 4487.262 ,   0.908 ,-25228.   ,  699.   ,   6.019726317  ,    5.848  },
	{  1  ,  5 ,   6, "B ","    x",   43603.      , 699.       ,  152.    , 116.    , STAR     , STAR    ,   6.046810     ,  750.     },
	{  6  ,  1 ,   7, "H ","  -nn",   49135.      ,1005.       ,  940.    , 144.    , 23034.   , 1005.   ,   7.052749     , 1079.     },
	{  5  ,  2 ,   7, "He","   -n",   26101.038   ,  16.658    , 4119.070 ,   2.380 , 11192.898,   16.658,   7.028020618  ,   17.883  },
	{  4  ,  3 ,   7, "Li","     ",   14908.141   ,   0.079    , 5606.291 ,   0.011 ,  -861.893,    0.071,   7.016004548  ,    0.084  },
	{  3  ,  4 ,   7, "Be","     ",   15770.034   ,   0.106    , 5371.400 ,   0.015 ,-12098.312,   70.712,   7.016929828  ,    0.113  },
	{  2  ,  5 ,   7, "B ","  +3n",   27868.346   ,  70.712    , 3531.306 ,  10.102 , STAR     , STAR    ,   7.029917901  ,   75.912  },
	{  6  ,  2 ,   8, "He","     ",   31598.044   ,   6.868    , 3925.975 ,   0.859 , 10651.200,    6.869,   8.033921897  ,    7.373  },
	{  5  ,  3 ,   8, "Li","     ",   20946.844   ,   0.095    , 5159.582 ,   0.012 , 16005.172,    0.101,   8.022487362  ,    0.101  },
	{  4  ,  4 ,   8, "Be","     ",    4941.672   ,   0.035    , 7062.435 ,   0.004 ,-17979.819,    1.001,   8.005305103  ,    0.037  },
	{  3  ,  5 ,   8, "B ","     ",   22921.490   ,   1.000    , 4717.164 ,   0.125 ,-12172.570,   23.089,   8.024607233  ,    1.073  },
	{  2  ,  6 ,   8, "C ","   4n",   35094.060   ,  23.068    , 3097.800 ,   2.883 , STAR     , STAR    ,   8.037675025  ,   24.764  },
	{  7  ,  2 ,   9, "He","     ",   40939.429   ,  29.418    , 3348.637 ,   3.269 , 15985.165,   29.481,   9.043950286  ,   31.581  },
	{  6  ,  3 ,   9, "Li","     ",   24954.264   ,   1.935    , 5037.839 ,   0.215 , 13606.616,    1.928,   9.026789505  ,    2.077  },
	{  5  ,  4 ,   9, "Be","     ",   11347.648   ,   0.398    , 6462.758 ,   0.044 , -1068.034,    0.899,   9.012182201  ,    0.426  },
	{  4  ,  5 ,   9, "B ","    -",   12415.681   ,   0.983    , 6257.160 ,   0.109 ,-16494.809,    2.353,   9.013328782  ,    1.055  },
	{  3  ,  6 ,   9, "C ","  -pp",   28910.491   ,   2.138    , 4337.476 ,   0.238 , STAR     , STAR    ,   9.031036689  ,    2.295  },
	{  8  ,  2 ,  10, "He","   ++",   48809.203   ,  70.001    , 3033.927 ,   7.000 , 15758.623,   71.615,  10.052398837  ,   75.149  },
	{  7  ,  3 ,  10, "Li","   -n",   33050.581   ,  15.124    , 4531.555 ,   1.512 , 20443.910,   15.123,  10.035481259  ,   16.236  },
	{  6  ,  4 ,  10, "Be","     ",   12606.670   ,   0.401    , 6497.711 ,   0.040 ,   555.939,    0.557,  10.013533818  ,    0.430  },
	{  5  ,  5 ,  10, "B ","     ",   12050.731   ,   0.386    , 6475.071 ,   0.039 , -3647.951,    0.118,  10.012936992  ,    0.413  },
	{  4  ,  6 ,  10, "C ","    -",   15698.682   ,   0.403    , 6032.041 ,   0.040 ,-23101.466,  400.000,  10.016853228  ,    0.432  },
	{  3  ,  7 ,  10, "N ","   --",   38800.148   , 400.000    , 3643.660 ,  40.000 , STAR     , STAR    ,  10.041653674  ,  429.417  },
	{  8  ,  3 ,  11, "Li","     ",   40797.310   ,  19.295    , 4149.104 ,   1.754 , 20623.246,   20.315,  11.043797715  ,   20.713  },
	{  7  ,  4 ,  11, "Be","   -n",   20174.064   ,   6.356    , 5952.822 ,   0.578 , 11506.133,    6.370,  11.021657749  ,    6.823  },
	{  6  ,  5 ,  11, "B ","     ",    8667.931   ,   0.418    , 6927.711 ,   0.038 , -1982.411,    0.854,  11.009305406  ,    0.448  },
	{  5  ,  6 ,  11, "C ","     ",   10650.342   ,   0.950    , 6676.370 ,   0.086 ,-13653.227,   46.162,  11.011433613  ,    1.020  },
	{  4  ,  7 ,  11, "N ","   -p",   24303.569   ,  46.156    , 5364.045 ,   4.196 , STAR     , STAR    ,  11.026090956  ,   49.550  },
	{  9  ,  3 ,  12, "Li","    x",   50096.      , 997.       , 3701.    ,  83.    , 25019.   ,  997.   ,  12.053780     , 1070.     },
	{  8  ,  4 ,  12, "Be","  -nn",   25076.506   ,  15.005    , 5720.826 ,   1.250 , 11707.607,   15.071,  12.026920737  ,   16.108  },
	{  7  ,  5 ,  12, "B ","  +pn",   13368.899   ,   1.400    , 6631.264 ,   0.117 , 13368.899,    1.400,  12.014352104  ,    1.502  },
	{  6  ,  6 ,  12, "C ","     ",       0.0     ,   0.0      , 7680.144 ,   0.000 ,-17338.082,    1.000,  12.0000000    ,    0.0    },
	{  5  ,  7 ,  12, "N ","     ",   17338.082   ,   1.000    , 6170.108 ,   0.083 ,-14709.872,   18.493,  12.018613197  ,    1.073  },
	{  4  ,  8 ,  12, "O ","  -pp",   32047.954   ,  18.466    , 4879.090 ,   1.539 , STAR     , STAR    ,  12.034404895  ,   19.824  },
	{  9  ,  4 ,  13, "Be","   -n",   33247.823   ,  71.590    , 5273.070 ,   5.507 , 16685.657,   71.598,  13.035693007  ,   76.855  },
	{  8  ,  5 ,  13, "B ","  -nn",   16562.166   ,   1.084    , 6496.402 ,   0.083 , 13437.155,    1.084,  13.017780217  ,    1.163  },
	{  7  ,  6 ,  13, "C ","     ",    3125.01129 ,   0.00091  , 7469.849 ,   0.000 , -2220.469,    0.270,  13.00335483778,    0.00098},
	{  6  ,  7 ,  13, "N ","     ",    5345.481   ,   0.270    , 7238.863 ,   0.021 ,-17766.948,    9.530,  13.005738609  ,    0.289  },
	{  5  ,  8 ,  13, "O ","  +3n",   23112.428   ,   9.526    , 5811.994 ,   0.733 , STAR     , STAR    ,  13.024812213  ,   10.226  },
	{ 10  ,  4 ,  14, "Be","    x",   39954.498   , 132.245    , 4993.897 ,   9.446 , 16290.816,  133.936,  14.042892920  ,  141.970  },
	{  9  ,  5 ,  14, "B ","     ",   23663.683   ,  21.213    , 6101.645 ,   1.515 , 20643.790,   21.213,  14.025404009  ,   22.773  },
	{  8  ,  6 ,  14, "C ","     ",    3019.89305 ,   0.00380  , 7520.319 ,   0.000 ,   156.476,    0.004,  14.00324198870,    0.00408},
	{  7  ,  7 ,  14, "N ","     ",    2863.41704 ,   0.00058  , 7475.614 ,   0.000 , -5143.939,    0.109,  14.00307400478,    0.00062},
	{  6  ,  8 ,  14, "O ","     ",    8007.356   ,   0.109    , 7052.308 ,   0.008 ,-24651.   ,  401.   ,  14.008596250  ,    0.116  },
	{  5  ,  9 ,  14, "F ","    x",   32658.      , 401.       , 5236.    ,  29.    , STAR     , STAR    ,  14.035060     ,  430.     },
	{ 11  ,  4 ,  15, "Be"," -n2p",   49798.      , 503.       , 4543.    ,  34.    , 20825.   ,  504.   ,  15.053460     ,  540.     },
	{ 10  ,  5 ,  15, "B ","  +3p",   28972.278   ,  22.369    , 5879.050 ,   1.491 , 19099.134,   22.384,  15.031103021  ,   24.014  },
	{  9  ,  6 ,  15, "C ","   -n",    9873.144   ,   0.800    , 7100.169 ,   0.053 ,  9771.706,    0.800,  15.010599256  ,    0.858  },
	{  8  ,  7 ,  15, "N ","     ",     101.43805 ,   0.00070  , 7699.459 ,   0.000 , -2754.166,    0.491,  15.00010889823,    0.00075},
	{  7  ,  8 ,  15, "O ","     ",    2855.605   ,   0.491    , 7463.692 ,   0.033 ,-13919.767,  133.794,  15.003065617  ,    0.526  },
	{  6  ,  9 ,  15, "F ","  p4n",   16775.372   , 133.793    , 6483.551 ,   8.920 , STAR     , STAR    ,  15.018009103  ,  143.632  },
	{ 12  ,  4 ,  16, "Be","    x",   57678.      , 503.       , 4271.    ,  31.    , 20596.   ,  507.   ,  16.061920     ,  540.     },
	{ 11  ,  5 ,  16, "B ","    x",   37081.686   ,  60.000    , 5509.228 ,   3.750 , 23387.557,   60.107,  16.039808829  ,   64.412  },
	{ 10  ,  6 ,  16, "C ","  -nn",   13694.129   ,   3.578    , 6922.054 ,   0.224 ,  8010.470,    4.436,  16.014701252  ,    3.840  },
	{  9  ,  7 ,  16, "N ","   -n",    5683.658   ,   2.622    , 7373.812 ,   0.164 , 10420.660,    2.622,  16.006101658  ,    2.815  },
	{  8  ,  8 ,  16, "O ","     ",   -4737.00141 ,   0.00016  , 7976.206 ,   0.000 ,-15417.255,    8.321,  15.99491461956,    0.00016},
	{  7  ,  9 ,  16, "F ","    -",   10680.254   ,   8.321    , 6963.731 ,   0.520 ,-13316.208,   22.106,  16.011465724  ,    8.932  },
	{  6  , 10 ,  16, "Ne","   --",   23996.462   ,  20.480    , 6082.572 ,   1.280 , STAR     , STAR    ,  16.025761262  ,   21.986  },
	{ 12  ,  5 ,  17, "B ","    x",   43770.816   , 170.873    , 5266.461 ,  10.051 , 22731.984,  171.755,  17.046989906  ,  183.440  },
	{ 11  ,  6 ,  17, "C "," 2p-n",   21038.832   ,  17.376    , 6557.616 ,   1.022 , 13167.463,   22.946,  17.022586116  ,   18.653  },
	{ 10  ,  7 ,  17, "N ","   +p",    7871.368   ,  15.013    , 7286.153 ,   0.883 ,  8680.181,   15.013,  17.008450261  ,   16.116  },
	{  9  ,  8 ,  17, "O ","     ",    -808.813   ,   0.110    , 7750.731 ,   0.006 , -2760.514,    0.271,  16.999131703  ,    0.118  },
	{  8  ,  9 ,  17, "F ","     ",    1951.701   ,   0.248    , 7542.328 ,   0.015 ,-14509.200,   26.954,  17.002095237  ,    0.266  },
	{  7  , 10 ,  17, "Ne","  +3n",   16460.901   ,  26.953    , 6642.825 ,   1.585 , STAR     , STAR    ,  17.017671504  ,   28.934  },
	{ 13  ,  5 ,  18, "B ","    x",   52322.      , 801.       , 4947.    ,  45.    , 27396.   ,  802.   ,  18.056170     ,  860.     },
	{ 12  ,  6 ,  18, "C ","   ++",   24926.178   ,  30.006    , 6425.747 ,   1.667 , 11811.712,   35.282,  18.026759354  ,   32.213  },
	{ 11  ,  7 ,  18, "N ","    +",   13114.466   ,  18.580    , 7038.490 ,   1.032 , 13895.988,   18.570,  18.014078959  ,   19.946  },
	{ 10  ,  8 ,  18, "O ","     ",    -781.522   ,   0.621    , 7767.025 ,   0.034 , -1655.223,    0.570,  17.999161001  ,    0.666  },
	{  9  ,  9 ,  18, "F ","     ",     873.701   ,   0.534    , 7631.605 ,   0.030 , -4443.465,    0.603,  18.000937956  ,    0.573  },
	{  8  , 10 ,  18, "Ne","   4n",    5317.166   ,   0.280    , 7341.282 ,   0.016 ,-18872.802,   50.301,  18.005708213  ,    0.300  },
	{  7  , 11 ,  18, "Na","    x",   24189.968   ,  50.301    , 6249.329 ,   2.794 , STAR     , STAR    ,  18.025969000  ,   54.000  },
	{ 14  ,  5 ,  19, "B ","    x",   59364.      , 401.       , 4741.    ,  21.    , 26943.   ,  412.   ,  19.063730     ,  430.     },
	{ 13  ,  6 ,  19, "C ","   -n",   32420.666   ,  98.391    , 6117.909 ,   5.178 , 16558.536,   99.748,  19.034805018  ,  105.627  },
	{ 12  ,  7 ,  19, "N "," p-2n",   15862.129   ,  16.415    , 6948.235 ,   0.864 , 12527.259,   16.634,  19.017028697  ,   17.622  },
	{ 11  ,  8 ,  19, "O ","   -n",    3334.870   ,   2.825    , 7566.389 ,   0.149 ,  4822.257,    2.826,  19.003580130  ,    3.032  },
	{ 10  ,  9 ,  19, "F ","     ",   -1487.386   ,   0.069    , 7779.015 ,   0.004 , -3238.827,    0.290,  18.998403224  ,    0.074  },
	{  9  , 10 ,  19, "Ne","     ",    1751.440   ,   0.286    , 7567.375 ,   0.015 ,-11175.367,   12.003,  19.001880248  ,    0.307  },
	{  8  , 11 ,  19, "Na","  p4n",   12926.808   ,  12.000    , 6938.021 ,   0.632 ,-20113.285,  251.789,  19.013877499  ,   12.882  },
	{  7  , 12 ,  19, "Mg","    x",   33040.092   , 251.503    , 5838.251 ,  13.237 , STAR     , STAR    ,  19.035470000  ,  270.000  },
	{ 14  ,  6 ,  20, "C ","    x",   37557.610   , 239.161    , 5958.733 ,  11.958 , 15792.500,  245.536,  20.040319754  ,  256.749  },
	{ 13  ,  7 ,  20, "N ","    x",   21765.110   ,  55.590    , 6709.240 ,   2.779 , 17967.648,   55.600,  20.023365807  ,   59.678  },
	{ 12  ,  8 ,  20, "O ","  -nn",    3797.462   ,   1.081    , 7568.505 ,   0.054 ,  3814.866,    1.083,  20.004076742  ,    1.160  },
	{ 11  ,  9 ,  20, "F ","     ",     -17.404   ,   0.075    , 7720.131 ,   0.004 ,  7024.527,    0.075,  19.999981315  ,    0.081  },
	{ 10  , 10 ,  20, "Ne","     ",   -7041.93131 ,   0.00179  , 8032.240 ,   0.000 ,-13889.650,    6.662,  19.99244017542,    0.00192},
	{  9  , 11 ,  20, "Na","    -",    6847.719   ,   6.662    , 7298.641 ,   0.333 ,-10722.630,   27.810,  20.007351328  ,    7.151  },
	{  8  , 12 ,  20, "Mg","   4n",   17570.348   ,  27.000    , 6723.392 ,   1.350 , STAR     , STAR    ,  20.018862545  ,   28.985  },
	{ 15  ,  6 ,  21, "C ","    x",   45960.      , 503.       , 5659.    ,  24.    , 20709.   ,  512.   ,  21.049340     ,  540.     },
	{ 14  ,  7 ,  21, "N ","    x",   25251.164   ,  95.045    , 6608.099 ,   4.526 , 17188.258,   95.802,  21.027108240  ,  102.035  },
	{ 13  ,  8 ,  21, "O ","  -3n",    8062.906   ,  12.016    , 7389.332 ,   0.572 ,  8110.457,   12.150,  21.008655886  ,   12.899  },
	{ 12  ,  9 ,  21, "F ","  -nn",     -47.551   ,   1.801    , 7738.290 ,   0.086 ,  5684.226,    1.802,  20.999948951  ,    1.933  },
	{ 11  , 10 ,  21, "Ne","   -n",   -5731.776   ,   0.039    , 7971.713 ,   0.002 , -3547.616,    0.701,  20.993846684  ,    0.041  },
	{ 10  , 11 ,  21, "Na","   -p",   -2184.161   ,   0.700    , 7765.524 ,   0.033 ,-13094.667,   16.430,  20.997655206  ,    0.751  },
	{  9  , 12 ,  21, "Mg","  +3n",   10910.506   ,  16.415    , 7104.714 ,   0.782 ,-15209.   ,  299.   ,  21.011712910  ,   17.621  },
	{  8  , 13 ,  21, "Al","    x",   26119.      , 298.       , 6343.    ,  14.    , STAR     , STAR    ,  21.028040     ,  320.     },
	{ 16  ,  6 ,  22, "C ","    x",   53281.      , 904.       , 5436.    ,  41.    , 21243.   ,  924.   ,  22.057200     ,  970.     },
	{ 15  ,  7 ,  22, "N ","    x",   32038.675   , 192.213    , 6366.085 ,   8.737 , 22754.523,  200.465,  22.034394934  ,  206.349  },
	{ 14  ,  8 ,  22, "O ","  -4n",    9284.152   ,  56.924    , 7364.821 ,   2.587 ,  6490.774,   58.259,  22.009966947  ,   61.110  },
	{ 13  ,  9 ,  22, "F ","    +",    2793.378   ,  12.399    , 7624.294 ,   0.564 , 10818.093,   12.399,  22.002998815  ,   13.310  },
	{ 12  , 10 ,  22, "Ne","     ",   -8024.715   ,   0.018    , 8080.465 ,   0.001 , -2842.278,    0.414,  21.991385113  ,    0.018  },
	{ 11  , 11 ,  22, "Na","    -",   -5182.436   ,   0.415    , 7915.709 ,   0.019 , -4785.474,    1.404,  21.994436425  ,    0.445  },
	{ 10  , 12 ,  22, "Mg","  +nn",    -396.963   ,   1.342    , 7662.626 ,   0.061 ,-18580.   ,   93.   ,  21.999573843  ,    1.440  },
	{  9  , 13 ,  22, "Al","    x",   18183.      ,  93.       , 6783.    ,   4.    ,-13982.   ,  221.   ,  22.019520     ,  100.     },
	{  8  , 14 ,  22, "Si","    x",   32164.      , 200.       , 6111.    ,   9.    , STAR     , STAR    ,  22.034530     ,  215.     },
	{ 16  ,  7 ,  23, "N ","    x",   38396.      , 298.       , 6164.    ,  13.    , 23783.   ,  322.   ,  23.041220     ,  320.     },
	{ 15  ,  8 ,  23, "O ","    x",   14612.960   , 121.867    , 7163.850 ,   5.299 , 11283.213,  145.528,  23.015687659  ,  130.829  },
	{ 14  ,  9 ,  23, "F "," p-2n",    3329.747   ,  79.541    , 7620.410 ,   3.458 ,  8483.792,   79.541,  23.003574631  ,   85.390  },
	{ 13  , 10 ,  23, "Ne","   -n",   -5154.045   ,   0.104    , 7955.255 ,   0.005 ,  4375.809,    0.104,  22.994466904  ,    0.112  },
	{ 12  , 11 ,  23, "Na","     ",   -9529.85358 ,   0.00273  , 8111.493 ,   0.000 , -4056.087,    1.286,  22.98976928087,    0.00293},
	{ 11  , 12 ,  23, "Mg","     ",   -5473.766   ,   1.286    , 7901.126 ,   0.056 ,-12243.337,   18.693,  22.994123669  ,    1.380  },
	{ 10  , 13 ,  23, "Al","  p4n",    6769.570   ,  18.648    , 7334.792 ,   0.811 ,-17002.   ,  197.   ,  23.007267432  ,   20.019  },
	{  9  , 14 ,  23, "Si","    x",   23772.      , 196.       , 6562.    ,   9.    , STAR     , STAR    ,  23.025520     ,  210.     },
	{ 17  ,  7 ,  24, "N ","    x",   47543.      , 401.       , 5862.    ,  17.    , 28473.   ,  465.   ,  24.051040     ,  430.     },
	{ 16  ,  8 ,  24, "O ","    x",   19070.400   , 236.242    , 7015.935 ,   9.843 , 11510.874,  247.053,  24.020472917  ,  253.616  },
	{ 15  ,  9 ,  24, "F ","    x",    7559.527   ,  72.282    , 7462.957 ,   3.012 , 13511.047,   72.283,  24.008115485  ,   77.598  },
	{ 14  , 10 ,  24, "Ne","  -nn",   -5951.521   ,   0.392    , 7993.319 ,   0.016 ,  2466.593,    0.399,  23.993610779  ,    0.420  },
	{ 13  , 11 ,  24, "Na","   -n",   -8418.114   ,   0.076    , 8063.496 ,   0.003 ,  5515.453,    0.077,  23.990962782  ,    0.082  },
	{ 12  , 12 ,  24, "Mg","     ",  -13933.567   ,   0.013    , 8260.709 ,   0.001 ,-13876.621,    2.782,  23.985041699  ,    0.013  },
	{ 11  , 13 ,  24, "Al","    -",     -56.946   ,   2.782    , 7649.919 ,   0.116 ,-10811.619,   19.670,  23.999938865  ,    2.986  },
	{ 10  , 14 ,  24, "Si","   --",   10754.673   ,  19.472    , 7166.837 ,   0.811 ,-21242.   ,  503.   ,  24.011545616  ,   20.904  },
	{  9  , 15 ,  24, "P ","    x",   31997.      , 503.       , 6249.    ,  21.    , STAR     , STAR    ,  24.034350     ,  540.     },
	{ 18  ,  7 ,  25, "N ","    x",   56504.      , 503.       , 5592.    ,  20.    , 29063.   ,  565.   ,  25.060660     ,  540.     },
	{ 17  ,  8 ,  25, "O ","   -n",   27442.      , 257.       , 6723.    ,  10.    , 16169.   ,  275.   ,  25.029460     ,  275.     },
	{ 16  ,  9 ,  25, "F ","    x",   11272.706   ,  98.238    , 7338.764 ,   3.930 , 13380.781,  101.529,  25.012101747  ,  105.462  },
	{ 15  , 10 ,  25, "Ne","    x",   -2108.075   ,  25.643    , 7842.701 ,   1.026 ,  7249.743,   25.671,  24.997736888  ,   27.529  },
	{ 14  , 11 ,  25, "Na","  -nn",   -9357.818   ,   1.200    , 8101.397 ,   0.048 ,  3835.008,    1.200,  24.989953968  ,    1.288  },
	{ 13  , 12 ,  25, "Mg","     ",  -13192.826   ,   0.032    , 8223.504 ,   0.001 , -4276.654,    0.476,  24.985836917  ,    0.034  },
	{ 12  , 13 ,  25, "Al","   -p",   -8916.172   ,   0.475    , 8021.144 ,   0.019 ,-12740.490,   10.011,  24.990428095  ,    0.510  },
	{ 11  , 14 ,  25, "Si","  +3n",    3824.318   ,  10.000    , 7480.230 ,   0.400 ,-15048.   ,  196.   ,  25.004105574  ,   10.735  },
	{ 10  , 15 ,  25, "P ","    x",   18872.      , 196.       , 6847.    ,   8.    , STAR     , STAR    ,  25.020260     ,  210.     },
	{ 18  ,  8 ,  26, "O ","  -nn",   35713.      , 257.       , 6457.    ,  10.    , 17441.   ,  306.   ,  26.038340     ,  275.     },
	{ 17  ,  9 ,  26, "F ","    x",   18271.772   , 166.585    , 7097.744 ,   6.407 , 17842.161,  168.722,  26.019615555  ,  178.835  },
	{ 16  , 10 ,  26, "Ne","    x",     429.611   ,  26.774    , 7753.891 ,   1.030 ,  7291.928,   27.402,  26.000461206  ,   28.743  },
	{ 15  , 11 ,  26, "Na","    x",   -6862.316   ,   5.832    , 8004.260 ,   0.224 ,  9352.266,    5.832,  25.992633000  ,    6.260  },
	{ 14  , 12 ,  26, "Mg","     ",  -16214.582   ,   0.027    , 8333.872 ,   0.001 , -4004.273,    0.058,  25.982592929  ,    0.029  },
	{ 13  , 13 ,  26, "Al","     ",  -12210.309   ,   0.060    , 8149.771 ,   0.002 , -5065.677,    3.001,  25.986891692  ,    0.064  },
	{ 12  , 14 ,  26, "Si","  +nn",   -7144.632   ,   3.000    , 7924.847 ,   0.115 ,-18118.   ,  196.   ,  25.992329921  ,    3.220  },
	{ 11  , 15 ,  26, "P ","    x",   10973.      , 196.       , 7198.    ,   8.    ,-14997.   ,  357.   ,  26.011780     ,  210.     },
	{ 10  , 16 ,  26, "S ","    x",   25970.      , 298.       , 6591.    ,  11.    , STAR     , STAR    ,  26.027880     ,  320.     },
	{ 19  ,  8 ,  27, "O ","    x",   44954.      , 503.       , 6175.    ,  19.    , 20027.   ,  628.   ,  27.048260     ,  540.     },
	{ 18  ,  9 ,  27, "F ","    x",   24926.860   , 376.688    , 6887.318 ,  13.951 , 17856.911,  392.528,  27.026760086  ,  404.391  },
	{ 17  , 10 ,  27, "Ne","    x",    7069.949   , 110.384    , 7519.709 ,   4.088 , 12587.386,  110.439,  27.007589903  ,  118.501  },
	{ 16  , 11 ,  27, "Na","     ",   -5517.436   ,   3.503    , 7956.933 ,   0.130 ,  9069.214,    3.503,  26.994076788  ,    3.760  },
	{ 15  , 12 ,  27, "Mg","   -n",  -14586.651   ,   0.049    , 8263.854 ,   0.002 ,  2610.007,    0.125,  26.984340585  ,    0.052  },
	{ 14  , 13 ,  27, "Al","     ",  -17196.658   ,   0.116    , 8331.545 ,   0.004 , -4812.357,    0.096,  26.981538627  ,    0.124  },
	{ 13  , 14 ,  27, "Si","    -",  -12384.301   ,   0.151    , 8124.334 ,   0.006 ,-11667.271,   26.341,  26.986704905  ,    0.162  },
	{ 12  , 15 ,  27, "P ","  p4n",    -717.030   ,  26.341    , 7663.237 ,   0.976 ,-18260.   ,  200.   ,  26.999230236  ,   28.277  },
	{ 11  , 16 ,  27, "S ","    -",   17543.      , 202.       , 6958.    ,   7.    , STAR     , STAR    ,  27.018833     ,  217.     },
	{ 20  ,  8 ,  28, "O ","    x",   53850.      , 596.       , 5925.    ,  21.    , 20623.   ,  786.   ,  28.057810     ,  640.     },
	{ 19  ,  9 ,  28, "F ","    x",   33226.      , 512.       , 6633.    ,  18.    , 21982.   ,  533.   ,  28.035670     ,  550.     },
	{ 18  , 10 ,  28, "Ne","    x",   11244.601   , 146.679    , 7390.315 ,   5.239 , 12233.847,  147.257,  28.012071575  ,  157.465  },
	{ 17  , 11 ,  28, "Na","     ",    -989.247   ,  13.041    , 7799.297 ,   0.466 , 14029.394,   13.194,  27.998938000  ,   14.000  },
	{ 16  , 12 ,  28, "Mg","    +",  -15018.641   ,   2.004    , 8272.406 ,   0.072 ,  1831.800,    2.000,  27.983876825  ,    2.151  },
	{ 15  , 13 ,  28, "Al","   -n",  -16850.441   ,   0.131    , 8309.886 ,   0.005 ,  4642.356,    0.131,  27.981910306  ,    0.140  },
	{ 14  , 14 ,  28, "Si","     ",  -21492.79678 ,   0.00181  , 8447.744 ,   0.000 ,-14334.044,    3.320,  27.97692653246,    0.00194},
	{ 13  , 15 ,  28, "P ","    -",   -7158.753   ,   3.320    , 7907.873 ,   0.119 ,-11231.956,  160.034,  27.992314761  ,    3.564  },
	{ 12  , 16 ,  28, "S ","   --",    4073.203   , 160.000    , 7478.790 ,   5.714 ,-22484.   ,  528.   ,  28.004372763  ,  171.767  },
	{ 11  , 17 ,  28, "Cl","    x",   26557.      , 503.       , 6648.    ,  18.    , STAR     , STAR    ,  28.028510     ,  540.     },
	{ 20  ,  9 ,  29, "F ","    x",   40296.      , 578.       , 6439.    ,  20.    , 22239.   ,  637.   ,  29.043260     ,  620.     },
	{ 19  , 10 ,  29, "Ne","    x",   18057.881   , 268.671    , 7178.857 ,   9.265 , 15392.877,  268.987,  29.019385933  ,  288.429  },
	{ 18  , 11 ,  29, "Na","     ",    2665.004   ,  13.041    , 7682.668 ,   0.450 , 13284.036,   19.113,  29.002861000  ,   14.000  },
	{ 17  , 12 ,  29, "Mg","    x",  -10619.032   ,  13.972    , 8113.761 ,   0.482 ,  7596.290,   14.024,  28.988600000  ,   15.000  },
	{ 16  , 13 ,  29, "Al","  -nn",  -18215.322   ,   1.206    , 8348.725 ,   0.042 ,  3679.724,    1.206,  28.980445046  ,    1.294  },
	{ 15  , 14 ,  29, "Si","   -n",  -21895.046   ,   0.021    , 8448.634 ,   0.001 , -4942.420,    0.600,  28.976494700  ,    0.022  },
	{ 14  , 15 ,  29, "P ","   -p",  -16952.626   ,   0.600    , 8251.228 ,   0.021 ,-13793.044,   50.004,  28.981800606  ,    0.644  },
	{ 13  , 16 ,  29, "S ","  +3n",   -3159.582   ,  50.000    , 7748.629 ,   1.724 ,-16303.   ,  202.   ,  28.996608049  ,   53.677  },
	{ 12  , 17 ,  29, "Cl","    x",   13143.      , 196.       , 7159.    ,   7.    , STAR     , STAR    ,  29.014110     ,  210.     },
	{ 21  ,  9 ,  30, "F ","    x",   48903.      , 596.       , 6206.    ,  20.    , 25801.   ,  825.   ,  30.052500     ,  640.     },
	{ 20  , 10 ,  30, "Ne","    x",   23102.025   , 570.734    , 7040.467 ,  19.024 , 14740.935,  571.288,  30.024801045  ,  612.708  },
	{ 19  , 11 ,  30, "Na","    x",    8361.090   ,  25.150    , 7505.754 ,   0.838 , 17271.762,   26.511,  30.008976000  ,   27.000  },
	{ 18  , 12 ,  30, "Mg","    x",   -8910.672   ,   8.383    , 8055.401 ,   0.279 ,  6961.747,   16.357,  29.990434000  ,    9.000  },
	{ 17  , 13 ,  30, "Al","    +",  -15872.419   ,  14.045    , 8261.381 ,   0.468 ,  8560.509,   14.045,  29.982960256  ,   15.077  },
	{ 16  , 14 ,  30, "Si","   -n",  -24432.928   ,   0.030    , 8520.653 ,   0.001 , -4232.352,    0.313,  29.973770171  ,    0.032  },
	{ 15  , 15 ,  30, "P ","   -p",  -20200.575   ,   0.313    , 8353.496 ,   0.010 , -6138.043,    3.019,  29.978313789  ,    0.336  },
	{ 14  , 16 ,  30, "S ","  +nn",  -14062.532   ,   3.003    , 8122.817 ,   0.100 ,-18506.   ,  196.   ,  29.984903249  ,    3.224  },
	{ 13  , 17 ,  30, "Cl","    x",    4443.      , 196.       , 7480.    ,   7.    ,-15640.   ,  357.   ,  30.004770     ,  210.     },
	{ 12  , 18 ,  30, "Ar","    x",   20083.      , 298.       , 6932.    ,  10.    , STAR     , STAR    ,  30.021560     ,  320.     },
	{ 22  ,  9 ,  31, "F ","  -nn",   56289.      , 597.       , 6028.    ,  19.    , 25447.   , 1083.   ,  31.060429     ,  641.     },
	{ 21  , 10 ,  31, "Ne","    x",   30842.      , 904.       , 6824.    ,  29.    , 18187.   ,  928.   ,  31.033110     ,  970.     },
	{ 20  , 11 ,  31, "Na","    x",   12654.768   , 211.321    , 7385.492 ,   6.817 , 15872.148,  211.668,  31.013585452  ,  226.862  },
	{ 19  , 12 ,  31, "Mg","    x",   -3217.380   ,  12.109    , 7872.260 ,   0.391 , 11736.247,   23.675,  30.996546000  ,   13.000  },
	{ 18  , 13 ,  31, "Al"," p-2n",  -14953.628   ,  20.343    , 8225.611 ,   0.656 ,  7995.378,   20.343,  30.983946619  ,   21.839  },
	{ 17  , 14 ,  31, "Si","   -n",  -22949.006   ,   0.039    , 8458.290 ,   0.001 ,  1491.879,    0.187,  30.975363227  ,    0.042  },
	{ 16  , 15 ,  31, "P ","     ",  -24440.885   ,   0.183    , 8481.178 ,   0.006 , -5396.237,    1.515,  30.973761629  ,    0.196  },
	{ 15  , 16 ,  31, "S ","   +n",  -19044.648   ,   1.506    , 8281.869 ,   0.049 ,-11977.483,   50.023,  30.979554728  ,    1.617  },
	{ 14  , 17 ,  31, "Cl","  p4n",   -7067.165   ,  50.000    , 7870.261 ,   1.613 ,-18360.   ,  200.   ,  30.992413086  ,   53.677  },
	{ 13  , 18 ,  31, "Ar","    -",   11293.      , 206.       , 7253.    ,   7.    , STAR     , STAR    ,  31.012123     ,  221.     },
	{ 22  , 10 ,  32, "Ne","    x",   37278.      , 801.       , 6662.    ,  25.    , 18214.   ,  877.   ,  32.040020     ,  860.     },
	{ 21  , 11 ,  32, "Na","    x",   19064.478   , 356.178    , 7206.621 ,  11.131 , 20019.260,  356.618,  32.020466560  ,  382.372  },
	{ 20  , 12 ,  32, "Mg","    x",    -954.781   ,  17.698    , 7807.774 ,   0.553 , 10107.185,   87.753,  31.998975000  ,   19.000  },
	{ 19  , 13 ,  32, "Al","    x",  -11061.966   ,  85.949    , 8099.175 ,   2.686 , 13018.940,   85.949,  31.988124489  ,   92.270  },
	{ 18  , 14 ,  32, "Si","   -n",  -24080.907   ,   0.050    , 8481.569 ,   0.002 ,   224.311,    0.194,  31.974148082  ,    0.053  },
	{ 17  , 15 ,  32, "P ","   -n",  -24305.218   ,   0.187    , 8464.130 ,   0.006 ,  1710.479,    0.217,  31.973907274  ,    0.200  },
	{ 16  , 16 ,  32, "S ","     ",  -26015.697   ,   0.138    , 8493.134 ,   0.004 ,-12685.926,    6.591,  31.972070999  ,    0.148  },
	{ 15  , 17 ,  32, "Cl","    -",  -13329.771   ,   6.593    , 8072.251 ,   0.206 ,-11129.568,    6.829,  31.985689901  ,    7.077  },
	{ 14  , 18 ,  32, "Ar","    x",   -2200.204   ,   1.780    , 7700.003 ,   0.056 ,-22619.   ,  503.   ,  31.997637984  ,    1.910  },
	{ 13  , 19 ,  32, "K ","    x",   20418.      , 503.       , 6969.    ,  16.    , STAR     , STAR    ,  32.021920     ,  540.     },
	{ 23  , 10 ,  33, "Ne","    x",   45997.      , 801.       , 6440.    ,  24.    , 21108.   , 1186.   ,  33.049380     ,  860.     },
	{ 22  , 11 ,  33, "Na","    x",   24889.293   , 874.999    , 7056.314 ,  26.515 , 19995.224,  875.218,  33.026719756  ,  939.350  },
	{ 21  , 12 ,  33, "Mg","    x",    4894.070   ,  19.561    , 7638.522 ,   0.593 , 13423.447,   75.329,  33.005254000  ,   21.000  },
	{ 20  , 13 ,  33, "Al","    x",   -8529.377   ,  72.745    , 8021.586 ,   2.204 , 11963.285,   74.439,  32.990843336  ,   78.095  },
	{ 19  , 14 ,  33, "Si"," +n2p",  -20492.662   ,  15.791    , 8360.402 ,   0.479 ,  5844.824,   15.829,  32.978000220  ,   16.951  },
	{ 18  , 15 ,  33, "P ","    +",  -26337.486   ,   1.098    , 8513.811 ,   0.033 ,   248.508,    1.090,  32.971725543  ,    1.179  },
	{ 17  , 16 ,  33, "S ","     ",  -26585.994   ,   0.136    , 8497.634 ,   0.004 , -5582.562,    0.438,  32.971458759  ,    0.146  },
	{ 16  , 17 ,  33, "Cl","   -p",  -21003.432   ,   0.458    , 8304.758 ,   0.014 ,-11619.291,    0.638,  32.977451887  ,    0.492  },
	{ 15  , 18 ,  33, "Ar","    x",   -9384.141   ,   0.443    , 7928.950 ,   0.013 ,-16147.   ,  196.   ,  32.989925709  ,    0.476  },
	{ 14  , 19 ,  33, "K ","    x",    6763.      , 196.       , 7416.    ,   6.    , STAR     , STAR    ,  33.007260     ,  210.     },
	{ 24  , 10 ,  34, "Ne","  -nn",   53121.      , 807.       , 6279.    ,  24.    , 20360.   , 1207.   ,  34.057028     ,  867.     },
	{ 23  , 11 ,  34, "Na","   -n",   32761.      , 898.       , 6855.    ,  26.    , 23952.   ,  927.   ,  34.035170     ,  964.     },
	{ 22  , 12 ,  34, "Mg","    x",    8808.603   , 231.396    , 7536.118 ,   6.806 , 11741.097,  257.531,  34.009456424  ,  248.414  },
	{ 21  , 13 ,  34, "Al","    x",   -2932.495   , 113.038    , 7858.434 ,   3.325 , 17024.276,  113.916,  33.996851837  ,  121.351  },
	{ 20  , 14 ,  34, "Si","  +pp",  -19956.770   ,  14.118    , 8336.138 ,   0.415 ,  4600.898,   14.976,  33.978575524  ,   15.155  },
	{ 19  , 15 ,  34, "P ","  +pn",  -24557.669   ,   5.004    , 8448.449 ,   0.147 ,  5374.120,    5.005,  33.973636257  ,    5.371  },
	{ 18  , 16 ,  34, "S ","     ",  -29931.788   ,   0.108    , 8583.501 ,   0.003 , -5492.012,    0.146,  33.967866902  ,    0.115  },
	{ 17  , 17 ,  34, "Cl","     ",  -24439.776   ,   0.179    , 8398.961 ,   0.005 , -6062.559,    0.425,  33.973762819  ,    0.192  },
	{ 16  , 18 ,  34, "Ar","  p4n",  -18377.217   ,   0.386    , 8197.640 ,   0.011 ,-16896.   ,  298.   ,  33.980271244  ,    0.413  },
	{ 15  , 19 ,  34, "K ","    x",   -1481.      , 298.       , 7678.    ,   9.    ,-14634.   ,  422.   ,  33.998410     ,  320.     },
	{ 14  , 20 ,  34, "Ca","    x",   13153.      , 298.       , 7224.    ,   9.    , STAR     , STAR    ,  34.014120     ,  320.     },
	{ 24  , 11 ,  35, "Na","   -n",   39582.      , 946.       , 6695.    ,  27.    , 23430.   , 1028.   ,  35.042493     , 1016.     },
	{ 23  , 12 ,  35, "Mg","    x",   16152.      , 401.       , 7342.    ,  11.    , 16282.   ,  437.   ,  35.017340     ,  430.     },
	{ 22  , 13 ,  35, "Al","    x",    -130.190   , 175.106    , 7784.451 ,   5.003 , 14230.117,  179.270,  34.999860235  ,  187.984  },
	{ 21  , 14 ,  35, "Si"," 2p-n",  -14360.307   ,  38.412    , 8168.673 ,   1.097 , 10497.433,   38.456,  34.984583575  ,   41.236  },
	{ 20  , 15 ,  35, "P ","   +p",  -24857.740   ,   1.867    , 8446.247 ,   0.053 ,  3988.616,    1.869,  34.973314117  ,    2.003  },
	{ 19  , 16 ,  35, "S ","     ",  -28846.356   ,   0.100    , 8537.855 ,   0.003 ,   167.184,    0.093,  34.969032161  ,    0.107  },
	{ 18  , 17 ,  35, "Cl","     ",  -29013.540   ,   0.038    , 8520.278 ,   0.001 , -5966.129,    0.746,  34.968852682  ,    0.040  },
	{ 17  , 18 ,  35, "Ar","    -",  -23047.411   ,   0.747    , 8327.465 ,   0.021 ,-11878.511,   20.015,  34.975257585  ,    0.801  },
	{ 16  , 19 ,  35, "K ","  p4n",  -11168.900   ,  20.001    , 7965.726 ,   0.571 ,-15770.   ,  197.   ,  34.988009692  ,   21.472  },
	{ 15  , 20 ,  35, "Ca","    x",    4602.      , 196.       , 7493.    ,   6.    , STAR     , STAR    ,  35.004940     ,  210.     },
	{ 25  , 11 ,  36, "Na","   -n",   47953.      , 952.       , 6500.    ,  26.    , 26529.   , 1076.   ,  36.051480     , 1022.     },
	{ 24  , 12 ,  36, "Mg","    x",   21424.      , 503.       , 7215.    ,  14.    , 15642.   ,  547.   ,  36.023000     ,  540.     },
	{ 23  , 13 ,  36, "Al","    x",    5781.974   , 214.687    , 7628.193 ,   5.964 , 18264.481,  247.652,  36.006207204  ,  230.475  },
	{ 22  , 14 ,  36, "Si","    x",  -12482.507   , 123.455    , 8113.807 ,   3.429 ,  7768.471,  124.149,  35.986599477  ,  132.534  },
	{ 21  , 15 ,  36, "P ","    +",  -20250.977   ,  13.114    , 8307.866 ,   0.364 , 10413.097,   13.112,  35.978259680  ,   14.078  },
	{ 20  , 16 ,  36, "S ","     ",  -30664.075   ,   0.189    , 8575.387 ,   0.005 , -1142.217,    0.193,  35.967080760  ,    0.202  },
	{ 19  , 17 ,  36, "Cl","     ",  -29521.857   ,   0.072    , 8521.927 ,   0.002 ,   709.682,    0.076,  35.968306981  ,    0.076  },
	{ 18  , 18 ,  36, "Ar","     ",  -30231.540   ,   0.027    , 8519.909 ,   0.001 ,-12805.369,    7.781,  35.967545105  ,    0.028  },
	{ 17  , 19 ,  36, "K ","    -",  -17426.171   ,   7.781    , 8142.472 ,   0.216 ,-10986.812,   40.750,  35.981292235  ,    8.352  },
	{ 16  , 20 ,  36, "Ca","   4n",   -6439.359   ,  40.001    , 7815.551 ,   1.111 ,-20337.   ,  505.   ,  35.993087063  ,   42.942  },
	{ 15  , 21 ,  36, "Sc","    x",   13898.      , 503.       , 7229.    ,  14.    , STAR     , STAR    ,  36.014920     ,  540.     },
	{ 26  , 11 ,  37, "Na","  -nn",   55275.      , 958.       , 6345.    ,  26.    , 26026.   , 1317.   ,  37.059340     , 1029.     },
	{ 25  , 12 ,  37, "Mg","    x",   29249.      , 904.       , 7027.    ,  24.    , 19303.   ,  962.   ,  37.031400     ,  970.     },
	{ 24  , 13 ,  37, "Al","    x",    9946.326   , 330.967    , 7527.619 ,   8.945 , 16526.324,  371.463,  37.010677820  ,  355.307  },
	{ 23  , 14 ,  37, "Si","    x",   -6579.998   , 168.659    , 7953.132 ,   4.558 , 12414.146,  172.875,  36.992936080  ,  181.062  },
	{ 22  , 15 ,  37, "P "," p-2n",  -18994.145   ,  37.948    , 8267.505 ,   1.026 ,  7902.216,   37.947,  36.979608946  ,   40.738  },
	{ 21  , 16 ,  37, "S ","   -n",  -26896.360   ,   0.199    , 8459.934 ,   0.005 ,  4865.172,    0.197,  36.971125567  ,    0.213  },
	{ 20  , 17 ,  37, "Cl","     ",  -31761.532   ,   0.047    , 8570.280 ,   0.001 ,  -813.873,    0.200,  36.965902591  ,    0.050  },
	{ 19  , 18 ,  37, "Ar","    -",  -30947.659   ,   0.205    , 8527.139 ,   0.006 , -6147.460,    0.226,  36.966776320  ,    0.220  },
	{ 18  , 19 ,  37, "K ","   -p",  -24800.199   ,   0.094    , 8339.847 ,   0.003 ,-11638.439,   22.362,  36.973375889  ,    0.100  },
	{ 17  , 20 ,  37, "Ca","  +3n",  -13161.760   ,  22.362    , 8004.150 ,   0.604 ,-16003.   ,  299.   ,  36.985870269  ,   24.006  },
	{ 16  , 21 ,  37, "Sc","    x",    2841.      , 298.       , 7550.    ,   8.    , STAR     , STAR    ,  37.003050     ,  320.     },
	{ 26  , 12 ,  38, "Mg","    x",   34996.      , 503.       , 6903.    ,  13.    , 18946.   ,  887.   ,  38.037570     ,  540.     },
	{ 25  , 13 ,  38, "Al","    x",   16050.594   , 730.517    , 7381.288 ,  19.224 , 20117.867,  743.339,  38.017231021  ,  784.242  },
	{ 24  , 14 ,  38, "Si","    x",   -4067.274   , 137.469    , 7890.118 ,   3.618 , 10690.547,  172.006,  37.995633601  ,  147.579  },
	{ 23  , 15 ,  38, "P ","    x",  -14757.820   , 103.385    , 8150.860 ,   2.721 , 12103.377,  103.633,  37.984156827  ,  110.988  },
	{ 22  , 16 ,  38, "S ","    +",  -26861.197   ,   7.172    , 8448.782 ,   0.189 ,  2936.900,    7.171,  37.971163317  ,    7.699  },
	{ 21  , 17 ,  38, "Cl","   -n",  -29798.097   ,   0.096    , 8505.480 ,   0.003 ,  4916.453,    0.350,  37.968010425  ,    0.102  },
	{ 20  , 18 ,  38, "Ar","     ",  -34714.551   ,   0.337    , 8614.273 ,   0.009 , -5913.860,    0.293,  37.962732394  ,    0.362  },
	{ 19  , 19 ,  38, "K ","     ",  -28800.691   ,   0.447    , 8438.057 ,   0.012 , -6741.472,    4.571,  37.969081184  ,    0.479  },
	{ 18  , 20 ,  38, "Ca","  +nn",  -22059.220   ,   4.557    , 8240.062 ,   0.120 ,-17122.   ,  298.   ,  37.976318452  ,    4.891  },
	{ 17  , 21 ,  38, "Sc","    x",   -4937.      , 298.       , 7769.    ,   8.    ,-14038.   ,  390.   ,  37.994700     ,  320.     },
	{ 16  , 22 ,  38, "Ti","    x",    9101.      , 252.       , 7379.    ,   7.    , STAR     , STAR    ,  38.009770     ,  270.     },
	{ 27  , 12 ,  39, "Mg","   -n",   43568.      , 513.       , 6713.    ,  13.    , 22171.   , 1559.   ,  39.046772     ,  551.     },
	{ 26  , 13 ,  39, "Al","    x",   21396.417   ,1471.761    , 7261.909 ,  37.737 , 19468.213, 1510.077,  39.022970000  , 1580.000  },
	{ 25  , 14 ,  39, "Si","    x",    1928.205   , 338.015    , 7741.034 ,   8.667 , 14801.940,  353.481,  39.002070013  ,  362.874  },
	{ 24  , 15 ,  39, "P ","    x",  -12873.735   , 103.412    , 8100.510 ,   2.652 , 10288.509,  114.865,  38.986179475  ,  111.017  },
	{ 23  , 16 ,  39, "S "," 2p-n",  -23162.245   ,  50.000    , 8344.258 ,   1.282 ,  6637.958,   50.030,  38.975134306  ,   53.677  },
	{ 22  , 17 ,  39, "Cl","  -nn",  -29800.203   ,   1.732    , 8494.402 ,   0.044 ,  3441.808,    5.295,  38.968008164  ,    1.859  },
	{ 21  , 18 ,  39, "Ar","    +",  -33242.011   ,   5.004    , 8562.593 ,   0.128 ,   565.000,    5.000,  38.964313231  ,    5.371  },
	{ 20  , 19 ,  39, "K ","     ",  -33807.011   ,   0.190    , 8557.020 ,   0.005 , -6532.611,    1.852,  38.963706679  ,    0.204  },
	{ 19  , 20 ,  39, "Ca","    -",  -27274.400   ,   1.862    , 8369.457 ,   0.048 ,-13106.379,   24.072,  38.970719725  ,    1.998  },
	{ 18  , 21 ,  39, "Sc"," 2n-p",  -14168.021   ,  24.001    , 8013.336 ,   0.615 ,-15668.   ,  206.   ,  38.984790002  ,   25.766  },
	{ 17  , 22 ,  39, "Ti","    x",    1500.      , 205.       , 7592.    ,   5.    , STAR     , STAR    ,  39.001610     ,  220.     },
	{ 28  , 12 ,  40, "Mg","    x",   50235.      , 904.       , 6581.    ,  23.    , 20940.   , 1142.   ,  40.053930     ,  970.     },
	{ 27  , 13 ,  40, "Al","    x",   29295.      , 699.       , 7085.    ,  17.    , 23828.   ,  893.   ,  40.031450     ,  750.     },
	{ 26  , 14 ,  40, "Si","    x",    5467.052   , 556.034    , 7660.819 ,  13.901 , 13573.889,  573.170,  40.005869121  ,  596.927  },
	{ 25  , 15 ,  40, "P ","    x",   -8106.838   , 139.101    , 7980.608 ,   3.478 , 14759.730,  198.275,  39.991296951  ,  149.330  },
	{ 24  , 16 ,  40, "S ","    x",  -22866.568   , 141.294    , 8330.043 ,   3.532 ,  4691.242,  144.887,  39.975451728  ,  151.685  },
	{ 23  , 17 ,  40, "Cl","    +",  -27557.810   ,  32.066    , 8427.765 ,   0.802 ,  7482.086,   32.066,  39.970415472  ,   34.423  },
	{ 22  , 18 ,  40, "Ar","     ",  -35039.89602 ,   0.00268  , 8595.259 ,   0.000 , -1504.691,    0.192,  39.96238312251,    0.00286},
	{ 21  , 19 ,  40, "K ","     ",  -33535.205   ,   0.192    , 8538.083 ,   0.005 ,  1311.070,    0.111,  39.963998475  ,    0.206  },
	{ 20  , 20 ,  40, "Ca","     ",  -34846.275   ,   0.209    , 8551.301 ,   0.005 ,-14323.047,    2.828,  39.962590983  ,    0.224  },
	{ 19  , 21 ,  40, "Sc","    -",  -20523.228   ,   2.836    , 8173.666 ,   0.071 ,-11672.953,  160.025,  39.977967407  ,    3.044  },
	{ 18  , 22 ,  40, "Ti","   --",   -8850.275   , 160.000    , 7862.283 ,   4.000 ,-19181.   ,  528.   ,  39.990498838  ,  171.767  },
	{ 17  , 23 ,  40, "V ","    x",   10330.      , 503.       , 7363.    ,  13.    , STAR     , STAR    ,  40.011090     ,  540.     },
	{ 28  , 13 ,  41, "Al","    x",   35704.      , 801.       , 6952.    ,  20.    , 22142.   , 2011.   ,  41.038330     ,  860.     },
	{ 27  , 14 ,  41, "Si","    x",   13562.553   ,1844.358    , 7473.380 ,  44.984 , 18839.061, 1856.990,  41.014560000  , 1980.000  },
	{ 26  , 15 ,  41, "P ","    x",   -5276.508   , 216.230    , 7913.788 ,   5.274 , 13742.597,  246.463,  40.994335435  ,  232.132  },
	{ 25  , 16 ,  41, "S ","    x",  -19019.105   , 118.272    , 8229.892 ,   2.885 ,  8288.083,  136.789,  40.979582149  ,  126.970  },
	{ 24  , 17 ,  41, "Cl","    x",  -27307.189   ,  68.723    , 8412.958 ,   1.676 ,  5760.279,   68.724,  40.970684525  ,   73.777  },
	{ 23  , 18 ,  41, "Ar","     ",  -33067.467   ,   0.332    , 8534.371 ,   0.008 ,  2491.606,    0.375,  40.964500611  ,    0.356  },
	{ 22  , 19 ,  41, "K ","     ",  -35559.074   ,   0.194    , 8576.061 ,   0.005 ,  -421.315,    0.179,  40.961825762  ,    0.208  },
	{ 21  , 20 ,  41, "Ca","     ",  -35137.759   ,   0.242    , 8546.703 ,   0.006 , -6495.367,    0.156,  40.962278062  ,    0.260  },
	{ 20  , 21 ,  41, "Sc","     ",  -28642.392   ,   0.225    , 8369.198 ,   0.006 ,-12942.   ,  100.   ,  40.969251125  ,    0.241  },
	{ 19  , 22 ,  41, "Ti","    x",  -15700.      , 100.       , 8034.    ,   2.    ,-15495.   ,  228.   ,  40.983145     ,  107.     },
	{ 18  , 23 ,  41, "V ","    x",    -205.      , 205.       , 7637.    ,   5.    , STAR     , STAR    ,  40.999780     ,  220.     },
	{ 29  , 13 ,  42, "Al","    x",   43678.      , 904.       , 6789.    ,  22.    , 25243.   , 1034.   ,  42.046890     ,  970.     },
	{ 28  , 14 ,  42, "Si","    x",   18434.      , 503.       , 7372.    ,  12.    , 17495.   ,  673.   ,  42.019790     ,  540.     },
	{ 27  , 15 ,  42, "P ","    x",     938.865   , 446.839    , 7769.554 ,  10.639 , 18616.368,  463.783,  42.001007913  ,  479.701  },
	{ 26  , 16 ,  42, "S ","    x",  -17677.503   , 124.215    , 8194.173 ,   2.957 ,  7235.487,  189.990,  41.981022419  ,  133.350  },
	{ 25  , 17 ,  42, "Cl","    x",  -24912.990   , 143.760    , 8347.819 ,   3.423 ,  9509.685,  143.876,  41.973254804  ,  154.332  },
	{ 24  , 18 ,  42, "Ar","    x",  -34422.675   ,   5.775    , 8555.613 ,   0.138 ,   598.881,    5.780,  41.963045736  ,    6.200  },
	{ 23  , 19 ,  42, "K ","   -n",  -35021.556   ,   0.221    , 8551.245 ,   0.005 ,  3525.516,    0.216,  41.962402810  ,    0.237  },
	{ 22  , 20 ,  42, "Ca","     ",  -38547.072   ,   0.249    , 8616.559 ,   0.006 , -6425.833,    0.124,  41.958618014  ,    0.267  },
	{ 21  , 21 ,  42, "Sc","     ",  -32121.239   ,   0.270    , 8444.935 ,   0.006 , -6999.687,    5.451,  41.965516429  ,    0.289  },
	{ 20  , 22 ,  42, "Ti","  -pp",  -25121.552   ,   5.452    , 8259.649 ,   0.130 ,-16952.   ,  196.   ,  41.973030902  ,    5.852  },
	{ 19  , 23 ,  42, "V ","    x",   -8169.      , 196.       , 7837.    ,   5.    ,-14159.   ,  357.   ,  41.991230     ,  210.     },
	{ 18  , 24 ,  42, "Cr","    x",    5990.      , 298.       , 7482.    ,   7.    , STAR     , STAR    ,  42.006430     ,  320.     },
	{ 29  , 14 ,  43, "Si","    x",   26697.      , 699.       , 7196.    ,  16.    , 20931.   , 1194.   ,  43.028660     ,  750.     },
	{ 28  , 15 ,  43, "P ","    x",    5765.948   , 968.754    , 7664.314 ,  22.529 , 17731.183,  989.580,  43.006190000  , 1040.000  },
	{ 27  , 16 ,  43, "S ","    x",  -11965.235   , 201.953    , 8058.473 ,   4.697 , 12202.933,  256.032,  42.987154790  ,  216.805  },
	{ 26  , 17 ,  43, "Cl","    x",  -24168.168   , 157.377    , 8324.068 ,   3.660 ,  7841.640,  157.466,  42.974054403  ,  168.951  },
	{ 25  , 18 ,  43, "Ar","    x",  -32009.808   ,   5.310    , 8488.237 ,   0.123 ,  4583.431,   10.406,  42.965636056  ,    5.700  },
	{ 24  , 19 ,  43, "K ","    +",  -36593.239   ,   8.949    , 8576.635 ,   0.208 ,  1815.400,    8.944,  42.960715540  ,    9.607  },
	{ 23  , 20 ,  43, "Ca","     ",  -38408.639   ,   0.301    , 8600.659 ,   0.007 , -2220.710,    1.865,  42.958766628  ,    0.323  },
	{ 22  , 21 ,  43, "Sc","   -p",  -36187.929   ,   1.874    , 8530.821 ,   0.044 , -6866.826,    7.147,  42.961150658  ,    2.011  },
	{ 21  , 22 ,  43, "Ti"," -n2p",  -29321.103   ,   6.903    , 8352.933 ,   0.161 ,-11297.   ,  233.   ,  42.968522499  ,    7.410  },
	{ 20  , 23 ,  43, "V ","    x",  -18024.      , 233.       , 8072.    ,   5.    ,-15891.   ,  320.   ,  42.980650     ,  250.     },
	{ 19  , 24 ,  43, "Cr","    x",   -2133.      , 219.       , 7684.    ,   5.    , STAR     , STAR    ,  42.997710     ,  235.     },
	{ 30  , 14 ,  44, "Si","    x",   32844.      , 801.       , 7076.    ,  18.    , 20744.   , 1063.   ,  44.035260     ,  860.     },
	{ 29  , 15 ,  44, "P ","    x",   12100.      , 699.       , 7530.    ,  16.    , 21216.   ,  802.   ,  44.012990     ,  750.     },
	{ 28  , 16 ,  44, "S ","    x",   -9116.168   , 394.541    , 7994.013 ,   8.967 , 11114.884,  409.063,  43.990213390  ,  423.557  },
	{ 27  , 17 ,  44, "Cl","    x",  -20231.052   , 108.028    , 8228.843 ,   2.455 , 12442.001,  108.040,  43.978281071  ,  115.973  },
	{ 26  , 18 ,  44, "Ar","    x",  -32673.053   ,   1.595    , 8493.836 ,   0.036 ,  3136.554,   35.814,  43.964924033  ,    1.712  },
	{ 25  , 19 ,  44, "K ","    +",  -35809.606   ,  35.779    , 8547.340 ,   0.813 ,  5658.873,   35.777,  43.961556804  ,   38.410  },
	{ 24  , 20 ,  44, "Ca","     ",  -41468.479   ,   0.376    , 8658.170 ,   0.009 , -3652.386,    1.756,  43.955481754  ,    0.403  },
	{ 23  , 21 ,  44, "Sc","   -p",  -37816.093   ,   1.767    , 8557.381 ,   0.040 ,  -267.634,    1.890,  43.959402752  ,    1.896  },
	{ 22  , 22 ,  44, "Ti","   -a",  -37548.459   ,   0.731    , 8533.518 ,   0.017 ,-13432.079,  121.096,  43.959690069  ,    0.784  },
	{ 21  , 23 ,  44, "V ","    x",  -24116.380   , 121.094    , 8210.463 ,   2.752 ,-10655.   ,  131.   ,  43.974110000  ,  130.000  },
	{ 20  , 24 ,  44, "Cr","    x",  -13461.      ,  50.       , 7951.    ,   1.    ,-19860.   ,  506.   ,  43.985549     ,   54.     },
	{ 19  , 25 ,  44, "Mn","    x",    6399.      , 503.       , 7481.    ,  11.    , STAR     , STAR    ,  44.006870     ,  540.     },
	{ 30  , 15 ,  45, "P ","    x",   17903.      , 801.       , 7413.    ,  18.    , 21156.   , 1918.   ,  45.019220     ,  860.     },
	{ 29  , 16 ,  45, "S ","    x",   -3252.672   ,1742.377    , 7865.431 ,  38.719 , 15109.975, 1746.767,  44.996508112  , 1870.519  },
	{ 28  , 17 ,  45, "Cl","    x",  -18362.647   , 123.756    , 8183.823 ,   2.750 , 11407.942,  123.758,  44.980286886  ,  132.857  },
	{ 27  , 18 ,  45, "Ar","    x",  -29770.589   ,   0.547    , 8419.947 ,   0.012 ,  6837.597,   10.269,  44.968039956  ,    0.586  },
	{ 26  , 19 ,  45, "K ","   +p",  -36608.186   ,  10.256    , 8554.508 ,   0.228 ,  4203.764,   10.257,  44.960699493  ,   11.009  },
	{ 25  , 20 ,  45, "Ca","     ",  -40811.950   ,   0.412    , 8630.540 ,   0.009 ,   255.842,    0.829,  44.956186566  ,    0.442  },
	{ 24  , 21 ,  45, "Sc","     ",  -41067.792   ,   0.837    , 8618.840 ,   0.019 , -2062.055,    0.509,  44.955911909  ,    0.898  },
	{ 23  , 22 ,  45, "Ti","    -",  -39005.737   ,   0.980    , 8555.631 ,   0.022 , -7126.108,   17.044,  44.958125616  ,    1.051  },
	{ 22  , 23 ,  45, "V ","  p4n",  -31879.629   ,  17.029    , 8379.887 ,   0.378 ,-12914.411,  503.295,  44.965775808  ,   18.281  },
	{ 21  , 24 ,  45, "Cr","    x",  -18965.218   , 503.007    , 8075.515 ,  11.178 ,-13851.   ,  585.   ,  44.979640000  ,  540.000  },
	{ 20  , 25 ,  45, "Mn","    x",   -5114.      , 298.       , 7750.    ,   7.    ,-18693.   ,  372.   ,  44.994510     ,  320.     },
	{ 19  , 26 ,  45, "Fe","  -pp",   13579.      , 222.       , 7318.    ,   5.    , STAR     , STAR    ,  45.014578     ,  238.     },
	{ 31  , 15 ,  46, "P ","    x",   25504.      , 904.       , 7262.    ,  20.    , 24806.   , 1142.   ,  46.027380     ,  970.     },
	{ 30  , 16 ,  46, "S ","    x",     699.      , 699.       , 7784.    ,  15.    , 15407.   , 1001.   ,  46.000750     ,  750.     },
	{ 29  , 17 ,  46, "Cl","    x",  -14708.253   , 717.339    , 8101.934 ,  15.594 , 15011.874,  718.504,  45.984210040  ,  770.095  },
	{ 28  , 18 ,  46, "Ar","  +pp",  -29720.127   ,  40.891    , 8411.271 ,   0.889 ,  5698.196,   43.364,  45.968094129  ,   43.898  },
	{ 27  , 19 ,  46, "K ","  +pn",  -35418.323   ,  15.546    , 8518.137 ,   0.338 ,  7716.754,   15.553,  45.961976864  ,   16.688  },
	{ 26  , 20 ,  46, "Ca","     ",  -43135.077   ,   2.276    , 8668.885 ,   0.049 , -1377.962,    2.246,  45.953692587  ,    2.443  },
	{ 25  , 21 ,  46, "Sc","   -n",  -41757.115   ,   0.844    , 8621.922 ,   0.018 ,  2366.307,    0.646,  45.955171890  ,    0.905  },
	{ 24  , 22 ,  46, "Ti","     ",  -44123.422   ,   0.833    , 8656.356 ,   0.018 , -7050.409,    0.600,  45.952631555  ,    0.894  },
	{ 23  , 23 ,  46, "V ","    -",  -37073.013   ,   1.027    , 8486.079 ,   0.022 , -7599.272,   20.021,  45.960200481  ,    1.102  },
	{ 22  , 24 ,  46, "Cr","    x",  -29473.742   ,  19.995    , 8303.870 ,   0.435 ,-17104.   ,  114.   ,  45.968358635  ,   21.465  },
	{ 21  , 25 ,  46, "Mn","    x",  -12370.      , 112.       , 7915.    ,   2.    ,-13125.   ,  371.   ,  45.986720     ,  120.     },
	{ 20  , 26 ,  46, "Fe","    x",     755.      , 354.       , 7613.    ,   8.    , STAR     , STAR    ,  46.000810     ,  380.     },
	{ 31  , 16 ,  47, "S ","    x",    8002.      , 801.       , 7635.    ,  17.    , 18518.   ,  999.   ,  47.008590     ,  860.     },
	{ 30  , 17 ,  47, "Cl","    x",  -10517.      , 596.       , 8012.    ,  13.    , 15391.   ,  604.   ,  46.988710     ,  640.     },
	{ 29  , 18 ,  47, "Ar"," 2p-n",  -25907.836   , 100.083    , 8322.926 ,   2.129 ,  9788.436,  100.233,  46.972186792  ,  107.443  },
	{ 28  , 19 ,  47, "K ","   +p",  -35696.272   ,   7.963    , 8514.544 ,   0.169 ,  6643.850,    7.975,  46.961678473  ,    8.549  },
	{ 27  , 20 ,  47, "Ca","     ",  -42340.123   ,   2.263    , 8639.257 ,   0.048 ,  1991.998,    1.174,  46.954546006  ,    2.429  },
	{ 26  , 21 ,  47, "Sc","     ",  -44332.121   ,   2.029    , 8664.995 ,   0.043 ,   600.273,    1.877,  46.952407508  ,    2.178  },
	{ 25  , 22 ,  47, "Ti","     ",  -44932.394   ,   0.822    , 8661.121 ,   0.017 , -2930.343,    0.298,  46.951763088  ,    0.882  },
	{ 24  , 23 ,  47, "V ","   -p",  -42002.051   ,   0.836    , 8582.127 ,   0.018 , -7443.667,   14.038,  46.954908940  ,    0.897  },
	{ 23  , 24 ,  47, "Cr","  +3n",  -34558.385   ,  14.036    , 8407.106 ,   0.299 ,-12296.   ,  159.   ,  46.962900046  ,   15.067  },
	{ 22  , 25 ,  47, "Mn","    x",  -22263.      , 158.       , 8129.    ,   3.    ,-15640.   ,  305.   ,  46.976100     ,  170.     },
	{ 21  , 26 ,  47, "Fe","    x",   -6623.      , 261.       , 7779.    ,   6.    ,-17326.   ,  567.   ,  46.992890     ,  280.     },
	{ 20  , 27 ,  47, "Co","    x",   10703.      , 503.       , 7394.    ,  11.    , STAR     , STAR    ,  47.011490     ,  540.     },
	{ 32  , 16 ,  48, "S ","    x",   13199.      , 904.       , 7536.    ,  19.    , 17903.   , 1142.   ,  48.014170     ,  970.     },
	{ 31  , 17 ,  48, "Cl","    x",   -4704.      , 699.       , 7892.    ,  15.    , 19012.   ,  760.   ,  47.994950     ,  750.     },
	{ 30  , 18 ,  48, "Ar","    x",  -23716.      , 298.       , 8272.    ,   6.    ,  8408.   ,  299.   ,  47.974540     ,  320.     },
	{ 29  , 19 ,  48, "K ","    +",  -32123.935   ,  24.106    , 8430.887 ,   0.502 , 12090.194,   23.757,  47.965513535  ,   25.878  },
	{ 28  , 20 ,  48, "Ca","     ",  -44214.129   ,   4.082    , 8666.467 ,   0.085 ,   281.972,    5.339,  47.952534177  ,    4.382  },
	{ 27  , 21 ,  48, "Sc","     ",  -44496.101   ,   5.400    , 8656.043 ,   0.113 ,  3991.625,    5.339,  47.952231468  ,    5.797  },
	{ 26  , 22 ,  48, "Ti","     ",  -48487.727   ,   0.822    , 8722.903 ,   0.017 , -4012.342,    2.415,  47.947946281  ,    0.882  },
	{ 25  , 23 ,  48, "V ","    -",  -44475.385   ,   2.551    , 8623.013 ,   0.053 , -1656.205,    7.764,  47.952253707  ,    2.738  },
	{ 24  , 24 ,  48, "Cr","  +nn",  -42819.180   ,   7.379    , 8572.210 ,   0.154 ,-13495.749,  112.023,  47.954031716  ,    7.921  },
	{ 23  , 25 ,  48, "Mn","    x",  -29323.431   , 111.779    , 8274.750 ,   2.329 ,-11163.   ,  132.   ,  47.968520000  ,  120.000  },
	{ 22  , 26 ,  48, "Fe","    x",  -18160.      ,  70.       , 8026.    ,   1.    ,-19800.   ,  407.   ,  47.980504     ,   75.     },
	{ 21  , 27 ,  48, "Co","    x",    1639.      , 401.       , 7597.    ,   8.    ,-16758.   ,  643.   ,  48.001760     ,  430.     },
	{ 20  , 28 ,  48, "Ni","    x",   18397.      , 503.       , 7232.    ,  10.    , STAR     , STAR    ,  48.019750     ,  540.     },
	{ 33  , 16 ,  49, "S ","   -n",   22001.      , 952.       , 7367.    ,  19.    , 21703.   , 1244.   ,  49.023619     , 1022.     },
	{ 32  , 17 ,  49, "Cl","    x",     298.      , 801.       , 7794.    ,  16.    , 18444.   ,  946.   ,  49.000320     ,  860.     },
	{ 31  , 18 ,  49, "Ar","    x",  -18146.      , 503.       , 8154.    ,  10.    , 12174.   ,  508.   ,  48.980520     ,  540.     },
	{ 30  , 19 ,  49, "K ","    +",  -30319.265   ,  70.119    , 8386.719 ,   1.431 , 10970.000,   70.000,  48.967450928  ,   75.276  },
	{ 29  , 20 ,  49, "Ca","   -n",  -41289.265   ,   4.086    , 8594.630 ,   0.083 ,  5263.103,    2.942,  48.955674148  ,    4.386  },
	{ 28  , 21 ,  49, "Sc","     ",  -46552.368   ,   3.997    , 8686.074 ,   0.082 ,  2006.431,    3.916,  48.950023975  ,    4.291  },
	{ 27  , 22 ,  49, "Ti","     ",  -48558.799   ,   0.822    , 8711.055 ,   0.017 ,  -601.856,    0.820,  48.947869982  ,    0.882  },
	{ 26  , 23 ,  49, "V ","    -",  -47956.943   ,   1.161    , 8682.806 ,   0.024 , -2626.459,    2.552,  48.948516101  ,    1.246  },
	{ 25  , 24 ,  49, "Cr","   +n",  -45330.484   ,   2.417    , 8613.239 ,   0.049 , -7714.898,   24.118,  48.951335721  ,    2.594  },
	{ 24  , 25 ,  49, "Mn","  p4n",  -37615.586   ,  24.010    , 8439.826 ,   0.490 ,-13033.   ,  151.   ,  48.959618005  ,   25.775  },
	{ 23  , 26 ,  49, "Fe","    x",  -24582.      , 149.       , 8158.    ,   3.    ,-15006.   ,  300.   ,  48.973610     ,  160.     },
	{ 22  , 27 ,  49, "Co","    x",   -9576.      , 261.       , 7836.    ,   5.    ,-18574.   ,  478.   ,  48.989720     ,  280.     },
	{ 21  , 28 ,  49, "Ni","    x",    8998.      , 401.       , 7441.    ,   8.    , STAR     , STAR    ,  49.009660     ,  430.     },
	{ 33  , 17 ,  50, "Cl","    x",    7303.      , 904.       , 7659.    ,  18.    , 21806.   , 1142.   ,  50.007840     ,  970.     },
	{ 32  , 18 ,  50, "Ar","    x",  -14503.      , 699.       , 8080.    ,  14.    , 10849.   ,  752.   ,  49.984430     ,  750.     },
	{ 31  , 19 ,  50, "K ","    +",  -25352.141   , 278.439    , 8281.068 ,   5.569 , 14218.691,  278.285,  49.972783355  ,  298.916  },
	{ 30  , 20 ,  50, "Ca","  -nn",  -39570.832   ,   9.268    , 8549.795 ,   0.185 ,  4966.053,   17.153,  49.957518962  ,    9.949  },
	{ 29  , 21 ,  50, "Sc","  -pn",  -44536.885   ,  15.546    , 8633.469 ,   0.311 ,  6889.787,   15.525,  49.952187685  ,   16.688  },
	{ 28  , 22 ,  50, "Ti","     ",  -51426.672   ,   0.823    , 8755.618 ,   0.016 , -2205.118,    0.986,  49.944791194  ,    0.883  },
	{ 27  , 23 ,  50, "V ","   +n",  -49221.554   ,   1.005    , 8695.869 ,   0.020 ,  1037.945,    0.318,  49.947158485  ,    1.078  },
	{ 26  , 24 ,  50, "Cr","     ",  -50259.499   ,   1.001    , 8700.981 ,   0.020 , -7632.685,    0.229,  49.946044205  ,    1.074  },
	{ 25  , 25 ,  50, "Mn","     ",  -42626.814   ,   1.026    , 8532.680 ,   0.021 , -8151.273,   60.007,  49.954238230  ,    1.101  },
	{ 24  , 26 ,  50, "Fe","   4n",  -34475.541   ,  60.004    , 8354.008 ,   1.200 ,-17280.   ,  178.   ,  49.962988982  ,   64.416  },
	{ 23  , 27 ,  50, "Co","    x",  -17195.      , 168.       , 7993.    ,   3.    ,-13404.   ,  310.   ,  49.981540     ,  180.     },
	{ 22  , 28 ,  50, "Ni","    x",   -3791.      , 261.       , 7709.    ,   5.    , STAR     , STAR    ,  49.995930     ,  280.     },
	{ 34  , 17 ,  51, "Cl","    x",   13497.      , 997.       , 7546.    ,  20.    , 21294.   , 1217.   ,  51.014490     , 1070.     },
	{ 33  , 18 ,  51, "Ar","    x",   -7797.      , 699.       , 7948.    ,  14.    , 14205.   ,  861.   ,  50.991630     ,  750.     },
	{ 32  , 19 ,  51, "K ","    x",  -22002.      , 503.       , 8211.    ,  10.    , 13861.   ,  512.   ,  50.976380     ,  540.     },
	{ 31  , 20 ,  51, "Ca","  -3n",  -35863.251   ,  93.793    , 8467.716 ,   1.839 ,  7354.933,   95.815,  50.961499214  ,  100.691  },
	{ 30  , 21 ,  51, "Sc"," -p2n",  -43218.184   ,  20.412    , 8596.590 ,   0.400 ,  6509.665,   20.403,  50.953603368  ,   21.913  },
	{ 29  , 22 ,  51, "Ti","   -n",  -49727.849   ,   0.958    , 8708.890 ,   0.019 ,  2473.534,    1.098,  50.946614955  ,    1.027  },
	{ 28  , 23 ,  51, "V ","     ",  -52201.383   ,   1.001    , 8742.051 ,   0.020 ,  -752.576,    0.238,  50.943959507  ,    1.075  },
	{ 27  , 24 ,  51, "Cr","     ",  -51448.807   ,   1.001    , 8711.954 ,   0.020 , -3207.466,    0.354,  50.944767431  ,    1.075  },
	{ 26  , 25 ,  51, "Mn","     ",  -48241.341   ,   0.998    , 8633.723 ,   0.020 , -8018.999,   15.027,  50.948210787  ,    1.071  },
	{ 25  , 26 ,  51, "Fe","  +3n",  -40222.341   ,  15.016    , 8461.147 ,   0.294 ,-12948.   ,  150.   ,  50.956819538  ,   16.120  },
	{ 24  , 27 ,  51, "Co","    x",  -27274.      , 149.       , 8192.    ,   3.    ,-15835.   ,  300.   ,  50.970720     ,  160.     },
	{ 23  , 28 ,  51, "Ni","    x",  -11439.      , 261.       , 7866.    ,   5.    , STAR     , STAR    ,  50.987720     ,  280.     },
	{ 34  , 18 ,  52, "Ar","    x",   -2999.      , 904.       , 7858.    ,  17.    , 13199.   , 1142.   ,  51.996780     ,  970.     },
	{ 33  , 19 ,  52, "K ","    x",  -16199.      , 699.       , 8097.    ,  13.    , 16310.   ,  988.   ,  51.982610     ,  750.     },
	{ 32  , 20 ,  52, "Ca","    x",  -32509.141   , 698.621    , 8395.590 ,  13.435 ,  7847.400,  724.862,  51.965100000  ,  750.000  },
	{ 31  , 21 ,  52, "Sc","    x",  -40356.541   , 193.271    , 8531.457 ,   3.717 ,  9108.295,  193.402,  51.956675468  ,  207.485  },
	{ 30  , 22 ,  52, "Ti","  -nn",  -49464.837   ,   7.119    , 8691.571 ,   0.137 ,  1976.474,    7.140,  51.946897311  ,    7.642  },
	{ 29  , 23 ,  52, "V ","   -n",  -51441.310   ,   1.009    , 8714.535 ,   0.019 ,  3975.623,    1.007,  51.944775479  ,    1.083  },
	{ 28  , 24 ,  52, "Cr","     ",  -55416.933   ,   0.779    , 8775.944 ,   0.015 , -4711.489,    1.895,  51.940507472  ,    0.835  },
	{ 27  , 25 ,  52, "Mn","  +pn",  -50705.444   ,   1.961    , 8670.294 ,   0.038 , -2373.829,    6.247,  51.945565464  ,    2.104  },
	{ 26  , 26 ,  52, "Fe","    -",  -48331.615   ,   6.547    , 8609.598 ,   0.126 ,-14416.   ,   66.   ,  51.948113875  ,    7.028  },
	{ 25  , 27 ,  52, "Co","    x",  -33916.      ,  65.       , 8317.    ,   1.    ,-11262.   ,  106.   ,  51.963590     ,   70.     },
	{ 24  , 28 ,  52, "Ni","    x",  -22654.      ,  84.       , 8086.    ,   2.    ,-20027.   ,  274.   ,  51.975680     ,   90.     },
	{ 23  , 29 ,  52, "Cu","    x",   -2627.      , 261.       , 7686.    ,   5.    , STAR     , STAR    ,  51.997180     ,  280.     },
	{ 35  , 18 ,  53, "Ar","    x",    4602.      , 997.       , 7719.    ,  19.    , 16599.   , 1217.   ,  53.004940     , 1070.     },
	{ 34  , 19 ,  53, "K ","    x",  -11998.      , 699.       , 8017.    ,  13.    , 15901.   ,  861.   ,  52.987120     ,  750.     },
	{ 33  , 20 ,  53, "Ca","    x",  -27898.      , 503.       , 8302.    ,   9.    ,  9725.   ,  585.   ,  52.970050     ,  540.     },
	{ 32  , 21 ,  53, "Sc","    x",  -37623.      , 298.       , 8471.    ,   6.    ,  9206.   ,  314.   ,  52.959610     ,  320.     },
	{ 31  , 22 ,  53, "Ti","    +",  -46828.839   , 100.051    , 8630.132 ,   1.888 ,  5020.000,  100.000,  52.949727171  ,  107.409  },
	{ 30  , 23 ,  53, "V ","   +p",  -51848.839   ,   3.193    , 8710.088 ,   0.060 ,  3435.902,    3.103,  52.944337979  ,    3.427  },
	{ 29  , 24 ,  53, "Cr","     ",  -55284.741   ,   0.771    , 8760.155 ,   0.015 ,  -596.837,    0.357,  52.940649386  ,    0.828  },
	{ 28  , 25 ,  53, "Mn","     ",  -54687.904   ,   0.817    , 8734.133 ,   0.015 , -3742.581,    1.719,  52.941290117  ,    0.876  },
	{ 27  , 26 ,  53, "Fe","   +n",  -50945.323   ,   1.773    , 8648.757 ,   0.033 , -8300.500,   18.083,  52.945307942  ,    1.903  },
	{ 26  , 27 ,  53, "Co","  p4n",  -42644.824   ,  18.010    , 8477.382 ,   0.340 ,-13275.   ,  159.   ,  52.954218896  ,   19.334  },
	{ 25  , 28 ,  53, "Ni","    x",  -29370.      , 158.       , 8212.    ,   3.    ,-15910.   ,  305.   ,  52.968470     ,  170.     },
	{ 24  , 29 ,  53, "Cu","    x",  -13460.      , 261.       , 7897.    ,   5.    , STAR     , STAR    ,  52.985550     ,  280.     },
	{ 35  , 19 ,  54, "K ","    x",   -5403.      , 904.       , 7896.    ,  17.    , 18490.   , 1142.   ,  53.994200     ,  970.     },
	{ 34  , 20 ,  54, "Ca","    x",  -23893.      , 699.       , 8224.    ,  13.    , 10326.   ,  791.   ,  53.974350     ,  750.     },
	{ 33  , 21 ,  54, "Sc","    x",  -34218.841   , 370.138    , 8400.753 ,   6.854 , 11375.554,  390.585,  53.963264561  ,  397.359  },
	{ 32  , 22 ,  54, "Ti","    x",  -45594.395   , 124.717    , 8596.924 ,   2.310 ,  4296.559,  125.618,  53.951052401  ,  133.889  },
	{ 31  , 23 ,  54, "V ","    +",  -49890.954   ,  15.020    , 8662.002 ,   0.278 ,  7041.591,   15.000,  53.946439854  ,   16.124  },
	{ 30  , 24 ,  54, "Cr","     ",  -56932.545   ,   0.765    , 8777.914 ,   0.014 , -1377.175,    1.008,  53.938880395  ,    0.821  },
	{ 29  , 25 ,  54, "Mn","   -p",  -55555.370   ,   1.263    , 8737.923 ,   0.023 ,   697.086,    1.100,  53.940358854  ,    1.355  },
	{ 28  , 26 ,  54, "Fe","     ",  -56252.456   ,   0.690    , 8736.344 ,   0.013 , -8242.916,    0.197,  53.939610501  ,    0.740  },
	{ 27  , 27 ,  54, "Co","     ",  -48009.541   ,   0.717    , 8569.209 ,   0.013 , -8798.762,   50.004,  53.948459635  ,    0.770  },
	{ 26  , 28 ,  54, "Ni","   4n",  -39210.779   ,  50.004    , 8391.781 ,   0.926 ,-17516.   ,  220.   ,  53.957905495  ,   53.681  },
	{ 25  , 29 ,  54, "Cu","    x",  -21694.      , 214.       , 8053.    ,   4.    ,-15127.   ,  454.   ,  53.976710     ,  230.     },
	{ 24  , 30 ,  54, "Zn","    x",   -6567.      , 401.       , 7758.    ,   7.    , STAR     , STAR    ,  53.992950     ,  430.     },
	{ 36  , 19 ,  55, "K ","    x",    -270.      , 997.       , 7806.    ,  18.    , 17847.   , 1217.   ,  54.999710     , 1070.     },
	{ 35  , 20 ,  55, "Ca","    x",  -18118.      , 699.       , 8116.    ,  13.    , 11463.   , 1015.   ,  54.980550     ,  750.     },
	{ 34  , 21 ,  55, "Sc","    x",  -29580.571   , 735.979    , 8310.432 ,  13.381 , 12089.761,  751.532,  54.968243949  ,  790.106  },
	{ 33  , 22 ,  55, "Ti","    x",  -41670.332   , 152.102    , 8516.021 ,   2.765 ,  7481.159,  182.032,  54.955265056  ,  163.288  },
	{ 32  , 23 ,  55, "V ","    +",  -49151.491   , 100.003    , 8637.817 ,   1.818 ,  5956.000,  100.000,  54.947233701  ,  107.357  },
	{ 31  , 24 ,  55, "Cr","   -n",  -55107.491   ,   0.788    , 8731.884 ,   0.014 ,  2603.089,    0.409,  54.940839672  ,    0.845  },
	{ 30  , 25 ,  55, "Mn","     ",  -57710.580   ,   0.680    , 8764.988 ,   0.012 ,  -231.212,    0.184,  54.938045141  ,    0.729  },
	{ 29  , 26 ,  55, "Fe","     ",  -57479.368   ,   0.686    , 8746.560 ,   0.012 , -3451.811,    0.378,  54.938293357  ,    0.735  },
	{ 28  , 27 ,  55, "Co","     ",  -54027.557   ,   0.730    , 8669.575 ,   0.013 , -8691.977,   11.015,  54.941999029  ,    0.783  },
	{ 27  , 28 ,  55, "Ni","  +3n",  -45335.579   ,  11.017    , 8497.315 ,   0.200 ,-13711.   ,  298.   ,  54.951330251  ,   11.827  },
	{ 26  , 29 ,  55, "Cu","    x",  -31624.      , 298.       , 8234.    ,   5.    ,-16702.   ,  390.   ,  54.966050     ,  320.     },
	{ 25  , 30 ,  55, "Zn","    x",  -14923.      , 252.       , 7916.    ,   5.    , STAR     , STAR    ,  54.983980     ,  270.     },
	{ 36  , 20 ,  56, "Ca","    x",  -13441.      , 904.       , 8032.    ,  16.    , 11830.   , 1142.   ,  55.985570     ,  970.     },
	{ 35  , 21 ,  56, "Sc","    x",  -25271.      , 699.       , 8229.    ,  12.    , 13665.   ,  726.   ,  55.972870     ,  750.     },
	{ 34  , 22 ,  56, "Ti","    x",  -38936.785   , 195.950    , 8459.266 ,   3.499 ,  7143.324,  283.052,  55.958199639  ,  210.361  },
	{ 33  , 23 ,  56, "V ","    x",  -46080.109   , 204.259    , 8572.855 ,   3.647 ,  9201.137,  204.268,  55.950530966  ,  219.281  },
	{ 32  , 24 ,  56, "Cr","    x",  -55281.245   ,   1.863    , 8723.191 ,   0.033 ,  1628.464,    1.985,  55.940653139  ,    2.000  },
	{ 31  , 25 ,  56, "Mn","     ",  -56909.710   ,   0.687    , 8738.300 ,   0.012 ,  3695.642,    0.212,  55.938904910  ,    0.737  },
	{ 30  , 26 ,  56, "Fe","     ",  -60605.352   ,   0.685    , 8790.323 ,   0.012 , -4566.000,    2.000,  55.934937475  ,    0.735  },
	{ 29  , 27 ,  56, "Co","    -",  -56039.352   ,   2.114    , 8694.817 ,   0.038 , -2135.678,   11.235,  55.939839278  ,    2.269  },
	{ 28  , 28 ,  56, "Ni","  -pp",  -53903.674   ,  11.072    , 8642.709 ,   0.198 ,-15303.   ,  140.   ,  55.942132022  ,   11.886  },
	{ 27  , 29 ,  56, "Cu","    x",  -38601.      , 140.       , 8355.    ,   2.    ,-12873.   ,  296.   ,  55.958560     ,  150.     },
	{ 26  , 30 ,  56, "Zn","    x",  -25728.      , 261.       , 8112.    ,   5.    ,-20987.   ,  369.   ,  55.972380     ,  280.     },
	{ 25  , 31 ,  56, "Ga","    x",   -4741.      , 261.       , 7723.    ,   5.    , STAR     , STAR    ,  55.994910     ,  280.     },
	{ 37  , 20 ,  57, "Ca","    x",   -7120.      ,1000.       , 7922.    ,  18.    , 13568.   , 1220.   ,  56.992356     , 1074.     },
	{ 36  , 21 ,  57, "Sc","    x",  -20688.      , 699.       , 8146.    ,  12.    , 12855.   ,  834.   ,  56.977790     ,  750.     },
	{ 35  , 22 ,  57, "Ti","    x",  -33543.903   , 455.424    , 8357.848 ,   7.990 , 10644.838,  511.557,  56.963989137  ,  488.917  },
	{ 34  , 23 ,  57, "V ","    x",  -44188.742   , 232.979    , 8530.874 ,   4.087 ,  8335.398,  232.986,  56.952561432  ,  250.113  },
	{ 33  , 24 ,  57, "Cr","    x",  -52524.140   ,   1.863    , 8663.384 ,   0.033 ,  4962.660,    2.625,  56.943613013  ,    2.000  },
	{ 32  , 25 ,  57, "Mn","     ",  -57486.800   ,   1.850    , 8736.723 ,   0.032 ,  2693.330,    1.912,  56.938285378  ,    1.985  },
	{ 31  , 26 ,  57, "Fe","     ",  -60180.130   ,   0.686    , 8770.249 ,   0.012 ,  -835.927,    0.547,  56.935393969  ,    0.736  },
	{ 30  , 27 ,  57, "Co","     ",  -59344.204   ,   0.713    , 8741.858 ,   0.013 , -3262.234,    1.863,  56.936291373  ,    0.765  },
	{ 29  , 28 ,  57, "Ni","     ",  -56081.969   ,   1.814    , 8670.901 ,   0.032 , -8772.393,   15.751,  56.939793526  ,    1.947  },
	{ 28  , 29 ,  57, "Cu"," 2n-p",  -47309.576   ,  15.657    , 8503.274 ,   0.275 ,-14510.   ,  104.   ,  56.949211078  ,   16.808  },
	{ 27  , 30 ,  57, "Zn","    x",  -32800.      , 102.       , 8235.    ,   2.    ,-16899.   ,  280.   ,  56.964788     ,  110.     },
	{ 26  , 31 ,  57, "Ga","    x",  -15901.      , 261.       , 7925.    ,   5.    , STAR     , STAR    ,  56.982930     ,  280.     },
	{ 37  , 21 ,  58, "Sc","    x",  -15174.      , 801.       , 8050.    ,  14.    , 15593.   , 1063.   ,  57.983710     ,  860.     },
	{ 36  , 22 ,  58, "Ti","    x",  -30767.      , 699.       , 8305.    ,  12.    ,  9441.   ,  741.   ,  57.966970     ,  750.     },
	{ 35  , 23 ,  58, "V ","    x",  -40208.743   , 247.930    , 8454.330 ,   4.275 , 11625.983,  320.382,  57.956834136  ,  266.164  },
	{ 34  , 24 ,  58, "Cr","    x",  -51834.726   , 202.917    , 8641.290 ,   3.499 ,  4072.100,  205.124,  57.944353129  ,  217.840  },
	{ 33  , 25 ,  58, "Mn","    +",  -55906.827   ,  30.008    , 8698.010 ,   0.517 ,  6246.591,   30.000,  57.939981549  ,   32.215  },
	{ 32  , 26 ,  58, "Fe","     ",  -62153.418   ,   0.704    , 8792.221 ,   0.012 , -2307.550,    1.204,  57.933275558  ,    0.755  },
	{ 31  , 27 ,  58, "Co","     ",  -59845.868   ,   1.250    , 8738.947 ,   0.022 ,   381.826,    1.110,  57.935752814  ,    1.341  },
	{ 30  , 28 ,  58, "Ni","     ",  -60227.694   ,   0.609    , 8732.041 ,   0.011 , -8565.639,    1.439,  57.935342907  ,    0.653  },
	{ 29  , 29 ,  58, "Cu","    -",  -51662.055   ,   1.563    , 8570.869 ,   0.027 , -9364.361,   50.021,  57.944538499  ,    1.677  },
	{ 28  , 30 ,  58, "Zn","   --",  -42297.694   ,  50.004    , 8395.926 ,   0.862 ,-18312.   ,  220.   ,  57.954591555  ,   53.681  },
	{ 27  , 31 ,  58, "Ga","    x",  -23986.      , 214.       , 8067.    ,   4.    ,-15612.   ,  382.   ,  57.974250     ,  230.     },
	{ 26  , 32 ,  58, "Ge","    x",   -8374.      , 317.       , 7784.    ,   5.    , STAR     , STAR    ,  57.991010     ,  340.     },
	{ 38  , 21 ,  59, "Sc","    x",  -10042.      , 904.       , 7963.    ,  15.    , 15174.   , 1142.   ,  58.989220     ,  970.     },
	{ 37  , 22 ,  59, "Ti","    x",  -25216.      , 699.       , 8207.    ,  12.    , 11851.   ,  763.   ,  58.972930     ,  750.     },
	{ 36  , 23 ,  59, "V ","    x",  -37066.562   , 307.377    , 8394.581 ,   5.210 , 10824.929,  392.657,  58.960207407  ,  329.983  },
	{ 35  , 24 ,  59, "Cr","    x",  -47891.490   , 244.333    , 8564.795 ,   4.141 ,  7588.072,  246.169,  58.948586367  ,  262.302  },
	{ 34  , 25 ,  59, "Mn"," 3p2n",  -55479.562   ,  30.006    , 8680.146 ,   0.509 ,  5183.552,   30.007,  58.940440237  ,   32.212  },
	{ 33  , 26 ,  59, "Fe","   -n",  -60663.114   ,   0.712    , 8754.743 ,   0.012 ,  1565.297,    0.577,  58.934875464  ,    0.764  },
	{ 32  , 27 ,  59, "Co","     ",  -62228.412   ,   0.624    , 8768.013 ,   0.011 , -1072.761,    0.188,  58.933195048  ,    0.669  },
	{ 31  , 28 ,  59, "Ni","     ",  -61155.650   ,   0.608    , 8736.570 ,   0.010 , -4798.427,    0.502,  58.934346705  ,    0.652  },
	{ 30  , 29 ,  59, "Cu","   -p",  -56357.224   ,   0.788    , 8641.981 ,   0.013 , -9096.724,   37.139,  58.939498028  ,    0.845  },
	{ 29  , 30 ,  59, "Zn","    -",  -47260.499   ,  37.147    , 8474.539 ,   0.630 ,-13140.   ,  172.   ,  58.949263764  ,   39.879  },
	{ 28  , 31 ,  59, "Ga","    x",  -34121.      , 168.       , 8239.    ,   3.    ,-17121.   ,  326.   ,  58.963370     ,  180.     },
	{ 27  , 32 ,  59, "Ge","    x",  -17000.      , 279.       , 7935.    ,   5.    , STAR     , STAR    ,  58.981750     ,  300.     },
	{ 39  , 21 ,  60, "Sc","    x",   -3996.      , 904.       , 7864.    ,  15.    , 17652.   , 1208.   ,  59.995710     ,  970.     },
	{ 38  , 22 ,  60, "Ti","    x",  -21648.      , 801.       , 8145.    ,  13.    , 10929.   ,  931.   ,  59.976760     ,  860.     },
	{ 37  , 23 ,  60, "V ","    x",  -32577.268   , 474.712    , 8314.372 ,   7.912 , 13926.608,  520.471,  59.965026862  ,  509.624  },
	{ 36  , 24 ,  60, "Cr","    x",  -46503.876   , 213.397    , 8533.443 ,   3.557 ,  6673.956,  230.100,  59.950076033  ,  229.090  },
	{ 35  , 25 ,  60, "Mn","    +",  -53177.832   ,  86.070    , 8631.637 ,   1.434 ,  8234.000,   86.000,  59.942911246  ,   92.399  },
	{ 34  , 26 ,  60, "Fe","  -nn",  -61411.832   ,   3.464    , 8755.831 ,   0.058 ,   237.181,    3.439,  59.934071683  ,    3.718  },
	{ 33  , 27 ,  60, "Co","   -n",  -61649.012   ,   0.628    , 8746.745 ,   0.010 ,  2823.067,    0.206,  59.933817059  ,    0.674  },
	{ 32  , 28 ,  60, "Ni","     ",  -64472.079   ,   0.607    , 8780.757 ,   0.010 , -6127.981,    1.573,  59.930786372  ,    0.651  },
	{ 31  , 29 ,  60, "Cu","    -",  -58344.099   ,   1.686    , 8665.585 ,   0.028 , -4156.331,   10.656,  59.937365030  ,    1.810  },
	{ 30  , 30 ,  60, "Zn","  -pp",  -54187.768   ,  10.556    , 8583.273 ,   0.176 ,-14189.   ,  112.   ,  59.941827035  ,   11.332  },
	{ 29  , 31 ,  60, "Ga","    x",  -39998.      , 112.       , 8334.    ,   2.    ,-12231.   ,  258.   ,  59.957060     ,  120.     },
	{ 28  , 32 ,  60, "Ge","    x",  -27768.      , 233.       , 8117.    ,   4.    ,-21368.   ,  640.   ,  59.970190     ,  250.     },
	{ 27  , 33 ,  60, "As","    x",   -6399.      , 596.       , 7748.    ,  10.    , STAR     , STAR    ,  59.993130     ,  640.     },
	{ 39  , 22 ,  61, "Ti","    x",  -15649.      , 904.       , 8046.    ,  15.    , 13712.   ,  988.   ,  60.983200     ,  970.     },
	{ 38  , 23 ,  61, "V ","    x",  -29361.      , 401.       , 8258.    ,   7.    , 12820.   ,  475.   ,  60.968480     ,  430.     },
	{ 37  , 24 ,  61, "Cr","    x",  -42180.653   , 254.607    , 8454.995 ,   4.174 ,  9375.083,  341.716,  60.954717204  ,  273.332  },
	{ 36  , 25 ,  61, "Mn","    x",  -51555.736   , 227.914    , 8595.859 ,   3.736 ,  7365.656,  228.791,  60.944652638  ,  244.676  },
	{ 35  , 26 ,  61, "Fe"," +n2p",  -58921.391   ,  20.009    , 8703.782 ,   0.328 ,  3977.031,   20.012,  60.936745281  ,   21.480  },
	{ 34  , 27 ,  61, "Co","  p2n",  -62898.422   ,   0.928    , 8756.154 ,   0.015 ,  1322.470,    0.782,  60.932475763  ,    0.996  },
	{ 33  , 28 ,  61, "Ni","     ",  -64220.892   ,   0.607    , 8765.009 ,   0.010 , -2237.252,    1.002,  60.931056033  ,    0.651  },
	{ 32  , 29 ,  61, "Cu","  p2n",  -61983.640   ,   0.978    , 8715.507 ,   0.016 , -5638.160,   16.279,  60.933457821  ,    1.050  },
	{ 31  , 30 ,  61, "Zn","  +3n",  -56345.480   ,  16.278    , 8610.253 ,   0.267 , -9255.000,   50.000,  60.939510635  ,   17.474  },
	{ 30  , 31 ,  61, "Ga","    -",  -47090.480   ,  52.583    , 8445.706 ,   0.862 ,-13361.   ,  303.   ,  60.949446287  ,   56.450  },
	{ 29  , 32 ,  61, "Ge","    x",  -33729.      , 298.       , 8214.    ,   5.    ,-15677.   ,  667.   ,  60.963790     ,  320.     },
	{ 28  , 33 ,  61, "As","    x",  -18052.      , 596.       , 7944.    ,  10.    , STAR     , STAR    ,  60.980620     ,  640.     },
	{ 40  , 22 ,  62, "Ti","    x",  -11653.      , 904.       , 7982.    ,  15.    , 12771.   , 1034.   ,  61.987490     ,  970.     },
	{ 39  , 23 ,  62, "V ","    x",  -24424.      , 503.       , 8175.    ,   8.    , 15991.   ,  605.   ,  61.973780     ,  540.     },
	{ 38  , 24 ,  62, "Cr","    x",  -40414.553   , 336.992    , 8420.321 ,   5.435 ,  7624.251,  404.144,  61.956613190  ,  361.776  },
	{ 37  , 25 ,  62, "Mn","    x",  -48038.804   , 223.088    , 8530.674 ,   3.598 , 10861.945,  223.558,  61.948428220  ,  239.494  },
	{ 36  , 26 ,  62, "Fe","  +pp",  -58900.749   ,  14.489    , 8693.248 ,   0.234 ,  2530.756,   24.690,  61.936767442  ,   15.554  },
	{ 35  , 27 ,  62, "Co","    +",  -61431.505   ,  20.009    , 8721.448 ,   0.323 ,  5314.591,   20.000,  61.934050563  ,   21.480  },
	{ 34  , 28 ,  62, "Ni","     ",  -66746.096   ,   0.597    , 8794.549 ,   0.010 , -3948.259,    4.058,  61.928345115  ,    0.641  },
	{ 33  , 29 ,  62, "Cu","    -",  -62797.837   ,   4.101    , 8718.249 ,   0.066 , -1626.406,   10.813,  61.932583745  ,    4.403  },
	{ 32  , 30 ,  62, "Zn","  +nn",  -61171.431   ,  10.023    , 8679.398 ,   0.162 , -9171.000,   26.000,  61.934329764  ,   10.760  },
	{ 31  , 31 ,  62, "Ga","    -",  -52000.431   ,  27.865    , 8518.860 ,   0.449 , -9757.   ,  142.   ,  61.944175238  ,   29.914  },
	{ 30  , 32 ,  62, "Ge","    x",  -42243.      , 140.       , 8349.    ,   2.    ,-17279.   ,  329.   ,  61.954650     ,  150.     },
	{ 29  , 33 ,  62, "As","    x",  -24964.      , 298.       , 8058.    ,   5.    , STAR     , STAR    ,  61.973200     ,  320.     },
	{ 41  , 22 ,  63, "Ti","    x",   -5198.      , 997.       , 7881.    ,  16.    , 15714.   , 1161.   ,  62.994420     , 1070.     },
	{ 40  , 23 ,  63, "V ","    x",  -20912.      , 596.       , 8118.    ,   9.    , 14615.   ,  667.   ,  62.977550     ,  640.     },
	{ 39  , 24 ,  63, "Cr","    x",  -35527.      , 298.       , 8337.    ,   5.    , 10824.   ,  394.   ,  62.961860     ,  320.     },
	{ 38  , 25 ,  63, "Mn","    x",  -46351.151   , 258.342    , 8496.595 ,   4.101 ,  9194.683,  308.236,  62.950239990  ,  277.341  },
	{ 37  , 26 ,  63, "Fe","    x",  -55545.834   , 168.133    , 8630.124 ,   2.669 ,  6294.553,  169.319,  62.940369091  ,  180.497  },
	{ 36  , 27 ,  63, "Co","   +p",  -61840.387   ,  20.009    , 8717.619 ,   0.318 ,  3672.169,   20.001,  62.933611611  ,   21.480  },
	{ 35  , 28 ,  63, "Ni","     ",  -65512.556   ,   0.597    , 8763.489 ,   0.009 ,    66.975,    0.015,  62.929669374  ,    0.641  },
	{ 34  , 29 ,  63, "Cu","     ",  -65579.531   ,   0.597    , 8752.134 ,   0.009 , -3366.505,    1.554,  62.929597474  ,    0.641  },
	{ 33  , 30 ,  63, "Zn","     ",  -62213.025   ,   1.583    , 8686.279 ,   0.025 , -5665.933,    2.051,  62.933211566  ,    1.699  },
	{ 32  , 31 ,  63, "Ga","    x",  -56547.093   ,   1.304    , 8583.926 ,   0.021 , -9637.   ,  196.   ,  62.939294196  ,    1.400  },
	{ 31  , 32 ,  63, "Ge","    x",  -46910.      , 196.       , 8419.    ,   3.    ,-13087.   ,  540.   ,  62.949640     ,  210.     },
	{ 30  , 33 ,  63, "As","    x",  -33823.      , 503.       , 8198.    ,   8.    , STAR     , STAR    ,  62.963690     ,  540.     },
	{ 41  , 23 ,  64, "V ","    x",  -15398.      , 699.       , 8031.    ,  11.    , 17754.   ,  805.   ,  63.983470     ,  750.     },
	{ 40  , 24 ,  64, "Cr","    x",  -33152.      , 401.       , 8296.    ,   6.    ,  9465.   ,  481.   ,  63.964410     ,  430.     },
	{ 39  , 25 ,  64, "Mn","    x",  -42616.698   , 266.746    , 8431.599 ,   4.168 , 12153.971,  384.240,  63.954249090  ,  286.363  },
	{ 38  , 26 ,  64, "Fe","    x",  -54770.668   , 276.563    , 8609.280 ,   4.321 ,  5022.017,  277.286,  63.941201265  ,  296.902  },
	{ 37  , 27 ,  64, "Co","    +",  -59792.686   ,  20.009    , 8675.525 ,   0.313 ,  7306.591,   20.000,  63.935809908  ,   21.480  },
	{ 36  , 28 ,  64, "Ni","     ",  -67099.277   ,   0.610    , 8777.467 ,   0.010 , -1675.034,    0.197,  63.927965959  ,    0.654  },
	{ 35  , 29 ,  64, "Cu","     ",  -65424.243   ,   0.600    , 8739.070 ,   0.009 ,   579.353,    0.682,  63.929764183  ,    0.644  },
	{ 34  , 30 ,  64, "Zn","     ",  -66003.595   ,   0.683    , 8735.898 ,   0.011 , -7169.267,    2.076,  63.929142222  ,    0.733  },
	{ 33  , 31 ,  64, "Ga","     ",  -58834.328   ,   2.020    , 8611.654 ,   0.032 , -4484.447,   31.735,  63.936838747  ,    2.168  },
	{ 32  , 32 ,  64, "Ge","    x",  -54349.881   ,  31.671    , 8529.361 ,   0.495 ,-14829.   ,  360.   ,  63.941653000  ,   34.000  },
	{ 31  , 33 ,  64, "As","   -p",  -39521.      , 358.       , 8285.    ,   6.    , STAR     , STAR    ,  63.957572     ,  384.     },
	{ 42  , 23 ,  65, "V ","    x",  -11252.      , 801.       , 7968.    ,  12.    , 16543.   ,  946.   ,  64.987920     ,  860.     },
	{ 41  , 24 ,  65, "Cr","    x",  -27796.      , 503.       , 8210.    ,   8.    , 12877.   ,  736.   ,  64.970160     ,  540.     },
	{ 40  , 25 ,  65, "Mn","    x",  -40672.693   , 536.695    , 8396.148 ,   8.257 , 10205.257,  589.251,  64.956336065  ,  576.165  },
	{ 39  , 26 ,  65, "Fe","    x",  -50877.951   , 243.259    , 8541.116 ,   3.742 ,  8291.983,  243.614,  64.945380270  ,  261.148  },
	{ 38  , 27 ,  65, "Co"," 3p2n",  -59169.934   ,  13.146    , 8656.649 ,   0.202 ,  5956.118,   13.158,  64.936478460  ,   14.112  },
	{ 37  , 28 ,  65, "Ni","     ",  -65126.052   ,   0.623    , 8736.246 ,   0.010 ,  2137.610,    0.729,  64.930084304  ,    0.668  },
	{ 36  , 29 ,  65, "Cu","     ",  -67263.661   ,   0.678    , 8757.096 ,   0.010 , -1352.063,    0.336,  64.927789485  ,    0.728  },
	{ 35  , 30 ,  65, "Zn","     ",  -65911.599   ,   0.684    , 8724.259 ,   0.011 , -3254.426,    0.664,  64.929240984  ,    0.734  },
	{ 34  , 31 ,  65, "Ga","     ",  -62657.173   ,   0.833    , 8662.154 ,   0.013 , -6242.549,  100.002,  64.932734754  ,    0.894  },
	{ 33  , 32 ,  65, "Ge","   ep",  -56414.625   , 100.002    , 8554.079 ,   1.538 , -9434.   ,  318.   ,  64.939436406  ,  107.356  },
	{ 32  , 33 ,  65, "As","   -p",  -46981.      , 302.       , 8397.    ,   5.    ,-14062.   ,  668.   ,  64.949564     ,  324.     },
	{ 31  , 34 ,  65, "Se","    x",  -32919.      , 596.       , 8169.    ,   9.    , STAR     , STAR    ,  64.964660     ,  640.     },
	{ 42  , 24 ,  66, "Cr","    x",  -24796.      , 596.       , 8163.    ,   9.    , 11457.   ,  718.   ,  65.973380     ,  640.     },
	{ 41  , 25 ,  66, "Mn","    x",  -36254.      , 401.       , 8324.    ,   6.    , 13320.   ,  502.   ,  65.961080     ,  430.     },
	{ 40  , 26 ,  66, "Fe","    x",  -49573.517   , 302.640    , 8514.234 ,   4.585 ,  6537.816,  393.887,  65.946780638  ,  324.897  },
	{ 39  , 27 ,  66, "Co","    x",  -56111.332   , 252.102    , 8601.438 ,   3.820 ,  9894.953,  252.106,  65.939762004  ,  270.642  },
	{ 38  , 28 ,  66, "Ni","    x",  -66006.285   ,   1.397    , 8739.508 ,   0.021 ,   251.989,    1.555,  65.929139334  ,    1.500  },
	{ 37  , 29 ,  66, "Cu","     ",  -66258.274   ,   0.683    , 8731.472 ,   0.010 ,  2641.152,    1.013,  65.928868813  ,    0.733  },
	{ 36  , 30 ,  66, "Zn","     ",  -68899.427   ,   0.920    , 8759.636 ,   0.014 , -5175.000,    3.000,  65.926033419  ,    0.987  },
	{ 35  , 31 ,  66, "Ga","    -",  -63724.427   ,   3.138    , 8669.373 ,   0.048 , -2100.000,   30.000,  65.931589010  ,    3.368  },
	{ 34  , 32 ,  66, "Ge","    -",  -61624.427   ,  30.164    , 8625.701 ,   0.457 ,-10122.123,  680.659,  65.933843453  ,   32.382  },
	{ 33  , 33 ,  66, "As","    x",  -51502.304   , 679.991    , 8460.482 ,  10.303 , -9781.   ,  742.   ,  65.944710000  ,  730.000  },
	{ 32  , 34 ,  66, "Se","    x",  -41722.      , 298.       , 8300.    ,   5.    , STAR     , STAR    ,  65.955210     ,  320.     },
	{ 43  , 24 ,  67, "Cr","    x",  -19049.      , 699.       , 8075.    ,  10.    , 14354.   ,  861.   ,  66.979550     ,  750.     },
	{ 42  , 25 ,  67, "Mn","    x",  -33403.      , 503.       , 8278.    ,   8.    , 12289.   ,  652.   ,  66.964140     ,  540.     },
	{ 41  , 26 ,  67, "Fe","    x",  -45692.348   , 415.570    , 8449.695 ,   6.203 ,  9368.702,  523.438,  66.950947244  ,  446.132  },
	{ 40  , 27 ,  67, "Co","    x",  -55061.049   , 318.259    , 8577.850 ,   4.750 ,  8681.631,  318.272,  66.940889529  ,  341.665  },
	{ 39  , 28 ,  67, "Ni","    x",  -63742.680   ,   2.888    , 8695.750 ,   0.043 ,  3576.099,    3.131,  66.931569414  ,    3.100  },
	{ 38  , 29 ,  67, "Cu","    x",  -67318.779   ,   1.211    , 8737.447 ,   0.018 ,   561.662,    1.531,  66.927730314  ,    1.300  },
	{ 37  , 30 ,  67, "Zn","     ",  -67880.441   ,   0.936    , 8734.154 ,   0.014 , -1000.758,    1.161,  66.927127345  ,    1.005  },
	{ 36  , 31 ,  67, "Ga","     ",  -66879.683   ,   1.271    , 8707.540 ,   0.019 , -4221.873,    4.814,  66.928201703  ,    1.364  },
	{ 35  , 32 ,  67, "Ge"," -n2p",  -62657.810   ,   4.666    , 8632.850 ,   0.070 , -6010.000,  100.000,  66.932734070  ,    5.008  },
	{ 34  , 33 ,  67, "As","    -",  -56647.810   , 100.109    , 8531.472 ,   1.494 ,-10157.   ,  220.   ,  66.939186071  ,  107.471  },
	{ 33  , 34 ,  67, "Se","    x",  -46491.      , 196.       , 8368.    ,   3.    ,-13693.   ,  540.   ,  66.950090     ,  210.     },
	{ 32  , 35 ,  67, "Br","    x",  -32798.      , 503.       , 8152.    ,   8.    , STAR     , STAR    ,  66.964790     ,  540.     },
	{ 43  , 25 ,  68, "Mn","    x",  -28597.      , 596.       , 8204.    ,   9.    , 14531.   ,  918.   ,  67.969300     ,  640.     },
	{ 42  , 26 ,  68, "Fe","    x",  -43128.173   , 698.621    , 8406.422 ,  10.274 ,  8222.243,  767.698,  67.953700000  ,  750.000  },
	{ 41  , 27 ,  68, "Co","    x",  -51350.415   , 318.259    , 8515.833 ,   4.680 , 12113.399,  318.273,  67.944873058  ,  341.665  },
	{ 40  , 28 ,  68, "Ni","    x",  -63463.815   ,   2.981    , 8682.466 ,   0.044 ,  2103.220,    3.375,  67.931868789  ,    3.200  },
	{ 39  , 29 ,  68, "Cu","    x",  -65567.035   ,   1.584    , 8701.890 ,   0.023 ,  4440.185,    1.849,  67.929610889  ,    1.700  },
	{ 38  , 30 ,  68, "Zn","     ",  -70007.220   ,   0.955    , 8755.682 ,   0.014 , -2921.100,    1.200,  67.924844154  ,    1.025  },
	{ 37  , 31 ,  68, "Ga","    -",  -67086.120   ,   1.534    , 8701.220 ,   0.023 ,  -106.336,    6.380,  67.927980084  ,    1.646  },
	{ 36  , 32 ,  68, "Ge","     ",  -66979.785   ,   6.227    , 8688.151 ,   0.092 , -8080.552,   42.917,  67.928094240  ,    6.684  },
	{ 35  , 33 ,  68, "As","    -",  -58899.233   ,  43.366    , 8557.814 ,   0.638 , -4684.419,   54.254,  67.936769069  ,   46.555  },
	{ 34  , 34 ,  68, "Se","    x",  -54214.814   ,  32.602    , 8477.420 ,   0.479 ,-15573.   ,  360.   ,  67.941798000  ,   35.000  },
	{ 33  , 35 ,  68, "Br","   -p",  -38642.      , 358.       , 8237.    ,   5.    , STAR     , STAR    ,  67.958516     ,  384.     },
	{ 44  , 25 ,  69, "Mn","    x",  -25299.      , 801.       , 8155.    ,  12.    , 13097.   ,  946.   ,  68.972840     ,  860.     },
	{ 43  , 26 ,  69, "Fe","    x",  -38396.      , 503.       , 8333.    ,   7.    , 11606.   ,  605.   ,  68.958780     ,  540.     },
	{ 42  , 27 ,  69, "Co","    x",  -50002.598   , 335.338    , 8489.857 ,   4.860 ,  9976.050,  335.359,  68.946320000  ,  360.000  },
	{ 41  , 28 ,  69, "Ni","    x",  -59978.648   ,   3.726    , 8623.099 ,   0.054 ,  5757.564,    3.979,  68.935610269  ,    4.000  },
	{ 40  , 29 ,  69, "Cu","    x",  -65736.213   ,   1.397    , 8695.203 ,   0.020 ,  2681.760,    1.700,  68.929429269  ,    1.500  },
	{ 39  , 30 ,  69, "Zn","   -n",  -68417.973   ,   0.969    , 8722.731 ,   0.014 ,   909.785,    1.525,  68.926550281  ,    1.039  },
	{ 38  , 31 ,  69, "Ga","     ",  -69327.758   ,   1.204    , 8724.578 ,   0.017 , -2227.152,    0.550,  68.925573587  ,    1.292  },
	{ 37  , 32 ,  69, "Ge","     ",  -67100.605   ,   1.324    , 8680.962 ,   0.019 , -4013.939,   31.200,  68.927964533  ,    1.421  },
	{ 36  , 33 ,  69, "As","     ",  -63086.666   ,  31.216    , 8611.451 ,   0.452 , -6785.135,   37.549,  68.932273675  ,   33.511  },
	{ 35  , 34 ,  69, "Se","     ",  -56301.531   ,  34.443    , 8501.777 ,   0.499 , -9826.   ,  111.   ,  68.939557817  ,   36.975  },
	{ 34  , 35 ,  69, "Br","   -p",  -46476.      , 105.       , 8348.    ,   2.    ,-14041.   ,  414.   ,  68.950106     ,  113.     },
	{ 33  , 36 ,  69, "Kr","    x",  -32435.      , 401.       , 8133.    ,   6.    , STAR     , STAR    ,  68.965180     ,  430.     },
	{ 44  , 26 ,  70, "Fe","    x",  -35900.      , 596.       , 8294.    ,   9.    ,  9743.   , 1029.   ,  69.961460     ,  640.     },
	{ 43  , 27 ,  70, "Co","    x",  -45643.206   , 838.345    , 8421.601 ,  11.976 , 13506.663,  906.862,  69.951000000  ,  900.000  },
	{ 42  , 28 ,  70, "Ni","    x",  -59149.870   , 345.800    , 8603.377 ,   4.940 ,  3826.257,  345.803,  69.936500000  ,  371.231  },
	{ 41  , 29 ,  70, "Cu","    x",  -62976.127   ,   1.584    , 8646.861 ,   0.023 ,  6588.522,    2.514,  69.932392343  ,    1.700  },
	{ 40  , 30 ,  70, "Zn","     ",  -69564.648   ,   1.952    , 8729.806 ,   0.028 ,  -654.559,    1.591,  69.925319274  ,    2.095  },
	{ 39  , 31 ,  70, "Ga","     ",  -68910.089   ,   1.208    , 8709.279 ,   0.017 ,  1653.022,    1.581,  69.926021972  ,    1.296  },
	{ 38  , 32 ,  70, "Ge","     ",  -70563.111   ,   1.027    , 8721.717 ,   0.015 , -6220.000,   50.000,  69.924247381  ,    1.102  },
	{ 37  , 33 ,  70, "As","    -",  -64343.111   ,  50.011    , 8621.684 ,   0.714 , -2296.895,   79.331,  69.930924826  ,   53.688  },
	{ 36  , 34 ,  70, "Se","    x",  -62046.216   ,  61.582    , 8577.695 ,   0.880 ,-10620.   ,  300.   ,  69.933390644  ,   66.111  },
	{ 35  , 35 ,  70, "Br","    -",  -51426.      , 306.       , 8415.    ,   4.    , -9750.   ,  484.   ,  69.944792     ,  329.     },
	{ 34  , 36 ,  70, "Kr","   --",  -41676.      , 385.       , 8264.    ,   5.    , STAR     , STAR    ,  69.955259     ,  413.     },
	{ 45  , 26 ,  71, "Fe","    x",  -31000.      , 801.       , 8221.    ,  11.    , 12873.   , 1160.   ,  70.966720     ,  860.     },
	{ 44  , 27 ,  71, "Co","    x",  -43873.368   , 838.345    , 8391.740 ,  11.808 , 11330.429,  915.572,  70.952900000  ,  900.000  },
	{ 43  , 28 ,  71, "Ni","    x",  -55203.797   , 368.036    , 8540.304 ,   5.184 ,  7507.330,  368.039,  70.940736283  ,  395.102  },
	{ 42  , 29 ,  71, "Cu","    x",  -62711.127   ,   1.490    , 8635.022 ,   0.021 ,  4615.771,   10.297,  70.932676833  ,    1.600  },
	{ 41  , 30 ,  71, "Zn","   -n",  -67326.897   ,  10.189    , 8689.014 ,   0.144 ,  2813.345,   10.238,  70.927721599  ,   10.938  },
	{ 40  , 31 ,  71, "Ga","     ",  -70140.242   ,   1.018    , 8717.620 ,   0.014 ,  -232.506,    0.217,  70.924701349  ,    1.092  },
	{ 39  , 32 ,  71, "Ge","     ",  -69907.736   ,   1.025    , 8703.326 ,   0.014 , -2013.400,    4.082,  70.924950954  ,    1.100  },
	{ 38  , 33 ,  71, "As","    -",  -67894.336   ,   4.209    , 8663.949 ,   0.059 , -4778.000,   31.305,  70.927112428  ,    4.518  },
	{ 37  , 34 ,  71, "Se","    -",  -63116.336   ,  31.587    , 8585.635 ,   0.445 , -6053.013,  569.089,  70.932241822  ,   33.909  },
	{ 36  , 35 ,  71, "Br","    x",  -57063.323   , 568.211    , 8489.362 ,   8.003 ,-10140.000,  320.000,  70.938740000  ,  610.000  },
	{ 35  , 36 ,  71, "Kr","    -",  -46923.323   , 652.123    , 8335.526 ,   9.185 ,-14619.   ,  824.   ,  70.949625738  ,  700.082  },
	{ 34  , 37 ,  71, "Rb","    x",  -32304.      , 503.       , 8119.    ,   7.    , STAR     , STAR    ,  70.965320     ,  540.     },
	{ 46  , 26 ,  72, "Fe","    x",  -28299.      , 801.       , 8182.    ,  11.    , 11001.   ,  999.   ,  71.969620     ,  860.     },
	{ 45  , 27 ,  72, "Co","    x",  -39300.      , 596.       , 8324.    ,   8.    , 14641.   ,  739.   ,  71.957810     ,  640.     },
	{ 44  , 28 ,  72, "Ni","    x",  -53940.319   , 436.425    , 8516.242 ,   6.061 ,  5842.680,  436.427,  71.942092682  ,  468.521  },
	{ 43  , 29 ,  72, "Cu","    x",  -59782.999   ,   1.397    , 8586.525 ,   0.019 ,  8348.381,    6.244,  71.935820307  ,    1.500  },
	{ 42  , 30 ,  72, "Zn","    +",  -68131.380   ,   6.086    , 8691.609 ,   0.085 ,   458.000,    6.000,  71.926857951  ,    6.533  },
	{ 41  , 31 ,  72, "Ga","     ",  -68589.380   ,   1.017    , 8687.104 ,   0.014 ,  3996.532,    1.836,  71.926366268  ,    1.091  },
	{ 40  , 32 ,  72, "Ge","     ",  -72585.911   ,   1.635    , 8731.745 ,   0.023 , -4356.102,    4.082,  71.922075815  ,    1.755  },
	{ 39  , 33 ,  72, "As","    -",  -68229.809   ,   4.398    , 8660.378 ,   0.061 ,  -335.402,   12.633,  71.926752283  ,    4.721  },
	{ 38  , 34 ,  72, "Se","     ",  -67894.407   ,  12.057    , 8644.854 ,   0.167 , -8879.206,   59.873,  71.927112352  ,   12.943  },
	{ 37  , 35 ,  72, "Br","     ",  -59015.201   ,  59.610    , 8510.665 ,   0.828 , -5074.282,   59.554,  71.936644572  ,   63.994  },
	{ 36  , 36 ,  72, "Kr","     ",  -53940.919   ,   7.993    , 8429.323 ,   0.111 ,-15824.   ,  503.   ,  71.942092038  ,    8.580  },
	{ 35  , 37 ,  72, "Rb","    x",  -38117.      , 503.       , 8199.    ,   7.    , STAR     , STAR    ,  71.959080     ,  540.     },
	{ 46  , 27 ,  73, "Co","    x",  -37036.      , 699.       , 8289.    ,  10.    , 12827.   ,  760.   ,  72.960240     ,  750.     },
	{ 45  , 28 ,  73, "Ni","    x",  -49863.      , 298.       , 8454.    ,   4.    ,  9124.   ,  298.   ,  72.946470     ,  320.     },
	{ 44  , 29 ,  73, "Cu","    x",  -58986.595   ,   3.912    , 8568.557 ,   0.054 ,  6423.748,   40.225,  72.936675282  ,    4.200  },
	{ 43  , 30 ,  73, "Zn"," +n2p",  -65410.343   ,  40.034    , 8645.837 ,   0.548 ,  4288.992,   40.069,  72.929779104  ,   42.978  },
	{ 42  , 31 ,  73, "Ga","    x",  -69699.335   ,   1.677    , 8693.873 ,   0.023 ,  1598.199,    2.342,  72.925174682  ,    1.800  },
	{ 41  , 32 ,  73, "Ge","     ",  -71297.534   ,   1.635    , 8705.049 ,   0.022 ,  -340.833,    3.578,  72.923458945  ,    1.755  },
	{ 40  , 33 ,  73, "As","     ",  -70956.701   ,   3.928    , 8689.663 ,   0.054 , -2739.059,    9.955,  72.923824844  ,    4.216  },
	{ 39  , 34 ,  73, "Se","     ",  -68217.642   ,  10.689    , 8641.425 ,   0.146 , -4588.706,   50.460,  72.926765345  ,   11.475  },
	{ 38  , 35 ,  73, "Br","     ",  -63628.936   ,  50.790    , 8567.849 ,   0.696 , -7077.185,   51.215,  72.931691524  ,   54.525  },
	{ 37  , 36 ,  73, "Kr","    x",  -56551.751   ,   6.578    , 8460.184 ,   0.090 ,-10500.   ,  150.   ,  72.939289195  ,    7.061  },
	{ 36  , 37 ,  73, "Rb","   -p",  -46052.      , 150.       , 8306.    ,   2.    ,-14353.   ,  615.   ,  72.950561     ,  161.     },
	{ 35  , 38 ,  73, "Sr","    x",  -31699.      , 596.       , 8098.    ,   8.    , STAR     , STAR    ,  72.965970     ,  640.     },
	{ 47  , 27 ,  74, "Co","    x",  -32248.      , 801.       , 8222.    ,  11.    , 16124.   ,  896.   ,  73.965380     ,  860.     },
	{ 46  , 28 ,  74, "Ni","    x",  -48372.      , 401.       , 8429.    ,   5.    ,  7634.   ,  401.   ,  73.948070     ,  430.     },
	{ 45  , 29 ,  74, "Cu","    x",  -56006.205   ,   6.148    , 8521.562 ,   0.083 ,  9702.678,   47.537,  73.939874862  ,    6.600  },
	{ 44  , 30 ,  74, "Zn","  +pp",  -65708.883   ,  47.138    , 8642.107 ,   0.637 ,  2340.702,   47.285,  73.929458609  ,   50.604  },
	{ 43  , 31 ,  74, "Ga","    x",  -68049.585   ,   3.726    , 8663.166 ,   0.050 ,  5372.853,    4.069,  73.926945762  ,    4.000  },
	{ 42  , 32 ,  74, "Ge","     ",  -73422.437   ,   1.635    , 8725.200 ,   0.022 , -2562.470,    1.696,  73.921177767  ,    1.754  },
	{ 41  , 33 ,  74, "As","     ",  -70859.967   ,   2.349    , 8680.000 ,   0.032 ,  1352.768,    1.756,  73.923928692  ,    2.521  },
	{ 40  , 34 ,  74, "Se","     ",  -72212.735   ,   1.676    , 8687.708 ,   0.023 , -6906.653,   15.000,  73.922476436  ,    1.798  },
	{ 39  , 35 ,  74, "Br","    -",  -65306.081   ,  15.093    , 8583.803 ,   0.204 , -2974.573,   15.231,  73.929891034  ,   16.203  },
	{ 38  , 36 ,  74, "Kr","     ",  -62331.509   ,   2.040    , 8533.034 ,   0.028 ,-10414.458,    4.036,  73.933084369  ,    2.189  },
	{ 37  , 37 ,  74, "Rb","     ",  -51917.050   ,   3.675    , 8381.726 ,   0.050 ,-11220.   ,  503.   ,  73.944264751  ,    3.945  },
	{ 36  , 38 ,  74, "Sr","    x",  -40697.      , 503.       , 8220.    ,   7.    , STAR     , STAR    ,  73.956310     ,  540.     },
	{ 48  , 27 ,  75, "Co","    x",  -29500.      , 801.       , 8183.    ,  11.    , 14401.   ,  896.   ,  74.968330     ,  860.     },
	{ 47  , 28 ,  75, "Ni","    x",  -43901.      , 401.       , 8365.    ,   5.    , 10218.   , 1057.   ,  74.952870     ,  430.     },
	{ 46  , 29 ,  75, "Cu","    x",  -54119.802   , 978.069    , 8490.407 ,  13.041 ,  8349.221,  980.616,  74.941900000  , 1050.000  },
	{ 45  , 30 ,  75, "Zn","    +",  -62469.023   ,  70.630    , 8591.299 ,   0.942 ,  5995.557,   70.588,  74.932936741  ,   75.824  },
	{ 44  , 31 ,  75, "Ga","    x",  -68464.580   ,   2.422    , 8660.808 ,   0.032 ,  3391.847,    2.923,  74.926500246  ,    2.600  },
	{ 43  , 32 ,  75, "Ge","   -n",  -71856.427   ,   1.636    , 8695.602 ,   0.022 ,  1175.983,    0.955,  74.922858948  ,    1.756  },
	{ 42  , 33 ,  75, "As","     ",  -73032.410   ,   1.818    , 8700.850 ,   0.024 ,  -863.392,    0.805,  74.921596478  ,    1.951  },
	{ 41  , 34 ,  75, "Se","     ",  -72169.018   ,   1.674    , 8678.907 ,   0.022 , -3030.000,   14.142,  74.922523368  ,    1.797  },
	{ 40  , 35 ,  75, "Br","    -",  -69139.018   ,  14.241    , 8628.076 ,   0.190 , -4815.395,   16.385,  74.925776207  ,   15.288  },
	{ 39  , 36 ,  75, "Kr","    x",  -64323.624   ,   8.104    , 8553.439 ,   0.108 , -7101.947,   11.009,  74.930945746  ,    8.700  },
	{ 38  , 37 ,  75, "Rb","    x",  -57221.677   ,   7.452    , 8448.315 ,   0.099 ,-10600.000,  220.000,  74.938570000  ,    8.000  },
	{ 37  , 38 ,  75, "Sr","    -",  -46621.677   , 220.126    , 8296.551 ,   2.935 , STAR     , STAR    ,  74.949949568  ,  236.315  },
	{ 48  , 28 ,  76, "Ni","    x",  -41610.      , 904.       , 8331.    ,  12.    ,  9366.   ,  904.   ,  75.955330     ,  970.     },
	{ 47  , 29 ,  76, "Cu","    x",  -50975.985   ,   6.707    , 8443.527 ,   0.088 , 11160.655,   80.304,  75.945275026  ,    7.200  },
	{ 46  , 30 ,  76, "Zn","    +",  -62136.640   ,  80.024    , 8580.083 ,   1.053 ,  4160.000,   80.000,  75.933293570  ,   85.909  },
	{ 45  , 31 ,  76, "Ga","    x",  -66296.640   ,   1.956    , 8624.526 ,   0.026 ,  6916.407,    2.560,  75.928827626  ,    2.100  },
	{ 44  , 32 ,  76, "Ge","     ",  -73213.046   ,   1.651    , 8705.238 ,   0.022 ,  -923.543,    0.830,  75.921402557  ,    1.772  },
	{ 43  , 33 ,  76, "As","     ",  -72289.504   ,   1.819    , 8682.792 ,   0.024 ,  2962.547,    0.829,  75.922394021  ,    1.953  },
	{ 42  , 34 ,  76, "Se","     ",  -75252.050   ,   1.651    , 8711.478 ,   0.022 , -4962.881,    9.322,  75.919213597  ,    1.772  },
	{ 41  , 35 ,  76, "Br","    -",  -70289.169   ,   9.467    , 8635.883 ,   0.125 , -1274.851,   10.291,  75.924541469  ,   10.163  },
	{ 40  , 36 ,  76, "Kr","     ",  -69014.318   ,   4.032    , 8608.815 ,   0.053 , -8534.486,    4.441,  75.925910078  ,    4.328  },
	{ 39  , 37 ,  76, "Rb","    x",  -60479.832   ,   1.863    , 8486.225 ,   0.025 , -6235.939,   37.306,  75.935072226  ,    2.000  },
	{ 38  , 38 ,  76, "Sr","    x",  -54243.893   ,  37.260    , 8393.879 ,   0.490 ,-15540.   ,  504.   ,  75.941766782  ,   40.000  },
	{ 37  , 39 ,  76, "Y ","    x",  -38704.      , 503.       , 8179.    ,   7.    , STAR     , STAR    ,  75.958450     ,  540.     },
	{ 49  , 28 ,  77, "Ni","    x",  -36747.      , 503.       , 8264.    ,   7.    , 11830.   ,  643.   ,  76.960550     ,  540.     },
	{ 48  , 29 ,  77, "Cu","    x",  -48577.      , 401.       , 8408.    ,   5.    , 10145.   ,  418.   ,  76.947850     ,  430.     },
	{ 47  , 30 ,  77, "Zn","    +",  -58722.344   , 120.024    , 8529.135 ,   1.559 ,  7270.000,  120.000,  76.936958967  ,  128.851  },
	{ 46  , 31 ,  77, "Ga","    x",  -65992.344   ,   2.422    , 8613.390 ,   0.031 ,  5221.685,    2.959,  76.929154300  ,    2.600  },
	{ 45  , 32 ,  77, "Ge","   -n",  -71214.029   ,   1.699    , 8671.044 ,   0.022 ,  2702.548,    1.800,  76.923548591  ,    1.824  },
	{ 44  , 33 ,  77, "As","     ",  -73916.577   ,   2.304    , 8695.981 ,   0.030 ,   683.016,    1.754,  76.920647286  ,    2.473  },
	{ 43  , 34 ,  77, "Se","     ",  -74599.594   ,   1.652    , 8694.691 ,   0.021 , -1364.680,    2.810,  76.919914038  ,    1.773  },
	{ 42  , 35 ,  77, "Br","    -",  -73234.914   ,   3.260    , 8666.808 ,   0.042 , -3065.471,    3.801,  76.921379082  ,    3.499  },
	{ 41  , 36 ,  77, "Kr","    x",  -70169.443   ,   1.956    , 8616.836 ,   0.025 , -5344.912,    7.704,  76.924670000  ,    2.100  },
	{ 40  , 37 ,  77, "Rb","    x",  -64824.531   ,   7.452    , 8537.261 ,   0.097 , -7020.468,   11.929,  76.930408000  ,    8.000  },
	{ 39  , 38 ,  77, "Sr","    x",  -57804.063   ,   9.315    , 8435.926 ,   0.121 ,-10899.   ,   63.   ,  76.937944782  ,   10.000  },
	{ 38  , 39 ,  77, "Y ","   -p",  -46905.      ,  62.       , 8284.    ,   1.    , STAR     , STAR    ,  76.949645     ,   67.     },
	{ 50  , 28 ,  78, "Ni","    x",  -34298.      ,1099.       , 8230.    ,  14.    , 10451.   , 1170.   ,  77.963180     , 1180.     },
	{ 49  , 29 ,  78, "Cu","    x",  -44749.      , 401.       , 8354.    ,   5.    , 12594.   ,  411.   ,  77.951960     ,  430.     },
	{ 48  , 30 ,  78, "Zn","    +",  -57342.570   ,  90.033    , 8505.576 ,   1.154 ,  6364.000,   90.000,  77.938440216  ,   96.653  },
	{ 47  , 31 ,  78, "Ga","    x",  -63706.570   ,   2.422    , 8577.135 ,   0.031 ,  8155.641,    4.593,  77.931608180  ,    2.600  },
	{ 46  , 32 ,  78, "Ge","  -nn",  -71862.211   ,   3.902    , 8671.665 ,   0.050 ,   955.208,   10.482,  77.922852739  ,    4.189  },
	{ 45  , 33 ,  78, "As","  +pn",  -72817.419   ,   9.934    , 8673.881 ,   0.127 ,  4208.667,    9.867,  77.921827281  ,   10.665  },
	{ 44  , 34 ,  78, "Se","     ",  -77026.086   ,   1.655    , 8717.808 ,   0.021 , -3573.784,    3.575,  77.917309090  ,    1.776  },
	{ 43  , 35 ,  78, "Br","    -",  -73452.302   ,   3.940    , 8661.960 ,   0.051 ,   727.424,    4.083,  77.921145706  ,    4.229  },
	{ 42  , 36 ,  78, "Kr","     ",  -74179.727   ,   1.075    , 8661.256 ,   0.014 , -7243.499,    7.529,  77.920364783  ,    1.153  },
	{ 41  , 37 ,  78, "Rb","    x",  -66936.228   ,   7.452    , 8558.361 ,   0.096 , -3762.304,   10.539,  77.928141000  ,    8.000  },
	{ 40  , 38 ,  78, "Sr","    x",  -63173.924   ,   7.452    , 8500.096 ,   0.096 ,-10647.   ,  401.   ,  77.932180000  ,    8.000  },
	{ 39  , 39 ,  78, "Y ","    x",  -52527.      , 401.       , 8354.    ,   5.    ,-10824.   ,  643.   ,  77.943610     ,  430.     },
	{ 38  , 40 ,  78, "Zr","    x",  -41703.      , 503.       , 8205.    ,   6.    , STAR     , STAR    ,  77.955230     ,  540.     },
	{ 50  , 29 ,  79, "Cu","    x",  -42327.      , 503.       , 8320.    ,   6.    , 11092.   ,  566.   ,  78.954560     ,  540.     },
	{ 49  , 30 ,  79, "Zn","    +",  -53420.      , 259.       , 8450.    ,   3.    ,  9090.   ,  240.   ,  78.942652     ,  278.     },
	{ 48  , 31 ,  79, "Ga","    +",  -62509.526   ,  98.140    , 8555.580 ,   1.242 ,  6979.000,   40.000,  78.932893260  ,  105.357  },
	{ 47  , 32 ,  79, "Ge","    +",  -69488.526   ,  89.619    , 8634.019 ,   1.134 ,  4148.000,   89.443,  78.925400995  ,   96.209  },
	{ 46  , 33 ,  79, "As","   +p",  -73636.526   ,   5.611    , 8676.622 ,   0.071 ,  2281.076,    5.493,  78.920947934  ,    6.023  },
	{ 45  , 34 ,  79, "Se","   -n",  -75917.602   ,   1.661    , 8695.593 ,   0.021 ,   150.912,    1.659,  78.918499098  ,    1.782  },
	{ 44  , 35 ,  79, "Br","   +n",  -76068.514   ,   2.017    , 8687.600 ,   0.026 , -1625.778,    3.333,  78.918337087  ,    2.165  },
	{ 43  , 36 ,  79, "Kr","    -",  -74442.736   ,   3.896    , 8657.118 ,   0.049 , -3639.374,    7.144,  78.920082431  ,    4.182  },
	{ 42  , 37 ,  79, "Rb","     ",  -70803.362   ,   5.988    , 8601.147 ,   0.076 , -5326.785,   10.302,  78.923989460  ,    6.427  },
	{ 41  , 38 ,  79, "Sr","    x",  -65476.577   ,   8.383    , 8523.816 ,   0.106 , -7120.000,  450.000,  78.929708000  ,    9.000  },
	{ 40  , 39 ,  79, "Y ","    -",  -58356.577   , 450.078    , 8423.786 ,   5.697 ,-10999.   ,  602.   ,  78.937351634  ,  483.178  },
	{ 39  , 40 ,  79, "Zr","    x",  -47357.      , 401.       , 8275.    ,   5.    , STAR     , STAR    ,  78.949160     ,  430.     },
	{ 51  , 29 ,  80, "Cu","    x",  -36449.      , 596.       , 8243.    ,   7.    , 15395.   ,  620.   ,  79.960870     ,  640.     },
	{ 50  , 30 ,  80, "Zn","    +",  -51844.769   , 172.051    , 8425.997 ,   2.151 ,  7290.400,  120.000,  79.944342348  ,  184.704  },
	{ 49  , 31 ,  80, "Ga","    +",  -59135.169   , 123.295    , 8507.347 ,   1.541 , 10380.000,  120.000,  79.936515781  ,  132.362  },
	{ 48  , 32 ,  80, "Ge","     ",  -69515.169   ,  28.312    , 8627.318 ,   0.354 ,  2644.117,   19.116,  79.925372392  ,   30.394  },
	{ 47  , 33 ,  80, "As","     ",  -72159.286   ,  23.332    , 8650.590 ,   0.292 ,  5600.649,   23.250,  79.922533816  ,   25.047  },
	{ 46  , 34 ,  80, "Se","     ",  -77759.936   ,   1.989    , 8710.819 ,   0.025 , -1870.463,    0.310,  79.916521271  ,    2.135  },
	{ 45  , 35 ,  80, "Br","    -",  -75889.472   ,   2.013    , 8677.659 ,   0.025 ,  2003.020,    2.415,  79.918529296  ,    2.161  },
	{ 44  , 36 ,  80, "Kr","     ",  -77892.492   ,   1.470    , 8692.917 ,   0.018 , -5719.638,    7.090,  79.916378965  ,    1.577  },
	{ 43  , 37 ,  80, "Rb","     ",  -72172.854   ,   6.975    , 8611.642 ,   0.087 , -1864.631,    9.585,  79.922519250  ,    7.487  },
	{ 42  , 38 ,  80, "Sr","    x",  -70308.223   ,   6.575    , 8578.555 ,   0.082 , -9090.437,  177.106,  79.924521013  ,    7.058  },
	{ 41  , 39 ,  80, "Y ","    x",  -61217.786   , 176.984    , 8455.145 ,   2.212 , -5700.743, 1500.862,  79.934280000  ,  190.000  },
	{ 40  , 40 ,  80, "Zr","    x",  -55517.043   ,1490.390    , 8374.107 ,  18.630 , STAR     , STAR    ,  79.940400000  , 1600.000  },
	{ 51  , 30 ,  81, "Zn","    x",  -46128.      , 298.       , 8351.    ,   4.    , 11856.   ,  355.   ,  80.950480     ,  320.     },
	{ 50  , 31 ,  81, "Ga","    +",  -57983.308   , 192.173    , 8487.744 ,   2.373 ,  8320.000,  150.000,  80.937752355  ,  206.306  },
	{ 49  , 32 ,  81, "Ge","    +",  -66303.308   , 120.127    , 8580.801 ,   1.483 ,  6230.000,  120.000,  80.928820467  ,  128.961  },
	{ 48  , 33 ,  81, "As","   +p",  -72533.308   ,   5.527    , 8648.056 ,   0.068 ,  3856.211,    5.283,  80.922132287  ,    5.933  },
	{ 47  , 34 ,  81, "Se","   -n",  -76389.519   ,   2.020    , 8686.005 ,   0.025 ,  1585.320,    2.226,  80.917992474  ,    2.168  },
	{ 46  , 35 ,  81, "Br","     ",  -77974.839   ,   1.952    , 8695.918 ,   0.024 ,  -280.801,    0.484,  80.916290563  ,    2.095  },
	{ 45  , 36 ,  81, "Kr","     ",  -77694.038   ,   1.987    , 8682.793 ,   0.025 , -2239.217,    6.290,  80.916592015  ,    2.133  },
	{ 44  , 37 ,  81, "Rb","     ",  -75454.821   ,   5.998    , 8645.490 ,   0.074 , -3927.116,    8.627,  80.918995913  ,    6.439  },
	{ 43  , 38 ,  81, "Sr","    x",  -71527.705   ,   6.200    , 8587.348 ,   0.077 , -5510.367,   61.845,  80.923211846  ,    6.656  },
	{ 42  , 39 ,  81, "Y ","    -",  -66017.338   ,  62.155    , 8509.661 ,   0.767 , -7528.855,  177.760,  80.929127468  ,   66.725  },
	{ 41  , 40 ,  81, "Zr","   ep",  -58488.484   , 166.540    , 8407.053 ,   2.056 ,-11010.   , 1507.   ,  80.937210026  ,  178.787  },
	{ 40  , 41 ,  81, "Nb","   -p",  -47478.      ,1498.       , 8261.    ,  18.    , STAR     , STAR    ,  80.949030     , 1608.     },
	{ 52  , 30 ,  82, "Zn","    x",  -42457.      , 503.       , 8303.    ,   6.    , 10647.   ,  585.   ,  81.954420     ,  540.     },
	{ 51  , 31 ,  82, "Ga","    x",  -53104.      , 298.       , 8423.    ,   4.    , 12520.   ,  385.   ,  81.942990     ,  320.     },
	{ 50  , 32 ,  82, "Ge","    +",  -65624.008   , 244.139    , 8566.304 ,   2.977 ,  4700.000,  140.000,  81.929549725  ,  262.094  },
	{ 49  , 33 ,  82, "As","    +",  -70324.008   , 200.010    , 8614.080 ,   2.439 ,  7270.000,  200.000,  81.924504067  ,  214.719  },
	{ 48  , 34 ,  82, "Se","     ",  -77594.008   ,   2.020    , 8693.198 ,   0.025 ,   -97.544,    2.077,  81.916699401  ,    2.168  },
	{ 47  , 35 ,  82, "Br","     ",  -77496.465   ,   1.950    , 8682.468 ,   0.024 ,  3093.044,    0.978,  81.916804119  ,    2.093  },
	{ 46  , 36 ,  82, "Kr","     ",  -80589.508   ,   1.780    , 8710.647 ,   0.022 , -4401.308,    3.231,  81.913483600  ,    1.910  },
	{ 45  , 37 ,  82, "Rb","     ",  -76188.201   ,   2.758    , 8647.431 ,   0.034 ,  -179.817,    6.215,  81.918208598  ,    2.960  },
	{ 44  , 38 ,  82, "Sr","     ",  -76008.384   ,   5.570    , 8635.698 ,   0.068 , -7815.991,  102.427,  81.918401639  ,    5.979  },
	{ 43  , 39 ,  82, "Y ","    -",  -68192.393   , 102.579    , 8530.840 ,   1.251 , -4000.   ,  200.   ,  81.926792451  ,  110.122  },
	{ 42  , 40 ,  82, "Zr","    -",  -64192.      , 225.       , 8473.    ,   3.    ,-11218.   ,  373.   ,  81.931087     ,  241.     },
	{ 41  , 41 ,  82, "Nb","    x",  -52974.      , 298.       , 8326.    ,   4.    , STAR     , STAR    ,  81.943130     ,  320.     },
	{ 53  , 30 ,  83, "Zn","    x",  -36300.      , 503.       , 8226.    ,   6.    , 13087.   ,  585.   ,  82.961030     ,  540.     },
	{ 52  , 31 ,  83, "Ga","    x",  -49388.      , 298.       , 8374.    ,   4.    , 11513.   ,  357.   ,  82.946980     ,  320.     },
	{ 51  , 32 ,  83, "Ge","    x",  -60901.      , 196.       , 8503.    ,   2.    ,  8980.   ,  294.   ,  82.934620     ,  210.     },
	{ 50  , 33 ,  83, "As","    +",  -69880.657   , 220.030    , 8602.199 ,   2.651 ,  5460.000,  220.000,  82.924980024  ,  236.211  },
	{ 49  , 34 ,  83, "Se","   -n",  -75340.657   ,   3.616    , 8658.557 ,   0.044 ,  3668.272,    5.153,  82.919118473  ,    3.882  },
	{ 48  , 35 ,  83, "Br","     ",  -79008.930   ,   4.221    , 8693.327 ,   0.051 ,   972.780,    4.078,  82.915180421  ,    4.531  },
	{ 47  , 36 ,  83, "Kr","     ",  -79981.709   ,   2.812    , 8695.621 ,   0.034 ,  -906.905,    6.621,  82.914136099  ,    3.019  },
	{ 46  , 37 ,  83, "Rb","     ",  -79074.805   ,   6.009    , 8675.269 ,   0.072 , -2279.366,    8.383,  82.915109701  ,    6.450  },
	{ 45  , 38 ,  83, "Sr","    -",  -76795.439   ,  10.315    , 8638.381 ,   0.124 , -4468.882,   43.097,  82.917556701  ,   11.073  },
	{ 44  , 39 ,  83, "Y ","    -",  -72326.557   ,  44.314    , 8575.113 ,   0.534 , -5868.000,   85.000,  82.922354243  ,   47.572  },
	{ 43  , 40 ,  83, "Zr","    -",  -66458.557   ,  95.858    , 8494.988 ,   1.155 , -7500.000,  300.000,  82.928653801  ,  102.907  },
	{ 42  , 41 ,  83, "Nb","    -",  -58958.557   , 314.942    , 8395.201 ,   3.794 ,-11210.   ,  593.   ,  82.936705382  ,  338.104  },
	{ 41  , 42 ,  83, "Mo","    x",  -47748.      , 503.       , 8251.    ,   6.    , STAR     , STAR    ,  82.948740     ,  540.     },
	{ 53  , 31 ,  84, "Ga","    x",  -44106.      , 401.       , 8308.    ,   5.    , 14140.   ,  499.   ,  83.952650     ,  430.     },
	{ 52  , 32 ,  84, "Ge","    x",  -58246.      , 298.       , 8467.    ,   4.    ,  7836.   ,  423.   ,  83.937470     ,  320.     },
	{ 51  , 33 ,  84, "As","    +",  -66082.      , 300.       , 8551.    ,   4.    ,  9870.   ,  300.   ,  83.929058     ,  322.     },
	{ 50  , 34 ,  84, "Se","     ",  -75951.829   ,  14.541    , 8658.841 ,   0.173 ,  1847.507,   19.726,  83.918462354  ,   15.610  },
	{ 49  , 35 ,  84, "Br","     ",  -77799.335   ,  14.651    , 8671.522 ,   0.174 ,  4631.656,   14.419,  83.916478974  ,   15.728  },
	{ 48  , 36 ,  84, "Kr","     ",  -82430.991   ,   2.805    , 8717.347 ,   0.033 , -2680.965,    2.298,  83.911506687  ,    3.010  },
	{ 47  , 37 ,  84, "Rb","     ",  -79750.025   ,   2.805    , 8676.117 ,   0.033 ,   893.812,    3.173,  83.914384821  ,    3.011  },
	{ 46  , 38 ,  84, "Sr","     ",  -80643.837   ,   3.202    , 8677.444 ,   0.038 , -6485.983,   91.323,  83.913425275  ,    3.437  },
	{ 45  , 39 ,  84, "Y ","    -",  -74157.855   ,  91.379    , 8590.916 ,   1.088 , -2666.   ,  216.   ,  83.920388264  ,   98.099  },
	{ 44  , 40 ,  84, "Zr","    x",  -71492.      , 196.       , 8550.    ,   2.    , -9613.   ,  357.   ,  83.923250     ,  210.     },
	{ 43  , 41 ,  84, "Nb","    x",  -61879.      , 298.       , 8426.    ,   4.    , -6073.   ,  499.   ,  83.933570     ,  320.     },
	{ 42  , 42 ,  84, "Mo","    x",  -55806.      , 401.       , 8344.    ,   5.    , STAR     , STAR    ,  83.940090     ,  430.     },
	{ 54  , 31 ,  85, "Ga","    x",  -40054.      , 503.       , 8257.    ,   6.    , 13013.   ,  643.   ,  84.957000     ,  540.     },
	{ 53  , 32 ,  85, "Ge","    x",  -53067.      , 401.       , 8401.    ,   5.    , 10256.   ,  446.   ,  84.943030     ,  430.     },
	{ 52  , 33 ,  85, "As","    x",  -63323.      , 196.       , 8513.    ,   2.    ,  9105.   ,  198.   ,  84.932020     ,  210.     },
	{ 51  , 34 ,  85, "Se","    +",  -72428.267   ,  29.896    , 8610.476 ,   0.352 ,  6182.000,   23.000,  84.922245053  ,   32.095  },
	{ 50  , 35 ,  85, "Br","    +",  -78610.267   ,  19.100    , 8674.001 ,   0.225 ,  2870.000,   19.000,  84.915608403  ,   20.504  },
	{ 49  , 36 ,  85, "Kr","     ",  -81480.267   ,   1.947    , 8698.562 ,   0.023 ,   687.064,    1.947,  84.912527331  ,    2.090  },
	{ 48  , 37 ,  85, "Rb","     ",  -82167.331   ,   0.011    , 8697.441 ,   0.000 , -1064.758,    2.837,  84.911789737  ,    0.012  },
	{ 47  , 38 ,  85, "Sr","     ",  -81102.572   ,   2.837    , 8675.710 ,   0.033 , -3260.449,   19.176,  84.912932803  ,    3.045  },
	{ 46  , 39 ,  85, "Y ","    x",  -77842.123   ,  18.965    , 8628.148 ,   0.223 , -4693.000,   99.000,  84.916433039  ,   20.360  },
	{ 45  , 40 ,  85, "Zr","    -",  -73149.123   , 100.800    , 8563.732 ,   1.186 , -6000.000,  200.000,  84.921471182  ,  108.213  },
	{ 44  , 41 ,  85, "Nb","    -",  -67149.123   , 223.966    , 8483.940 ,   2.635 , -8046.   ,  358.   ,  84.927912447  ,  240.437  },
	{ 43  , 42 ,  85, "Mo","   ep",  -59103.      , 280.       , 8380.    ,   3.    ,-11439.   ,  489.   ,  84.936550     ,  300.     },
	{ 42  , 43 ,  85, "Tc","    x",  -47665.      , 401.       , 8236.    ,   5.    , STAR     , STAR    ,  84.948830     ,  430.     },
	{ 55  , 31 ,  86, "Ga","    x",  -34353.      , 801.       , 8189.    ,   9.    , 15491.   ,  946.   ,  85.963120     ,  860.     },
	{ 54  , 32 ,  86, "Ge","    x",  -49844.      , 503.       , 8360.    ,   6.    ,  9306.   ,  585.   ,  85.946490     ,  540.     },
	{ 53  , 33 ,  86, "As","    x",  -59150.      , 298.       , 8459.    ,   3.    , 11391.   ,  298.   ,  85.936500     ,  320.     },
	{ 52  , 34 ,  86, "Se","    +",  -70540.570   ,  15.557    , 8582.256 ,   0.181 ,  5099.000,   11.000,  85.924271579  ,   16.700  },
	{ 51  , 35 ,  86, "Br","    +",  -75639.570   ,  11.000    , 8632.450 ,   0.128 ,  7626.000,   11.000,  85.918797577  ,   11.809  },
	{ 50  , 36 ,  86, "Kr","    x",  -83265.570   ,   0.102    , 8712.027 ,   0.001 ,  -518.554,    0.224,  85.910610729  ,    0.110  },
	{ 49  , 37 ,  86, "Rb","     ",  -82747.017   ,   0.199    , 8696.901 ,   0.002 ,  1776.559,    1.074,  85.911167419  ,    0.214  },
	{ 48  , 38 ,  86, "Sr","     ",  -84523.576   ,   1.074    , 8708.461 ,   0.012 , -5240.000,   14.142,  85.909260204  ,    1.152  },
	{ 47  , 39 ,  86, "Y ","    -",  -79283.576   ,  14.183    , 8638.434 ,   0.165 , -1479.226,   33.258,  85.914885576  ,   15.225  },
	{ 46  , 40 ,  86, "Zr","   4n",  -77804.350   ,  30.093    , 8612.137 ,   0.350 , -7978.000,   80.000,  85.916473591  ,   32.306  },
	{ 45  , 41 ,  86, "Nb","    -",  -69826.350   ,  85.473    , 8510.272 ,   0.994 , -5270.000,  430.000,  85.925038326  ,   91.758  },
	{ 44  , 42 ,  86, "Mo","    -",  -64556.350   , 438.413    , 8439.896 ,   5.098 ,-11349.   ,  530.   ,  85.930695904  ,  470.655  },
	{ 43  , 43 ,  86, "Tc","    x",  -53207.      , 298.       , 8299.    ,   3.    , STAR     , STAR    ,  85.942880     ,  320.     },
	{ 55  , 32 ,  87, "Ge","    x",  -44237.      , 503.       , 8292.    ,   6.    , 11746.   ,  585.   ,  86.952510     ,  540.     },
	{ 54  , 33 ,  87, "As","    x",  -55983.      , 298.       , 8418.    ,   3.    , 10599.   ,  301.   ,  86.939900     ,  320.     },
	{ 53  , 34 ,  87, "Se","    +",  -66581.926   ,  39.212    , 8530.882 ,   0.451 ,  7275.000,   35.000,  86.928521358  ,   42.095  },
	{ 52  , 35 ,  87, "Br","    +",  -73856.926   ,  17.680    , 8605.510 ,   0.203 ,  6852.500,   17.678,  86.920711324  ,   18.979  },
	{ 51  , 36 ,  87, "Kr","   -n",  -80709.426   ,   0.267    , 8675.282 ,   0.003 ,  3888.369,    0.267,  86.913354862  ,    0.286  },
	{ 50  , 37 ,  87, "Rb","     ",  -84597.795   ,   0.012    , 8710.983 ,   0.000 ,   282.618,    1.073,  86.909180526  ,    0.012  },
	{ 49  , 38 ,  87, "Sr","     ",  -84880.413   ,   1.073    , 8705.239 ,   0.012 , -1861.690,    1.128,  86.908877124  ,    1.152  },
	{ 48  , 39 ,  87, "Y ","    -",  -83018.723   ,   1.557    , 8674.848 ,   0.018 , -3670.573,    8.449,  86.910875730  ,    1.671  },
	{ 47  , 40 ,  87, "Zr","  +3n",  -79348.150   ,   8.343    , 8623.665 ,   0.096 , -5165.000,   60.000,  86.914816252  ,    8.956  },
	{ 46  , 41 ,  87, "Nb","    -",  -74183.150   ,  60.577    , 8555.305 ,   0.696 , -6488.223,  214.905,  86.920361108  ,   65.032  },
	{ 45  , 42 ,  87, "Mo","    -",  -67694.927   , 223.279    , 8471.735 ,   2.566 , -8573.   ,  372.   ,  86.927326502  ,  239.700  },
	{ 44  , 43 ,  87, "Tc","    x",  -59122.      , 298.       , 8364.    ,   3.    ,-11783.   ,  667.   ,  86.936530     ,  320.     },
	{ 43  , 44 ,  87, "Ru","    x",  -47339.      , 596.       , 8220.    ,   7.    , STAR     , STAR    ,  86.949180     ,  640.     },
	{ 56  , 32 ,  88, "Ge","    x",  -40138.      , 699.       , 8243.    ,   8.    , 11150.   ,  861.   ,  87.956910     ,  750.     },
	{ 55  , 33 ,  88, "As","    x",  -51288.      , 503.       , 8361.    ,   6.    , 12590.   ,  505.   ,  87.944940     ,  540.     },
	{ 54  , 34 ,  88, "Se","    +",  -63878.135   ,  49.366    , 8494.935 ,   0.561 ,  6854.000,   31.000,  87.931423998  ,   52.996  },
	{ 53  , 35 ,  88, "Br","    +",  -70732.135   ,  38.419    , 8563.931 ,   0.437 ,  8960.000,   36.000,  87.924065926  ,   41.244  },
	{ 52  , 36 ,  88, "Kr","  -nn",  -79692.135   ,  13.417    , 8656.859 ,   0.152 ,  2916.863,   13.418,  87.914446969  ,   14.403  },
	{ 51  , 37 ,  88, "Rb","   -n",  -82608.998   ,   0.160    , 8681.115 ,   0.002 ,  5312.742,    1.095,  87.911315588  ,    0.172  },
	{ 50  , 38 ,  88, "Sr","     ",  -87921.740   ,   1.083    , 8732.596 ,   0.012 , -3622.600,    1.500,  87.905612124  ,    1.163  },
	{ 49  , 39 ,  88, "Y ","    -",  -84299.140   ,   1.850    , 8682.540 ,   0.021 ,  -676.039,   10.410,  87.909501146  ,    1.986  },
	{ 48  , 40 ,  88, "Zr","  +nn",  -83623.101   ,  10.277    , 8665.968 ,   0.117 , -7550.000,  100.000,  87.910226904  ,   11.032  },
	{ 47  , 41 ,  88, "Nb","    -",  -76073.101   , 100.527    , 8571.282 ,   1.142 , -3373.013,  102.538,  87.918332163  ,  107.919  },
	{ 46  , 42 ,  88, "Mo","   4n",  -72700.088   ,  20.359    , 8524.062 ,   0.231 , -9990.   ,  200.   ,  87.921953241  ,   21.855  },
	{ 45  , 43 ,  88, "Tc","    -",  -62710.      , 201.       , 8402.    ,   2.    , -7063.   ,  448.   ,  87.932678     ,  216.     },
	{ 44  , 44 ,  88, "Ru","    x",  -55647.      , 401.       , 8313.    ,   5.    , STAR     , STAR    ,  87.940260     ,  430.     },
	{ 57  , 32 ,  89, "Ge","    x",  -33692.      , 904.       , 8169.    ,  10.    , 13451.   , 1034.   ,  88.963830     ,  970.     },
	{ 56  , 33 ,  89, "As","    x",  -47143.      , 503.       , 8311.    ,   6.    , 12054.   ,  585.   ,  88.949390     ,  540.     },
	{ 55  , 34 ,  89, "Se","    x",  -59196.      , 298.       , 8438.    ,   3.    ,  9375.   ,  304.   ,  88.936450     ,  320.     },
	{ 54  , 35 ,  89, "Br","    +",  -68571.620   ,  59.807    , 8534.120 ,   0.672 ,  8155.000,   30.000,  88.926385334  ,   64.205  },
	{ 53  , 36 ,  89, "Kr","    +",  -76726.620   ,  51.739    , 8616.959 ,   0.581 ,  4985.882,   51.450,  88.917630581  ,   55.543  },
	{ 52  , 37 ,  89, "Rb","     ",  -81712.502   ,   5.462    , 8664.190 ,   0.061 ,  4496.639,    5.447,  88.912278016  ,    5.863  },
	{ 51  , 38 ,  89, "Sr","     ",  -86209.141   ,   1.087    , 8705.924 ,   0.012 ,  1492.607,    2.599,  88.907450675  ,    1.166  },
	{ 50  , 39 ,  89, "Y ","     ",  -87701.749   ,   2.552    , 8713.904 ,   0.029 , -2832.864,    2.780,  88.905848295  ,    2.739  },
	{ 49  , 40 ,  89, "Zr","     ",  -84868.884   ,   3.698    , 8673.284 ,   0.042 , -4218.499,   27.055,  88.908889500  ,    3.970  },
	{ 48  , 41 ,  89, "Nb","    x",  -80650.386   ,  26.801    , 8617.094 ,   0.301 , -5646.497,   30.948,  88.913418245  ,   28.771  },
	{ 47  , 42 ,  89, "Mo","  +3n",  -75003.889   ,  15.475    , 8544.860 ,   0.174 , -7160.   ,  200.   ,  88.919480009  ,   16.612  },
	{ 46  , 43 ,  89, "Tc","    -",  -67844.      , 201.       , 8456.    ,   2.    , -8331.   ,  542.   ,  88.927167     ,  215.     },
	{ 45  , 44 ,  89, "Ru","    x",  -59513.      , 503.       , 8353.    ,   6.    ,-11855.   ,  673.   ,  88.936110     ,  540.     },
	{ 44  , 45 ,  89, "Rh","   -p",  -47658.      , 448.       , 8211.    ,   5.    , STAR     , STAR    ,  88.948837     ,  481.     },
	{ 57  , 33 ,  90, "As","    x",  -41451.      , 801.       , 8245.    ,   9.    , 14475.   ,  896.   ,  89.955500     ,  860.     },
	{ 56  , 34 ,  90, "Se","    x",  -55927.      , 401.       , 8397.    ,   4.    ,  8693.   ,  408.   ,  89.939960     ,  430.     },
	{ 55  , 35 ,  90, "Br","    +",  -64619.846   ,  77.249    , 8485.069 ,   0.858 , 10350.000,   75.000,  89.930627737  ,   82.930  },
	{ 54  , 36 ,  90, "Kr","    +",  -74969.846   ,  18.505    , 8591.377 ,   0.206 ,  4391.865,   17.313,  89.919516555  ,   19.866  },
	{ 53  , 37 ,  90, "Rb","     ",  -79361.712   ,   6.534    , 8631.483 ,   0.073 ,  6579.892,    6.644,  89.914801694  ,    7.014  },
	{ 52  , 38 ,  90, "Sr","     ",  -85941.604   ,   2.887    , 8695.900 ,   0.032 ,   545.858,    1.406,  89.907737888  ,    3.099  },
	{ 51  , 39 ,  90, "Y ","     ",  -86487.462   ,   2.552    , 8693.272 ,   0.028 ,  2279.804,    1.666,  89.907151886  ,    2.739  },
	{ 50  , 40 ,  90, "Zr","     ",  -88767.265   ,   2.368    , 8709.910 ,   0.026 , -6111.000,    4.000,  89.904704416  ,    2.542  },
	{ 49  , 41 ,  90, "Nb","    -",  -82656.265   ,   4.648    , 8633.318 ,   0.052 , -2489.000,    4.000,  89.911264845  ,    4.990  },
	{ 48  , 42 ,  90, "Mo","    -",  -80167.265   ,   6.133    , 8596.969 ,   0.068 , -8960.663,  242.109,  89.913936896  ,    6.583  },
	{ 47  , 43 ,  90, "Tc","    -",  -71206.603   , 242.187    , 8488.714 ,   2.691 , -5900.   ,  384.   ,  89.923556564  ,  259.998  },
	{ 46  , 44 ,  90, "Ru","    x",  -65307.      , 298.       , 8414.    ,   3.    ,-12091.   ,  585.   ,  89.929890     ,  320.     },
	{ 45  , 45 ,  90, "Rh","    x",  -53216.      , 503.       , 8271.    ,   6.    , STAR     , STAR    ,  89.942870     ,  540.     },
	{ 58  , 33 ,  91, "As","    x",  -36859.      , 904.       , 8193.    ,  10.    , 13479.   , 1034.   ,  90.960430     ,  970.     },
	{ 57  , 34 ,  91, "Se","    x",  -50338.      , 503.       , 8332.    ,   6.    , 11170.   ,  508.   ,  90.945960     ,  540.     },
	{ 56  , 35 ,  91, "Br","    +",  -61508.323   ,  72.560    , 8446.330 ,   0.797 ,  9802.000,   44.721,  90.933968095  ,   77.895  },
	{ 55  , 36 ,  91, "Kr","    +",  -71310.323   ,  57.139    , 8545.447 ,   0.628 ,  6435.000,   56.569,  90.923445215  ,   61.341  },
	{ 54  , 37 ,  91, "Rb","     ",  -77745.323   ,   8.055    , 8607.564 ,   0.089 ,  5899.956,    8.934,  90.916536958  ,    8.647  },
	{ 53  , 38 ,  91, "Sr","     ",  -83645.279   ,   4.523    , 8663.802 ,   0.050 ,  2699.752,    4.198,  90.910203095  ,    4.856  },
	{ 52  , 39 ,  91, "Y ","     ",  -86345.031   ,   2.887    , 8684.872 ,   0.032 ,  1545.371,    1.819,  90.907304791  ,    3.099  },
	{ 51  , 40 ,  91, "Zr","     ",  -87890.402   ,   2.346    , 8693.257 ,   0.026 , -1257.960,    2.958,  90.905645767  ,    2.518  },
	{ 50  , 41 ,  91, "Nb","    -",  -86632.442   ,   3.776    , 8670.836 ,   0.041 , -4428.277,   11.538,  90.906996243  ,    4.053  },
	{ 49  , 42 ,  91, "Mo","   +n",  -82204.165   ,  11.181    , 8613.577 ,   0.123 , -6220.000,  200.000,  90.911750194  ,   12.003  },
	{ 48  , 43 ,  91, "Tc","    -",  -75984.165   , 200.312    , 8536.628 ,   2.201 , -7326.   ,  617.   ,  90.918427639  ,  215.044  },
	{ 47  , 44 ,  91, "Ru","   IT",  -68658.      , 583.       , 8448.    ,   6.    , -9555.   ,  707.   ,  90.926292     ,  626.     },
	{ 46  , 45 ,  91, "Rh","    x",  -59103.      , 401.       , 8334.    ,   4.    ,-11700.   ,  400.   ,  90.936550     ,  430.     },
	{ 45  , 46 ,  91, "Pd","    -",  -47403.      , 566.       , 8197.    ,   6.    , STAR     , STAR    ,  90.949110     ,  608.     },
	{ 59  , 33 ,  92, "As","    x",  -30926.      , 904.       , 8127.    ,  10.    , 15724.   , 1082.   ,  91.966800     ,  970.     },
	{ 58  , 34 ,  92, "Se","    x",  -46649.      , 596.       , 8289.    ,   6.    ,  9931.   ,  598.   ,  91.949920     ,  640.     },
	{ 57  , 35 ,  92, "Br","    +",  -56580.144   ,  49.595    , 8388.687 ,   0.539 , 12204.904,   48.192,  91.939258714  ,   53.242  },
	{ 56  , 36 ,  92, "Kr","    +",  -68785.048   ,  11.715    , 8512.845 ,   0.127 ,  5987.000,   10.000,  91.926156210  ,   12.576  },
	{ 55  , 37 ,  92, "Rb","     ",  -74772.048   ,   6.102    , 8569.417 ,   0.066 ,  8095.654,    6.397,  91.919728900  ,    6.550  },
	{ 54  , 38 ,  92, "Sr","     ",  -82867.702   ,   3.403    , 8648.910 ,   0.037 ,  1945.625,    9.500,  91.911037858  ,    3.653  },
	{ 53  , 39 ,  92, "Y ","     ",  -84813.327   ,   9.264    , 8661.554 ,   0.101 ,  3640.555,    9.162,  91.908949143  ,    9.945  },
	{ 52  , 40 ,  92, "Zr","     ",  -88453.882   ,   2.345    , 8692.622 ,   0.025 , -2005.544,    1.794,  91.905040847  ,    2.517  },
	{ 51  , 41 ,  92, "Nb","     ",  -86448.337   ,   2.828    , 8662.318 ,   0.031 ,   356.666,    3.962,  91.907193888  ,    3.036  },
	{ 50  , 42 ,  92, "Mo","     ",  -86805.003   ,   3.804    , 8657.692 ,   0.041 , -7870.356,   25.725,  91.906810991  ,    4.083  },
	{ 49  , 43 ,  92, "Tc","    -",  -78934.648   ,  26.004    , 8563.640 ,   0.283 , -4527.   ,  299.   ,  91.915260166  ,   27.916  },
	{ 48  , 44 ,  92, "Ru","    x",  -74408.      , 298.       , 8506.    ,   3.    ,-11048.   ,  499.   ,  91.920120     ,  320.     },
	{ 47  , 45 ,  92, "Rh","    x",  -63360.      , 401.       , 8377.    ,   4.    , -7862.   ,  643.   ,  91.931980     ,  430.     },
	{ 46  , 46 ,  92, "Pd","    x",  -55498.      , 503.       , 8283.    ,   5.    , STAR     , STAR    ,  91.940420     ,  540.     },
	{ 59  , 34 ,  93, "Se","    x",  -40716.      , 801.       , 8223.    ,   9.    , 12333.   ,  855.   ,  92.956290     ,  860.     },
	{ 58  , 35 ,  93, "Br","    x",  -53049.      , 298.       , 8347.    ,   3.    , 10969.   ,  314.   ,  92.943050     ,  320.     },
	{ 57  , 36 ,  93, "Kr","    +",  -64017.525   , 100.287    , 8456.834 ,   1.078 ,  8600.000,  100.000,  92.931274357  ,  107.662  },
	{ 56  , 37 ,  93, "Rb","     ",  -72617.525   ,   7.579    , 8540.895 ,   0.081 ,  7467.082,    8.776,  92.922041876  ,    8.136  },
	{ 55  , 38 ,  93, "Sr","     ",  -80084.606   ,   7.531    , 8612.773 ,   0.081 ,  4138.554,   11.785,  92.914025634  ,    8.085  },
	{ 54  , 39 ,  93, "Y ","     ",  -84223.160   ,  10.632    , 8648.862 ,   0.114 ,  2893.879,   10.496,  92.909582713  ,   11.414  },
	{ 53  , 40 ,  93, "Zr","     ",  -87117.040   ,   2.341    , 8671.566 ,   0.025 ,    91.238,    1.583,  92.906476006  ,    2.512  },
	{ 52  , 41 ,  93, "Nb","     ",  -87208.278   ,   2.429    , 8664.135 ,   0.026 ,  -404.783,    3.511,  92.906378058  ,    2.607  },
	{ 51  , 42 ,  93, "Mo","     ",  -86803.495   ,   3.804    , 8651.370 ,   0.041 , -3200.962,    1.004,  92.906812610  ,    4.083  },
	{ 50  , 43 ,  93, "Tc","   -p",  -83602.533   ,   3.933    , 8608.539 ,   0.042 , -6337.000,   85.000,  92.910248984  ,    4.222  },
	{ 49  , 44 ,  93, "Ru","    -",  -77265.533   ,  85.091    , 8531.987 ,   0.915 , -8093.   ,  409.   ,  92.917052034  ,   91.348  },
	{ 48  , 45 ,  93, "Rh","    x",  -69173.      , 401.       , 8437.    ,   4.    , -9473.   ,  566.   ,  92.925740     ,  430.     },
	{ 47  , 46 ,  93, "Pd","    x",  -59699.      , 401.       , 8326.    ,   4.    ,-12920.   ,  718.   ,  92.935910     ,  430.     },
	{ 46  , 47 ,  93, "Ag","    x",  -46780.      , 596.       , 8179.    ,   6.    , STAR     , STAR    ,  92.949780     ,  640.     },
	{ 60  , 34 ,  94, "Se","    x",  -36803.      , 801.       , 8180.    ,   9.    , 11001.   ,  896.   ,  93.960490     ,  860.     },
	{ 59  , 35 ,  94, "Br","    x",  -47804.      , 401.       , 8289.    ,   4.    , 13339.   ,  501.   ,  93.948680     ,  430.     },
	{ 58  , 36 ,  94, "Kr","    +",  -61143.      , 300.       , 8422.    ,   3.    ,  7410.   ,  300.   ,  93.934360     ,  322.     },
	{ 57  , 37 ,  94, "Rb","     ",  -68553.352   ,   8.357    , 8492.663 ,   0.089 , 10287.079,   10.187,  93.926404946  ,    8.971  },
	{ 56  , 38 ,  94, "Sr","     ",  -78840.430   ,   7.184    , 8593.777 ,   0.076 ,  3508.069,    7.709,  93.915361312  ,    7.711  },
	{ 55  , 39 ,  94, "Y ","     ",  -82348.499   ,   7.166    , 8622.774 ,   0.076 ,  4918.338,    7.012,  93.911595245  ,    7.693  },
	{ 54  , 40 ,  94, "Zr","     ",  -87266.837   ,   2.420    , 8666.774 ,   0.026 ,  -902.335,    2.216,  93.906315192  ,    2.598  },
	{ 53  , 41 ,  94, "Nb","     ",  -86364.502   ,   2.429    , 8648.852 ,   0.026 ,  2045.206,    1.985,  93.907283888  ,    2.607  },
	{ 52  , 42 ,  94, "Mo","     ",  -88409.708   ,   1.918    , 8662.287 ,   0.020 , -4255.748,    4.069,  93.905088269  ,    2.058  },
	{ 51  , 43 ,  94, "Tc","    -",  -84153.961   ,   4.498    , 8608.690 ,   0.048 , -1586.063,   13.461,  93.909657002  ,    4.828  },
	{ 50  , 44 ,  94, "Ru","  +nn",  -82567.898   ,  12.733    , 8583.494 ,   0.135 , -9630.   ,  447.   ,  93.911359711  ,   13.669  },
	{ 49  , 45 ,  94, "Rh","   IT",  -72938.      , 447.       , 8473.    ,   5.    , -6588.   ,  600.   ,  93.921698     ,  480.     },
	{ 48  , 46 ,  94, "Pd","    x",  -66350.      , 401.       , 8394.    ,   4.    ,-13050.   ,  643.   ,  93.928770     ,  430.     },
	{ 47  , 47 ,  94, "Ag","    x",  -53300.      , 503.       , 8247.    ,   5.    , STAR     , STAR    ,  93.942780     ,  540.     },
	{ 60  , 35 ,  95, "Br","    x",  -43901.      , 503.       , 8245.    ,   5.    , 12137.   ,  643.   ,  94.952870     ,  540.     },
	{ 59  , 36 ,  95, "Kr","    x",  -56039.      , 401.       , 8365.    ,   4.    ,  9815.   ,  401.   ,  94.939840     ,  430.     },
	{ 58  , 37 ,  95, "Rb","     ",  -65853.935   ,  21.112    , 8459.813 ,   0.222 ,  9262.891,   20.936,  94.929302889  ,   22.665  },
	{ 57  , 38 ,  95, "Sr","     ",  -75116.826   ,   7.481    , 8549.082 ,   0.079 ,  6090.243,    7.800,  94.919358766  ,    8.031  },
	{ 56  , 39 ,  95, "Y ","     ",  -81207.068   ,   7.222    , 8604.954 ,   0.076 ,  4450.698,    7.055,  94.912820621  ,    7.752  },
	{ 55  , 40 ,  95, "Zr","     ",  -85657.766   ,   2.399    , 8643.569 ,   0.025 ,  1124.134,    1.834,  94.908042600  ,    2.575  },
	{ 54  , 41 ,  95, "Nb","     ",  -86781.901   ,   1.968    , 8647.166 ,   0.021 ,   925.591,    0.495,  94.906835792  ,    2.112  },
	{ 53  , 42 ,  95, "Mo","     ",  -87707.492   ,   1.916    , 8648.674 ,   0.020 , -1690.619,    5.082,  94.905842129  ,    2.057  },
	{ 52  , 43 ,  95, "Tc","     ",  -86016.873   ,   5.417    , 8622.643 ,   0.057 , -2567.053,   12.672,  94.907657084  ,    5.815  },
	{ 51  , 44 ,  95, "Ru","     ",  -83449.819   ,  11.874    , 8587.386 ,   0.125 , -5110.000,  150.000,  94.910412929  ,   12.747  },
	{ 50  , 45 ,  95, "Rh","    -",  -78339.819   , 150.469    , 8525.362 ,   1.584 , -8189.   ,  428.   ,  94.915898740  ,  161.535  },
	{ 49  , 46 ,  95, "Pd","    x",  -70151.      , 401.       , 8431.    ,   4.    ,-10051.   ,  566.   ,  94.924690     ,  430.     },
	{ 48  , 47 ,  95, "Ag","    x",  -60100.      , 401.       , 8317.    ,   4.    ,-13404.   ,  718.   ,  94.935480     ,  430.     },
	{ 47  , 48 ,  95, "Cd","    x",  -46696.      , 596.       , 8168.    ,   6.    , STAR     , STAR    ,  94.949870     ,  640.     },
	{ 61  , 35 ,  96, "Br","    x",  -38629.      , 699.       , 8188.    ,   7.    , 14401.   ,  861.   ,  95.958530     ,  750.     },
	{ 60  , 36 ,  96, "Kr","    x",  -53030.      , 503.       , 8330.    ,   5.    ,  8195.   ,  504.   ,  95.943070     ,  540.     },
	{ 59  , 37 ,  96, "Rb","     ",  -61224.644   ,  29.434    , 8407.544 ,   0.307 , 11714.315,   28.915,  95.934272637  ,   31.598  },
	{ 58  , 38 ,  96, "Sr","     ",  -72938.959   ,  27.380    , 8521.419 ,   0.285 ,  5407.750,   18.281,  95.921696802  ,   29.393  },
	{ 57  , 39 ,  96, "Y ","     ",  -78346.709   ,  23.442    , 8569.600 ,   0.244 ,  7096.082,   23.305,  95.915891343  ,   25.165  },
	{ 56  , 40 ,  96, "Zr","     ",  -85442.791   ,   2.788    , 8635.368 ,   0.029 ,   160.905,    3.882,  95.908273386  ,    2.993  },
	{ 55  , 41 ,  96, "Nb","    +",  -85603.696   ,   3.730    , 8628.895 ,   0.039 ,  3186.800,    3.200,  95.908100647  ,    4.004  },
	{ 54  , 42 ,  96, "Mo","     ",  -88790.496   ,   1.916    , 8653.941 ,   0.020 , -2973.242,    5.145,  95.904679477  ,    2.057  },
	{ 53  , 43 ,  96, "Tc","    -",  -85817.254   ,   5.490    , 8614.821 ,   0.057 ,   254.808,    9.545,  95.907871383  ,    5.893  },
	{ 52  , 44 ,  96, "Ru","     ",  -86072.062   ,   7.882    , 8609.326 ,   0.082 , -6392.653,   10.000,  95.907597835  ,    8.461  },
	{ 51  , 45 ,  96, "Rh","    -",  -79679.409   ,  12.733    , 8534.586 ,   0.133 , -3450.000,  150.000,  95.914460631  ,   13.669  },
	{ 50  , 46 ,  96, "Pd","    -",  -76229.409   , 150.539    , 8490.499 ,   1.568 ,-11658.   ,  428.   ,  95.918164359  ,  161.610  },
	{ 49  , 47 ,  96, "Ag","    x",  -64571.      , 401.       , 8361.    ,   4.    , -8467.   ,  643.   ,  95.930680     ,  430.     },
	{ 48  , 48 ,  96, "Cd","    x",  -56104.      , 503.       , 8265.    ,   5.    , STAR     , STAR    ,  95.939770     ,  540.     },
	{ 62  , 35 ,  97, "Br","    x",  -34652.      , 801.       , 8146.    ,   8.    , 13264.   ,  946.   ,  96.962800     ,  860.     },
	{ 61  , 36 ,  97, "Kr","    x",  -47916.      , 503.       , 8275.    ,   5.    , 10440.   ,  504.   ,  96.948560     ,  540.     },
	{ 60  , 37 ,  97, "Rb","     ",  -58356.314   ,  30.512    , 8374.508 ,   0.315 , 10431.794,   28.156,  96.937351916  ,   32.756  },
	{ 59  , 38 ,  97, "Sr","     ",  -68788.109   ,  19.190    , 8473.987 ,   0.198 ,  7469.584,   15.837,  96.926152923  ,   20.600  },
	{ 58  , 39 ,  97, "Y ","     ",  -76257.693   ,  11.667    , 8542.927 ,   0.120 ,  6688.952,   11.335,  96.918133995  ,   12.524  },
	{ 57  , 40 ,  97, "Zr","     ",  -82946.645   ,   2.785    , 8603.820 ,   0.029 ,  2658.998,    1.788,  96.910953109  ,    2.990  },
	{ 56  , 41 ,  97, "Nb","     ",  -85605.644   ,   2.552    , 8623.167 ,   0.026 ,  1934.798,    1.788,  96.908098556  ,    2.739  },
	{ 55  , 42 ,  97, "Mo","     ",  -87540.442   ,   1.913    , 8635.048 ,   0.020 ,  -320.334,    4.117,  96.906021465  ,    2.053  },
	{ 54  , 43 ,  97, "Tc","     ",  -87220.108   ,   4.538    , 8623.680 ,   0.047 , -1107.865,    9.443,  96.906365358  ,    4.872  },
	{ 53  , 44 ,  97, "Ru","   -n",  -86112.242   ,   8.350    , 8604.193 ,   0.086 , -3523.000,   35.355,  96.907554700  ,    8.964  },
	{ 52  , 45 ,  97, "Rh","    -",  -82589.242   ,  36.328    , 8559.808 ,   0.375 , -4790.000,  300.000,  96.911336797  ,   38.999  },
	{ 51  , 46 ,  97, "Pd","    -",  -77799.242   , 302.192    , 8502.361 ,   3.115 , -6980.000,  110.000,  96.916479073  ,  324.415  },
	{ 50  , 47 ,  97, "Ag","    -",  -70819.242   , 321.589    , 8422.337 ,   3.315 ,-10216.   ,  514.   ,  96.923972412  ,  345.240  },
	{ 49  , 48 ,  97, "Cd","    x",  -60603.      , 401.       , 8309.    ,   4.    ,-13600.   ,  718.   ,  96.934940     ,  430.     },
	{ 48  , 49 ,  97, "In","    x",  -47003.      , 596.       , 8161.    ,   6.    , STAR     , STAR    ,  96.949540     ,  640.     },
	{ 62  , 36 ,  98, "Kr","    x",  -44796.      , 596.       , 8241.    ,   6.    ,  9426.   ,  598.   ,  97.951910     ,  640.     },
	{ 61  , 37 ,  98, "Rb","     ",  -54221.644   ,  50.247    , 8329.223 ,   0.513 , 12424.019,   45.250,  97.941790668  ,   53.942  },
	{ 60  , 38 ,  98, "Sr","     ",  -66645.662   ,  26.349    , 8448.016 ,   0.269 ,  5821.758,    9.969,  97.928452934  ,   28.287  },
	{ 59  , 39 ,  98, "Y ","     ",  -72467.420   ,  24.549    , 8499.439 ,   0.250 ,  8819.505,   14.689,  97.922203020  ,   26.354  },
	{ 58  , 40 ,  98, "Zr","     ",  -81286.925   ,  19.946    , 8581.450 ,   0.204 ,  2241.622,   20.371,  97.912734892  ,   21.412  },
	{ 57  , 41 ,  98, "Nb","  -pn",  -83528.547   ,   5.725    , 8596.341 ,   0.058 ,  4583.177,    5.461,  97.910328412  ,    6.145  },
	{ 56  , 42 ,  98, "Mo","     ",  -88111.723   ,   1.913    , 8635.125 ,   0.020 , -1683.952,    3.385,  97.905408169  ,    2.054  },
	{ 55  , 43 ,  98, "Tc","     ",  -86427.771   ,   3.817    , 8609.959 ,   0.039 ,  1796.697,    7.156,  97.907215966  ,    4.097  },
	{ 54  , 44 ,  98, "Ru","     ",  -88224.469   ,   6.271    , 8620.309 ,   0.064 , -5049.653,   10.000,  97.905287132  ,    6.732  },
	{ 53  , 45 ,  98, "Rh","    -",  -83174.815   ,  11.804    , 8560.799 ,   0.120 , -1874.858,   24.521,  97.910708158  ,   12.671  },
	{ 52  , 46 ,  98, "Pd","  -pp",  -81299.957   ,  21.497    , 8533.685 ,   0.219 , -8239.343,   63.433,  97.912720902  ,   23.078  },
	{ 51  , 47 ,  98, "Ag","    -",  -73060.614   ,  66.976    , 8441.627 ,   0.683 , -5430.000,   40.000,  97.921566201  ,   71.902  },
	{ 50  , 48 ,  98, "Cd","    -",  -67630.614   ,  78.012    , 8378.235 ,   0.796 ,-13734.   ,  211.   ,  97.927395546  ,   83.749  },
	{ 49  , 49 ,  98, "In","    x",  -53896.      , 196.       , 8230.    ,   2.    , STAR     , STAR    ,  97.942140     ,  210.     },
	{ 63  , 36 ,  99, "Kr","    x",  -39495.      , 596.       , 8186.    ,   6.    , 11384.   ,  609.   ,  98.957600     ,  640.     },
	{ 62  , 37 ,  99, "Rb","     ",  -50878.870   , 125.670    , 8292.853 ,   1.269 , 11306.807,  108.907,  98.945379283  ,  134.912  },
	{ 61  , 38 ,  99, "Sr","     ",  -62185.677   ,  79.999    , 8399.161 ,   0.808 ,  8015.248,   76.801,  98.933240926  ,   85.882  },
	{ 60  , 39 ,  99, "Y ","     ",  -70200.924   ,  24.391    , 8472.220 ,   0.246 ,  7567.548,   13.983,  98.924636204  ,   26.185  },
	{ 59  , 40 ,  99, "Zr","     ",  -77768.473   ,  20.033    , 8540.758 ,   0.202 ,  4558.481,   14.979,  98.916512106  ,   21.506  },
	{ 58  , 41 ,  99, "Nb","     ",  -82326.954   ,  13.339    , 8578.900 ,   0.135 ,  3638.886,   13.305,  98.911618375  ,   14.319  },
	{ 57  , 42 ,  99, "Mo","     ",  -85965.840   ,   1.915    , 8607.754 ,   0.019 ,  1357.302,    0.959,  98.907711870  ,    2.056  },
	{ 56  , 43 ,  99, "Tc","     ",  -87323.141   ,   1.979    , 8613.562 ,   0.020 ,   293.835,    1.420,  98.906254747  ,    2.124  },
	{ 55  , 44 ,  99, "Ru","     ",  -87616.977   ,   2.011    , 8608.627 ,   0.020 , -2042.582,    6.876,  98.905939302  ,    2.158  },
	{ 54  , 45 ,  99, "Rh","     ",  -85574.394   ,   7.137    , 8580.093 ,   0.072 , -3386.659,   15.037,  98.908132104  ,    7.661  },
	{ 53  , 46 ,  99, "Pd","     ",  -82187.735   ,  15.180    , 8537.982 ,   0.153 , -5430.000,  150.000,  98.911767833  ,   16.296  },
	{ 52  , 47 ,  99, "Ag","    -",  -76757.735   , 150.766    , 8475.231 ,   1.523 , -6905.   ,  254.   ,  98.917597178  ,  161.854  },
	{ 51  , 48 ,  99, "Cd","    x",  -69853.      , 205.       , 8398.    ,   2.    , -8579.   ,  450.   ,  98.925010     ,  220.     },
	{ 50  , 49 ,  99, "In","    x",  -61274.      , 401.       , 8303.    ,   4.    ,-14075.   ,  718.   ,  98.934220     ,  430.     },
	{ 49  , 50 ,  99, "Sn","    x",  -47199.      , 596.       , 8153.    ,   6.    , STAR     , STAR    ,  98.949330     ,  640.     },
	{ 64  , 36 , 100, "Kr","    x",  -36198.      , 503.       , 8152.    ,   5.    , 10498.   ,  585.   ,  99.961140     ,  540.     },
	{ 63  , 37 , 100, "Rb","    x",  -46696.      , 298.       , 8249.    ,   3.    , 13524.   ,  324.   ,  99.949870     ,  320.     },
	{ 62  , 38 , 100, "Sr","    +",  -60219.307   , 127.217    , 8376.218 ,   1.272 ,  7075.000,  100.000,  99.935351911  ,  136.573  },
	{ 61  , 39 , 100, "Y ","    +",  -67294.307   ,  78.640    , 8439.145 ,   0.786 ,  9310.000,   70.000,  99.927756586  ,   84.423  },
	{ 60  , 40 , 100, "Zr","    +",  -76604.307   ,  35.837    , 8524.422 ,   0.358 ,  3335.000,   25.000,  99.917761889  ,   38.472  },
	{ 59  , 41 , 100, "Nb","    +",  -79939.307   ,  25.677    , 8549.948 ,   0.257 ,  6245.000,   25.000,  99.914181619  ,   27.564  },
	{ 58  , 42 , 100, "Mo","     ",  -86184.307   ,   5.855    , 8604.575 ,   0.059 ,  -168.083,    5.915,  99.907477336  ,    6.285  },
	{ 57  , 43 , 100, "Tc","   -n",  -86016.224   ,   2.217    , 8595.070 ,   0.022 ,  3202.759,    1.737,  99.907657780  ,    2.380  },
	{ 56  , 44 , 100, "Ru","     ",  -89218.984   ,   2.011    , 8619.274 ,   0.020 , -3634.759,   18.127,  99.904219476  ,    2.158  },
	{ 55  , 45 , 100, "Rh","     ",  -85584.225   ,  18.198    , 8575.103 ,   0.182 ,  -358.007,   21.276,  99.908121550  ,   19.536  },
	{ 54  , 46 , 100, "Pd","     ",  -85226.218   ,  11.256    , 8563.700 ,   0.113 , -7077.835,   76.517,  99.908505886  ,   12.083  },
	{ 53  , 47 , 100, "Ag","     ",  -78148.384   ,  77.126    , 8485.098 ,   0.771 , -3898.554,   66.587,  99.916104255  ,   82.797  },
	{ 52  , 48 , 100, "Cd","     ",  -74249.829   ,  95.269    , 8438.289 ,   0.953 ,-10080.000,  230.000,  99.920289525  ,  102.275  },
	{ 51  , 49 , 100, "In","    -",  -64169.829   , 248.950    , 8329.666 ,   2.490 , -7390.000,  660.000,  99.931110851  ,  267.259  },
	{ 50  , 50 , 100, "Sn","    -",  -56779.829   , 705.391    , 8247.942 ,   7.054 , STAR     , STAR    ,  99.939044343  ,  757.268  },
	{ 64  , 37 , 101, "Rb","    +",  -43597.231   , 166.082    , 8216.371 ,   1.644 , 11810.000,  110.000, 100.953196445  ,  178.296  },
	{ 63  , 38 , 101, "Sr","    +",  -55407.231   , 124.432    , 8325.555 ,   1.232 ,  9505.000,   80.000, 100.940517888  ,  133.583  },
	{ 62  , 39 , 101, "Y ","    +",  -64912.231   ,  95.306    , 8411.918 ,   0.944 ,  8545.000,   90.000, 100.930313850  ,  102.315  },
	{ 61  , 40 , 101, "Zr","    +",  -73457.231   ,  31.357    , 8488.776 ,   0.310 ,  5485.000,   25.000, 100.921140415  ,   33.663  },
	{ 60  , 41 , 101, "Nb","    +",  -78942.231   ,  18.928    , 8535.337 ,   0.187 ,  4569.000,   18.000, 100.915252025  ,   20.320  },
	{ 59  , 42 , 101, "Mo","   -n",  -83511.231   ,   5.856    , 8572.829 ,   0.058 ,  2824.609,   24.718, 100.910347001  ,    6.286  },
	{ 58  , 43 , 101, "Tc","    +",  -86335.840   ,  24.084    , 8593.049 ,   0.238 ,  1613.880,   24.000, 100.907314659  ,   25.855  },
	{ 57  , 44 , 101, "Ru","     ",  -87949.720   ,   2.014    , 8601.282 ,   0.020 ,  -541.699,   17.132, 100.905582087  ,    2.161  },
	{ 56  , 45 , 101, "Rh","  +nn",  -87408.021   ,  17.230    , 8588.173 ,   0.171 , -1980.000,    4.000, 100.906163625  ,   18.497  },
	{ 55  , 46 , 101, "Pd","    -",  -85428.021   ,  17.688    , 8560.823 ,   0.175 , -4203.824,  102.899, 100.908289242  ,   18.989  },
	{ 54  , 47 , 101, "Ag","    -",  -81224.197   , 104.408    , 8511.455 ,   1.034 , -5476.538,  108.998, 100.912802233  ,  112.087  },
	{ 53  , 48 , 101, "Cd","    -",  -75747.660   , 150.936    , 8449.486 ,   1.494 , -7134.   ,  334.   , 100.918681538  ,  162.036  },
	{ 52  , 49 , 101, "In","    x",  -68614.      , 298.       , 8371.    ,   3.    , -9054.   ,  422.   , 100.926340     ,  320.     },
	{ 51  , 50 , 101, "Sn","    x",  -59560.      , 298.       , 8274.    ,   3.    , STAR     , STAR    , 100.936060     ,  320.     },
	{ 65  , 37 , 102, "Rb","    x",  -38312.      , 503.       , 8163.    ,   5.    , 14765.   ,  515.   , 101.958870     ,  540.     },
	{ 64  , 38 , 102, "Sr","    +",  -53077.471   , 111.172    , 8300.222 ,   1.090 ,  8815.000,   70.000, 101.943018987  ,  119.348  },
	{ 63  , 39 , 102, "Y ","    +",  -61892.471   ,  86.367    , 8378.974 ,   0.847 ,  9850.000,   70.000, 101.933555695  ,   92.718  },
	{ 62  , 40 , 102, "Zr","    +",  -71742.471   ,  50.589    , 8467.872 ,   0.496 ,  4605.000,   30.000, 101.922981285  ,   54.309  },
	{ 61  , 41 , 102, "Nb","    +",  -76347.471   ,  40.734    , 8505.349 ,   0.399 ,  7210.000,   35.000, 101.918037614  ,   43.730  },
	{ 60  , 42 , 102, "Mo","  -nn",  -83557.471   ,  20.839    , 8568.365 ,   0.204 ,  1008.194,   22.495, 101.910297360  ,   22.372  },
	{ 59  , 43 , 102, "Tc","     ",  -84565.665   ,   9.393    , 8570.579 ,   0.092 ,  4532.378,    9.321, 101.909215019  ,   10.083  },
	{ 58  , 44 , 102, "Ru","     ",  -89098.043   ,   2.014    , 8607.344 ,   0.020 , -2323.038,    4.552, 101.904349312  ,    2.162  },
	{ 57  , 45 , 102, "Rh","     ",  -86775.004   ,   4.941    , 8576.900 ,   0.048 ,  1150.071,    4.513, 101.906843196  ,    5.304  },
	{ 56  , 46 , 102, "Pd","     ",  -87925.075   ,   2.988    , 8580.505 ,   0.029 , -5660.182,   28.104, 101.905608544  ,    3.207  },
	{ 55  , 47 , 102, "Ag","    x",  -82264.893   ,  27.945    , 8517.343 ,   0.274 , -2587.000,    8.000, 101.911685000  ,   30.000  },
	{ 54  , 48 , 102, "Cd","    -",  -79677.893   ,  29.067    , 8484.310 ,   0.285 , -8968.406,  107.851, 101.914462258  ,   31.205  },
	{ 53  , 49 , 102, "In","    -",  -70709.488   , 111.699    , 8388.714 ,   1.095 , -5780.000,   70.000, 101.924090238  ,  119.913  },
	{ 52  , 50 , 102, "Sn","    -",  -64929.488   , 131.820    , 8324.377 ,   1.292 , STAR     , STAR    , 101.930295324  ,  141.515  },
	{ 65  , 38 , 103, "Sr","    x",  -47553.      , 503.       , 8244.    ,   5.    , 11383.   ,  585.   , 102.948950     ,  540.     },
	{ 64  , 39 , 103, "Y ","    x",  -58936.      , 298.       , 8347.    ,   3.    ,  9436.   ,  317.   , 102.936730     ,  320.     },
	{ 63  , 40 , 103, "Zr","    +",  -68372.027   , 108.742    , 8431.299 ,   1.056 ,  6945.000,   85.000, 102.926599606  ,  116.739  },
	{ 62  , 41 , 103, "Nb","    +",  -75317.027   ,  67.822    , 8491.131 ,   0.658 ,  5530.000,   30.000, 102.919143842  ,   72.810  },
	{ 61  , 42 , 103, "Mo","    +",  -80847.027   ,  60.826    , 8537.225 ,   0.591 ,  3750.000,   60.000, 102.913207142  ,   65.299  },
	{ 60  , 43 , 103, "Tc","   +p",  -84597.027   ,   9.992    , 8566.037 ,   0.097 ,  2661.748,    9.899, 102.909181351  ,   10.726  },
	{ 59  , 44 , 103, "Ru","     ",  -87258.775   ,   2.018    , 8584.283 ,   0.020 ,   763.411,    2.118, 102.906323847  ,    2.166  },
	{ 58  , 45 , 103, "Rh","     ",  -88022.185   ,   2.806    , 8584.100 ,   0.027 ,  -543.075,    0.796, 102.905504292  ,    3.012  },
	{ 57  , 46 , 103, "Pd","     ",  -87479.110   ,   2.902    , 8571.231 ,   0.028 , -2687.744,   16.740, 102.906087307  ,    3.115  },
	{ 56  , 47 , 103, "Ag","     ",  -84791.366   ,  16.682    , 8537.541 ,   0.162 , -4141.912,   10.423, 102.908972720  ,   17.908  },
	{ 55  , 48 , 103, "Cd","     ",  -80649.453   ,  15.370    , 8489.733 ,   0.149 , -6050.000,   20.000, 102.913419246  ,   16.500  },
	{ 54  , 49 , 103, "In","    -",  -74599.453   ,  25.224    , 8423.399 ,   0.245 , -7625.   ,  299.   , 102.919914188  ,   27.078  },
	{ 53  , 50 , 103, "Sn","    x",  -66974.      , 298.       , 8342.    ,   3.    ,-10796.   ,  422.   , 102.928100     ,  320.     },
	{ 52  , 51 , 103, "Sb","    x",  -56178.      , 298.       , 8229.    ,   3.    , STAR     , STAR    , 102.939690     ,  320.     },
	{ 66  , 38 , 104, "Sr","    x",  -44404.      , 699.       , 8212.    ,   7.    , 10507.   ,  805.   , 103.952330     ,  750.     },
	{ 65  , 39 , 104, "Y ","    x",  -54912.      , 401.       , 8306.    ,   4.    , 11429.   ,  566.   , 103.941050     ,  430.     },
	{ 64  , 40 , 104, "Zr","    x",  -66341.      , 401.       , 8408.    ,   4.    ,  5883.   ,  414.   , 103.928780     ,  430.     },
	{ 63  , 41 , 104, "Nb","    +",  -72223.666   , 104.810    , 8457.350 ,   1.008 ,  8105.000,   90.000, 103.922464701  ,  112.518  },
	{ 62  , 42 , 104, "Mo","    +",  -80328.666   ,  53.713    , 8527.760 ,   0.516 ,  2157.500,   28.284, 103.913763625  ,   57.663  },
	{ 61  , 43 , 104, "Tc","    +",  -82486.166   ,  45.663    , 8540.983 ,   0.439 ,  5602.706,   45.555, 103.911447454  ,   49.021  },
	{ 60  , 44 , 104, "Ru","     ",  -88088.872   ,   3.137    , 8587.333 ,   0.030 , -1139.047,    3.505, 103.905432701  ,    3.367  },
	{ 59  , 45 , 104, "Rh","   -n",  -86949.825   ,   2.807    , 8568.858 ,   0.027 ,  2440.221,    4.670, 103.906655518  ,    3.013  },
	{ 58  , 46 , 104, "Pd","   +n",  -89390.045   ,   4.133    , 8584.799 ,   0.040 , -4278.653,    4.000, 103.904035834  ,    4.436  },
	{ 57  , 47 , 104, "Ag","    -",  -85111.392   ,   5.751    , 8536.135 ,   0.055 , -1136.719,   11.009, 103.908629157  ,    6.174  },
	{ 56  , 48 , 104, "Cd","     ",  -83974.674   ,   9.466    , 8517.683 ,   0.091 , -7868.047,   84.373, 103.909849475  ,   10.161  },
	{ 55  , 49 , 104, "In","     ",  -76106.627   ,  84.733    , 8434.506 ,   0.815 , -4515.000,   60.000, 103.918296171  ,   90.964  },
	{ 54  , 50 , 104, "Sn","    -",  -71591.627   , 103.825    , 8383.570 ,   0.998 ,-12415.   ,  377.   , 103.923143223  ,  111.461  },
	{ 53  , 51 , 104, "Sb","   +a",  -59176.      , 362.       , 8257.    ,   3.    , STAR     , STAR    , 103.936472     ,  389.     },
	{ 67  , 38 , 105, "Sr","    x",  -38582.      , 699.       , 8156.    ,   7.    , 12771.   ,  861.   , 104.958580     ,  750.     },
	{ 66  , 39 , 105, "Y ","    x",  -51353.      , 503.       , 8270.    ,   5.    , 11010.   ,  643.   , 104.944870     ,  540.     },
	{ 65  , 40 , 105, "Zr","    x",  -62364.      , 401.       , 8367.    ,   4.    ,  8489.   ,  413.   , 104.933050     ,  430.     },
	{ 64  , 41 , 105, "Nb","    +",  -70852.653   ,  99.799    , 8440.617 ,   0.950 ,  6485.000,   70.000, 104.923936545  ,  107.138  },
	{ 63  , 42 , 105, "Mo","    +",  -77337.653   ,  71.133    , 8494.928 ,   0.677 ,  4950.000,   45.000, 104.916974610  ,   76.363  },
	{ 62  , 43 , 105, "Tc","    +",  -82287.653   ,  55.089    , 8534.619 ,   0.525 ,  3640.000,   55.000, 104.911660566  ,   59.140  },
	{ 61  , 44 , 105, "Ru","     ",  -85927.653   ,   3.138    , 8561.835 ,   0.030 ,  1917.988,    3.486, 104.907752866  ,    3.368  },
	{ 60  , 45 , 105, "Rh","     ",  -87845.641   ,   4.027    , 8572.651 ,   0.038 ,   567.188,    2.505, 104.905693821  ,    4.323  },
	{ 59  , 46 , 105, "Pd","     ",  -88412.828   ,   4.073    , 8570.602 ,   0.039 , -1344.837,   10.596, 104.905084920  ,    4.372  },
	{ 58  , 47 , 105, "Ag","     ",  -87067.992   ,  10.982    , 8550.343 ,   0.105 , -2737.888,    4.494, 104.906528661  ,   11.789  },
	{ 57  , 48 , 105, "Cd","     ",  -84330.103   ,  11.549    , 8516.817 ,   0.110 , -4849.018,   12.978, 104.909467905  ,   12.398  },
	{ 56  , 49 , 105, "In","     ",  -79481.085   ,  17.348    , 8463.185 ,   0.165 , -6218.558,   82.430, 104.914673540  ,   18.623  },
	{ 55  , 50 , 105, "Sn","   +a",  -73262.528   ,  80.586    , 8396.509 ,   0.767 , -9442.472,  132.280, 104.921349437  ,   86.513  },
	{ 54  , 51 , 105, "Sb","   -p",  -63820.056   , 104.903    , 8299.130 ,   0.999 ,-11321.   ,  514.   , 104.931486348  ,  112.618  },
	{ 53  , 52 , 105, "Te","    x",  -52499.      , 503.       , 8184.    ,   5.    , STAR     , STAR    , 104.943640     ,  540.     },
	{ 67  , 39 , 106, "Y ","    x",  -46770.      , 699.       , 8225.    ,   7.    , 12929.   ,  861.   , 105.949790     ,  750.     },
	{ 66  , 40 , 106, "Zr","    x",  -59699.      , 503.       , 8339.    ,   5.    ,  7396.   ,  540.   , 105.935910     ,  540.     },
	{ 65  , 41 , 106, "Nb","    x",  -67096.      , 196.       , 8402.    ,   2.    ,  9160.   ,  196.   , 105.927970     ,  210.     },
	{ 64  , 42 , 106, "Mo","    +",  -76255.078   ,  17.948    , 8480.718 ,   0.169 ,  3520.000,   12.021, 105.918136802  ,   19.267  },
	{ 63  , 43 , 106, "Tc","    +",  -79775.078   ,  13.328    , 8506.545 ,   0.126 ,  6547.000,   11.000, 105.914357927  ,   14.308  },
	{ 62  , 44 , 106, "Ru","    +",  -86322.078   ,   7.525    , 8560.929 ,   0.071 ,    39.400,    0.212, 105.907329433  ,    8.078  },
	{ 61  , 45 , 106, "Rh","    +",  -86361.478   ,   7.522    , 8553.920 ,   0.071 ,  3541.000,    6.325, 105.907287135  ,    8.075  },
	{ 60  , 46 , 106, "Pd","     ",  -89902.478   ,   4.073    , 8579.945 ,   0.038 , -2965.138,    2.819, 105.903485715  ,    4.372  },
	{ 59  , 47 , 106, "Ag","     ",  -86937.340   ,   4.913    , 8544.591 ,   0.046 ,   195.159,    7.606, 105.906668921  ,    5.274  },
	{ 58  , 48 , 106, "Cd","     ",  -87132.499   ,   5.931    , 8539.052 ,   0.056 , -6526.048,   11.281, 105.906459410  ,    6.367  },
	{ 57  , 49 , 106, "In","     ",  -80606.451   ,  12.333    , 8470.105 ,   0.116 , -3181.246,   49.038, 105.913465411  ,   13.240  },
	{ 56  , 50 , 106, "Sn","     ",  -77425.204   ,  50.288    , 8432.712 ,   0.474 ,-11095.   ,  317.   , 105.916880620  ,   53.986  },
	{ 55  , 51 , 106, "Sb","   +a",  -66330.      , 313.       , 8321.    ,   3.    , -8116.   ,  340.   , 105.928791     ,  336.     },
	{ 54  , 52 , 106, "Te","   -a",  -58214.429   , 132.152    , 8236.717 ,   1.247 , STAR     , STAR    , 105.937504237  ,  141.870  },
	{ 68  , 39 , 107, "Y ","    x",  -42718.      , 503.       , 8185.    ,   5.    , 12473.   ,  585.   , 106.954140     ,  540.     },
	{ 67  , 40 , 107, "Zr","    x",  -55191.      , 298.       , 8295.    ,   3.    ,  9725.   ,  499.   , 106.940750     ,  320.     },
	{ 66  , 41 , 107, "Nb","    x",  -64916.      , 401.       , 8378.    ,   4.    ,  8027.   ,  432.   , 106.930310     ,  430.     },
	{ 65  , 42 , 107, "Mo","    +",  -72942.869   , 161.627    , 8445.937 ,   1.511 ,  6160.000,   60.000, 106.921692604  ,  173.513  },
	{ 64  , 43 , 107, "Tc","    +",  -79102.869   , 150.077    , 8496.195 ,   1.403 ,  4820.000,   85.000, 106.915079572  ,  161.114  },
	{ 63  , 44 , 107, "Ru","    +",  -83922.869   , 123.686    , 8533.930 ,   1.156 ,  2940.416,  123.109, 106.909905089  ,  132.782  },
	{ 62  , 45 , 107, "Rh","     ",  -86863.285   ,  11.929    , 8554.099 ,   0.111 ,  1504.308,   12.453, 106.906748423  ,   12.805  },
	{ 61  , 46 , 107, "Pd","     ",  -88367.594   ,   4.083    , 8560.847 ,   0.038 ,    34.150,    2.715, 106.905133481  ,    4.383  },
	{ 60  , 47 , 107, "Ag","     ",  -88401.743   ,   4.271    , 8553.854 ,   0.040 , -1416.903,    3.966, 106.905096820  ,    4.584  },
	{ 59  , 48 , 107, "Cd","     ",  -86984.841   ,   5.773    , 8533.300 ,   0.054 , -3425.264,   10.265, 106.906617928  ,    6.197  },
	{ 58  , 49 , 107, "In","     ",  -83559.577   ,  11.391    , 8493.977 ,   0.106 , -4982.775,   84.204, 106.910295100  ,   12.228  },
	{ 57  , 50 , 107, "Sn","     ",  -78576.801   ,  83.434    , 8440.097 ,   0.780 , -7923.   ,  310.   , 106.915644329  ,   89.570  },
	{ 56  , 51 , 107, "Sb","    x",  -70654.      , 298.       , 8359.    ,   3.    ,-10113.   ,  422.   , 106.924150     ,  320.     },
	{ 55  , 52 , 107, "Te","   -a",  -60541.      , 298.       , 8257.    ,   3.    , STAR     , STAR    , 106.935006     ,  320.     },
	{ 69  , 39 , 108, "Y ","    x",  -37744.      , 801.       , 8138.    ,   7.    , 14457.   ,  999.   , 107.959480     ,  860.     },
	{ 68  , 40 , 108, "Zr","    x",  -52201.      , 596.       , 8265.    ,   6.    ,  8495.   ,  667.   , 107.943960     ,  640.     },
	{ 67  , 41 , 108, "Nb","    x",  -60696.      , 298.       , 8336.    ,   3.    , 10607.   ,  357.   , 107.934840     ,  320.     },
	{ 66  , 42 , 108, "Mo","    +",  -71303.      , 196.       , 8427.    ,   2.    ,  4650.   ,  150.   , 107.923453     ,  211.     },
	{ 65  , 43 , 108, "Tc","    +",  -75952.879   , 126.467    , 8463.095 ,   1.171 ,  7720.000,   50.000, 107.918461226  ,  135.767  },
	{ 64  , 44 , 108, "Ru","    +",  -83672.879   , 116.163    , 8527.332 ,   1.076 ,  1346.426,   49.568, 107.910173465  ,  124.706  },
	{ 63  , 45 , 108, "Rh","    +",  -85019.304   , 105.056    , 8532.555 ,   0.973 ,  4505.000,  105.000, 107.908728018  ,  112.782  },
	{ 62  , 46 , 108, "Pd","     ",  -89524.304   ,   3.442    , 8567.024 ,   0.032 , -1922.468,    5.349, 107.903891701  ,    3.695  },
	{ 61  , 47 , 108, "Ag","   -n",  -87601.836   ,   4.274    , 8541.980 ,   0.040 ,  1650.489,    6.966, 107.905955556  ,    4.588  },
	{ 60  , 48 , 108, "Cd","     ",  -89252.325   ,   5.566    , 8550.018 ,   0.052 , -5136.721,    8.509, 107.904183683  ,    5.974  },
	{ 59  , 49 , 108, "In","     ",  -84115.603   ,   9.749    , 8495.212 ,   0.090 , -2074.621,   19.469, 107.909698180  ,   10.466  },
	{ 58  , 50 , 108, "Sn","     ",  -82040.983   ,  19.854    , 8468.758 ,   0.184 , -9533.   ,  206.   , 107.911925378  ,   21.314  },
	{ 57  , 51 , 108, "Sb","    x",  -72507.      , 205.       , 8373.    ,   2.    , -6786.   ,  230.   , 107.922160     ,  220.     },
	{ 56  , 52 , 108, "Te","   -a",  -65721.935   , 103.908    , 8303.168 ,   0.962 ,-13070.   ,  374.   , 107.929444597  ,  111.550  },
	{ 55  , 53 , 108, "I ","   -p",  -52652.      , 359.       , 8175.    ,   3.    , STAR     , STAR    , 107.943475     ,  385.     },
	{ 69  , 40 , 109, "Zr","    x",  -47283.      , 503.       , 8218.    ,   5.    , 10815.   ,  711.   , 108.949240     ,  540.     },
	{ 68  , 41 , 109, "Nb","    x",  -58097.      , 503.       , 8310.    ,   5.    ,  9147.   ,  585.   , 108.937630     ,  540.     },
	{ 67  , 42 , 109, "Mo","    x",  -67245.      , 298.       , 8387.    ,   3.    ,  7291.   ,  313.   , 108.927810     ,  320.     },
	{ 66  , 43 , 109, "Tc","    +",  -74535.668   ,  96.272    , 8446.498 ,   0.883 ,  6315.000,   70.000, 108.919982665  ,  103.351  },
	{ 65  , 44 , 109, "Ru","    +",  -80850.668   ,  66.093    , 8497.257 ,   0.606 ,  4160.000,   65.000, 108.913203233  ,   70.953  },
	{ 64  , 45 , 109, "Rh","   +p",  -85010.668   ,  11.968    , 8528.244 ,   0.110 ,  2595.923,   11.844, 108.908737289  ,   12.847  },
	{ 63  , 46 , 109, "Pd","     ",  -87606.591   ,   3.440    , 8544.883 ,   0.032 ,  1116.078,    1.971, 108.905950451  ,    3.692  },
	{ 62  , 47 , 109, "Ag","     ",  -88722.669   ,   2.900    , 8547.944 ,   0.027 ,  -214.245,    2.913, 108.904752292  ,    3.113  },
	{ 61  , 48 , 109, "Cd","     ",  -88508.424   ,   3.896    , 8538.801 ,   0.036 , -2019.678,    5.831, 108.904982293  ,    4.182  },
	{ 60  , 49 , 109, "In","     ",  -86488.746   ,   5.828    , 8513.095 ,   0.053 , -3849.592,   11.140, 108.907150507  ,    6.256  },
	{ 59  , 50 , 109, "Sn","  +3n",  -82639.154   ,   9.967    , 8470.600 ,   0.091 , -6380.000,   16.000, 108.911283214  ,   10.700  },
	{ 58  , 51 , 109, "Sb","    -",  -76259.154   ,  18.851    , 8404.890 ,   0.173 , -8647.142,   65.956, 108.918132426  ,   20.236  },
	{ 57  , 52 , 109, "Te","   ep",  -67612.012   ,  63.199    , 8318.381 ,   0.580 , -9998.565,  121.630, 108.927415515  ,   67.847  },
	{ 56  , 53 , 109, "I ","   -p",  -57613.447   , 103.925    , 8219.474 ,   0.953 , STAR     , STAR    , 108.938149417  ,  111.568  },
	{ 70  , 40 , 110, "Zr","    x",  -43901.      , 801.       , 8186.    ,   7.    ,  9715.   ,  946.   , 109.952870     ,  860.     },
	{ 69  , 41 , 110, "Nb","    x",  -53617.      , 503.       , 8267.    ,   5.    , 11839.   ,  643.   , 109.942440     ,  540.     },
	{ 68  , 42 , 110, "Mo","    x",  -65456.      , 401.       , 8368.    ,   4.    ,  5505.   ,  408.   , 109.929730     ,  430.     },
	{ 67  , 43 , 110, "Tc","    +",  -70960.763   ,  76.550    , 8410.589 ,   0.696 ,  9021.000,   55.000, 109.923820483  ,   82.179  },
	{ 66  , 44 , 110, "Ru","     ",  -79981.763   ,  53.244    , 8485.485 ,   0.484 ,  2794.138,   44.211, 109.914136041  ,   57.159  },
	{ 65  , 45 , 110, "Rh","     ",  -82775.901   ,  50.445    , 8503.774 ,   0.459 ,  5573.274,   51.019, 109.911136411  ,   54.155  },
	{ 64  , 46 , 110, "Pd","     ",  -88349.175   ,  10.873    , 8547.328 ,   0.099 ,  -888.623,   10.745, 109.905153254  ,   11.672  },
	{ 63  , 47 , 110, "Ag","     ",  -87460.552   ,   2.899    , 8532.138 ,   0.026 ,  2892.439,    1.614, 109.906107231  ,    3.112  },
	{ 62  , 48 , 110, "Cd","     ",  -90352.990   ,   2.665    , 8551.320 ,   0.024 , -3878.000,   11.547, 109.903002070  ,    2.860  },
	{ 61  , 49 , 110, "In","    -",  -86474.990   ,  11.850    , 8508.954 ,   0.108 ,  -631.103,   18.173, 109.907165274  ,   12.722  },
	{ 60  , 50 , 110, "Sn","    x",  -85843.888   ,  13.777    , 8496.104 ,   0.125 , -8300.   ,  200.   , 109.907842791  ,   14.790  },
	{ 59  , 51 , 110, "Sb","    -",  -77544.      , 200.       , 8414.    ,   2.    , -5267.   ,  207.   , 109.916753     ,  215.     },
	{ 58  , 52 , 110, "Te","   -a",  -72277.120   ,  52.642    , 8358.545 ,   0.479 ,-11956.   ,  313.   , 109.922407316  ,   56.513  },
	{ 57  , 53 , 110, "I ","   +a",  -60321.      , 309.       , 8243.    ,   3.    , -8417.   ,  336.   , 109.935242     ,  332.     },
	{ 56  , 54 , 110, "Xe","   -a",  -51904.646   , 132.883    , 8159.116 ,   1.208 , STAR     , STAR    , 109.944278068  ,  142.656  },
	{ 70  , 41 , 111, "Nb","    x",  -50627.      , 503.       , 8238.    ,   5.    , 10470.   ,  643.   , 110.945650     ,  540.     },
	{ 69  , 42 , 111, "Mo","    x",  -61097.      , 401.       , 8326.    ,   4.    ,  8120.   ,  415.   , 110.934410     ,  430.     },
	{ 68  , 43 , 111, "Tc","    +",  -69216.683   , 108.698    , 8391.820 ,   0.979 ,  7449.000,   80.000, 110.925692830  ,  116.691  },
	{ 67  , 44 , 111, "Ru","    x",  -76665.683   ,  73.588    , 8451.880 ,   0.663 ,  5691.509,   79.323, 110.917696000  ,   79.000  },
	{ 66  , 45 , 111, "Rh","    +",  -82357.192   ,  29.613    , 8496.106 ,   0.267 ,  3646.966,   27.542, 110.911585913  ,   31.791  },
	{ 65  , 46 , 111, "Pd","   -n",  -86004.158   ,  10.880    , 8521.914 ,   0.098 ,  2216.561,   10.860, 110.907670734  ,   11.680  },
	{ 64  , 47 , 111, "Ag","    +",  -88220.719   ,   3.015    , 8534.834 ,   0.027 ,  1036.800,    1.414, 110.905291157  ,    3.236  },
	{ 63  , 48 , 111, "Cd","     ",  -89257.519   ,   2.662    , 8537.127 ,   0.024 ,  -861.791,    4.636, 110.904178107  ,    2.858  },
	{ 62  , 49 , 111, "In","     ",  -88395.728   ,   4.828    , 8522.315 ,   0.043 , -2450.930,    7.182, 110.905103278  ,    5.183  },
	{ 61  , 50 , 111, "Sn","   +n",  -85944.797   ,   6.836    , 8493.186 ,   0.062 , -5056.652,   28.769, 110.907734460  ,    7.339  },
	{ 60  , 51 , 111, "Sb","    x",  -80888.145   ,  27.945    , 8440.583 ,   0.252 , -7403.228,   76.621, 110.913163000  ,   30.000  },
	{ 59  , 52 , 111, "Te","   ep",  -73484.917   ,  71.343    , 8366.839 ,   0.643 , -8538.   ,  311.   , 110.921110692  ,   76.589  },
	{ 58  , 53 , 111, "I ","   -a",  -64947.      , 302.       , 8283.    ,   3.    ,-10550.   ,  427.   , 110.930276     ,  324.     },
	{ 57  , 54 , 111, "Xe","   -a",  -54397.      , 302.       , 8181.    ,   3.    , STAR     , STAR    , 110.941602     ,  325.     },
	{ 71  , 41 , 112, "Nb","    x",  -45802.      , 699.       , 8194.    ,   6.    , 13032.   ,  918.   , 111.950830     ,  750.     },
	{ 70  , 42 , 112, "Mo","    x",  -58833.      , 596.       , 8303.    ,   5.    ,  7166.   ,  609.   , 111.936840     ,  640.     },
	{ 69  , 43 , 112, "Tc","    +",  -65999.617   , 124.158    , 8360.234 ,   1.109 ,  9484.000,  100.000, 111.929146493  ,  133.289  },
	{ 68  , 44 , 112, "Ru","    x",  -75483.617   ,  73.588    , 8437.928 ,   0.657 ,  4257.710,   89.881, 111.918965000  ,   79.000  },
	{ 67  , 45 , 112, "Rh","    +",  -79741.327   ,  51.609    , 8468.958 ,   0.461 ,  6595.072,   48.388, 111.914394159  ,   55.404  },
	{ 66  , 46 , 112, "Pd","     ",  -86336.399   ,  17.947    , 8520.857 ,   0.160 ,   288.060,   16.719, 111.907314058  ,   19.267  },
	{ 65  , 47 , 112, "Ag","     ",  -86624.458   ,  16.884    , 8516.444 ,   0.151 ,  3956.060,   16.719, 111.907004814  ,   18.125  },
	{ 64  , 48 , 112, "Cd","     ",  -90580.518   ,   2.659    , 8544.780 ,   0.024 , -2584.451,    4.736, 111.902757809  ,    2.854  },
	{ 63  , 49 , 112, "In","     ",  -87996.067   ,   5.126    , 8514.720 ,   0.046 ,   665.202,    4.736, 111.905532331  ,    5.502  },
	{ 62  , 50 , 112, "Sn","     ",  -88661.269   ,   4.283    , 8513.674 ,   0.038 , -7060.540,   18.337, 111.904818207  ,    4.598  },
	{ 61  , 51 , 112, "Sb","    x",  -81600.729   ,  17.829    , 8443.648 ,   0.159 , -4299.462,  171.208, 111.912398009  ,   19.140  },
	{ 60  , 52 , 112, "Te"," 2p-n",  -77301.267   , 170.277    , 8398.275 ,   1.520 ,-10206.   ,  271.   , 111.917013672  ,  182.799  },
	{ 59  , 53 , 112, "I ","   -a",  -67096.      , 211.       , 8300.    ,   2.    , -7129.   ,  235.   , 111.927970     ,  226.     },
	{ 58  , 54 , 112, "Xe","   -a",  -59966.685   , 104.097    , 8229.531 ,   0.929 ,-13673.   ,  320.   , 111.935623112  ,  111.753  },
	{ 57  , 55 , 112, "Cs","   -p",  -46294.      , 302.       , 8100.    ,   3.    , STAR     , STAR    , 111.950301     ,  325.     },
	{ 72  , 41 , 113, "Nb","    x",  -42197.      , 801.       , 8161.    ,   7.    , 11942.   ,  999.   , 112.954700     ,  860.     },
	{ 71  , 42 , 113, "Mo","    x",  -54138.      , 596.       , 8260.    ,   5.    ,  9585.   ,  667.   , 112.941880     ,  640.     },
	{ 70  , 43 , 113, "Tc","    x",  -63724.      , 298.       , 8338.    ,   3.    ,  8479.   ,  306.   , 112.931590     ,  320.     },
	{ 69  , 44 , 113, "Ru","    +",  -72202.714   ,  69.997    , 8405.649 ,   0.619 ,  6480.000,   50.000, 112.922487194  ,   75.145  },
	{ 68  , 45 , 113, "Rh","     ",  -78682.714   ,  48.986    , 8456.070 ,   0.434 ,  5009.314,   43.292, 112.915530627  ,   52.588  },
	{ 67  , 46 , 113, "Pd","     ",  -83692.028   ,  35.792    , 8493.477 ,   0.317 ,  3340.644,   32.783, 112.910152908  ,   38.423  },
	{ 66  , 47 , 113, "Ag","     ",  -87032.672   ,  16.613    , 8516.117 ,   0.147 ,  2016.607,   16.409, 112.906566579  ,   17.834  },
	{ 65  , 48 , 113, "Cd","     ",  -89049.279   ,   2.673    , 8527.040 ,   0.024 ,   320.341,    3.269, 112.904401662  ,    2.869  },
	{ 64  , 49 , 113, "In","     ",  -89369.620   ,   3.212    , 8522.951 ,   0.028 , -1036.581,    2.733, 112.904057761  ,    3.448  },
	{ 63  , 50 , 113, "Sn","     ",  -88333.039   ,   4.017    , 8506.854 ,   0.036 , -3913.295,   17.121, 112.905170577  ,    4.312  },
	{ 62  , 51 , 113, "Sb","    -",  -84419.744   ,  17.586    , 8465.300 ,   0.156 , -6072.714,   33.018, 112.909371672  ,   18.878  },
	{ 61  , 52 , 113, "Te","    x",  -78347.030   ,  27.945    , 8404.636 ,   0.247 , -7218.691,   60.301, 112.915891000  ,   30.000  },
	{ 60  , 53 , 113, "I ","   -a",  -71128.339   ,  53.435    , 8333.830 ,   0.473 , -9036.042,   96.697, 112.923640583  ,   57.365  },
	{ 59  , 54 , 113, "Xe","   -a",  -62092.297   ,  80.586    , 8246.942 ,   0.713 ,-10388.114,  131.667, 112.933341174  ,   86.513  },
	{ 58  , 55 , 113, "Cs","   -p",  -51704.182   , 104.129    , 8148.088 ,   0.921 , STAR     , STAR    , 112.944493274  ,  111.786  },
	{ 72  , 42 , 114, "Mo","    x",  -51307.      , 699.       , 8233.    ,   6.    ,  8421.   ,  918.   , 113.944920     ,  750.     },
	{ 71  , 43 , 114, "Tc","    x",  -59727.      , 596.       , 8300.    ,   5.    , 10804.   ,  639.   , 113.935880     ,  640.     },
	{ 70  , 44 , 114, "Ru","    +",  -70532.      , 230.       , 8388.    ,   2.    ,  5100.   ,  200.   , 113.924281     ,  246.     },
	{ 69  , 45 , 114, "Rh","    x",  -75631.725   , 112.711    , 8425.932 ,   0.989 ,  7864.941,  115.162, 113.918806000  ,  121.000  },
	{ 68  , 46 , 114, "Pd","     ",  -83496.665   ,  23.634    , 8488.060 ,   0.207 ,  1452.137,   17.694, 113.910362638  ,   25.372  },
	{ 67  , 47 , 114, "Ag","     ",  -84948.803   ,  24.824    , 8493.936 ,   0.218 ,  5072.138,   24.692, 113.908803704  ,   26.649  },
	{ 66  , 48 , 114, "Cd","     ",  -90020.941   ,   2.674    , 8531.565 ,   0.023 , -1448.786,    3.266, 113.903358540  ,    2.870  },
	{ 65  , 49 , 114, "In","     ",  -88572.155   ,   3.205    , 8511.994 ,   0.028 ,  1988.746,    0.660, 113.904913876  ,    3.440  },
	{ 64  , 50 , 114, "Sn","     ",  -90560.901   ,   3.172    , 8522.576 ,   0.028 , -6045.518,   28.124, 113.902778869  ,    3.405  },
	{ 63  , 51 , 114, "Sb","    x",  -84515.383   ,  27.945    , 8462.683 ,   0.245 , -2626.813,   39.520, 113.909269000  ,   30.000  },
	{ 62  , 52 , 114, "Te","    x",  -81888.570   ,  27.945    , 8432.778 ,   0.245 , -9092.   ,  299.   , 113.912089000  ,   30.000  },
	{ 61  , 53 , 114, "I ","    x",  -72796.      , 298.       , 8346.    ,   3.    , -5710.   ,  298.   , 113.921850     ,  320.     },
	{ 60  , 54 , 114, "Xe","    x",  -67085.913   ,  11.178    , 8289.205 ,   0.098 ,-12547.   ,  305.   , 113.927980306  ,   12.000  },
	{ 59  , 55 , 114, "Cs","   ep",  -54539.      , 305.       , 8172.    ,   3.    , -8594.   ,  335.   , 113.941450     ,  327.     },
	{ 58  , 56 , 114, "Ba","   -a",  -45945.564   , 139.200    , 8090.038 ,   1.221 , STAR     , STAR    , 113.950675405  ,  149.437  },
	{ 73  , 42 , 115, "Mo","    x",  -46305.      , 801.       , 8188.    ,   7.    , 10805.   , 1063.   , 114.950290     ,  860.     },
	{ 72  , 43 , 115, "Tc","    x",  -57110.      , 699.       , 8275.    ,   6.    ,  9319.   ,  710.   , 114.938690     ,  750.     },
	{ 71  , 44 , 115, "Ru","    +",  -66428.402   , 128.715    , 8349.623 ,   1.119 ,  7780.000,  100.000, 114.928686173  ,  138.180  },
	{ 70  , 45 , 115, "Rh","    x",  -74208.402   ,  81.040    , 8410.472 ,   0.705 ,  6194.598,  101.425, 114.920334000  ,   87.000  },
	{ 69  , 46 , 115, "Pd","    +",  -80403.000   ,  60.988    , 8457.535 ,   0.530 ,  4584.000,   50.000, 114.913683824  ,   65.473  },
	{ 68  , 47 , 115, "Ag","    +",  -84987.000   ,  34.922    , 8490.593 ,   0.304 ,  3103.485,   34.816, 114.908762698  ,   37.490  },
	{ 67  , 48 , 115, "Cd","     ",  -88090.485   ,   2.724    , 8510.777 ,   0.024 ,  1446.131,    4.235, 114.905430969  ,    2.923  },
	{ 66  , 49 , 115, "In","     ",  -89536.616   ,   4.463    , 8516.549 ,   0.039 ,   499.361,    4.061, 114.903878484  ,    4.791  },
	{ 65  , 50 , 115, "Sn","     ",  -90035.978   ,   2.944    , 8514.088 ,   0.026 , -3032.574,   16.293, 114.903342397  ,    3.160  },
	{ 64  , 51 , 115, "Sb","    x",  -87003.403   ,  16.025    , 8480.915 ,   0.139 , -4940.644,   32.214, 114.906598000  ,   17.203  },
	{ 63  , 52 , 115, "Te","    x",  -82062.759   ,  27.945    , 8431.150 ,   0.243 , -5724.962,   40.184, 114.911902000  ,   30.000  },
	{ 62  , 53 , 115, "I ","    x",  -76337.797   ,  28.876    , 8374.564 ,   0.251 , -7681.026,   31.313, 114.918048000  ,   31.000  },
	{ 61  , 54 , 115, "Xe","    x",  -68656.771   ,  12.109    , 8300.970 ,   0.105 , -8957.   ,  298.   , 114.926293920  ,   13.000  },
	{ 60  , 55 , 115, "Cs","    x",  -59699.      , 298.       , 8216.    ,   3.    ,-10675.   ,  667.   , 114.935910     ,  320.     },
	{ 59  , 56 , 115, "Ba","    x",  -49025.      , 596.       , 8117.    ,   5.    , STAR     , STAR    , 114.947370     ,  640.     },
	{ 73  , 43 , 116, "Tc","    x",  -52751.      , 699.       , 8236.    ,   6.    , 11700.   ,  988.   , 115.943370     ,  750.     },
	{ 72  , 44 , 116, "Ru","    x",  -64450.      , 699.       , 8330.    ,   6.    ,  6286.   ,  712.   , 115.930810     ,  750.     },
	{ 71  , 45 , 116, "Rh","    x",  -70735.792   , 137.861    , 8377.612 ,   1.188 ,  9224.899,  148.639, 115.924062000  ,  148.000  },
	{ 70  , 46 , 116, "Pd","    +",  -79960.691   ,  55.568    , 8450.393 ,   0.479 ,  2607.000,   30.000, 115.914158662  ,   59.654  },
	{ 69  , 47 , 116, "Ag","    +",  -82567.691   ,  46.773    , 8466.122 ,   0.403 ,  6151.701,   46.667, 115.911359933  ,   50.213  },
	{ 68  , 48 , 116, "Cd","     ",  -88719.392   ,   3.150    , 8512.410 ,   0.027 ,  -469.373,    4.634, 115.904755809  ,    3.381  },
	{ 67  , 49 , 116, "In","   -n",  -88250.019   ,   4.468    , 8501.619 ,   0.039 ,  3278.088,    4.068, 115.905259703  ,    4.797  },
	{ 66  , 50 , 116, "Sn","     ",  -91528.107   ,   2.943    , 8523.134 ,   0.025 , -4706.932,    5.141, 115.901740530  ,    3.159  },
	{ 65  , 51 , 116, "Sb","     ",  -86821.176   ,   5.840    , 8475.813 ,   0.050 , -1552.214,   28.549, 115.906793629  ,    6.269  },
	{ 64  , 52 , 116, "Te","    x",  -85268.962   ,  27.945    , 8455.687 ,   0.241 , -7776.702,  100.553, 115.908460000  ,   30.000  },
	{ 63  , 53 , 116, "I ","    +",  -77492.260   ,  96.592    , 8381.902 ,   0.833 , -4445.512,   95.707, 115.916808633  ,  103.695  },
	{ 62  , 54 , 116, "Xe","    x",  -73046.747   ,  13.041    , 8336.835 ,   0.112 ,-10979.   ,  102.   , 115.921581087  ,   14.000  },
	{ 61  , 55 , 116, "Cs","   -p",  -62068.      , 101.       , 8235.    ,   1.    , -7464.   ,  413.   , 115.933367     ,  108.     },
	{ 60  , 56 , 116, "Ba","    x",  -54604.      , 401.       , 8164.    ,   3.    , STAR     , STAR    , 115.941380     ,  430.     },
	{ 74  , 43 , 117, "Tc","    x",  -49854.      , 699.       , 8210.    ,   6.    , 10153.   ,  988.   , 116.946480     ,  750.     },
	{ 73  , 44 , 117, "Ru","    x",  -60007.      , 699.       , 8290.    ,   6.    ,  8942.   ,  861.   , 116.935580     ,  750.     },
	{ 72  , 45 , 117, "Rh","    x",  -68949.      , 503.       , 8360.    ,   4.    ,  7581.   ,  507.   , 116.925980     ,  540.     },
	{ 71  , 46 , 117, "Pd","    +",  -76530.301   ,  59.455    , 8417.833 ,   0.508 ,  5735.000,   32.000, 116.917841338  ,   63.827  },
	{ 70  , 47 , 117, "Ag","    +",  -82265.301   ,  50.109    , 8460.163 ,   0.428 ,  4160.000,   50.000, 116.911684562  ,   53.794  },
	{ 69  , 48 , 117, "Cd","   -n",  -86425.301   ,   3.305    , 8489.032 ,   0.028 ,  2519.741,    6.197, 116.907218618  ,    3.548  },
	{ 68  , 49 , 117, "In","     ",  -88945.042   ,   5.668    , 8503.882 ,   0.048 ,  1454.908,    4.863, 116.904513564  ,    6.085  },
	{ 67  , 50 , 117, "Sn","     ",  -90399.950   ,   2.922    , 8509.630 ,   0.025 , -1755.200,    8.953, 116.902951656  ,    3.136  },
	{ 66  , 51 , 117, "Sb","     ",  -88644.750   ,   9.413    , 8487.942 ,   0.080 , -3547.854,   16.386, 116.904835941  ,   10.104  },
	{ 65  , 52 , 117, "Te","    x",  -85096.897   ,  13.412    , 8450.931 ,   0.115 , -4662.389,   30.997, 116.908644719  ,   14.398  },
	{ 64  , 53 , 117, "I ","    x",  -80434.508   ,  27.945    , 8404.395 ,   0.239 , -6249.147,   29.810, 116.913650000  ,   30.000  },
	{ 63  , 54 , 117, "Xe","    x",  -74185.361   ,  10.378    , 8344.297 ,   0.089 , -7742.546,   63.267, 116.920358735  ,   11.141  },
	{ 62  , 55 , 117, "Cs","     ",  -66442.814   ,  62.410    , 8271.435 ,   0.533 , -9155.   ,  307.   , 116.928670701  ,   67.000  },
	{ 61  , 56 , 117, "Ba","   ep",  -57288.      , 300.       , 8186.    ,   3.    ,-10776.   ,  501.   , 116.938499     ,  322.     },
	{ 60  , 57 , 117, "La","   -p",  -46512.      , 401.       , 8088.    ,   3.    , STAR     , STAR    , 116.950068     ,  430.     },
	{ 75  , 43 , 118, "Tc","    x",  -45196.      , 904.       , 8169.    ,   8.    , 12724.   , 1208.   , 117.951480     ,  970.     },
	{ 74  , 44 , 118, "Ru","    x",  -57920.      , 801.       , 8270.    ,   7.    ,  7219.   ,  946.   , 117.937820     ,  860.     },
	{ 73  , 45 , 118, "Rh","    x",  -65139.      , 503.       , 8325.    ,   4.    , 10326.   ,  545.   , 117.930070     ,  540.     },
	{ 72  , 46 , 118, "Pd","    +",  -75465.639   , 209.931    , 8405.874 ,   1.779 ,  4100.000,  200.000, 117.918984300  ,  225.370  },
	{ 71  , 47 , 118, "Ag","    +",  -79565.639   ,  63.806    , 8433.990 ,   0.541 ,  7142.918,   60.508, 117.914582768  ,   68.498  },
	{ 70  , 48 , 118, "Cd","  -nn",  -86708.557   ,  20.247    , 8487.893 ,   0.172 ,   521.789,   21.759, 117.906914530  ,   21.735  },
	{ 69  , 49 , 118, "In","     ",  -87230.346   ,   8.250    , 8485.685 ,   0.070 ,  4425.714,    7.787, 117.906354367  ,    8.856  },
	{ 68  , 50 , 118, "Sn","     ",  -91656.060   ,   2.888    , 8516.561 ,   0.024 , -3656.639,    2.975, 117.901603167  ,    3.100  },
	{ 67  , 51 , 118, "Sb","    -",  -87999.420   ,   4.146    , 8478.942 ,   0.035 ,  -278.377,   15.289, 117.905528731  ,    4.450  },
	{ 66  , 52 , 118, "Te","  +nn",  -87721.044   ,  14.770    , 8469.953 ,   0.125 , -6749.995,   24.670, 117.905827581  ,   15.856  },
	{ 65  , 53 , 118, "I ","    x",  -80971.048   ,  19.760    , 8406.119 ,   0.167 , -2891.968,   22.320, 117.913074000  ,   21.213  },
	{ 64  , 54 , 118, "Xe","    x",  -78079.081   ,  10.378    , 8374.981 ,   0.088 , -9669.690,   16.442, 117.916178655  ,   11.141  },
	{ 63  , 55 , 118, "Cs","     ",  -68409.391   ,  12.753    , 8286.405 ,   0.108 , -6037.   ,  196.   , 117.926559494  ,   13.690  },
	{ 62  , 56 , 118, "Ba","    x",  -62373.      , 196.       , 8229.    ,   2.    ,-12752.   ,  357.   , 117.933040     ,  210.     },
	{ 61  , 57 , 118, "La","    x",  -49621.      , 298.       , 8114.    ,   3.    , STAR     , STAR    , 117.946730     ,  320.     },
	{ 75  , 44 , 119, "Ru","    x",  -53244.      , 699.       , 8229.    ,   6.    ,  9995.   ,  918.   , 118.942840     ,  750.     },
	{ 74  , 45 , 119, "Rh","    x",  -63239.      , 596.       , 8307.    ,   5.    ,  8383.   ,  667.   , 118.932110     ,  640.     },
	{ 73  , 46 , 119, "Pd","    x",  -71623.      , 298.       , 8371.    ,   3.    ,  6935.   ,  311.   , 118.923110     ,  320.     },
	{ 72  , 47 , 119, "Ag","    +",  -78557.492   ,  89.775    , 8422.470 ,   0.754 ,  5350.000,   40.000, 118.915665059  ,   96.377  },
	{ 71  , 48 , 119, "Cd","    +",  -83907.492   ,  80.371    , 8460.854 ,   0.675 ,  3797.000,   80.000, 118.909921597  ,   86.281  },
	{ 70  , 49 , 119, "In","     ",  -87704.492   ,   7.713    , 8486.187 ,   0.065 ,  2363.871,    7.653, 118.905845350  ,    8.280  },
	{ 69  , 50 , 119, "Sn","     ",  -90068.363   ,   2.873    , 8499.477 ,   0.024 ,  -590.920,    7.689, 118.903307630  ,    3.083  },
	{ 68  , 51 , 119, "Sb","     ",  -89477.443   ,   8.200    , 8487.937 ,   0.069 , -2293.000,    2.000, 118.903942009  ,    8.803  },
	{ 67  , 52 , 119, "Te","    -",  -87184.443   ,   8.441    , 8462.094 ,   0.071 , -3418.913,   29.192, 118.906403645  ,    9.061  },
	{ 66  , 53 , 119, "I ","    x",  -83765.530   ,  27.945    , 8426.789 ,   0.235 , -4971.093,   29.810, 118.910074000  ,   30.000  },
	{ 65  , 54 , 119, "Xe","    x",  -78794.437   ,  10.378    , 8378.441 ,   0.087 , -6489.361,   17.379, 118.915410688  ,   11.141  },
	{ 64  , 55 , 119, "Cs","   IT",  -72305.075   ,  13.940    , 8317.334 ,   0.117 , -7714.965,  200.754, 118.922377304  ,   14.965  },
	{ 63  , 56 , 119, "Ba","   ep",  -64590.110   , 200.269    , 8245.928 ,   1.683 , -9623.   ,  448.   , 118.930659661  ,  214.997  },
	{ 62  , 57 , 119, "La","    x",  -54967.      , 401.       , 8158.    ,   3.    ,-10964.   ,  718.   , 118.940990     ,  430.     },
	{ 61  , 58 , 119, "Ce","    x",  -44004.      , 596.       , 8060.    ,   5.    , STAR     , STAR    , 118.952760     ,  640.     },
	{ 76  , 44 , 120, "Ru","    x",  -50943.      , 801.       , 8209.    ,   7.    ,  8290.   ,  999.   , 119.945310     ,  860.     },
	{ 75  , 45 , 120, "Rh","    x",  -59234.      , 596.       , 8272.    ,   5.    , 10915.   ,  609.   , 119.936410     ,  640.     },
	{ 74  , 46 , 120, "Pd","    +",  -70149.064   , 123.908    , 8355.993 ,   1.033 ,  5500.000,  100.000, 119.924691878  ,  133.020  },
	{ 73  , 47 , 120, "Ag","    +",  -75649.064   ,  73.165    , 8395.307 ,   0.610 ,  8325.000,   70.711, 119.918787384  ,   78.546  },
	{ 72  , 48 , 120, "Cd","   +a",  -83974.064   ,  18.793    , 8458.162 ,   0.157 ,  1761.008,   44.245, 119.909850129  ,   20.174  },
	{ 71  , 49 , 120, "In","    +",  -85735.073   ,  40.078    , 8466.318 ,   0.334 ,  5370.000,   40.000, 119.907959608  ,   43.025  },
	{ 70  , 50 , 120, "Sn","     ",  -91105.073   ,   2.504    , 8504.548 ,   0.021 , -2680.608,    7.140, 119.902194676  ,    2.687  },
	{ 69  , 51 , 120, "Sb","    -",  -88424.465   ,   7.566    , 8475.690 ,   0.063 ,   980.122,   12.220, 119.905072427  ,    8.122  },
	{ 68  , 52 , 120, "Te","     ",  -89404.587   ,   9.696    , 8477.338 ,   0.081 , -5615.000,   15.000, 119.904020222  ,   10.409  },
	{ 67  , 53 , 120, "I ","    -",  -83789.587   ,  17.861    , 8424.027 ,   0.149 , -1617.140,   21.417, 119.910048173  ,   19.174  },
	{ 66  , 54 , 120, "Xe","    x",  -82172.448   ,  11.817    , 8404.032 ,   0.098 , -8283.785,   15.461, 119.911784244  ,   12.686  },
	{ 65  , 55 , 120, "Cs","   IT",  -73888.663   ,   9.970    , 8328.480 ,   0.083 , -5000.000,  300.000, 119.920677253  ,   10.702  },
	{ 64  , 56 , 120, "Ba","    -",  -68888.663   , 300.166    , 8280.294 ,   2.501 ,-11201.   ,  586.   , 119.926044974  ,  322.241  },
	{ 63  , 57 , 120, "La","    x",  -57687.      , 503.       , 8180.    ,   4.    , -7983.   ,  861.   , 119.938070     ,  540.     },
	{ 62  , 58 , 120, "Ce","    x",  -49705.      , 699.       , 8107.    ,   6.    , STAR     , STAR    , 119.946640     ,  750.     },
	{ 76  , 45 , 121, "Rh","    x",  -57082.      , 904.       , 8252.    ,   7.    ,  9175.   , 1034.   , 120.938720     ,  970.     },
	{ 75  , 46 , 121, "Pd","    x",  -66257.      , 503.       , 8321.    ,   4.    ,  8404.   ,  524.   , 120.928870     ,  540.     },
	{ 74  , 47 , 121, "Ag","    +",  -74661.064   , 146.810    , 8384.464 ,   1.213 ,  6400.000,  120.000, 120.919848046  ,  157.607  },
	{ 73  , 48 , 121, "Cd","    +",  -81061.064   ,  84.576    , 8430.891 ,   0.699 ,  4780.000,   80.000, 120.912977363  ,   90.796  },
	{ 72  , 49 , 121, "In","   +p",  -85841.064   ,  27.444    , 8463.929 ,   0.227 ,  3363.012,   27.420, 120.907845822  ,   29.462  },
	{ 71  , 50 , 121, "Sn","     ",  -89204.076   ,   2.495    , 8485.257 ,   0.021 ,   391.036,    2.074, 120.904235480  ,    2.678  },
	{ 70  , 51 , 121, "Sb","     ",  -89595.111   ,   2.198    , 8482.023 ,   0.018 , -1043.961,   25.874, 120.903815686  ,    2.359  },
	{ 69  , 52 , 121, "Te","     ",  -88551.151   ,  25.930    , 8466.930 ,   0.214 , -2263.891,   26.853, 120.904936424  ,   27.837  },
	{ 68  , 53 , 121, "I ","     ",  -86287.260   ,  10.361    , 8441.754 ,   0.086 , -3814.485,   15.192, 120.907366811  ,   11.122  },
	{ 67  , 54 , 121, "Xe","    x",  -82472.775   ,  11.111    , 8403.764 ,   0.092 , -5372.280,   17.730, 120.911461829  ,   11.928  },
	{ 66  , 55 , 121, "Cs","    x",  -77100.495   ,  13.817    , 8352.899 ,   0.114 , -6357.716,  141.176, 120.917229209  ,   14.832  },
	{ 65  , 56 , 121, "Ba","    -",  -70742.779   , 141.851    , 8293.890 ,   1.172 , -8342.   ,  523.   , 120.924054499  ,  152.283  },
	{ 64  , 57 , 121, "La","    x",  -62401.      , 503.       , 8218.    ,   4.    , -9697.   ,  711.   , 120.933010     ,  540.     },
	{ 63  , 58 , 121, "Ce","    x",  -52704.      , 503.       , 8132.    ,   4.    ,-11125.   ,  862.   , 120.943420     ,  540.     },
	{ 62  , 59 , 121, "Pr","   -p",  -41579.      , 700.       , 8033.    ,   6.    , STAR     , STAR    , 120.955364     ,  752.     },
	{ 77  , 45 , 122, "Rh","    x",  -52900.      , 699.       , 8216.    ,   6.    , 11793.   ,  805.   , 121.943210     ,  750.     },
	{ 76  , 46 , 122, "Pd","    x",  -64692.      , 401.       , 8307.    ,   3.    ,  6539.   ,  450.   , 121.930550     ,  430.     },
	{ 75  , 47 , 122, "Ag","    x",  -71231.      , 205.       , 8354.    ,   2.    ,  9499.   ,  209.   , 121.923530     ,  220.     },
	{ 74  , 48 , 122, "Cd","  +pp",  -80730.320   ,  43.023    , 8425.233 ,   0.353 ,  2847.038,   65.998, 121.913332432  ,   46.186  },
	{ 73  , 49 , 122, "In","    +",  -83577.359   ,  50.074    , 8442.156 ,   0.410 ,  6368.591,   50.000, 121.910276010  ,   53.756  },
	{ 72  , 50 , 122, "Sn","     ",  -89945.950   ,   2.716    , 8487.945 ,   0.022 , -1615.774,    2.755, 121.903439046  ,    2.915  },
	{ 71  , 51 , 122, "Sb","     ",  -88330.175   ,   2.197    , 8468.288 ,   0.018 ,  1983.852,    1.884, 121.905173651  ,    2.358  },
	{ 70  , 52 , 122, "Te","     ",  -90314.028   ,   1.490    , 8478.137 ,   0.012 , -4234.000,    5.000, 121.903043898  ,    1.599  },
	{ 69  , 53 , 122, "I ","    -",  -86080.028   ,   5.217    , 8437.019 ,   0.043 ,  -725.026,   12.275, 121.907589284  ,    5.601  },
	{ 68  , 54 , 122, "Xe","    x",  -85355.002   ,  11.111    , 8424.664 ,   0.091 , -7215.169,   33.830, 121.908367632  ,   11.928  },
	{ 67  , 55 , 122, "Cs","     ",  -78139.833   ,  31.953    , 8359.110 ,   0.262 , -3530.889,   42.449, 121.916113434  ,   34.303  },
	{ 66  , 56 , 122, "Ba","    x",  -74608.944   ,  27.945    , 8323.756 ,   0.229 ,-10066.   ,  299.   , 121.919904000  ,   30.000  },
	{ 65  , 57 , 122, "La","    x",  -64543.      , 298.       , 8235.    ,   2.    , -6707.   ,  499.   , 121.930710     ,  320.     },
	{ 64  , 58 , 122, "Ce","    x",  -57836.      , 401.       , 8173.    ,   3.    ,-12948.   ,  643.   , 121.937910     ,  430.     },
	{ 63  , 59 , 122, "Pr","    x",  -44889.      , 503.       , 8061.    ,   4.    , STAR     , STAR    , 121.951810     ,  540.     },
	{ 77  , 46 , 123, "Pd","    x",  -60612.      , 596.       , 8272.    ,   5.    ,  9343.   ,  630.   , 122.934930     ,  640.     },
	{ 76  , 47 , 123, "Ag","    x",  -69955.      , 205.       , 8341.    ,   2.    ,  7356.   ,  209.   , 122.924900     ,  220.     },
	{ 75  , 48 , 123, "Cd","    +",  -77311.209   ,  40.876    , 8394.558 ,   0.332 ,  6115.000,   33.000, 122.917002999  ,   43.881  },
	{ 74  , 49 , 123, "In","    +",  -83426.209   ,  24.121    , 8437.912 ,   0.196 ,  4394.265,   23.968, 122.910438276  ,   25.894  },
	{ 73  , 50 , 123, "Sn","     ",  -87820.474   ,   2.706    , 8467.278 ,   0.022 ,  1403.639,    2.879, 122.905720838  ,    2.904  },
	{ 72  , 51 , 123, "Sb","     ",  -89224.113   ,   2.071    , 8472.329 ,   0.017 ,   -52.219,    1.543, 122.904213970  ,    2.223  },
	{ 71  , 52 , 123, "Te","     ",  -89171.894   ,   1.483    , 8465.544 ,   0.012 , -1228.581,    3.448, 122.904270029  ,    1.592  },
	{ 70  , 53 , 123, "I ","     ",  -87943.313   ,   3.734    , 8449.195 ,   0.030 , -2694.761,    9.690, 122.905588965  ,    4.008  },
	{ 69  , 54 , 123, "Xe","     ",  -85248.552   ,   9.537    , 8420.926 ,   0.078 , -4204.882,   15.414, 122.908481910  ,   10.238  },
	{ 68  , 55 , 123, "Cs","    x",  -81043.671   ,  12.109    , 8380.379 ,   0.098 , -5388.693,   17.125, 122.912996036  ,   13.000  },
	{ 67  , 56 , 123, "Ba","    x",  -75654.978   ,  12.109    , 8330.208 ,   0.098 , -6948.   ,  196.   , 122.918781036  ,   13.000  },
	{ 66  , 57 , 123, "La","    x",  -68707.      , 196.       , 8267.    ,   2.    , -8532.   ,  357.   , 122.926240     ,  210.     },
	{ 65  , 58 , 123, "Ce","    x",  -60175.      , 298.       , 8192.    ,   2.    , -9837.   ,  667.   , 122.935400     ,  320.     },
	{ 64  , 59 , 123, "Pr","    x",  -50338.      , 596.       , 8105.    ,   5.    , STAR     , STAR    , 122.945960     ,  640.     },
	{ 78  , 46 , 124, "Pd","    x",  -58796.      , 503.       , 8255.    ,   4.    ,  7676.   ,  540.   , 123.936880     ,  540.     },
	{ 77  , 47 , 124, "Ag","    x",  -66471.      , 196.       , 8311.    ,   2.    , 10239.   ,  205.   , 123.928640     ,  210.     },
	{ 76  , 48 , 124, "Cd","    +",  -76710.752   ,  62.641    , 8387.108 ,   0.505 ,  4166.000,   39.000, 123.917647616  ,   67.248  },
	{ 75  , 49 , 124, "In","    +",  -80876.752   ,  49.020    , 8414.396 ,   0.395 ,  7360.000,   49.000, 123.913175231  ,   52.624  },
	{ 74  , 50 , 124, "Sn","     ",  -88236.752   ,   1.394    , 8467.441 ,   0.011 ,  -616.460,    2.096, 123.905273946  ,    1.496  },
	{ 73  , 51 , 124, "Sb","     ",  -87620.291   ,   2.070    , 8456.161 ,   0.017 ,  2904.256,    1.535, 123.905935743  ,    2.222  },
	{ 72  , 52 , 124, "Te","     ",  -90524.548   ,   1.475    , 8473.273 ,   0.012 , -3159.587,    1.859, 123.902817896  ,    1.583  },
	{ 71  , 53 , 124, "I ","    -",  -87364.961   ,   2.373    , 8441.483 ,   0.019 ,   295.143,    2.847, 123.906209852  ,    2.547  },
	{ 70  , 54 , 124, "Xe","     ",  -87660.103   ,   1.827    , 8437.554 ,   0.015 , -5928.769,    8.502, 123.905893003  ,    1.961  },
	{ 69  , 55 , 124, "Cs","    x",  -81731.335   ,   8.304    , 8383.432 ,   0.067 , -2641.535,   15.005, 123.912257798  ,    8.914  },
	{ 68  , 56 , 124, "Ba","    x",  -79089.800   ,  12.497    , 8355.820 ,   0.101 , -8831.190,   58.030, 123.915093603  ,   13.416  },
	{ 67  , 57 , 124, "La","    x",  -70258.610   ,  56.669    , 8278.292 ,   0.457 , -5436.   ,  303.   , 123.924574275  ,   60.836  },
	{ 66  , 58 , 124, "Ce","    x",  -64823.      , 298.       , 8228.    ,   2.    ,-11690.   ,  667.   , 123.930410     ,  320.     },
	{ 65  , 59 , 124, "Pr","    x",  -53132.      , 596.       , 8128.    ,   5.    , -8635.   ,  843.   , 123.942960     ,  640.     },
	{ 64  , 60 , 124, "Nd","    x",  -44497.      , 596.       , 8052.    ,   5.    , STAR     , STAR    , 123.952230     ,  640.     },
	{ 78  , 47 , 125, "Ag","    x",  -64804.      , 298.       , 8296.    ,   2.    ,  8554.   ,  306.   , 124.930430     ,  320.     },
	{ 77  , 48 , 125, "Cd","    +",  -73358.534   ,  68.893    , 8357.764 ,   0.551 ,  7122.000,   62.000, 124.921246370  ,   73.959  },
	{ 76  , 49 , 125, "In","    +",  -80480.534   ,  30.038    , 8408.482 ,   0.240 ,  5418.000,   30.000, 124.913600588  ,   32.246  },
	{ 75  , 50 , 125, "Sn","   -n",  -85898.534   ,   1.501    , 8445.567 ,   0.012 ,  2356.966,    2.669, 124.907784125  ,    1.611  },
	{ 74  , 51 , 125, "Sb","    +",  -88255.501   ,   2.584    , 8458.164 ,   0.021 ,   766.700,    2.121, 124.905253818  ,    2.773  },
	{ 73  , 52 , 125, "Te","     ",  -89022.201   ,   1.475    , 8458.039 ,   0.012 ,  -185.770,    0.060, 124.904430731  ,    1.583  },
	{ 72  , 53 , 125, "I ","    -",  -88836.431   ,   1.477    , 8450.294 ,   0.012 , -1644.366,    2.193, 124.904630164  ,    1.585  },
	{ 71  , 54 , 125, "Xe","     ",  -87192.064   ,   1.869    , 8430.880 ,   0.015 , -3104.489,    7.835, 124.906395464  ,    2.006  },
	{ 70  , 55 , 125, "Cs","     ",  -84087.575   ,   7.744    , 8399.785 ,   0.062 , -4419.606,   13.544, 124.909728270  ,    8.314  },
	{ 69  , 56 , 125, "Ba","    x",  -79667.970   ,  11.111    , 8358.170 ,   0.089 , -5908.580,   28.225, 124.914472912  ,   11.928  },
	{ 68  , 57 , 125, "La","    x",  -73759.389   ,  25.946    , 8304.642 ,   0.208 , -7102.   ,  197.   , 124.920816034  ,   27.854  },
	{ 67  , 58 , 125, "Ce","    x",  -66658.      , 196.       , 8242.    ,   2.    , -8747.   ,  446.   , 124.928440     ,  210.     },
	{ 66  , 59 , 125, "Pr","    x",  -57911.      , 401.       , 8165.    ,   3.    ,-10293.   ,  566.   , 124.937830     ,  430.     },
	{ 65  , 60 , 125, "Nd","    x",  -47618.      , 401.       , 8077.    ,   3.    , STAR     , STAR    , 124.948880     ,  430.     },
	{ 79  , 47 , 126, "Ag","    x",  -61013.      , 298.       , 8264.    ,   2.    , 11315.   ,  303.   , 125.934500     ,  320.     },
	{ 78  , 48 , 126, "Cd","    +",  -72327.416   ,  54.143    , 8347.307 ,   0.430 ,  5486.000,   36.000, 125.922353321  ,   58.124  },
	{ 77  , 49 , 126, "In","    +",  -77813.416   ,  40.441    , 8384.638 ,   0.321 ,  8207.000,   39.000, 125.916463857  ,   43.414  },
	{ 76  , 50 , 126, "Sn","  -nn",  -86020.416   ,  10.698    , 8443.564 ,   0.085 ,   378.000,   30.000, 125.907653280  ,   11.484  },
	{ 75  , 51 , 126, "Sb","    -",  -86398.416   ,  31.850    , 8440.355 ,   0.253 ,  3666.159,   31.856, 125.907247480  ,   34.192  },
	{ 74  , 52 , 126, "Te","     ",  -90064.575   ,   1.477    , 8463.242 ,   0.012 , -2154.039,    3.626, 125.903311696  ,    1.585  },
	{ 73  , 53 , 126, "I ","     ",  -87910.536   ,   3.744    , 8439.937 ,   0.030 ,  1258.000,    5.000, 125.905624153  ,    4.018  },
	{ 72  , 54 , 126, "Xe","    -",  -89168.536   ,   6.246    , 8443.712 ,   0.050 , -4823.596,   13.625, 125.904273634  ,    6.705  },
	{ 71  , 55 , 126, "Cs","    x",  -84344.940   ,  12.109    , 8399.221 ,   0.096 , -1675.013,   17.402, 125.909451977  ,   13.000  },
	{ 70  , 56 , 126, "Ba","    x",  -82669.928   ,  12.497    , 8379.718 ,   0.099 , -7696.460,   91.366, 125.911250177  ,   13.416  },
	{ 69  , 57 , 126, "La","    x",  -74973.468   ,  90.508    , 8312.426 ,   0.718 , -4152.910,   94.723, 125.919512667  ,   97.163  },
	{ 68  , 58 , 126, "Ce","    x",  -70820.558   ,  27.945    , 8273.257 ,   0.222 ,-10562.   ,  198.   , 125.923971000  ,   30.000  },
	{ 67  , 59 , 126, "Pr","    x",  -60258.      , 196.       , 8183.    ,   2.    , -7368.   ,  446.   , 125.935310     ,  210.     },
	{ 66  , 60 , 126, "Nd","    x",  -52890.      , 401.       , 8119.    ,   3.    ,-13320.   ,  643.   , 125.943220     ,  430.     },
	{ 65  , 61 , 126, "Pm","    x",  -39570.      , 503.       , 8007.    ,   4.    , STAR     , STAR    , 125.957520     ,  540.     },
	{ 80  , 47 , 127, "Ag","    x",  -58898.      , 298.       , 8246.    ,   2.    ,  9619.   ,  307.   , 126.936770     ,  320.     },
	{ 79  , 48 , 127, "Cd","    +",  -68517.100   ,  74.386    , 8315.132 ,   0.586 ,  8468.000,   63.000, 126.926443864  ,   79.857  },
	{ 78  , 49 , 127, "In","    +",  -76985.100   ,  39.552    , 8375.649 ,   0.311 ,  6514.000,   31.000, 126.917353091  ,   42.460  },
	{ 77  , 50 , 127, "Sn","    +",  -83499.100   ,  24.563    , 8420.780 ,   0.193 ,  3201.000,   24.000, 126.910360024  ,   26.369  },
	{ 76  , 51 , 127, "Sb","    +",  -86700.100   ,   5.228    , 8439.824 ,   0.041 ,  1581.000,    5.000, 126.906923609  ,    5.612  },
	{ 75  , 52 , 127, "Te","     ",  -88281.100   ,   1.528    , 8446.113 ,   0.012 ,   702.025,    3.487, 126.905226336  ,    1.640  },
	{ 74  , 53 , 127, "I ","     ",  -88983.125   ,   3.532    , 8445.481 ,   0.028 ,  -662.331,    2.044, 126.904472681  ,    3.791  },
	{ 73  , 54 , 127, "Xe","     ",  -88320.793   ,   4.013    , 8434.105 ,   0.032 , -2080.773,    6.381, 126.905183723  ,    4.307  },
	{ 72  , 55 , 127, "Cs","     ",  -86240.020   ,   5.575    , 8411.561 ,   0.044 , -3424.425,   12.769, 126.907417525  ,    5.985  },
	{ 71  , 56 , 127, "Ba","    x",  -82815.595   ,  11.488    , 8378.437 ,   0.090 , -4919.826,   28.376, 126.911093797  ,   12.332  },
	{ 70  , 57 , 127, "La","    x",  -77895.769   ,  25.946    , 8333.538 ,   0.204 , -5920.158,   63.313, 126.916375448  ,   27.854  },
	{ 69  , 58 , 127, "Ce","    x",  -71975.611   ,  57.753    , 8280.762 ,   0.455 , -7544.   ,  204.   , 126.922731000  ,   62.000  },
	{ 68  , 59 , 127, "Pr","    x",  -64431.      , 196.       , 8215.    ,   2.    , -9008.   ,  446.   , 126.930830     ,  210.     },
	{ 67  , 60 , 127, "Nd","    x",  -55424.      , 401.       , 8138.    ,   3.    ,-10368.   ,  718.   , 126.940500     ,  430.     },
	{ 66  , 61 , 127, "Pm","    x",  -45056.      , 596.       , 8050.    ,   5.    , STAR     , STAR    , 126.951630     ,  640.     },
	{ 81  , 47 , 128, "Ag","    x",  -54800.      , 298.       , 8212.    ,   2.    , 12489.   ,  419.   , 127.941170     ,  320.     },
	{ 80  , 48 , 128, "Cd","    +",  -67288.998   , 294.042    , 8303.632 ,   2.297 ,  7070.000,  290.000, 127.927762285  ,  315.667  },
	{ 79  , 49 , 128, "In","    +",  -74358.998   ,  48.589    , 8352.755 ,   0.380 ,  8975.600,   40.249, 127.920172328  ,   52.162  },
	{ 78  , 50 , 128, "Sn","    +",  -83334.598   ,  27.219    , 8416.765 ,   0.213 ,  1273.933,   14.519, 127.910536624  ,   29.220  },
	{ 77  , 51 , 128, "Sb","   IT",  -84608.531   ,  25.061    , 8420.605 ,   0.196 ,  4383.560,   25.000, 127.909169001  ,   26.904  },
	{ 76  , 52 , 128, "Te","     ",  -88992.091   ,   1.750    , 8448.740 ,   0.014 , -1254.152,    3.823, 127.904463056  ,    1.878  },
	{ 75  , 53 , 128, "I ","     ",  -87737.939   ,   3.532    , 8432.829 ,   0.028 ,  2122.100,    3.707, 127.905809443  ,    3.791  },
	{ 74  , 54 , 128, "Xe","     ",  -89860.039   ,   1.428    , 8443.296 ,   0.011 , -3928.661,    5.384, 127.903531275  ,    1.532  },
	{ 73  , 55 , 128, "Cs","     ",  -85931.378   ,   5.497    , 8406.491 ,   0.043 ,  -529.864,   11.495, 127.907748866  ,    5.901  },
	{ 72  , 56 , 128, "Ba","     ",  -85401.514   ,  10.095    , 8396.240 ,   0.079 , -6769.613,   55.376, 127.908317698  ,   10.837  },
	{ 71  , 57 , 128, "La","    x",  -78631.901   ,  54.448    , 8337.240 ,   0.425 , -3097.984,   61.200, 127.915585177  ,   58.452  },
	{ 70  , 58 , 128, "Ce","    x",  -75533.918   ,  27.945    , 8306.925 ,   0.218 , -9203.161,   40.859, 127.918911000  ,   30.000  },
	{ 69  , 59 , 128, "Pr","    x",  -66330.757   ,  29.808    , 8228.913 ,   0.233 , -6147.   ,  198.   , 127.928791000  ,   32.000  },
	{ 68  , 60 , 128, "Nd","    x",  -60184.      , 196.       , 8175.    ,   2.    ,-12137.   ,  446.   , 127.935390     ,  210.     },
	{ 67  , 61 , 128, "Pm","    x",  -48046.      , 401.       , 8074.    ,   3.    , -8998.   ,  643.   , 127.948420     ,  430.     },
	{ 66  , 62 , 128, "Sm","    x",  -39048.      , 503.       , 7997.    ,   4.    , STAR     , STAR    , 127.958080     ,  540.     },
	{ 82  , 47 , 129, "Ag","    x",  -52452.      , 401.       , 8193.    ,   3.    , 10749.   ,  499.   , 128.943690     ,  430.     },
	{ 81  , 48 , 129, "Cd","    x",  -63202.      , 298.       , 8270.    ,   2.    ,  9737.   ,  301.   , 128.932150     ,  320.     },
	{ 80  , 49 , 129, "In","    +",  -72938.793   ,  43.103    , 8339.564 ,   0.334 ,  7655.000,   32.000, 128.921696980  ,   46.272  },
	{ 79  , 50 , 129, "Sn","    x",  -80593.793   ,  28.876    , 8392.840 ,   0.224 ,  4033.888,   35.873, 128.913479000  ,   31.000  },
	{ 78  , 51 , 129, "Sb","    +",  -84627.681   ,  21.285    , 8418.046 ,   0.165 ,  2375.500,   21.213, 128.909148442  ,   22.850  },
	{ 77  , 52 , 129, "Te","     ",  -87003.181   ,   1.751    , 8430.396 ,   0.014 ,  1500.186,    3.090, 128.906598238  ,    1.879  },
	{ 76  , 53 , 129, "I ","     ",  -88503.367   ,   3.163    , 8435.960 ,   0.025 ,   194.019,    3.151, 128.904987722  ,    3.395  },
	{ 75  , 54 , 129, "Xe","     ",  -88697.386   ,   0.739    , 8431.400 ,   0.006 , -1196.962,    4.563, 128.904779435  ,    0.793  },
	{ 74  , 55 , 129, "Cs","     ",  -87500.424   ,   4.603    , 8416.056 ,   0.036 , -2435.868,   10.934, 128.906064426  ,    4.941  },
	{ 73  , 56 , 129, "Ba","     ",  -85064.555   ,  10.951    , 8391.109 ,   0.085 , -3738.436,   23.613, 128.908679439  ,   11.756  },
	{ 72  , 57 , 129, "La","    x",  -81326.120   ,  20.920    , 8356.064 ,   0.162 , -5038.623,   34.908, 128.912692815  ,   22.459  },
	{ 71  , 58 , 129, "Ce","    x",  -76287.496   ,  27.945    , 8310.940 ,   0.217 , -6513.938,   40.859, 128.918102000  ,   30.000  },
	{ 70  , 59 , 129, "Pr","    x",  -69773.559   ,  29.808    , 8254.380 ,   0.231 , -7539.   ,  204.   , 128.925095000  ,   32.000  },
	{ 69  , 60 , 129, "Nd","   ep",  -62235.      , 202.       , 8190.    ,   2.    , -9289.   ,  449.   , 128.933188     ,  217.     },
	{ 68  , 61 , 129, "Pm","    x",  -52946.      , 401.       , 8112.    ,   3.    ,-10694.   ,  643.   , 128.943160     ,  430.     },
	{ 67  , 62 , 129, "Sm","    x",  -42253.      , 503.       , 8023.    ,   4.    , STAR     , STAR    , 128.954640     ,  540.     },
	{ 83  , 47 , 130, "Ag","  -nn",  -46157.      , 334.       , 8144.    ,   3.    , 15413.   ,  437.   , 129.950448     ,  358.     },
	{ 82  , 48 , 130, "Cd","    +",  -61569.949   , 282.769    , 8256.066 ,   2.175 ,  8320.000,  280.000, 129.933901937  ,  303.564  },
	{ 81  , 49 , 130, "In","    +",  -69889.949   ,  39.474    , 8314.048 ,   0.304 , 10249.000,   38.000, 129.924970049  ,   42.376  },
	{ 80  , 50 , 130, "Sn","     ",  -80138.949   ,  10.685    , 8386.868 ,   0.082 ,  2152.656,   14.152, 129.913967295  ,   11.470  },
	{ 79  , 51 , 130, "Sb","     ",  -82291.605   ,  17.089    , 8397.409 ,   0.131 ,  5059.805,   17.166, 129.911656324  ,   18.345  },
	{ 78  , 52 , 130, "Te","     ",  -87351.410   ,   1.926    , 8430.312 ,   0.015 ,  -419.031,    3.219, 129.906224399  ,    2.067  },
	{ 77  , 53 , 130, "I ","     ",  -86932.379   ,   3.163    , 8421.071 ,   0.024 ,  2949.334,    3.155, 129.906674247  ,    3.395  },
	{ 76  , 54 , 130, "Xe","     ",  -89881.713   ,   0.750    , 8437.740 ,   0.006 , -2981.289,    8.365, 129.903508007  ,    0.805  },
	{ 75  , 55 , 130, "Cs","     ",  -86900.424   ,   8.366    , 8408.789 ,   0.064 ,   361.178,    8.818, 129.906708552  ,    8.980  },
	{ 74  , 56 , 130, "Ba","     ",  -87261.603   ,   2.790    , 8405.549 ,   0.021 , -5633.594,   26.096, 129.906320811  ,    2.995  },
	{ 73  , 57 , 130, "La","    x",  -81628.008   ,  25.946    , 8356.196 ,   0.200 , -2205.103,   38.133, 129.912368724  ,   27.854  },
	{ 72  , 58 , 130, "Ce","    x",  -79422.905   ,  27.945    , 8333.216 ,   0.215 , -8247.448,   70.085, 129.914736000  ,   30.000  },
	{ 71  , 59 , 130, "Pr","    x",  -71175.457   ,  64.273    , 8263.756 ,   0.494 , -4579.225,   70.085, 129.923590000  ,   69.000  },
	{ 70  , 60 , 130, "Nd","    x",  -66596.233   ,  27.945    , 8222.513 ,   0.215 ,-11126.   ,  299.   , 129.928506000  ,   30.000  },
	{ 69  , 61 , 130, "Pm","    x",  -55470.      , 298.       , 8131.    ,   2.    , -7890.   ,  499.   , 129.940450     ,  320.     },
	{ 68  , 62 , 130, "Sm","    x",  -47581.      , 401.       , 8064.    ,   3.    ,-13645.   ,  643.   , 129.948920     ,  430.     },
	{ 67  , 63 , 130, "Eu","   -p",  -33936.      , 503.       , 7953.    ,   4.    , STAR     , STAR    , 129.963569     ,  540.     },
	{ 83  , 48 , 131, "Cd","    x",  -55266.      , 298.       , 8207.    ,   2.    , 12872.   ,  299.   , 130.940670     ,  320.     },
	{ 82  , 49 , 131, "In","    +",  -68137.141   ,  27.993    , 8298.814 ,   0.214 ,  9177.077,   18.305, 130.926851767  ,   30.051  },
	{ 81  , 50 , 131, "Sn","     ",  -77314.218   ,  21.178    , 8362.896 ,   0.162 ,  4673.766,   11.046, 130.916999769  ,   22.735  },
	{ 80  , 51 , 131, "Sb","     ",  -81987.983   ,  20.617    , 8392.602 ,   0.157 ,  3221.489,   20.594, 130.911982275  ,   22.133  },
	{ 79  , 52 , 131, "Te","     ",  -85209.473   ,   1.927    , 8411.221 ,   0.015 ,  2234.891,    2.235, 130.908523864  ,    2.068  },
	{ 78  , 53 , 131, "I ","    +",  -87444.363   ,   1.135    , 8422.309 ,   0.009 ,   970.848,    0.605, 130.906124609  ,    1.218  },
	{ 77  , 54 , 131, "Xe","     ",  -88415.211   ,   0.960    , 8423.748 ,   0.007 ,  -355.425,    4.997, 130.905082362  ,    1.030  },
	{ 76  , 55 , 131, "Cs","     ",  -88059.787   ,   5.017    , 8415.063 ,   0.038 , -1375.996,    5.370, 130.905463926  ,    5.386  },
	{ 75  , 56 , 131, "Ba","     ",  -86683.790   ,   2.803    , 8398.587 ,   0.021 , -2914.534,   28.085, 130.906941118  ,    3.009  },
	{ 74  , 57 , 131, "La","    x",  -83769.256   ,  27.945    , 8370.367 ,   0.213 , -4053.862,   43.651, 130.910070000  ,   30.000  },
	{ 73  , 58 , 131, "Ce","    x",  -79715.394   ,  33.534    , 8333.449 ,   0.256 , -5437.131,   62.013, 130.914422000  ,   36.000  },
	{ 72  , 59 , 131, "Pr","    x",  -74278.264   ,  52.164    , 8285.972 ,   0.398 , -6509.280,   59.177, 130.920259000  ,   56.000  },
	{ 71  , 60 , 131, "Nd","    x",  -67768.984   ,  27.945    , 8230.311 ,   0.213 , -8032.   ,  198.   , 130.927247000  ,   30.000  },
	{ 70  , 61 , 131, "Pm","    x",  -59737.      , 196.       , 8163.    ,   1.    , -9538.   ,  357.   , 130.935870     ,  210.     },
	{ 69  , 62 , 131, "Sm","    x",  -50198.      , 298.       , 8084.    ,   2.    ,-10846.   ,  499.   , 130.946110     ,  320.     },
	{ 68  , 63 , 131, "Eu","   -p",  -39353.      , 401.       , 7995.    ,   3.    , STAR     , STAR    , 130.957753     ,  430.     },
	{ 84  , 48 , 132, "Cd","    x",  -50720.      , 503.       , 8171.    ,   4.    , 11699.   ,  507.   , 131.945550     ,  540.     },
	{ 83  , 49 , 132, "In","    +",  -62419.171   ,  61.532    , 8253.773 ,   0.466 , 14135.000,   60.000, 131.932990260  ,   66.057  },
	{ 82  , 50 , 132, "Sn","     ",  -76554.171   ,  13.644    , 8354.930 ,   0.103 ,  3119.402,    9.380, 131.917815713  ,   14.647  },
	{ 81  , 51 , 132, "Sb","     ",  -79673.573   ,  14.373    , 8372.634 ,   0.109 ,  5508.610,   14.413, 131.914466896  ,   15.430  },
	{ 80  , 52 , 132, "Te","     ",  -85182.183   ,   6.924    , 8408.440 ,   0.052 ,   517.704,    3.961, 131.908553160  ,    7.433  },
	{ 79  , 53 , 132, "I ","     ",  -85699.888   ,   5.797    , 8406.435 ,   0.044 ,  3580.592,    5.721, 131.907997381  ,    6.222  },
	{ 78  , 54 , 132, "Xe","     ",  -89280.480   ,   0.972    , 8427.633 ,   0.007 , -2124.554,    2.089, 131.904153457  ,    1.043  },
	{ 77  , 55 , 132, "Cs","     ",  -87155.926   ,   1.900    , 8405.612 ,   0.014 ,  1278.915,    2.174, 131.906434260  ,    2.039  },
	{ 76  , 56 , 132, "Ba","     ",  -88434.841   ,   1.057    , 8409.373 ,   0.008 , -4694.596,   39.178, 131.905061288  ,    1.134  },
	{ 75  , 57 , 132, "La","    x",  -83740.245   ,  39.164    , 8367.881 ,   0.297 , -1266.219,   44.239, 131.910101145  ,   42.044  },
	{ 74  , 58 , 132, "Ce","     ",  -82474.025   ,  20.574    , 8352.362 ,   0.156 , -7260.542,   60.431, 131.911460487  ,   22.086  },
	{ 73  , 59 , 132, "Pr","    x",  -75213.484   ,  56.821    , 8291.431 ,   0.430 , -3787.676,   61.762, 131.919255000  ,   61.000  },
	{ 72  , 60 , 132, "Nd","    x",  -71425.808   ,  24.205    , 8256.810 ,   0.183 , -9714.   ,  197.   , 131.923321237  ,   25.985  },
	{ 71  , 61 , 132, "Pm","    x",  -61711.      , 196.       , 8177.    ,   1.    , -6465.   ,  357.   , 131.933750     ,  210.     },
	{ 70  , 62 , 132, "Sm","    x",  -55247.      , 298.       , 8122.    ,   2.    ,-12743.   ,  499.   , 131.940690     ,  320.     },
	{ 69  , 63 , 132, "Eu","    x",  -42504.      , 401.       , 8020.    ,   3.    , STAR     , STAR    , 131.954370     ,  430.     },
	{ 84  , 49 , 133, "In","    x",  -57930.      , 298.       , 8219.    ,   2.    , 13023.   ,  300.   , 132.937810     ,  320.     },
	{ 83  , 50 , 133, "Sn","    +",  -70952.598   ,  35.662    , 8310.680 ,   0.268 ,  7990.000,   25.000, 132.923829249  ,   38.284  },
	{ 82  , 51 , 133, "Sb","    +",  -78942.598   ,  25.431    , 8364.873 ,   0.191 ,  4002.000,    7.000, 132.915251630  ,   27.301  },
	{ 81  , 52 , 133, "Te","    +",  -82944.598   ,  24.449    , 8389.081 ,   0.184 ,  2942.000,   24.000, 132.910955306  ,   26.247  },
	{ 80  , 53 , 133, "I ","    +",  -85886.598   ,   4.665    , 8405.319 ,   0.035 ,  1757.000,    4.000, 132.907796939  ,    5.007  },
	{ 79  , 54 , 133, "Xe","    +",  -87643.598   ,   2.400    , 8412.647 ,   0.018 ,   427.360,    2.400, 132.905910722  ,    2.576  },
	{ 78  , 55 , 133, "Cs","     ",  -88070.958   ,   0.022    , 8409.978 ,   0.000 ,  -517.499,    0.995, 132.905451932  ,    0.023  },
	{ 77  , 56 , 133, "Ba","     ",  -87553.459   ,   0.995    , 8400.205 ,   0.007 , -2059.076,   27.963, 132.906007490  ,    1.068  },
	{ 76  , 57 , 133, "La","    x",  -85494.383   ,  27.945    , 8378.841 ,   0.210 , -3071.155,   32.379, 132.908218000  ,   30.000  },
	{ 75  , 58 , 133, "Ce","    x",  -82423.228   ,  16.354    , 8349.867 ,   0.123 , -4485.621,   20.583, 132.911515020  ,   17.557  },
	{ 74  , 59 , 133, "Pr","    x",  -77937.607   ,  12.497    , 8310.258 ,   0.094 , -5605.235,   48.222, 132.916330532  ,   13.416  },
	{ 73  , 60 , 133, "Nd","    x",  -72332.373   ,  46.575    , 8262.231 ,   0.350 , -6924.726,   68.552, 132.922348000  ,   50.000  },
	{ 72  , 61 , 133, "Pm","    x",  -65407.646   ,  50.301    , 8204.283 ,   0.378 , -8279.   ,  202.   , 132.929782000  ,   54.000  },
	{ 71  , 62 , 133, "Sm","    x",  -57129.      , 196.       , 8136.    ,   1.    , -9846.   ,  357.   , 132.938670     ,  210.     },
	{ 70  , 63 , 133, "Eu","    x",  -47283.      , 298.       , 8056.    ,   2.    , STAR     , STAR    , 132.949240     ,  320.     },
	{ 85  , 49 , 134, "In","    x",  -52024.      , 401.       , 8173.    ,   3.    , 14772.   ,  413.   , 133.944150     ,  430.     },
	{ 84  , 50 , 134, "Sn","    +",  -66795.791   ,  99.945    , 8277.873 ,   0.746 ,  7370.000,   90.000, 133.928291765  ,  107.295  },
	{ 83  , 51 , 134, "Sb","    +",  -74165.791   ,  43.463    , 8327.034 ,   0.324 ,  8393.699,   42.135, 133.920379744  ,   46.659  },
	{ 82  , 52 , 134, "Te","    +",  -82559.490   ,  10.663    , 8383.836 ,   0.080 ,  1513.000,    7.000, 133.911368737  ,   11.447  },
	{ 81  , 53 , 134, "I ","    +",  -84072.490   ,   8.044    , 8389.288 ,   0.060 ,  4052.000,    8.000, 133.909744465  ,    8.635  },
	{ 80  , 54 , 134, "Xe","    x",  -88124.490   ,   0.840    , 8413.689 ,   0.006 , -1233.309,    0.840, 133.905394464  ,    0.901  },
	{ 79  , 55 , 134, "Cs","     ",  -86891.181   ,   0.026    , 8398.646 ,   0.000 ,  2058.687,    0.398, 133.906718475  ,    0.028  },
	{ 78  , 56 , 134, "Ba","     ",  -88949.868   ,   0.399    , 8408.171 ,   0.003 , -3731.218,   19.934, 133.904508383  ,    0.428  },
	{ 77  , 57 , 134, "La","    x",  -85218.650   ,  19.930    , 8374.488 ,   0.149 ,  -382.667,   28.510, 133.908514011  ,   21.395  },
	{ 76  , 58 , 134, "Ce","    x",  -84835.983   ,  20.387    , 8365.794 ,   0.152 , -6321.972,   40.912, 133.908924821  ,   21.886  },
	{ 75  , 59 , 134, "Pr","    x",  -78514.011   ,  35.470    , 8312.777 ,   0.265 , -2867.552,   37.387, 133.915711737  ,   38.078  },
	{ 74  , 60 , 134, "Nd","    x",  -75646.459   ,  11.817    , 8285.538 ,   0.088 , -8907.708,   58.949, 133.918790181  ,   12.686  },
	{ 73  , 61 , 134, "Pm","    x",  -66738.751   ,  57.753    , 8213.225 ,   0.431 , -5232.   ,  204.   , 133.928353000  ,   62.000  },
	{ 72  , 62 , 134, "Sm","    x",  -61507.      , 196.       , 8168.    ,   1.    ,-11681.   ,  277.   , 133.933970     ,  210.     },
	{ 71  , 63 , 134, "Eu","    x",  -49826.      , 196.       , 8075.    ,   1.    , -8253.   ,  446.   , 133.946510     ,  210.     },
	{ 70  , 64 , 134, "Gd","    x",  -41573.      , 401.       , 8008.    ,   3.    , STAR     , STAR    , 133.955370     ,  430.     },
	{ 86  , 49 , 135, "In","    x",  -47199.      , 503.       , 8137.    ,   4.    , 13600.   ,  643.   , 134.949330     ,  540.     },
	{ 85  , 50 , 135, "Sn","    x",  -60799.      , 401.       , 8232.    ,   3.    ,  8909.   ,  414.   , 134.934730     ,  430.     },
	{ 84  , 51 , 135, "Sb","    +",  -69707.636   , 102.731    , 8292.117 ,   0.761 ,  8120.000,   50.000, 134.925165771  ,  110.285  },
	{ 83  , 52 , 135, "Te","    +",  -77827.636   ,  89.742    , 8346.470 ,   0.665 ,  5962.000,   89.443, 134.916448592  ,   96.341  },
	{ 82  , 53 , 135, "I ","     ",  -83789.636   ,   7.320    , 8384.838 ,   0.054 ,  2627.397,    5.885, 134.910048121  ,    7.858  },
	{ 81  , 54 , 135, "Xe","     ",  -86417.033   ,   4.532    , 8398.505 ,   0.034 ,  1164.821,    4.425, 134.907227495  ,    4.865  },
	{ 80  , 55 , 135, "Cs","     ",  -87581.853   ,   1.000    , 8401.338 ,   0.007 ,   268.659,    1.081, 134.905977008  ,    1.073  },
	{ 79  , 56 , 135, "Ba","     ",  -87850.512   ,   0.412    , 8397.533 ,   0.003 , -1200.000,   10.000, 134.905688591  ,    0.442  },
	{ 78  , 57 , 135, "La","    -",  -86650.512   ,  10.008    , 8382.849 ,   0.074 , -2025.582,    4.667, 134.906976844  ,   10.744  },
	{ 77  , 58 , 135, "Ce","    -",  -84624.930   ,  11.043    , 8362.049 ,   0.082 , -3689.042,   16.174, 134.909151396  ,   11.855  },
	{ 76  , 59 , 135, "Pr","    x",  -80935.888   ,  11.817    , 8328.928 ,   0.088 , -4722.130,   22.627, 134.913111745  ,   12.686  },
	{ 75  , 60 , 135, "Nd","    x",  -76213.758   ,  19.296    , 8288.154 ,   0.143 , -6236.202,   61.775, 134.918181160  ,   20.714  },
	{ 74  , 61 , 135, "Pm","    x",  -69977.556   ,  58.684    , 8236.165 ,   0.435 , -7120.340,  165.389, 134.924876000  ,   63.000  },
	{ 73  , 62 , 135, "Sm","    x",  -62857.216   , 154.628    , 8177.626 ,   1.145 , -8663.   ,  336.   , 134.932520000  ,  166.000  },
	{ 72  , 63 , 135, "Eu","    x",  -54194.      , 298.       , 8108.    ,   2.    ,-10014.   ,  585.   , 134.941820     ,  320.     },
	{ 71  , 64 , 135, "Gd","    x",  -44181.      , 503.       , 8028.    ,   4.    , STAR     , STAR    , 134.952570     ,  540.     },
	{ 86  , 50 , 136, "Sn","    x",  -56504.      , 503.       , 8199.    ,   4.    ,  8374.   ,  585.   , 135.939340     ,  540.     },
	{ 85  , 51 , 136, "Sb","    x",  -64879.      , 298.       , 8255.    ,   2.    ,  9547.   ,  301.   , 135.930350     ,  320.     },
	{ 84  , 52 , 136, "Te","     ",  -74425.210   ,  45.231    , 8319.429 ,   0.333 ,  5074.084,   56.403, 135.920101246  ,   48.557  },
	{ 83  , 53 , 136, "I ","     ",  -79499.294   ,  49.698    , 8350.986 ,   0.365 ,  6925.844,   49.440, 135.914653993  ,   53.352  },
	{ 82  , 54 , 136, "Xe","     ",  -86425.137   ,   7.041    , 8396.158 ,   0.052 ,   -86.426,    7.285, 135.907218794  ,    7.558  },
	{ 81  , 55 , 136, "Cs","    +",  -86338.711   ,   1.902    , 8389.770 ,   0.014 ,  2548.224,    1.857, 135.907311576  ,    2.042  },
	{ 80  , 56 , 136, "Ba","     ",  -88886.935   ,   0.414    , 8402.755 ,   0.003 , -2849.991,   52.916, 135.904575945  ,    0.444  },
	{ 79  , 57 , 136, "La","    x",  -86036.945   ,  52.914    , 8376.046 ,   0.389 ,   431.388,   54.562, 135.907635536  ,   56.805  },
	{ 78  , 58 , 136, "Ce","     ",  -86468.332   ,  13.308    , 8373.466 ,   0.098 , -5141.091,   14.532, 135.907172422  ,   14.286  },
	{ 77  , 59 , 136, "Pr","     ",  -81327.241   ,  12.258    , 8329.911 ,   0.090 , -2127.927,   17.026, 135.912691611  ,   13.159  },
	{ 76  , 60 , 136, "Nd","    x",  -79199.314   ,  11.817    , 8308.512 ,   0.087 , -8001.342,   78.951, 135.914976035  ,   12.686  },
	{ 75  , 61 , 136, "Pm","    x",  -71197.972   ,  78.062    , 8243.926 ,   0.574 , -4387.055,   79.056, 135.923565829  ,   83.802  },
	{ 74  , 62 , 136, "Sm","    x",  -66810.917   ,  12.497    , 8205.916 ,   0.092 ,-10549.   ,  196.   , 135.928275527  ,   13.416  },
	{ 73  , 63 , 136, "Eu","    x",  -56262.      , 196.       , 8123.    ,   1.    , -7210.   ,  446.   , 135.939600     ,  210.     },
	{ 72  , 64 , 136, "Gd","    x",  -49052.      , 401.       , 8064.    ,   3.    ,-13078.   ,  718.   , 135.947340     ,  430.     },
	{ 71  , 65 , 136, "Tb","    x",  -35974.      , 596.       , 7962.    ,   4.    , STAR     , STAR    , 135.961380     ,  640.     },
	{ 87  , 50 , 137, "Sn","    x",  -50310.      , 596.       , 8153.    ,   4.    ,  9948.   ,  718.   , 136.945990     ,  640.     },
	{ 86  , 51 , 137, "Sb","    x",  -60258.      , 401.       , 8220.    ,   3.    ,  9303.   ,  419.   , 136.935310     ,  430.     },
	{ 85  , 52 , 137, "Te","    +",  -69561.221   , 122.466    , 8282.114 ,   0.894 ,  6941.600,  119.282, 136.925322954  ,  131.472  },
	{ 84  , 53 , 137, "I "," p-2n",  -76502.820   ,  27.741    , 8327.072 ,   0.202 ,  5876.530,   26.833, 136.917870840  ,   29.781  },
	{ 83  , 54 , 137, "Xe","   -n",  -82379.350   ,   7.042    , 8364.256 ,   0.051 ,  4166.249,    7.046, 136.911562125  ,    7.559  },
	{ 82  , 55 , 137, "Cs","     ",  -86545.599   ,   0.455    , 8388.956 ,   0.003 ,  1175.628,    0.172, 136.907089473  ,    0.487  },
	{ 81  , 56 , 137, "Ba","     ",  -87721.227   ,   0.421    , 8391.827 ,   0.003 ,  -620.575,   13.410, 136.905827384  ,    0.451  },
	{ 80  , 57 , 137, "La","    +",  -87100.653   ,  13.404    , 8381.586 ,   0.098 , -1222.100,    1.600, 136.906493598  ,   14.389  },
	{ 79  , 58 , 137, "Ce","     ",  -85878.553   ,  13.308    , 8366.955 ,   0.097 , -2701.219,    9.315, 136.907805577  ,   14.286  },
	{ 78  , 59 , 137, "Pr","     ",  -83177.333   ,  11.787    , 8341.528 ,   0.086 , -3597.134,   16.069, 136.910705455  ,   12.653  },
	{ 77  , 60 , 137, "Nd","     ",  -79580.199   ,  11.482    , 8309.561 ,   0.084 , -5507.324,   17.375, 136.914567137  ,   12.326  },
	{ 76  , 61 , 137, "Pm","    x",  -74072.875   ,  13.041    , 8263.651 ,   0.095 , -6047.495,   44.352, 136.920479493  ,   14.000  },
	{ 75  , 62 , 137, "Sm","     ",  -68025.381   ,  42.391    , 8213.798 ,   0.309 , -8009.   ,  200.   , 136.926971746  ,   45.508  },
	{ 74  , 63 , 137, "Eu","    x",  -60016.      , 196.       , 8150.    ,   1.    , -8803.   ,  446.   , 136.935570     ,  210.     },
	{ 73  , 64 , 137, "Gd","    x",  -51214.      , 401.       , 8080.    ,   3.    ,-10209.   ,  718.   , 136.945020     ,  430.     },
	{ 72  , 65 , 137, "Tb","    x",  -41004.      , 596.       , 7999.    ,   4.    , STAR     , STAR    , 136.955980     ,  640.     },
	{ 87  , 51 , 138, "Sb","    x",  -55154.      , 298.       , 8182.    ,   2.    , 10777.   ,  362.   , 137.940790     ,  320.     },
	{ 86  , 52 , 138, "Te","    x",  -65931.      , 205.       , 8254.    ,   1.    ,  6400.   ,  221.   , 137.929220     ,  220.     },
	{ 85  , 53 , 138, "I ","    +",  -72330.890   ,  82.351    , 8294.988 ,   0.597 ,  7820.000,   70.000, 137.922349591  ,   88.407  },
	{ 84  , 54 , 138, "Xe","    +",  -80150.890   ,  43.378    , 8345.985 ,   0.314 ,  2736.517,   42.400, 137.913954475  ,   46.568  },
	{ 83  , 55 , 138, "Cs","     ",  -82887.407   ,   9.160    , 8360.146 ,   0.066 ,  5374.224,    9.160, 137.911016704  ,    9.833  },
	{ 82  , 56 , 138, "Ba","     ",  -88261.631   ,   0.423    , 8393.420 ,   0.003 , -1736.950,    3.524, 137.905247237  ,    0.453  },
	{ 81  , 57 , 138, "La","   +n",  -86524.681   ,   3.528    , 8375.164 ,   0.026 ,  1043.841,   10.363, 137.907111930  ,    3.787  },
	{ 80  , 58 , 138, "Ce","     ",  -87568.521   ,  10.156    , 8377.059 ,   0.074 , -4437.000,   10.000, 137.905991321  ,   10.902  },
	{ 79  , 59 , 138, "Pr","    -",  -83131.521   ,  14.253    , 8339.238 ,   0.103 , -1113.438,   18.515, 137.910754636  ,   15.300  },
	{ 78  , 60 , 138, "Nd","    x",  -82018.083   ,  11.817    , 8325.500 ,   0.086 , -7077.789,   29.927, 137.911949961  ,   12.686  },
	{ 77  , 61 , 138, "Pm","    x",  -74940.294   ,  27.494    , 8268.543 ,   0.199 , -3442.504,   29.927, 137.919548281  ,   29.516  },
	{ 76  , 62 , 138, "Sm","    x",  -71497.790   ,  11.817    , 8237.928 ,   0.086 , -9748.121,   30.341, 137.923243961  ,   12.686  },
	{ 75  , 63 , 138, "Eu","    x",  -61749.669   ,  27.945    , 8161.620 ,   0.202 , -5972.   ,  198.   , 137.933709000  ,   30.000  },
	{ 74  , 64 , 138, "Gd","    x",  -55778.      , 196.       , 8113.    ,   1.    ,-12147.   ,  446.   , 137.940120     ,  210.     },
	{ 73  , 65 , 138, "Tb","    x",  -43631.      , 401.       , 8019.    ,   3.    , -8691.   ,  718.   , 137.953160     ,  430.     },
	{ 72  , 66 , 138, "Dy","    x",  -34940.      , 596.       , 7950.    ,   4.    , STAR     , STAR    , 137.962490     ,  640.     },
	{ 88  , 51 , 139, "Sb","    x",  -50319.      , 503.       , 8146.    ,   4.    , 10479.   ,  643.   , 138.945980     ,  540.     },
	{ 87  , 52 , 139, "Te","    x",  -60799.      , 401.       , 8216.    ,   3.    ,  8039.   ,  402.   , 138.934730     ,  430.     },
	{ 86  , 53 , 139, "I ","    +",  -68837.893   ,  31.074    , 8268.249 ,   0.224 ,  6806.000,   23.000, 138.926099478  ,   33.359  },
	{ 85  , 54 , 139, "Xe","    +",  -75643.893   ,  20.894    , 8311.585 ,   0.150 ,  5057.023,   20.655, 138.918792936  ,   22.431  },
	{ 84  , 55 , 139, "Cs","    +",  -80700.915   ,   3.152    , 8342.338 ,   0.023 ,  4212.829,    3.123, 138.913363999  ,    3.384  },
	{ 83  , 56 , 139, "Ba","     ",  -84913.745   ,   0.424    , 8367.017 ,   0.003 ,  2317.626,    2.408, 138.908841341  ,    0.455  },
	{ 82  , 57 , 139, "La","     ",  -87231.371   ,   2.415    , 8378.063 ,   0.017 ,  -278.875,    6.950, 138.906353267  ,    2.592  },
	{ 81  , 58 , 139, "Ce","     ",  -86952.496   ,   7.347    , 8370.428 ,   0.053 , -2129.161,    2.996, 138.906652651  ,    7.886  },
	{ 80  , 59 , 139, "Pr","     ",  -84823.335   ,   7.916    , 8349.482 ,   0.057 , -2831.638,   26.407, 138.908938399  ,    8.498  },
	{ 79  , 60 , 139, "Nd","     ",  -81991.697   ,  25.845    , 8323.482 ,   0.186 , -4495.198,   24.680, 138.911978288  ,   27.745  },
	{ 78  , 61 , 139, "Pm","     ",  -77496.499   ,  13.481    , 8285.514 ,   0.097 , -5116.252,   17.326, 138.916804082  ,   14.472  },
	{ 77  , 62 , 139, "Sm","    x",  -72380.247   ,  10.884    , 8243.078 ,   0.078 , -6982.177,   17.071, 138.922296605  ,   11.684  },
	{ 76  , 63 , 139, "Eu","    x",  -65398.070   ,  13.151    , 8187.218 ,   0.095 , -7869.   ,  196.   , 138.929792280  ,   14.117  },
	{ 75  , 64 , 139, "Gd","    x",  -57529.      , 196.       , 8125.    ,   1.    , -9362.   ,  357.   , 138.938240     ,  210.     },
	{ 74  , 65 , 139, "Tb","    x",  -48168.      , 298.       , 8052.    ,   2.    ,-10479.   ,  585.   , 138.948290     ,  320.     },
	{ 73  , 66 , 139, "Dy","    x",  -37688.      , 503.       , 7971.    ,   4.    , STAR     , STAR    , 138.959540     ,  540.     },
	{ 88  , 52 , 140, "Te","    x",  -56961.      , 298.       , 8188.    ,   2.    ,  7312.   ,  357.   , 139.938850     ,  320.     },
	{ 87  , 53 , 140, "I ","    x",  -64273.      , 196.       , 8234.    ,   1.    ,  8718.   ,  205.   , 139.931000     ,  210.     },
	{ 86  , 54 , 140, "Xe","    +",  -72990.992   ,  60.558    , 8290.919 ,   0.433 ,  4060.000,   60.000, 139.921640943  ,   65.011  },
	{ 85  , 55 , 140, "Cs","     ",  -77050.992   ,   8.203    , 8314.331 ,   0.059 ,  6220.376,    9.893, 139.917282354  ,    8.805  },
	{ 84  , 56 , 140, "Ba","     ",  -83271.368   ,   7.959    , 8353.174 ,   0.057 ,  1049.663,    8.042, 139.910604505  ,    8.544  },
	{ 83  , 57 , 140, "La","     ",  -84321.031   ,   2.415    , 8355.083 ,   0.017 ,  3762.248,    1.829, 139.909477645  ,    2.592  },
	{ 82  , 58 , 140, "Ce","     ",  -88083.278   ,   2.462    , 8376.368 ,   0.018 , -3388.000,    6.000, 139.905438706  ,    2.642  },
	{ 81  , 59 , 140, "Pr","    -",  -84695.278   ,   6.485    , 8346.580 ,   0.046 ,  -443.508,   28.688, 139.909075874  ,    6.962  },
	{ 80  , 60 , 140, "Nd","    x",  -84251.770   ,  27.945    , 8337.824 ,   0.200 , -6045.200,   24.000, 139.909552000  ,   30.000  },
	{ 79  , 61 , 140, "Pm","    -",  -78206.570   ,  36.836    , 8289.056 ,   0.263 , -2750.607,   38.899, 139.916041789  ,   39.545  },
	{ 78  , 62 , 140, "Sm","    x",  -75455.963   ,  12.497    , 8263.820 ,   0.089 , -8470.000,   50.000, 139.918994687  ,   13.416  },
	{ 77  , 63 , 140, "Eu","    -",  -66985.963   ,  51.538    , 8197.732 ,   0.368 , -5203.691,   58.627, 139.928087607  ,   55.328  },
	{ 76  , 64 , 140, "Gd","    x",  -61782.272   ,  27.945    , 8154.975 ,   0.200 ,-11300.000,  800.000, 139.933674000  ,   30.000  },
	{ 75  , 65 , 140, "Tb","    -",  -50482.272   , 800.488    , 8068.672 ,   5.718 , -7643.   ,  945.   , 139.945805049  ,  859.359  },
	{ 74  , 66 , 140, "Dy","    x",  -42839.      , 503.       , 8008.    ,   4.    ,-13534.   ,  711.   , 139.954010     ,  540.     },
	{ 73  , 67 , 140, "Ho","   -p",  -29305.      , 503.       , 7906.    ,   4.    , STAR     , STAR    , 139.968539     ,  540.     },
	{ 89  , 52 , 141, "Te","    x",  -51558.      , 401.       , 8148.    ,   3.    ,  8961.   ,  446.   , 140.944650     ,  430.     },
	{ 88  , 53 , 141, "I ","    x",  -60519.      , 196.       , 8206.    ,   1.    ,  7808.   ,  216.   , 140.935030     ,  210.     },
	{ 87  , 54 , 141, "Xe","    +",  -68326.902   ,  90.613    , 8256.283 ,   0.643 ,  6150.000,   90.000, 140.926648049  ,   97.277  },
	{ 86  , 55 , 141, "Cs","     ",  -74476.902   ,  10.525    , 8294.351 ,   0.075 ,  5248.730,   10.910, 140.920045752  ,   11.299  },
	{ 85  , 56 , 141, "Ba","     ",  -79725.632   ,   8.108    , 8326.028 ,   0.058 ,  3212.589,    8.808, 140.914411009  ,    8.704  },
	{ 84  , 57 , 141, "La","     ",  -82938.221   ,   4.577    , 8343.264 ,   0.032 ,  2501.884,    3.920, 140.910962152  ,    4.913  },
	{ 83  , 58 , 141, "Ce","     ",  -85440.105   ,   2.462    , 8355.459 ,   0.017 ,   580.787,    1.058, 140.908276270  ,    2.643  },
	{ 82  , 59 , 141, "Pr","     ",  -86020.892   ,   2.468    , 8354.029 ,   0.018 , -1823.014,    2.809, 140.907652769  ,    2.649  },
	{ 81  , 60 , 141, "Nd","    -",  -84197.879   ,   3.739    , 8335.552 ,   0.027 , -3674.929,   14.464, 140.909609854  ,    4.014  },
	{ 80  , 61 , 141, "Pm","    x",  -80522.949   ,  13.972    , 8303.940 ,   0.099 , -4584.287,   16.421, 140.913555054  ,   15.000  },
	{ 79  , 62 , 141, "Sm","     ",  -75938.662   ,   8.627    , 8265.879 ,   0.061 , -6012.078,   14.319, 140.918476488  ,    9.261  },
	{ 78  , 63 , 141, "Eu","     ",  -69926.584   ,  12.641    , 8217.691 ,   0.090 , -6702.360,   23.457, 140.924930720  ,   13.570  },
	{ 77  , 64 , 141, "Gd","    x",  -63224.224   ,  19.760    , 8164.608 ,   0.140 , -8683.387,  107.098, 140.932126000  ,   21.213  },
	{ 76  , 65 , 141, "Tb","    x",  -54540.837   , 105.259    , 8097.475 ,   0.747 , -9224.   ,  316.   , 140.941448000  ,  113.000  },
	{ 75  , 66 , 141, "Dy","    x",  -45317.      , 298.       , 8027.    ,   2.    ,-10944.   ,  585.   , 140.951350     ,  320.     },
	{ 74  , 67 , 141, "Ho","   -p",  -34374.      , 503.       , 7943.    ,   4.    , STAR     , STAR    , 140.963098     ,  540.     },
	{ 90  , 52 , 142, "Te","    x",  -47432.      , 596.       , 8119.    ,   4.    ,  8290.   ,  718.   , 141.949080     ,  640.     },
	{ 89  , 53 , 142, "I ","    x",  -55722.      , 401.       , 8172.    ,   3.    ,  9753.   ,  413.   , 141.940180     ,  430.     },
	{ 88  , 54 , 142, "Xe","    +",  -65475.096   , 100.560    , 8234.897 ,   0.708 ,  5040.000,  100.000, 141.929709590  ,  107.955  },
	{ 87  , 55 , 142, "Cs","     ",  -70515.096   ,  10.600    , 8264.881 ,   0.075 ,  7308.052,   10.730, 141.924298927  ,   11.379  },
	{ 86  , 56 , 142, "Ba","     ",  -77823.147   ,   6.181    , 8310.836 ,   0.044 ,  2211.628,    4.576, 141.916453410  ,    6.635  },
	{ 85  , 57 , 142, "La","     ",  -80034.775   ,   5.663    , 8320.902 ,   0.040 ,  4503.704,    5.251, 141.914079130  ,    6.079  },
	{ 84  , 58 , 142, "Ce","     ",  -84538.479   ,   2.993    , 8347.108 ,   0.021 ,  -745.754,    2.376, 141.909244205  ,    3.213  },
	{ 83  , 59 , 142, "Pr","     ",  -83792.724   ,   2.468    , 8336.347 ,   0.017 ,  2162.471,    1.503, 141.910044806  ,    2.649  },
	{ 82  , 60 , 142, "Nd","     ",  -85955.195   ,   2.328    , 8346.066 ,   0.016 , -4798.288,   25.169, 141.907723297  ,    2.498  },
	{ 81  , 61 , 142, "Pm","    x",  -81156.907   ,  25.061    , 8306.766 ,   0.176 , -2164.018,   25.696, 141.912874471  ,   26.904  },
	{ 80  , 62 , 142, "Sm","     ",  -78992.889   ,   5.675    , 8286.017 ,   0.040 , -7673.000,   30.000, 141.915197641  ,    6.092  },
	{ 79  , 63 , 142, "Eu","    -",  -71319.889   ,  30.532    , 8226.472 ,   0.215 , -4360.374,   41.390, 141.923434945  ,   32.777  },
	{ 78  , 64 , 142, "Gd","    x",  -66959.515   ,  27.945    , 8190.256 ,   0.197 , -9900.   ,  300.   , 141.928116000  ,   30.000  },
	{ 77  , 65 , 142, "Tb","    -",  -57060.      , 301.       , 8115.    ,   2.    , -7100.000,  200.000, 141.938744     ,  323.     },
	{ 76  , 66 , 142, "Dy","    -",  -49960.      , 362.       , 8060.    ,   3.    ,-12486.   ,  620.   , 141.946366     ,  388.     },
	{ 75  , 67 , 142, "Ho","    x",  -37474.      , 503.       , 7966.    ,   4.    , STAR     , STAR    , 141.959770     ,  540.     },
	{ 90  , 53 , 143, "I ","    x",  -51642.      , 401.       , 8142.    ,   3.    ,  8803.   ,  446.   , 142.944560     ,  430.     },
	{ 89  , 54 , 143, "Xe","    x",  -60445.      , 196.       , 8199.    ,   1.    ,  7227.   ,  197.   , 142.935110     ,  210.     },
	{ 88  , 55 , 143, "Cs","     ",  -67671.410   ,  23.686    , 8243.641 ,   0.166 ,  6264.326,   21.812, 142.927351750  ,   25.427  },
	{ 87  , 56 , 143, "Ba","     ",  -73935.736   ,  13.248    , 8281.977 ,   0.093 ,  4251.337,   18.197, 142.920626719  ,   14.222  },
	{ 86  , 57 , 143, "La","     ",  -78187.073   ,  15.425    , 8306.235 ,   0.108 ,  3424.926,   15.246, 142.916062720  ,   16.559  },
	{ 85  , 58 , 143, "Ce","     ",  -81611.999   ,   2.993    , 8324.715 ,   0.021 ,  1461.499,    1.823, 142.912385910  ,    3.212  },
	{ 84  , 59 , 143, "Pr","     ",  -83073.499   ,   2.633    , 8329.464 ,   0.018 ,   933.950,    1.353, 142.910816926  ,    2.827  },
	{ 83  , 60 , 143, "Nd","     ",  -84007.448   ,   2.328    , 8330.524 ,   0.016 , -1041.714,    2.415, 142.909814290  ,    2.498  },
	{ 82  , 61 , 143, "Pm","     ",  -82965.734   ,   3.308    , 8317.769 ,   0.023 , -3442.543,    3.555, 142.910932616  ,    3.551  },
	{ 81  , 62 , 143, "Sm","     ",  -79523.191   ,   3.630    , 8288.224 ,   0.025 , -5280.799,   11.570, 142.914628338  ,    3.897  },
	{ 80  , 63 , 143, "Eu","    x",  -74242.392   ,  10.986    , 8245.824 ,   0.077 , -6010.000,  200.000, 142.920297509  ,   11.793  },
	{ 79  , 64 , 143, "Gd","    -",  -68232.392   , 200.301    , 8198.326 ,   1.401 , -7797.992,  208.985, 142.926749510  ,  215.032  },
	{ 78  , 65 , 143, "Tb","    x",  -60434.400   ,  59.616    , 8138.323 ,   0.417 , -8112.   ,  204.   , 142.935121000  ,   64.000  },
	{ 77  , 66 , 143, "Dy","    x",  -52322.      , 196.       , 8076.    ,   1.    ,-10042.   ,  446.   , 142.943830     ,  210.     },
	{ 76  , 67 , 143, "Ho","    x",  -42281.      , 401.       , 8000.    ,   3.    ,-10926.   ,  718.   , 142.954610     ,  430.     },
	{ 75  , 68 , 143, "Er","    x",  -31354.      , 596.       , 7919.    ,   4.    , STAR     , STAR    , 142.966340     ,  640.     },
	{ 91  , 53 , 144, "I ","    x",  -46584.      , 503.       , 8107.    ,   3.    , 10694.   ,  585.   , 143.949990     ,  540.     },
	{ 90  , 54 , 144, "Xe","    x",  -57278.      , 298.       , 8176.    ,   2.    ,  5992.   ,  299.   , 143.938510     ,  320.     },
	{ 89  , 55 , 144, "Cs","     ",  -63269.947   ,  26.252    , 8211.879 ,   0.182 ,  8499.008,   25.518, 143.932076914  ,   28.182  },
	{ 88  , 56 , 144, "Ba","     ",  -71768.956   ,  13.349    , 8265.467 ,   0.093 ,  3123.492,   48.895, 143.922952853  ,   14.331  },
	{ 87  , 57 , 144, "La","     ",  -74892.447   ,  48.815    , 8281.725 ,   0.339 ,  5544.542,   48.807, 143.919599647  ,   52.405  },
	{ 86  , 58 , 144, "Ce","     ",  -80436.989   ,   3.444    , 8314.795 ,   0.024 ,   318.656,    0.832, 143.913647336  ,    3.696  },
	{ 85  , 59 , 144, "Pr","     ",  -80755.645   ,   3.342    , 8311.575 ,   0.023 ,  2997.521,    2.399, 143.913305245  ,    3.587  },
	{ 84  , 60 , 144, "Nd","     ",  -83753.165   ,   2.328    , 8326.959 ,   0.016 , -2332.060,    2.249, 143.910087274  ,    2.498  },
	{ 83  , 61 , 144, "Pm","     ",  -81421.106   ,   3.190    , 8305.331 ,   0.022 ,   550.853,    2.551, 143.912590843  ,    3.424  },
	{ 82  , 62 , 144, "Sm","     ",  -81971.958   ,   2.807    , 8303.723 ,   0.019 , -6350.316,   10.908, 143.911999478  ,    3.013  },
	{ 81  , 63 , 144, "Eu","     ",  -75621.643   ,  10.827    , 8254.191 ,   0.075 , -3862.139,   29.969, 143.918816823  ,   11.623  },
	{ 80  , 64 , 144, "Gd","    x",  -71759.504   ,  27.945    , 8221.937 ,   0.194 , -9391.323,   39.520, 143.922963000  ,   30.000  },
	{ 79  , 65 , 144, "Tb","    x",  -62368.181   ,  27.945    , 8151.287 ,   0.194 , -5783.646,   41.543, 143.933045000  ,   30.000  },
	{ 78  , 66 , 144, "Dy","    x",  -56584.535   ,  30.739    , 8105.690 ,   0.213 ,-11388.   ,  300.   , 143.939254000  ,   33.000  },
	{ 77  , 67 , 144, "Ho","    x",  -45196.      , 298.       , 8021.    ,   2.    , -8290.   ,  499.   , 143.951480     ,  320.     },
	{ 76  , 68 , 144, "Er","    x",  -36906.      , 401.       , 7958.    ,   3.    , STAR     , STAR    , 143.960380     ,  430.     },
	{ 91  , 54 , 145, "Xe","    x",  -52098.      , 298.       , 8139.    ,   2.    ,  7959.   ,  298.   , 144.944070     ,  320.     },
	{ 90  , 55 , 145, "Cs","     ",  -60056.986   ,  10.842    , 8188.751 ,   0.075 ,  7358.000,   70.000, 144.935526170  ,   11.639  },
	{ 89  , 56 , 145, "Ba","    -",  -67414.986   ,  70.835    , 8234.100 ,   0.489 ,  5571.853,  114.628, 144.927627032  ,   76.044  },
	{ 88  , 57 , 145, "La","    +",  -72986.839   ,  90.123    , 8267.131 ,   0.622 ,  4110.000,   80.000, 144.921645401  ,   96.750  },
	{ 87  , 58 , 145, "Ce","    +",  -77096.839   ,  41.498    , 8290.081 ,   0.286 ,  2535.000,   40.825, 144.917233135  ,   44.550  },
	{ 86  , 59 , 145, "Pr","     ",  -79631.839   ,   7.446    , 8302.168 ,   0.051 ,  1805.295,    7.071, 144.914511700  ,    7.993  },
	{ 85  , 60 , 145, "Nd","     ",  -81437.134   ,   2.334    , 8309.223 ,   0.016 ,  -163.372,    2.181, 144.912573636  ,    2.505  },
	{ 84  , 61 , 145, "Pm","     ",  -81273.762   ,   3.137    , 8302.701 ,   0.022 ,  -616.026,    2.422, 144.912749023  ,    3.367  },
	{ 83  , 62 , 145, "Sm","     ",  -80657.737   ,   2.814    , 8293.057 ,   0.019 , -2659.307,    2.721, 144.913410353  ,    3.020  },
	{ 82  , 63 , 145, "Eu","     ",  -77998.429   ,   3.843    , 8269.321 ,   0.027 , -5071.067,   19.146, 144.916265237  ,    4.125  },
	{ 81  , 64 , 145, "Gd","    x",  -72927.362   ,  18.756    , 8228.953 ,   0.129 , -7046.517,   59.837, 144.921709252  ,   20.135  },
	{ 80  , 65 , 145, "Tb","    x",  -65880.845   ,  56.821    , 8174.961 ,   0.392 , -7592.608,   72.883, 144.929274000  ,   61.000  },
	{ 79  , 66 , 145, "Dy","    x",  -58288.238   ,  45.643    , 8117.202 ,   0.315 , -9105.   ,  302.   , 144.937425000  ,   49.000  },
	{ 78  , 67 , 145, "Ho","    x",  -49183.      , 298.       , 8049.    ,   2.    , -9492.   ,  499.   , 144.947200     ,  320.     },
	{ 77  , 68 , 145, "Er","    x",  -39691.      , 401.       , 7978.    ,   3.    ,-11814.   ,  567.   , 144.957390     ,  430.     },
	{ 76  , 69 , 145, "Tm","   -p",  -27877.      , 401.       , 7891.    ,   3.    , STAR     , STAR    , 144.970073     ,  430.     },
	{ 92  , 54 , 146, "Xe","    x",  -48671.      , 401.       , 8115.    ,   3.    ,  6949.   ,  407.   , 145.947750     ,  430.     },
	{ 91  , 55 , 146, "Cs","     ",  -55620.044   ,  71.271    , 8157.557 ,   0.488 ,  9380.006,   37.033, 145.940289423  ,   76.512  },
	{ 90  , 56 , 146, "Ba","     ",  -65000.050   ,  72.302    , 8216.445 ,   0.495 ,  4122.897,   42.531, 145.930219572  ,   77.619  },
	{ 89  , 57 , 146, "La","     ",  -69122.947   ,  71.388    , 8239.325 ,   0.489 ,  6552.549,   46.510, 145.925793460  ,   76.638  },
	{ 88  , 58 , 146, "Ce","     ",  -75675.496   ,  66.442    , 8278.847 ,   0.455 ,  1038.312,   35.196, 145.918759009  ,   71.328  },
	{ 87  , 59 , 146, "Pr","     ",  -76713.808   ,  61.711    , 8280.600 ,   0.423 ,  4217.242,   61.689, 145.917644336  ,   66.249  },
	{ 86  , 60 , 146, "Nd","     ",  -80931.050   ,   2.334    , 8304.127 ,   0.016 , -1471.170,    4.160, 145.913116939  ,    2.505  },
	{ 85  , 61 , 146, "Pm","    +",  -79459.880   ,   4.687    , 8288.692 ,   0.032 ,  1542.000,    3.000, 145.914696305  ,    5.031  },
	{ 84  , 62 , 146, "Sm","     ",  -81001.880   ,   3.601    , 8293.895 ,   0.025 , -3879.595,    5.879, 145.913040900  ,    3.866  },
	{ 83  , 63 , 146, "Eu","     ",  -77122.285   ,   6.233    , 8261.964 ,   0.043 , -1029.106,    7.141, 145.917205817  ,    6.691  },
	{ 82  , 64 , 146, "Gd","     ",  -76093.179   ,   4.707    , 8249.557 ,   0.032 , -8323.809,   45.058, 145.918310608  ,    5.052  },
	{ 81  , 65 , 146, "Tb","     ",  -67769.370   ,  45.211    , 8187.186 ,   0.310 , -5215.234,   49.829, 145.927246584  ,   48.535  },
	{ 80  , 66 , 146, "Dy","     ",  -62554.136   ,  27.112    , 8146.107 ,   0.186 ,-10987.   ,  197.   , 145.932845369  ,   29.106  },
	{ 79  , 67 , 146, "Ho","    x",  -51568.      , 196.       , 8065.    ,   1.    , -6856.   ,  357.   , 145.944640     ,  210.     },
	{ 78  , 68 , 146, "Er","    x",  -44712.      , 298.       , 8013.    ,   2.    ,-13437.   ,  499.   , 145.952000     ,  320.     },
	{ 77  , 69 , 146, "Tm","   -p",  -31275.      , 401.       , 7916.    ,   3.    , STAR     , STAR    , 145.966425     ,  430.     },
	{ 93  , 54 , 147, "Xe","    x",  -43259.      , 401.       , 8078.    ,   3.    ,  8761.   ,  404.   , 146.953560     ,  430.     },
	{ 92  , 55 , 147, "Cs","     ",  -52019.275   ,  53.056    , 8132.475 ,   0.361 ,  8579.   ,  212.   , 146.944155008  ,   56.957  },
	{ 91  , 56 , 147, "Ba","    +",  -60598.      , 206.       , 8186.    ,   1.    ,  6250.   ,  200.   , 146.934945     ,  221.     },
	{ 90  , 57 , 147, "La","    +",  -66848.403   ,  48.072    , 8222.709 ,   0.327 ,  5180.345,   37.139, 146.928235284  ,   51.607  },
	{ 89  , 58 , 147, "Ce","    +",  -72028.748   ,  30.523    , 8252.628 ,   0.208 ,  3426.000,   20.000, 146.922673954  ,   32.767  },
	{ 88  , 59 , 147, "Pr","    +",  -75454.748   ,  23.057    , 8270.612 ,   0.157 ,  2697.188,   22.938, 146.918995992  ,   24.752  },
	{ 87  , 60 , 147, "Nd","     ",  -78151.936   ,   2.335    , 8283.638 ,   0.016 ,   896.000,    0.896, 146.916100441  ,    2.506  },
	{ 86  , 61 , 147, "Pm","     ",  -79047.936   ,   2.409    , 8284.411 ,   0.016 ,   224.139,    0.301, 146.915138545  ,    2.586  },
	{ 85  , 62 , 147, "Sm","     ",  -79272.075   ,   2.412    , 8280.614 ,   0.016 , -1721.576,    2.295, 146.914897923  ,    2.589  },
	{ 84  , 63 , 147, "Eu","     ",  -77550.499   ,   3.228    , 8263.580 ,   0.022 , -2187.436,    2.775, 146.916746111  ,    3.465  },
	{ 83  , 64 , 147, "Gd","     ",  -75363.063   ,   3.030    , 8243.378 ,   0.021 , -4611.049,   11.523, 146.919094420  ,    3.252  },
	{ 82  , 65 , 147, "Tb","    -",  -70752.013   ,  11.915    , 8206.688 ,   0.081 , -6564.159,   23.074, 146.924044585  ,   12.791  },
	{ 81  , 66 , 147, "Dy","    x",  -64187.855   ,  19.760    , 8156.712 ,   0.134 , -8350.378,   34.225, 146.931091500  ,   21.213  },
	{ 80  , 67 , 147, "Ho","    x",  -55837.477   ,  27.945    , 8094.584 ,   0.190 , -8788.   ,  299.   , 146.940056000  ,   30.000  },
	{ 79  , 68 , 147, "Er","    x",  -47050.      , 298.       , 8029.    ,   2.    ,-10685.   ,  422.   , 146.949490     ,  320.     },
	{ 78  , 69 , 147, "Tm","   -p",  -36365.      , 298.       , 7951.    ,   2.    , STAR     , STAR    , 146.960961     ,  320.     },
	{ 93  , 55 , 148, "Cs","     ",  -47302.986   , 575.724    , 8100.195 ,   3.890 , 10710.417,  581.848, 147.949218153  ,  618.065  },
	{ 92  , 56 , 148, "Ba","    +",  -58013.403   ,  84.181    , 8167.277 ,   0.569 ,  5115.000,   60.000, 147.937720047  ,   90.371  },
	{ 91  , 57 , 148, "La","    +",  -63128.403   ,  59.045    , 8196.551 ,   0.399 ,  7262.354,   51.191, 147.932228868  ,   63.387  },
	{ 90  , 58 , 148, "Ce","    +",  -70390.756   ,  29.425    , 8240.335 ,   0.199 ,  2140.000,   14.000, 147.924432410  ,   31.588  },
	{ 89  , 59 , 148, "Pr","    +",  -72530.756   ,  25.881    , 8249.508 ,   0.175 ,  4882.647,   25.725, 147.922135026  ,   27.784  },
	{ 88  , 60 , 148, "Nd","     ",  -77413.404   ,   2.837    , 8277.213 ,   0.019 ,  -541.505,    5.902, 147.916893288  ,    3.045  },
	{ 87  , 61 , 148, "Pm","   +p",  -76871.898   ,   6.083    , 8268.268 ,   0.041 ,  2470.270,    5.639, 147.917474618  ,    6.530  },
	{ 86  , 62 , 148, "Sm","     ",  -79342.169   ,   2.417    , 8279.673 ,   0.016 , -3039.671,   10.309, 147.914822674  ,    2.594  },
	{ 85  , 63 , 148, "Eu","     ",  -76302.498   ,  10.208    , 8253.849 ,   0.069 ,   -26.668,   10.366, 147.918085895  ,   10.958  },
	{ 84  , 64 , 148, "Gd","     ",  -76275.830   ,   2.807    , 8248.382 ,   0.019 , -5735.373,   14.120, 147.918114524  ,    3.013  },
	{ 83  , 65 , 148, "Tb","     ",  -70540.457   ,  13.907    , 8204.344 ,   0.094 , -2680.961,    9.723, 147.924271701  ,   14.929  },
	{ 82  , 66 , 148, "Dy","     ",  -67859.496   ,  10.583    , 8180.943 ,   0.072 , -9844.186,  129.909, 147.927149831  ,   11.360  },
	{ 81  , 67 , 148, "Ho","    x",  -58015.310   , 129.478    , 8109.142 ,   0.875 , -6364.   ,  235.   , 147.937718000  ,  139.000  },
	{ 80  , 68 , 148, "Er","    x",  -51651.      , 196.       , 8061.    ,   1.    ,-12380.   ,  446.   , 147.944550     ,  210.     },
	{ 79  , 69 , 148, "Tm","    x",  -39272.      , 401.       , 7972.    ,   3.    , -8924.   ,  718.   , 147.957840     ,  430.     },
	{ 78  , 70 , 148, "Yb","    x",  -30348.      , 596.       , 7906.    ,   4.    , STAR     , STAR    , 147.967420     ,  640.     },
	{ 94  , 55 , 149, "Cs","    x",  -43845.      , 196.       , 8077.    ,   1.    ,  9641.   ,  277.   , 148.952930     ,  210.     },
	{ 93  , 56 , 149, "Ba","    x",  -53486.      , 196.       , 8136.    ,   1.    ,  7309.   ,  371.   , 148.942580     ,  210.     },
	{ 92  , 57 , 149, "La","    +",  -60795.      , 315.       , 8180.    ,   2.    ,  5900.   ,  300.   , 148.934734     ,  338.     },
	{ 91  , 58 , 149, "Ce","    +",  -66695.080   ,  96.908    , 8214.397 ,   0.650 ,  4361.471,   51.450, 148.928399883  ,  104.034  },
	{ 90  , 59 , 149, "Pr","    +",  -71056.550   ,  82.122    , 8238.418 ,   0.551 ,  3324.324,   82.073, 148.923717651  ,   88.161  },
	{ 89  , 60 , 149, "Nd","     ",  -74380.875   ,   2.838    , 8255.479 ,   0.019 ,  1690.370,    3.445, 148.920148842  ,    3.046  },
	{ 88  , 61 , 149, "Pm","     ",  -76071.245   ,   4.159    , 8261.573 ,   0.028 ,  1070.677,    3.505, 148.918334155  ,    4.464  },
	{ 87  , 62 , 149, "Sm","     ",  -77141.922   ,   2.443    , 8263.508 ,   0.016 ,  -695.362,    3.732, 148.917184735  ,    2.622  },
	{ 86  , 63 , 149, "Eu","     ",  -76446.560   ,   4.348    , 8253.590 ,   0.029 , -1313.107,    4.141, 148.917931238  ,    4.667  },
	{ 85  , 64 , 149, "Gd","     ",  -75133.454   ,   3.950    , 8239.527 ,   0.027 , -3637.478,    4.359, 148.919340915  ,    4.240  },
	{ 84  , 65 , 149, "Tb","     ",  -71495.975   ,   4.284    , 8209.864 ,   0.029 , -3780.821,    8.779, 148.923245909  ,    4.598  },
	{ 83  , 66 , 149, "Dy","     ",  -67715.154   ,   8.764    , 8179.238 ,   0.059 , -6026.751,   16.183, 148.927304787  ,    9.408  },
	{ 82  , 67 , 149, "Ho","    -",  -61688.403   ,  18.404    , 8133.540 ,   0.124 , -7946.788,   33.461, 148.933774771  ,   19.757  },
	{ 81  , 68 , 149, "Er","    x",  -53741.615   ,  27.945    , 8074.955 ,   0.188 , -9701.   ,  299.   , 148.942306000  ,   30.000  },
	{ 80  , 69 , 149, "Tm","    x",  -44041.      , 298.       , 8005.    ,   2.    ,-10545.   ,  585.   , 148.952720     ,  320.     },
	{ 79  , 70 , 149, "Yb","    x",  -33497.      , 503.       , 7929.    ,   3.    , STAR     , STAR    , 148.964040     ,  540.     },
	{ 95  , 55 , 150, "Cs","    x",  -38964.      , 298.       , 8044.    ,   2.    , 11634.   ,  499.   , 149.958170     ,  320.     },
	{ 94  , 56 , 150, "Ba","    x",  -50599.      , 401.       , 8117.    ,   3.    ,  6437.   ,  566.   , 149.945680     ,  430.     },
	{ 93  , 57 , 150, "La","    x",  -57035.      , 401.       , 8154.    ,   3.    ,  7788.   ,  403.   , 149.938770     ,  430.     },
	{ 92  , 58 , 150, "Ce","    +",  -64823.663   ,  47.814    , 8200.968 ,   0.319 ,  3480.000,   40.000, 149.930408931  ,   51.330  },
	{ 91  , 59 , 150, "Pr","    +",  -68303.663   ,  26.194    , 8218.952 ,   0.175 ,  5386.000,   26.000, 149.926672997  ,   28.120  },
	{ 90  , 60 , 150, "Nd","     ",  -73689.663   ,   3.184    , 8249.643 ,   0.021 ,   -86.324,   20.121, 149.920890888  ,    3.418  },
	{ 89  , 61 , 150, "Pm","    +",  -73603.339   ,  20.147    , 8243.852 ,   0.134 ,  3454.000,   20.000, 149.920983561  ,   21.629  },
	{ 88  , 62 , 150, "Sm","     ",  -77057.339   ,   2.433    , 8261.663 ,   0.016 , -2260.066,    6.208, 149.917275539  ,    2.611  },
	{ 87  , 63 , 150, "Eu","     ",  -74797.274   ,   6.497    , 8241.380 ,   0.043 ,   971.496,    3.544, 149.919701819  ,    6.975  },
	{ 86  , 64 , 150, "Gd","     ",  -75768.769   ,   6.317    , 8242.641 ,   0.042 , -4658.225,    8.391, 149.918658876  ,    6.781  },
	{ 85  , 65 , 150, "Tb","     ",  -71110.545   ,   7.556    , 8206.371 ,   0.050 , -1793.590,    8.445, 149.923659686  ,    8.111  },
	{ 84  , 66 , 150, "Dy","     ",  -69316.955   ,   4.910    , 8189.198 ,   0.033 , -7369.047,   14.562, 149.925585184  ,    5.271  },
	{ 83  , 67 , 150, "Ho","     ",  -61947.908   ,  14.182    , 8134.855 ,   0.095 , -4115.021,   13.592, 149.933496182  ,   15.225  },
	{ 82  , 68 , 150, "Er","     ",  -57832.887   ,  17.201    , 8102.206 ,   0.115 ,-11221.   ,  196.   , 149.937913839  ,   18.466  },
	{ 81  , 69 , 150, "Tm","    x",  -46612.      , 196.       , 8022.    ,   1.    , -7880.   ,  446.   , 149.949960     ,  210.     },
	{ 80  , 70 , 150, "Yb","    x",  -38732.      , 401.       , 7964.    ,   3.    ,-13794.   ,  643.   , 149.958420     ,  430.     },
	{ 79  , 71 , 150, "Lu","   -p",  -24938.      , 503.       , 7867.    ,   3.    , STAR     , STAR    , 149.973228     ,  540.     },
	{ 96  , 55 , 151, "Cs","    x",  -35220.      , 503.       , 8020.    ,   3.    , 10600.   ,  643.   , 150.962190     ,  540.     },
	{ 95  , 56 , 151, "Ba","    x",  -45820.      , 401.       , 8085.    ,   3.    ,  8467.   ,  566.   , 150.950810     ,  430.     },
	{ 94  , 57 , 151, "La","    x",  -54287.      , 401.       , 8136.    ,   3.    ,  7213.   ,  413.   , 150.941720     ,  430.     },
	{ 93  , 58 , 151, "Ce","    +",  -61500.777   , 102.629    , 8178.103 ,   0.680 ,  5270.000,  100.000, 150.933976196  ,  110.176  },
	{ 92  , 59 , 151, "Pr","    +",  -66770.777   ,  23.079    , 8207.823 ,   0.153 ,  4182.119,   22.858, 150.928318618  ,   24.776  },
	{ 91  , 60 , 151, "Nd","   -n",  -70952.896   ,   3.186    , 8230.338 ,   0.021 ,  2442.336,    4.495, 150.923828929  ,    3.420  },
	{ 90  , 61 , 151, "Pm","     ",  -73395.232   ,   5.340    , 8241.331 ,   0.035 ,  1187.249,    4.809, 150.921206973  ,    5.732  },
	{ 89  , 62 , 151, "Sm","     ",  -74582.481   ,   2.433    , 8244.012 ,   0.016 ,    76.613,    0.539, 150.919932409  ,    2.612  },
	{ 88  , 63 , 151, "Eu","     ",  -74659.094   ,   2.455    , 8239.339 ,   0.016 ,  -464.183,    2.779, 150.919850161  ,    2.635  },
	{ 87  , 64 , 151, "Gd","     ",  -74194.911   ,   3.674    , 8231.084 ,   0.024 , -2565.391,    3.760, 150.920348482  ,    3.944  },
	{ 86  , 65 , 151, "Tb","     ",  -71629.520   ,   4.582    , 8208.913 ,   0.030 , -2870.919,    5.125, 150.923102543  ,    4.918  },
	{ 85  , 66 , 151, "Dy","   -a",  -68758.601   ,   4.020    , 8184.719 ,   0.027 , -5126.515,   11.962, 150.926184601  ,    4.315  },
	{ 84  , 67 , 151, "Ho","   -a",  -63632.086   ,  12.053    , 8145.588 ,   0.080 , -5366.115,   20.409, 150.931688142  ,   12.939  },
	{ 83  , 68 , 151, "Er","    x",  -58265.971   ,  16.470    , 8104.869 ,   0.109 , -7484.169,   26.104, 150.937448903  ,   17.681  },
	{ 82  , 69 , 151, "Tm","   +a",  -50781.802   ,  20.252    , 8050.124 ,   0.134 , -9237.886,  300.190, 150.945483490  ,   21.741  },
	{ 81  , 70 , 151, "Yb","   ep",  -41543.916   , 300.493    , 7983.765 ,   1.990 ,-11342.   ,  501.   , 150.955400769  ,  322.592  },
	{ 80  , 71 , 151, "Lu","   -p",  -30202.      , 401.       , 7903.    ,   3.    , STAR     , STAR    , 150.967577     ,  430.     },
	{ 96  , 56 , 152, "Ba","    x",  -42597.      , 503.       , 8063.    ,   3.    ,  7471.   ,  643.   , 151.954270     ,  540.     },
	{ 95  , 57 , 152, "La","    x",  -50068.      , 401.       , 8107.    ,   3.    ,  9045.   ,  446.   , 151.946250     ,  430.     },
	{ 94  , 58 , 152, "Ce","    x",  -59113.      , 196.       , 8162.    ,   1.    ,  4695.   ,  231.   , 151.936540     ,  210.     },
	{ 93  , 59 , 152, "Pr","    +",  -63808.061   , 122.497    , 8187.433 ,   0.806 ,  6350.000,  120.000, 151.931499225  ,  131.506  },
	{ 92  , 60 , 152, "Nd","     ",  -70158.061   ,  24.609    , 8224.062 ,   0.162 ,  1104.215,   18.504, 151.924682219  ,   26.419  },
	{ 91  , 61 , 152, "Pm","     ",  -71262.276   ,  26.016    , 8226.180 ,   0.171 ,  3506.488,   25.911, 151.923496795  ,   27.929  },
	{ 90  , 62 , 152, "Sm","     ",  -74768.765   ,   2.471    , 8244.102 ,   0.016 , -1874.268,    0.709, 151.919732425  ,    2.652  },
	{ 89  , 63 , 152, "Eu","     ",  -72894.497   ,   2.455    , 8226.624 ,   0.016 ,  1819.709,    1.170, 151.921744534  ,    2.636  },
	{ 88  , 64 , 152, "Gd","   +n",  -74714.206   ,   2.513    , 8233.449 ,   0.017 , -3990.000,   40.000, 151.919790996  ,    2.697  },
	{ 87  , 65 , 152, "Tb","    -",  -70724.206   ,  40.079    , 8202.052 ,   0.264 ,  -599.754,   40.298, 151.924074438  ,   43.026  },
	{ 86  , 66 , 152, "Dy","   -a",  -70124.452   ,   5.181    , 8192.959 ,   0.034 , -6516.186,   14.837, 151.924718300  ,    5.561  },
	{ 85  , 67 , 152, "Ho","   -a",  -63608.266   ,  13.971    , 8144.942 ,   0.092 , -3108.093,    9.947, 151.931713714  ,   14.998  },
	{ 84  , 68 , 152, "Er","   -a",  -60500.173   ,  10.706    , 8119.347 ,   0.070 , -8729.599,   74.363, 151.935050389  ,   11.493  },
	{ 83  , 69 , 152, "Tm","    x",  -51770.574   ,  73.588    , 8056.769 ,   0.484 , -5465.000,  195.000, 151.944422000  ,   79.000  },
	{ 82  , 70 , 152, "Yb","    -",  -46305.574   , 208.423    , 8015.668 ,   1.371 ,-12884.   ,  286.   , 151.950288919  ,  223.751  },
	{ 81  , 71 , 152, "Lu","    x",  -33422.      , 196.       , 7926.    ,   1.    , STAR     , STAR    , 151.964120     ,  210.     },
	{ 97  , 56 , 153, "Ba","    x",  -37623.      , 801.       , 8031.    ,   5.    ,  9306.   ,  999.   , 152.959610     ,  860.     },
	{ 96  , 57 , 153, "La","    x",  -46929.      , 596.       , 8087.    ,   4.    ,  8421.   ,  718.   , 152.949620     ,  640.     },
	{ 95  , 58 , 153, "Ce","    x",  -55349.      , 401.       , 8137.    ,   3.    ,  6279.   ,  414.   , 152.940580     ,  430.     },
	{ 94  , 59 , 153, "Pr","    +",  -61628.663   , 103.673    , 8172.430 ,   0.678 ,  5720.000,  100.000, 152.933838905  ,  111.297  },
	{ 93  , 60 , 153, "Nd","    +",  -67348.663   ,  27.352    , 8204.702 ,   0.179 ,  3336.000,   25.000, 152.927698232  ,   29.363  },
	{ 92  , 61 , 153, "Pm","     ",  -70684.663   ,  11.097    , 8221.392 ,   0.073 ,  1881.183,   10.826, 152.924116889  ,   11.913  },
	{ 91  , 62 , 153, "Sm","     ",  -72565.846   ,   2.474    , 8228.574 ,   0.016 ,   807.621,    0.730, 152.922097356  ,    2.656  },
	{ 90  , 63 , 153, "Eu","     ",  -73373.467   ,   2.457    , 8228.740 ,   0.016 ,  -483.636,    1.161, 152.921230339  ,    2.637  },
	{ 89  , 64 , 153, "Gd","     ",  -72889.831   ,   2.509    , 8220.465 ,   0.016 , -1569.609,    3.895, 152.921749543  ,    2.693  },
	{ 88  , 65 , 153, "Tb","     ",  -71320.222   ,   4.491    , 8205.093 ,   0.029 , -2170.458,    1.936, 152.923434588  ,    4.821  },
	{ 87  , 66 , 153, "Dy","     ",  -69149.764   ,   4.535    , 8185.793 ,   0.030 , -4130.355,    6.228, 152.925764670  ,    4.868  },
	{ 86  , 67 , 153, "Ho","   -a",  -65019.410   ,   5.554    , 8153.684 ,   0.036 , -4531.442,    9.529, 152.930198789  ,    5.962  },
	{ 85  , 68 , 153, "Er","     ",  -60487.968   ,   8.828    , 8118.954 ,   0.058 , -6472.598,   16.309, 152.935063492  ,    9.476  },
	{ 84  , 69 , 153, "Tm","   -a",  -54015.370   ,  18.461    , 8071.536 ,   0.121 , -6956.   ,  196.   , 152.942012112  ,   19.819  },
	{ 83  , 70 , 153, "Yb","    x",  -47059.      , 196.       , 8021.    ,   1.    , -8651.   ,  286.   , 152.949480     ,  210.     },
	{ 82  , 71 , 153, "Lu","   +a",  -38407.984   , 208.658    , 7959.300 ,   1.364 ,-11106.   ,  545.   , 152.958767331  ,  224.004  },
	{ 81  , 72 , 153, "Hf","    x",  -27302.      , 503.       , 7882.    ,   3.    , STAR     , STAR    , 152.970690     ,  540.     },
	{ 97  , 57 , 154, "La","    x",  -42383.      , 596.       , 8057.    ,   4.    , 10321.   ,  780.   , 153.954500     ,  640.     },
	{ 96  , 58 , 154, "Ce","    x",  -52704.      , 503.       , 8119.    ,   3.    ,  5498.   ,  525.   , 153.943420     ,  540.     },
	{ 95  , 59 , 154, "Pr","    +",  -58201.466   , 151.651    , 8149.519 ,   0.985 ,  7490.000,  100.000, 153.937518153  ,  162.803  },
	{ 94  , 60 , 154, "Nd","    +",  -65691.466   , 114.008    , 8193.075 ,   0.740 ,  2806.930,  122.439, 153.929477307  ,  122.393  },
	{ 93  , 61 , 154, "Pm","    +",  -68498.396   ,  44.794    , 8206.221 ,   0.291 ,  3963.200,   44.721, 153.926463943  ,   48.088  },
	{ 92  , 62 , 154, "Sm","     ",  -72461.596   ,   2.548    , 8226.876 ,   0.017 ,  -717.217,    1.077, 153.922209273  ,    2.735  },
	{ 91  , 63 , 154, "Eu","     ",  -71744.378   ,   2.462    , 8217.139 ,   0.016 ,  1968.842,    1.143, 153.922979237  ,    2.643  },
	{ 90  , 64 , 154, "Gd","     ",  -73713.221   ,   2.504    , 8224.843 ,   0.016 , -3551.247,   45.298, 153.920865598  ,    2.688  },
	{ 89  , 65 , 154, "Tb","    -",  -70161.974   ,  45.367    , 8196.703 ,   0.295 ,   236.191,   45.918, 153.924678019  ,   48.704  },
	{ 88  , 66 , 154, "Dy","     ",  -70398.165   ,   7.633    , 8193.157 ,   0.050 , -5753.952,   10.198, 153.924424457  ,    8.194  },
	{ 87  , 67 , 154, "Ho","   -a",  -64644.213   ,   8.383    , 8150.713 ,   0.054 , -2032.055,    9.508, 153.930601579  ,    8.999  },
	{ 86  , 68 , 154, "Er","     ",  -62612.157   ,   5.470    , 8132.438 ,   0.036 , -8182.921,   15.004, 153.932783081  ,    5.871  },
	{ 85  , 69 , 154, "Tm","   -a",  -54429.236   ,  14.426    , 8074.222 ,   0.094 , -4495.502,   13.954, 153.941567808  ,   15.486  },
	{ 84  , 70 , 154, "Yb","   -a",  -49933.735   ,  17.288    , 8039.950 ,   0.112 ,-10366.   ,  203.   , 153.946393928  ,   18.559  },
	{ 83  , 71 , 154, "Lu","   +a",  -39568.      , 202.       , 7968.    ,   1.    , -6835.   ,  542.   , 153.957522     ,  217.     },
	{ 82  , 72 , 154, "Hf","    x",  -32733.      , 503.       , 7918.    ,   3.    , STAR     , STAR    , 153.964860     ,  540.     },
	{ 98  , 57 , 155, "La","    x",  -38797.      , 801.       , 8034.    ,   5.    ,  9604.   ,  999.   , 154.958350     ,  860.     },
	{ 97  , 58 , 155, "Ce","    x",  -48400.      , 596.       , 8091.    ,   4.    ,  7377.   ,  667.   , 154.948040     ,  640.     },
	{ 96  , 59 , 155, "Pr","    x",  -55778.      , 298.       , 8133.    ,   2.    ,  6695.   ,  335.   , 154.940120     ,  320.     },
	{ 95  , 60 , 155, "Nd","    +",  -62473.      , 153.       , 8172.    ,   1.    ,  4500.   ,  150.   , 154.932932     ,  164.     },
	{ 94  , 61 , 155, "Pm","    +",  -66973.239   ,  30.109    , 8195.511 ,   0.194 ,  3224.000,   30.000, 154.928101267  ,   32.323  },
	{ 93  , 62 , 155, "Sm","   -n",  -70197.239   ,   2.562    , 8211.264 ,   0.017 ,  1627.228,    1.172, 154.924640161  ,    2.750  },
	{ 92  , 63 , 155, "Eu","     ",  -71824.466   ,   2.490    , 8216.715 ,   0.016 ,   252.657,    1.195, 154.922893260  ,    2.672  },
	{ 91  , 64 , 155, "Gd","     ",  -72077.123   ,   2.504    , 8213.297 ,   0.016 ,  -822.709,   11.916, 154.922622022  ,    2.688  },
	{ 90  , 65 , 155, "Tb","    +",  -71254.414   ,  12.125    , 8202.942 ,   0.078 , -2094.500,    1.897, 154.923505236  ,   13.016  },
	{ 89  , 66 , 155, "Dy","   +n",  -69159.914   ,  11.976    , 8184.382 ,   0.077 , -3120.241,   21.528, 154.925753775  ,   12.856  },
	{ 88  , 67 , 155, "Ho","    x",  -66039.673   ,  17.890    , 8159.204 ,   0.115 , -3824.209,   19.041, 154.929103491  ,   19.205  },
	{ 87  , 68 , 155, "Er","   -a",  -62215.463   ,   6.520    , 8129.484 ,   0.042 , -5580.124,   14.107, 154.933208949  ,    6.999  },
	{ 86  , 69 , 155, "Tm","   -a",  -56635.339   ,  13.223    , 8088.436 ,   0.085 , -6131.907,   21.243, 154.939199459  ,   14.195  },
	{ 85  , 70 , 155, "Yb","   -a",  -50503.433   ,  16.625    , 8043.828 ,   0.107 , -7949.262,   26.076, 154.945782332  ,   17.847  },
	{ 84  , 71 , 155, "Lu","   +a",  -42554.171   ,  20.089    , 7987.495 ,   0.130 , -8452.   ,  401.   , 154.954316216  ,   21.566  },
	{ 83  , 72 , 155, "Hf","    x",  -34102.      , 401.       , 7928.    ,   3.    ,-10434.   ,  643.   , 154.963390     ,  430.     },
	{ 82  , 73 , 155, "Ta","   -p",  -23668.      , 503.       , 7856.    ,   3.    , STAR     , STAR    , 154.974592     ,  540.     },
	{ 98  , 58 , 156, "Ce","    x",  -45401.      , 596.       , 8071.    ,   4.    ,  6511.   ,  718.   , 155.951260     ,  640.     },
	{ 97  , 59 , 156, "Pr","    x",  -51912.      , 401.       , 8108.    ,   3.    ,  8618.   ,  449.   , 155.944270     ,  430.     },
	{ 96  , 60 , 156, "Nd","    +",  -60530.237   , 202.934    , 8158.429 ,   1.301 ,  3690.000,  200.000, 155.935018114  ,  217.858  },
	{ 95  , 61 , 156, "Pm","    +",  -64220.237   ,  34.382    , 8177.068 ,   0.220 ,  5150.089,   33.035, 155.931056736  ,   36.910  },
	{ 94  , 62 , 156, "Sm","     ",  -69370.326   ,   9.528    , 8205.066 ,   0.061 ,   722.503,    7.913, 155.925527887  ,   10.228  },
	{ 93  , 63 , 156, "Eu","     ",  -70092.829   ,   5.812    , 8204.682 ,   0.037 ,  2449.369,    5.291, 155.924752249  ,    6.239  },
	{ 92  , 64 , 156, "Gd","     ",  -72542.197   ,   2.504    , 8215.368 ,   0.016 , -2444.677,    3.676, 155.922122743  ,    2.688  },
	{ 91  , 65 , 156, "Tb","     ",  -70097.520   ,   4.412    , 8194.682 ,   0.028 ,   432.309,    7.162, 155.924747213  ,    4.736  },
	{ 90  , 66 , 156, "Dy","     ",  -70529.829   ,   6.589    , 8192.439 ,   0.042 , -5175.278,   45.195, 155.924283110  ,    7.073  },
	{ 89  , 67 , 156, "Ho","    x",  -65354.551   ,  44.712    , 8154.249 ,   0.287 , -1141.730,   50.950, 155.929839000  ,   48.000  },
	{ 88  , 68 , 156, "Er","    x",  -64212.821   ,  24.428    , 8141.915 ,   0.157 , -7372.994,   29.062, 155.931064698  ,   26.224  },
	{ 87  , 69 , 156, "Tm","   -a",  -56839.827   ,  15.744    , 8089.637 ,   0.101 , -3575.337,   12.821, 155.938979933  ,   16.901  },
	{ 86  , 70 , 156, "Yb","   -a",  -53264.490   ,  11.287    , 8061.703 ,   0.072 , -9514.567,   74.518, 155.942818215  ,   12.116  },
	{ 85  , 71 , 156, "Lu","   -a",  -43749.923   ,  73.658    , 7995.697 ,   0.472 , -5897.756,  195.064, 155.953032523  ,   79.074  },
	{ 84  , 72 , 156, "Hf","   -a",  -37852.167   , 208.458    , 7952.876 ,   1.336 ,-12053.   ,  452.   , 155.959364025  ,  223.788  },
	{ 83  , 73 , 156, "Ta","   -p",  -25799.      , 401.       , 7871.    ,   3.    , STAR     , STAR    , 155.972303     ,  430.     },
	{ 99  , 58 , 157, "Ce","    x",  -40669.      , 699.       , 8041.    ,   4.    ,  8300.   ,  805.   , 156.956340     ,  750.     },
	{ 98  , 59 , 157, "Pr","    x",  -48969.      , 401.       , 8089.    ,   3.    ,  7825.   ,  446.   , 156.947430     ,  430.     },
	{ 97  , 60 , 157, "Nd","    x",  -56793.      , 196.       , 8134.    ,   1.    ,  5580.   ,  225.   , 156.939030     ,  210.     },
	{ 96  , 61 , 157, "Pm","    +",  -62373.426   , 111.930    , 8164.631 ,   0.713 ,  4360.000,  100.000, 156.933039369  ,  120.161  },
	{ 95  , 62 , 157, "Sm","    +",  -66733.426   ,  50.282    , 8187.419 ,   0.320 ,  2734.000,   50.000, 156.928358717  ,   53.980  },
	{ 94  , 63 , 157, "Eu","     ",  -69467.426   ,   5.319    , 8199.850 ,   0.034 ,  1363.252,    4.833, 156.925423647  ,    5.710  },
	{ 93  , 64 , 157, "Gd","     ",  -70830.678   ,   2.505    , 8203.550 ,   0.016 ,   -60.052,    0.297, 156.923960135  ,    2.689  },
	{ 92  , 65 , 157, "Tb","     ",  -70770.626   ,   2.521    , 8198.184 ,   0.016 , -1342.740,    6.288, 156.924024604  ,    2.706  },
	{ 91  , 66 , 157, "Dy","     ",  -69427.886   ,   6.672    , 8184.648 ,   0.042 , -2598.956,   25.323, 156.925466095  ,    7.162  },
	{ 90  , 67 , 157, "Ho","    x",  -66828.930   ,  24.428    , 8163.111 ,   0.156 , -3409.092,   37.117, 156.928256188  ,   26.224  },
	{ 89  , 68 , 157, "Er","    x",  -63419.838   ,  27.945    , 8136.414 ,   0.178 , -4710.565,   39.520, 156.931916000  ,   30.000  },
	{ 88  , 69 , 157, "Tm","    x",  -58709.273   ,  27.945    , 8101.428 ,   0.178 , -5267.458,   29.727, 156.936973000  ,   30.000  },
	{ 87  , 70 , 157, "Yb","     ",  -53441.815   ,  10.138    , 8062.894 ,   0.065 , -6958.682,   17.523, 156.942627848  ,   10.883  },
	{ 86  , 71 , 157, "Lu","   IT",  -46483.134   ,  18.682    , 8013.588 ,   0.119 , -7729.   ,  197.   , 156.950098300  ,   20.056  },
	{ 85  , 72 , 157, "Hf","   -a",  -38754.      , 196.       , 7959.    ,   1.    , -9126.   ,  286.   , 156.958396     ,  210.     },
	{ 84  , 73 , 157, "Ta","   IT",  -29628.547   , 208.684    , 7896.268 ,   1.329 , STAR     , STAR    , 156.968192445  ,  224.031  },
	{ 99  , 59 , 158, "Pr","    x",  -44730.      , 596.       , 8062.    ,   4.    ,  9669.   ,  718.   , 157.951980     ,  640.     },
	{ 98  , 60 , 158, "Nd","    x",  -54399.      , 401.       , 8119.    ,   3.    ,  4693.   ,  420.   , 157.941600     ,  430.     },
	{ 97  , 61 , 158, "Pm","    +",  -59092.669   , 127.015    , 8143.276 ,   0.804 ,  6120.000,  100.000, 157.936561407  ,  136.356  },
	{ 96  , 62 , 158, "Sm","    +",  -65212.669   ,  78.313    , 8177.059 ,   0.496 ,  1999.000,   15.000, 157.929991317  ,   84.072  },
	{ 95  , 63 , 158, "Eu","    +",  -67211.669   ,  76.863    , 8184.759 ,   0.486 ,  3485.082,   76.822, 157.927845302  ,   82.515  },
	{ 94  , 64 , 158, "Gd","     ",  -70696.751   ,   2.505    , 8201.865 ,   0.016 , -1219.535,    0.942, 157.924103912  ,    2.689  },
	{ 93  , 65 , 158, "Tb","     ",  -69477.216   ,   2.618    , 8189.195 ,   0.017 ,   934.893,    2.582, 157.925413137  ,    2.810  },
	{ 92  , 66 , 158, "Dy","     ",  -70412.109   ,   3.397    , 8190.160 ,   0.022 , -4221.083,   27.005, 157.924409487  ,    3.647  },
	{ 91  , 67 , 158, "Ho","    -",  -66191.026   ,  27.218    , 8158.493 ,   0.172 ,  -887.217,   37.106, 157.928941007  ,   29.219  },
	{ 90  , 68 , 158, "Er","     ",  -65303.809   ,  25.219    , 8147.926 ,   0.160 , -6600.615,   31.341, 157.929893474  ,   27.074  },
	{ 89  , 69 , 158, "Tm","     ",  -58703.194   ,  25.219    , 8101.199 ,   0.160 , -2688.377,   26.520, 157.936979525  ,   27.074  },
	{ 88  , 70 , 158, "Yb","     ",  -56014.817   ,   8.203    , 8079.232 ,   0.052 , -8800.444,   16.911, 157.939865617  ,    8.806  },
	{ 87  , 71 , 158, "Lu","   -a",  -47214.373   ,  15.138    , 8018.581 ,   0.096 , -5110.253,   14.938, 157.949313283  ,   16.251  },
	{ 86  , 72 , 158, "Hf","   -a",  -42104.119   ,  17.501    , 7981.286 ,   0.111 ,-11085.   ,  203.   , 157.954799366  ,   18.787  },
	{ 85  , 73 , 158, "Ta","   +a",  -31019.      , 202.       , 7906.    ,   1.    , -7324.   ,  542.   , 157.966699     ,  217.     },
	{ 84  , 74 , 158, "W ","   -a",  -23695.      , 503.       , 7855.    ,   3.    , STAR     , STAR    , 157.974562     ,  540.     },
	{100  , 59 , 159, "Pr","    x",  -41451.      , 699.       , 8042.    ,   4.    ,  8765.   ,  861.   , 158.955500     ,  750.     },
	{ 99  , 60 , 159, "Nd","    x",  -50217.      , 503.       , 8092.    ,   3.    ,  6632.   ,  540.   , 158.946090     ,  540.     },
	{ 98  , 61 , 159, "Pm","    x",  -56849.      , 196.       , 8129.    ,   1.    ,  5364.   ,  220.   , 158.938970     ,  210.     },
	{ 97  , 62 , 159, "Sm","    +",  -62213.301   , 100.268    , 8157.530 ,   0.631 ,  3840.000,  100.000, 158.933211271  ,  107.641  },
	{ 96  , 63 , 159, "Eu","     ",  -66053.301   ,   7.321    , 8176.760 ,   0.046 ,  2515.223,    6.991, 158.929088861  ,    7.859  },
	{ 95  , 64 , 159, "Gd","     ",  -68568.524   ,   2.508    , 8187.659 ,   0.016 ,   970.524,    0.745, 158.926388658  ,    2.692  },
	{ 94  , 65 , 159, "Tb","     ",  -69539.048   ,   2.551    , 8188.842 ,   0.016 ,  -365.571,    1.167, 158.925346757  ,    2.739  },
	{ 93  , 66 , 159, "Dy","     ",  -69173.476   ,   2.731    , 8181.623 ,   0.017 , -1837.600,    2.683, 158.925739214  ,    2.931  },
	{ 92  , 67 , 159, "Ho","    -",  -67335.876   ,   3.829    , 8165.145 ,   0.024 , -2768.500,    2.000, 158.927711959  ,    4.110  },
	{ 91  , 68 , 159, "Er","    -",  -64567.376   ,   4.319    , 8142.813 ,   0.027 , -3996.979,   28.277, 158.930684066  ,    4.637  },
	{ 90  , 69 , 159, "Tm","    x",  -60570.398   ,  27.945    , 8112.754 ,   0.176 , -4727.425,   33.434, 158.934975000  ,   30.000  },
	{ 89  , 70 , 159, "Yb","    x",  -55842.973   ,  18.356    , 8078.101 ,   0.115 , -6127.998,   41.898, 158.940050099  ,   19.706  },
	{ 88  , 71 , 159, "Lu","    x",  -49714.975   ,  37.663    , 8034.640 ,   0.237 , -6861.472,   41.256, 158.946628776  ,   40.433  },
	{ 87  , 72 , 159, "Hf","   -a",  -42853.503   ,  16.838    , 7986.566 ,   0.106 , -8405.153,   26.540, 158.953994870  ,   18.076  },
	{ 86  , 73 , 159, "Ta","   IT",  -34448.350   ,  20.514    , 7928.783 ,   0.129 , -9222.   ,  401.   , 158.963018173  ,   22.022  },
	{ 85  , 74 , 159, "W ","   -a",  -25227.      , 401.       , 7866.    ,   3.    , STAR     , STAR    , 158.972918     ,  430.     },
	{100  , 60 , 160, "Nd","    x",  -47422.      , 596.       , 8074.    ,   4.    ,  5682.   ,  667.   , 159.949090     ,  640.     },
	{ 99  , 61 , 160, "Pm","    x",  -53104.      , 298.       , 8105.    ,   2.    ,  7312.   ,  357.   , 159.942990     ,  320.     },
	{ 98  , 62 , 160, "Sm","    x",  -60417.      , 196.       , 8146.    ,   1.    ,  2952.   ,  280.   , 159.935140     ,  210.     },
	{ 97  , 63 , 160, "Eu","    +",  -63369.      , 200.       , 8159.    ,   1.    ,  4580.   ,  200.   , 159.931971     ,  215.     },
	{ 96  , 64 , 160, "Gd","     ",  -67948.626   ,   2.556    , 8183.057 ,   0.016 ,  -105.688,    0.971, 159.927054146  ,    2.744  },
	{ 95  , 65 , 160, "Tb","     ",  -67842.938   ,   2.555    , 8177.507 ,   0.016 ,  1835.126,    1.255, 159.927167606  ,    2.742  },
	{ 94  , 66 , 160, "Dy","     ",  -69678.064   ,   2.536    , 8184.087 ,   0.016 , -3290.000,   15.000, 159.925197517  ,    2.721  },
	{ 93  , 67 , 160, "Ho","    -",  -66388.064   ,  15.213    , 8158.635 ,   0.095 ,  -329.576,   28.778, 159.928729478  ,   16.331  },
	{ 92  , 68 , 160, "Er","    x",  -66058.488   ,  24.428    , 8151.685 ,   0.153 , -5756.175,   42.089, 159.929083292  ,   26.224  },
	{ 91  , 69 , 160, "Tm","    x",  -60302.313   ,  34.274    , 8110.820 ,   0.214 , -2132.696,   38.042, 159.935262801  ,   36.794  },
	{ 90  , 70 , 160, "Yb","    x",  -58169.617   ,  16.507    , 8092.601 ,   0.103 , -7899.680,   59.170, 159.937552344  ,   17.721  },
	{ 89  , 71 , 160, "Lu","    x",  -50269.937   ,  56.821    , 8038.338 ,   0.355 , -4332.732,   57.990, 159.946033000  ,   61.000  },
	{ 88  , 72 , 160, "Hf","   -a",  -45937.205   ,  11.583    , 8006.369 ,   0.072 ,-10061.697,   89.775, 159.950684379  ,   12.434  },
	{ 87  , 73 , 160, "Ta","   -a",  -35875.507   ,  89.025    , 7938.593 ,   0.556 , -6513.704,  201.422, 159.961486056  ,   95.572  },
	{ 86  , 74 , 160, "W ","   -a",  -29361.804   , 208.508    , 7892.993 ,   1.303 ,-12702.   ,  452.   , 159.968478805  ,  223.843  },
	{ 85  , 75 , 160, "Re","   -p",  -16660.      , 401.       , 7809.    ,   3.    , STAR     , STAR    , 159.982115     ,  430.     },
	{101  , 60 , 161, "Nd","    x",  -42961.      , 699.       , 8047.    ,   4.    ,  7471.   ,  861.   , 160.953880     ,  750.     },
	{100  , 61 , 161, "Pm","    x",  -50431.      , 503.       , 8088.    ,   3.    ,  6548.   ,  585.   , 160.945860     ,  540.     },
	{ 99  , 62 , 161, "Sm","    x",  -56979.      , 298.       , 8124.    ,   2.    ,  4797.   ,  422.   , 160.938830     ,  320.     },
	{ 98  , 63 , 161, "Eu","    x",  -61777.      , 298.       , 8149.    ,   2.    ,  3736.   ,  298.   , 160.933680     ,  320.     },
	{ 97  , 64 , 161, "Gd","   -n",  -65512.709   ,   2.745    , 8167.233 ,   0.017 ,  1955.478,    1.419, 160.929669211  ,    2.946  },
	{ 96  , 65 , 161, "Tb","     ",  -67468.186   ,   2.604    , 8174.520 ,   0.016 ,   592.947,    1.332, 160.927569919  ,    2.795  },
	{ 95  , 66 , 161, "Dy","     ",  -68061.133   ,   2.535    , 8173.344 ,   0.016 ,  -858.290,    2.186, 160.926933364  ,    2.721  },
	{ 94  , 67 , 161, "Ho","     ",  -67202.843   ,   3.222    , 8163.153 ,   0.020 , -1993.894,    9.354, 160.927854776  ,    3.458  },
	{ 93  , 68 , 161, "Er","   +n",  -65208.950   ,   9.404    , 8145.910 ,   0.058 , -3310.241,   29.485, 160.929995309  ,   10.095  },
	{ 92  , 69 , 161, "Tm","    x",  -61898.708   ,  27.945    , 8120.490 ,   0.174 , -4054.494,   32.197, 160.933549000  ,   30.000  },
	{ 91  , 70 , 161, "Yb","    x",  -57844.214   ,  15.993    , 8090.447 ,   0.099 , -5281.870,   32.197, 160.937901678  ,   17.168  },
	{ 90  , 71 , 161, "Lu","    x",  -52562.344   ,  27.945    , 8052.781 ,   0.174 , -6243.659,   35.900, 160.943572000  ,   30.000  },
	{ 89  , 72 , 161, "Hf","     ",  -46318.685   ,  22.536    , 8009.142 ,   0.140 , -7585.   ,   59.   , 160.950274844  ,   24.193  },
	{ 88  , 73 , 161, "Ta","   IT",  -38734.      ,  55.       , 7957.    ,   0.    , -8327.   ,  203.   , 160.958417     ,   59.     },
	{ 87  , 74 , 161, "W ","   -a",  -30407.      , 196.       , 7901.    ,   1.    , -9531.   ,  286.   , 160.967357     ,  210.     },
	{ 86  , 75 , 161, "Re","   -p",  -20875.601   , 208.576    , 7836.532 ,   1.296 , STAR     , STAR    , 160.977589119  ,  223.915  },
	{101  , 61 , 162, "Pm","    x",  -46305.      , 699.       , 8063.    ,   4.    ,  8449.   ,  861.   , 161.950290     ,  750.     },
	{100  , 62 , 162, "Sm","    x",  -54753.      , 503.       , 8110.    ,   3.    ,  3894.   ,  585.   , 161.941220     ,  540.     },
	{ 99  , 63 , 162, "Eu","    x",  -58647.      , 298.       , 8129.    ,   2.    ,  5640.   ,  298.   , 161.937040     ,  320.     },
	{ 98  , 64 , 162, "Gd","  -nn",  -64287.290   ,   4.580    , 8159.077 ,   0.028 ,  1393.997,   36.583, 161.930984751  ,    4.916  },
	{ 97  , 65 , 162, "Tb","    +",  -65681.287   ,  36.452    , 8162.853 ,   0.225 ,  2505.521,   36.364, 161.929488234  ,   39.132  },
	{ 96  , 66 , 162, "Dy","     ",  -68186.808   ,   2.535    , 8173.490 ,   0.016 , -2139.695,    3.127, 161.926798447  ,    2.721  },
	{ 95  , 67 , 162, "Ho","     ",  -66047.112   ,   3.921    , 8155.452 ,   0.024 ,   295.507,    4.009, 161.929095504  ,    4.209  },
	{ 94  , 68 , 162, "Er","     ",  -66342.620   ,   3.467    , 8152.447 ,   0.021 , -4859.062,   26.047, 161.928778264  ,    3.721  },
	{ 93  , 69 , 162, "Tm","    -",  -61483.558   ,  26.277    , 8117.624 ,   0.162 , -1652.031,   30.658, 161.933994682  ,   28.209  },
	{ 92  , 70 , 162, "Yb","    x",  -59831.527   ,  15.993    , 8102.597 ,   0.099 , -6994.661,   76.721, 161.935768210  ,   17.168  },
	{ 91  , 71 , 162, "Lu","    x",  -52836.866   ,  75.036    , 8054.590 ,   0.463 , -3663.761,   75.647, 161.943277288  ,   80.554  },
	{ 90  , 72 , 162, "Hf","   -a",  -49173.105   ,   9.598    , 8027.145 ,   0.059 , -9390.728,   53.017, 161.947210498  ,   10.304  },
	{ 89  , 73 , 162, "Ta","   -a",  -39782.377   ,  52.241    , 7964.348 ,   0.322 , -5780.440,   52.254, 161.957291859  ,   56.083  },
	{ 88  , 74 , 162, "W ","   -a",  -34001.937   ,  17.710    , 7923.837 ,   0.109 ,-11648.   ,  203.   , 161.963497417  ,   19.012  },
	{ 87  , 75 , 162, "Re","   +a",  -22354.      , 202.       , 7847.    ,   1.    , -7851.   ,  542.   , 161.976002     ,  217.     },
	{ 86  , 76 , 162, "Os","   -a",  -14503.      , 503.       , 7794.    ,   3.    , STAR     , STAR    , 161.984431     ,  540.     },
	{102  , 61 , 163, "Pm","    x",  -43147.      , 801.       , 8043.    ,   5.    ,  7750.   , 1063.   , 162.953680     ,  860.     },
	{101  , 62 , 163, "Sm","    x",  -50897.      , 699.       , 8086.    ,   4.    ,  5729.   ,  861.   , 162.945360     ,  750.     },
	{100  , 63 , 163, "Eu","    x",  -56626.      , 503.       , 8116.    ,   3.    ,  4862.   ,  585.   , 162.939210     ,  540.     },
	{ 99  , 64 , 163, "Gd","    x",  -61488.      , 298.       , 8141.    ,   2.    ,  3113.   ,  298.   , 162.933990     ,  320.     },
	{ 98  , 65 , 163, "Tb","   +p",  -64601.404   ,   4.735    , 8155.666 ,   0.029 ,  1785.094,    4.001, 162.930647536  ,    5.083  },
	{ 97  , 66 , 163, "Dy","     ",  -66386.498   ,   2.535    , 8161.818 ,   0.016 ,    -2.555,    0.016, 162.928731159  ,    2.720  },
	{ 96  , 67 , 163, "Ho","     ",  -66383.942   ,   2.535    , 8157.002 ,   0.016 , -1209.868,    4.655, 162.928733903  ,    2.720  },
	{ 95  , 68 , 163, "Er","     ",  -65174.074   ,   5.243    , 8144.780 ,   0.032 , -2439.000,    3.000, 162.930032749  ,    5.628  },
	{ 94  , 69 , 163, "Tm","    -",  -62735.074   ,   6.040    , 8125.017 ,   0.037 , -3430.861,   16.915, 162.932651124  ,    6.484  },
	{ 93  , 70 , 163, "Yb","    x",  -59304.213   ,  15.993    , 8099.170 ,   0.098 , -4512.804,   32.197, 162.936334305  ,   17.168  },
	{ 92  , 71 , 163, "Lu","    x",  -54791.409   ,  27.945    , 8066.684 ,   0.171 , -5505.130,   39.520, 162.941179000  ,   30.000  },
	{ 91  , 72 , 163, "Hf","    x",  -49286.280   ,  27.945    , 8028.110 ,   0.171 , -6745.201,   47.219, 162.947089000  ,   30.000  },
	{ 90  , 73 , 163, "Ta","   -a",  -42541.078   ,  38.061    , 7981.929 ,   0.234 , -7631.983,   65.055, 162.954330271  ,   40.860  },
	{ 89  , 74 , 163, "W ","   -a",  -34909.095   ,  52.759    , 7930.308 ,   0.324 , -8902.281,   56.404, 162.962523542  ,   56.639  },
	{ 88  , 75 , 163, "Re","   IT",  -26006.814   ,  19.947    , 7870.893 ,   0.122 , -9883.   ,  404.   , 162.972080535  ,   21.413  },
	{ 87  , 76 , 163, "Os","   -a",  -16124.      , 404.       , 7805.    ,   2.    , STAR     , STAR    , 162.982690     ,  433.     },
	{102  , 62 , 164, "Sm","    x",  -48177.      , 801.       , 8069.    ,   5.    ,  4928.   ,  999.   , 163.948280     ,  860.     },
	{101  , 63 , 164, "Eu","    x",  -53104.      , 596.       , 8095.    ,   4.    ,  6642.   ,  718.   , 163.942990     ,  640.     },
	{100  , 64 , 164, "Gd","    x",  -59746.      , 401.       , 8130.    ,   2.    ,  2337.   ,  413.   , 163.935860     ,  430.     },
	{ 99  , 65 , 164, "Tb","    +",  -62083.294   , 100.032    , 8139.797 ,   0.610 ,  3890.000,  100.000, 163.933350838  ,  107.388  },
	{ 98  , 66 , 164, "Dy","     ",  -65973.294   ,   2.534    , 8158.746 ,   0.015 ,  -986.225,    1.446, 163.929174751  ,    2.720  },
	{ 97  , 67 , 164, "Ho","     ",  -64987.069   ,   2.773    , 8147.963 ,   0.017 ,   962.493,    2.317, 163.930233507  ,    2.977  },
	{ 96  , 68 , 164, "Er","     ",  -65949.562   ,   3.070    , 8149.061 ,   0.019 , -4061.100,   28.113, 163.929200229  ,    3.295  },
	{ 95  , 69 , 164, "Tm","    x",  -61888.462   ,  27.945    , 8119.528 ,   0.170 ,  -865.746,   32.197, 163.933560000  ,   30.000  },
	{ 94  , 70 , 164, "Yb","    x",  -61022.716   ,  15.993    , 8109.478 ,   0.098 , -6380.346,   32.197, 163.934489416  ,   17.168  },
	{ 93  , 71 , 164, "Lu","    x",  -54642.370   ,  27.945    , 8065.803 ,   0.170 , -2820.829,   34.600, 163.941339000  ,   30.000  },
	{ 92  , 72 , 164, "Hf","   +a",  -51821.541   ,  20.403    , 8043.833 ,   0.124 , -8538.740,   34.600, 163.944367284  ,   21.903  },
	{ 91  , 73 , 164, "Ta","    x",  -43282.801   ,  27.945    , 7986.997 ,   0.170 , -5049.053,   30.317, 163.953534000  ,   30.000  },
	{ 90  , 74 , 164, "W ","   -a",  -38233.747   ,  11.756    , 7951.440 ,   0.072 ,-10590.   ,  160.   , 163.958954382  ,   12.621  },
	{ 89  , 75 , 164, "Re","   +a",  -27644.      , 159.       , 7882.    ,   1.    , -7184.   ,  241.   , 163.970323     ,  171.     },
	{ 88  , 76 , 164, "Os","   -a",  -20459.661   , 208.591    , 7833.520 ,   1.272 ,-13195.   ,  463.   , 163.978035649  ,  223.931  },
	{ 87  , 77 , 164, "Ir","   -a",   -7265.      , 413.       , 7748.    ,   3.    , STAR     , STAR    , 163.992201     ,  443.     },
	{103  , 62 , 165, "Sm","    x",  -43799.      , 904.       , 8043.    ,   5.    ,  6763.   , 1142.   , 164.952980     ,  970.     },
	{102  , 63 , 165, "Eu","    x",  -50561.      , 699.       , 8079.    ,   4.    ,  5906.   ,  861.   , 164.945720     ,  750.     },
	{101  , 64 , 165, "Gd","    x",  -56467.      , 503.       , 8110.    ,   3.    ,  4192.   ,  540.   , 164.939380     ,  540.     },
	{100  , 65 , 165, "Tb","    x",  -60659.      , 196.       , 8131.    ,   1.    ,  2959.   ,  196.   , 164.934880     ,  210.     },
	{ 99  , 66 , 165, "Dy","   -n",  -63617.935   ,   2.535    , 8143.942 ,   0.015 ,  1286.638,    0.881, 164.931703333  ,    2.721  },
	{ 98  , 67 , 165, "Ho","     ",  -64904.574   ,   2.525    , 8146.998 ,   0.015 ,  -376.261,    2.036, 164.930322070  ,    2.710  },
	{ 97  , 68 , 165, "Er","     ",  -64528.312   ,   3.081    , 8139.976 ,   0.019 , -1592.378,    1.529, 164.930726003  ,    3.307  },
	{ 96  , 69 , 165, "Tm","     ",  -62935.934   ,   3.319    , 8125.584 ,   0.020 , -2648.711,   28.141, 164.932435492  ,    3.562  },
	{ 95  , 70 , 165, "Yb","    x",  -60287.224   ,  27.945    , 8104.790 ,   0.169 , -3844.951,   38.539, 164.935279000  ,   30.000  },
	{ 94  , 71 , 165, "Lu","    x",  -56442.273   ,  26.540    , 8076.745 ,   0.161 , -4806.766,   38.539, 164.939406724  ,   28.491  },
	{ 93  , 72 , 165, "Hf","    x",  -51635.507   ,  27.945    , 8042.872 ,   0.169 , -5780.400,   32.904, 164.944567000  ,   30.000  },
	{ 92  , 73 , 165, "Ta","   +a",  -45855.107   ,  17.371    , 8003.098 ,   0.105 , -6993.130,   30.423, 164.950772514  ,   18.648  },
	{ 91  , 74 , 165, "W ","     ",  -38861.977   ,  24.976    , 7955.974 ,   0.151 , -8205.166,   37.301, 164.958279949  ,   26.813  },
	{ 90  , 75 , 165, "Re","   +a",  -30656.812   ,  27.705    , 7901.504 ,   0.168 , -9011.   ,  204.   , 164.967088557  ,   29.742  },
	{ 89  , 76 , 165, "Os","   -a",  -21646.      , 202.       , 7842.    ,   1.    ,-10021.   ,  295.   , 164.976762     ,  217.     },
	{ 88  , 77 , 165, "Ir","   IT",  -11625.      , 215.       , 7777.    ,   1.    , STAR     , STAR    , 164.987520     ,  230.     },
	{103  , 63 , 166, "Eu","    x",  -46603.      , 801.       , 8055.    ,   5.    ,  7797.   ,  999.   , 165.949970     ,  860.     },
	{102  , 64 , 166, "Gd","    x",  -54399.      , 596.       , 8097.    ,   4.    ,  3361.   ,  604.   , 165.941600     ,  640.     },
	{101  , 65 , 166, "Tb","    +",  -57760.118   , 100.033    , 8112.929 ,   0.603 ,  4830.000,  100.000, 165.937991959  ,  107.389  },
	{100  , 66 , 166, "Dy","   -n",  -62590.118   ,   2.566    , 8137.313 ,   0.015 ,   486.778,    0.968, 165.932806741  ,    2.755  },
	{ 99  , 67 , 166, "Ho","     ",  -63076.897   ,   2.525    , 8135.532 ,   0.015 ,  1854.699,    0.890, 165.932284162  ,    2.710  },
	{ 98  , 68 , 166, "Er","     ",  -64931.595   ,   2.514    , 8141.992 ,   0.015 , -3037.667,   11.547, 165.930293061  ,    2.698  },
	{ 97  , 69 , 166, "Tm","    -",  -61893.929   ,  11.817    , 8118.980 ,   0.071 ,  -305.447,   14.046, 165.933554131  ,   12.686  },
	{ 96  , 70 , 166, "Yb","  +nn",  -61588.481   ,   8.263    , 8112.427 ,   0.050 , -5567.500,   30.932, 165.933882042  ,    8.870  },
	{ 95  , 71 , 166, "Lu","    x",  -56020.981   ,  29.808    , 8074.175 ,   0.180 , -2161.998,   40.859, 165.939859000  ,   32.000  },
	{ 94  , 72 , 166, "Hf","    x",  -53858.984   ,  27.945    , 8056.438 ,   0.168 , -7761.208,   39.520, 165.942180000  ,   30.000  },
	{ 93  , 73 , 166, "Ta","    x",  -46097.776   ,  27.945    , 8004.971 ,   0.168 , -4205.931,   29.817, 165.950512000  ,   30.000  },
	{ 92  , 74 , 166, "W ","   -a",  -41891.844   ,  10.398    , 7974.921 ,   0.063 ,-10042.   ,   88.   , 165.955027253  ,   11.163  },
	{ 91  , 75 , 166, "Re","   IT",  -31850.      ,  88.       , 7910.    ,   1.    , -6411.   ,   88.   , 165.965808     ,   94.     },
	{ 90  , 76 , 166, "Os","   -a",  -25438.400   ,  18.236    , 7866.378 ,   0.110 ,-12233.   ,  203.   , 165.972690753  ,   19.577  },
	{ 89  , 77 , 166, "Ir","   -p",  -13205.      , 202.       , 7788.    ,   1.    , -8413.   ,  542.   , 165.985824     ,  217.     },
	{ 88  , 78 , 166, "Pt","   -a",   -4792.      , 503.       , 7733.    ,   3.    , STAR     , STAR    , 165.994855     ,  540.     },
	{104  , 63 , 167, "Eu","    x",  -43585.      , 801.       , 8037.    ,   5.    ,  7117.   ,  999.   , 166.953210     ,  860.     },
	{103  , 64 , 167, "Gd","    x",  -50701.      , 596.       , 8075.    ,   4.    ,  5142.   ,  718.   , 166.945570     ,  640.     },
	{102  , 65 , 167, "Tb","    x",  -55843.      , 401.       , 8101.    ,   2.    ,  4093.   ,  405.   , 166.940050     ,  430.     },
	{101  , 66 , 167, "Dy","    +",  -59936.551   ,  60.271    , 8121.028 ,   0.361 ,  2350.000,   60.000, 166.935655462  ,   64.703  },
	{100  , 67 , 167, "Ho","  p2n",  -62286.551   ,   5.709    , 8130.415 ,   0.034 ,  1010.182,    5.222, 166.933132633  ,    6.128  },
	{ 99  , 68 , 167, "Er","     ",  -63296.733   ,   2.512    , 8131.779 ,   0.015 ,  -748.422,    1.478, 166.932048159  ,    2.696  },
	{ 98  , 69 , 167, "Tm","     ",  -62548.311   ,   2.674    , 8122.613 ,   0.016 , -1954.258,    3.814, 166.932851622  ,    2.870  },
	{ 97  , 70 , 167, "Yb","     ",  -60594.053   ,   4.628    , 8106.226 ,   0.028 , -3092.928,   32.007, 166.934949605  ,    4.968  },
	{ 96  , 71 , 167, "Lu","    x",  -57501.125   ,  31.671    , 8083.021 ,   0.190 , -4033.369,   42.237, 166.938270000  ,   34.000  },
	{ 95  , 72 , 167, "Hf","    x",  -53467.756   ,  27.945    , 8054.184 ,   0.167 , -5116.697,   39.520, 166.942600000  ,   30.000  },
	{ 94  , 73 , 167, "Ta","    x",  -48351.060   ,  27.945    , 8018.861 ,   0.167 , -6262.448,   33.941, 166.948093000  ,   30.000  },
	{ 93  , 74 , 167, "W ","   +a",  -42088.612   ,  19.264    , 7976.676 ,   0.115 , -7251.   ,   56.   , 166.954816014  ,   20.680  },
	{ 92  , 75 , 167, "Re","   +a",  -34837.      ,  52.       , 7929.    ,   0.    , -8334.   ,   89.   , 166.962601     ,   56.     },
	{ 91  , 76 , 167, "Os","   -a",  -26502.896   ,  72.688    , 7873.979 ,   0.435 , -9424.099,   75.117, 166.971547969  ,   78.033  },
	{ 90  , 77 , 167, "Ir","   -p",  -17078.797   ,  18.948    , 7812.863 ,   0.113 ,-10539.   ,  407.   , 166.981665156  ,   20.341  },
	{ 89  , 78 , 167, "Pt","   -a",   -6540.      , 407.       , 7745.    ,   2.    , STAR     , STAR    , 166.992979     ,  437.     },
	{104  , 64 , 168, "Gd","    x",  -48102.      , 699.       , 8060.    ,   4.    ,  4397.   ,  861.   , 167.948360     ,  750.     },
	{103  , 65 , 168, "Tb","    x",  -52499.      , 503.       , 8081.    ,   3.    ,  6065.   ,  522.   , 167.943640     ,  540.     },
	{102  , 66 , 168, "Dy","  +pp",  -58564.175   , 140.027    , 8112.563 ,   0.833 ,  1502.556,  143.186, 167.937128769  ,  150.325  },
	{101  , 67 , 168, "Ho","    +",  -60066.731   ,  30.105    , 8116.850 ,   0.179 ,  2930.000,   30.000, 167.935515708  ,   32.319  },
	{100  , 68 , 168, "Er","     ",  -62996.731   ,   2.512    , 8129.634 ,   0.015 , -1679.066,    1.851, 167.932370224  ,    2.697  },
	{ 99  , 69 , 168, "Tm","     ",  -61317.664   ,   2.897    , 8114.982 ,   0.017 ,   256.981,    4.042, 167.934172776  ,    3.109  },
	{ 98  , 70 , 168, "Yb","     ",  -61574.646   ,   4.391    , 8111.855 ,   0.026 , -4510.495,   46.744, 167.933896895  ,    4.713  },
	{ 97  , 71 , 168, "Lu","    -",  -57064.151   ,  46.950    , 8080.350 ,   0.279 , -1703.599,   54.637, 167.938739111  ,   50.403  },
	{ 96  , 72 , 168, "Hf","    x",  -55360.552   ,  27.945    , 8065.553 ,   0.166 , -6966.644,   39.520, 167.940568000  ,   30.000  },
	{ 95  , 73 , 168, "Ta","    x",  -48393.908   ,  27.945    , 8019.428 ,   0.166 , -3503.716,   32.343, 167.948047000  ,   30.000  },
	{ 94  , 74 , 168, "W ","   +a",  -44890.192   ,  16.283    , 7993.916 ,   0.097 , -9095.307,   34.858, 167.951808394  ,   17.481  },
	{ 93  , 75 , 168, "Re","   -a",  -35794.885   ,  30.821    , 7935.120 ,   0.183 , -5804.205,   33.112, 167.961572608  ,   33.087  },
	{ 92  , 76 , 168, "Os","   -a",  -29990.680   ,  12.103    , 7895.914 ,   0.072 ,-11250.   ,  152.   , 167.967803678  ,   12.993  },
	{ 91  , 77 , 168, "Ir","   IT",  -18741.      , 151.       , 7824.    ,   1.    , -7704.   ,  236.   , 167.979881     ,  163.     },
	{ 90  , 78 , 168, "Pt","   -a",  -11037.512   , 208.792    , 7773.784 ,   1.243 , STAR     , STAR    , 167.988150742  ,  224.147  },
	{105  , 64 , 169, "Gd","    x",  -43901.      , 801.       , 8035.    ,   5.    ,  6194.   ,  999.   , 168.952870     ,  860.     },
	{104  , 65 , 169, "Tb","    x",  -50096.      , 596.       , 8067.    ,   4.    ,  5507.   ,  668.   , 168.946220     ,  640.     },
	{103  , 66 , 169, "Dy","    +",  -55603.099   , 300.679    , 8094.798 ,   1.779 ,  3200.000,  300.000, 168.940307614  ,  322.791  },
	{102  , 67 , 169, "Ho","   +p",  -58803.099   ,  20.189    , 8109.103 ,   0.119 ,  2125.585,   20.057, 168.936872273  ,   21.673  },
	{101  , 68 , 169, "Er","     ",  -60928.684   ,   2.516    , 8117.052 ,   0.015 ,   351.279,    1.080, 168.934590364  ,    2.701  },
	{100  , 69 , 169, "Tm","     ",  -61279.963   ,   2.476    , 8114.501 ,   0.015 ,  -909.652,    3.751, 168.934213250  ,    2.658  },
	{ 99  , 70 , 169, "Yb","     ",  -60370.311   ,   4.391    , 8104.489 ,   0.026 , -2293.000,    3.000, 168.935189802  ,    4.713  },
	{ 98  , 71 , 169, "Lu","    -",  -58077.311   ,   5.318    , 8086.292 ,   0.031 , -3360.421,   28.446, 168.937651439  ,    5.708  },
	{ 97  , 72 , 169, "Hf","    x",  -54716.890   ,  27.945    , 8061.778 ,   0.165 , -4426.460,   39.520, 168.941259000  ,   30.000  },
	{ 96  , 73 , 169, "Ta","    x",  -50290.430   ,  27.945    , 8030.957 ,   0.165 , -5372.662,   31.925, 168.946011000  ,   30.000  },
	{ 95  , 74 , 169, "W ","     ",  -44917.768   ,  15.436    , 7994.537 ,   0.091 , -6531.921,   32.062, 168.951778790  ,   16.571  },
	{ 94  , 75 , 169, "Re","     ",  -38385.847   ,  28.102    , 7951.257 ,   0.166 , -7664.495,   37.744, 168.958791096  ,   30.168  },
	{ 93  , 76 , 169, "Os","   -a",  -30721.352   ,  25.197    , 7901.276 ,   0.149 , -8640.233,   36.542, 168.967019270  ,   27.050  },
	{ 92  , 77 , 169, "Ir","   +a",  -22081.119   ,  26.465    , 7845.521 ,   0.157 , -9706.   ,  204.   , 168.976294942  ,   28.411  },
	{ 91  , 78 , 169, "Pt","   -a",  -12375.      , 202.       , 7783.    ,   1.    ,-10586.   ,  360.   , 168.986715     ,  217.     },
	{ 90  , 79 , 169, "Au","    x",   -1788.      , 298.       , 7716.    ,   2.    , STAR     , STAR    , 168.998080     ,  320.     },
	{105  , 65 , 170, "Tb","    x",  -46342.      , 699.       , 8045.    ,   4.    ,  7322.   ,  725.   , 169.950250     ,  750.     },
	{104  , 66 , 170, "Dy","    x",  -53663.      , 196.       , 8083.    ,   1.    ,  2581.   ,  202.   , 169.942390     ,  210.     },
	{103  , 67 , 170, "Ho","    +",  -56244.606   ,  50.076    , 8093.831 ,   0.295 ,  3870.000,   50.000, 169.939618929  ,   53.758  },
	{102  , 68 , 170, "Er","     ",  -60114.606   ,   2.754    , 8111.994 ,   0.016 ,  -313.992,    1.814, 169.935464312  ,    2.957  },
	{101  , 69 , 170, "Tm","     ",  -59800.614   ,   2.476    , 8105.545 ,   0.015 ,   968.344,    0.791, 169.935801397  ,    2.658  },
	{100  , 70 , 170, "Yb","     ",  -60768.957   ,   2.449    , 8106.639 ,   0.014 , -3458.759,   16.843, 169.934761837  ,    2.628  },
	{ 99  , 71 , 170, "Lu","    -",  -57310.199   ,  17.020    , 8081.691 ,   0.100 , -1056.344,   32.720, 169.938474968  ,   18.271  },
	{ 98  , 72 , 170, "Hf","    x",  -56253.855   ,  27.945    , 8070.875 ,   0.164 , -6116.190,   39.520, 169.939609000  ,   30.000  },
	{ 97  , 73 , 170, "Ta","    x",  -50137.665   ,  27.945    , 8030.296 ,   0.164 , -2844.301,   31.777, 169.946175000  ,   30.000  },
	{ 96  , 74 , 170, "W ","   +a",  -47293.364   ,  15.127    , 8008.962 ,   0.089 , -8375.611,   29.904, 169.949228482  ,   16.239  },
	{ 95  , 75 , 170, "Re","    x",  -38917.754   ,  25.795    , 7955.092 ,   0.152 , -4989.974,   28.004, 169.958220071  ,   27.692  },
	{ 94  , 76 , 170, "Os","   -a",  -33927.780   ,  10.900    , 7921.137 ,   0.064 ,-10608.   ,  102.   , 169.963577028  ,   11.701  },
	{ 93  , 77 , 170, "Ir","   -a",  -23320.      , 102.       , 7854.    ,   1.    , -7014.   ,  102.   , 169.974965     ,  109.     },
	{ 92  , 78 , 170, "Pt","   -a",  -16305.533   ,  18.662    , 7808.273 ,   0.110 ,-12693.   ,  204.   , 169.982495289  ,   20.034  },
	{ 91  , 79 , 170, "Au","   -p",   -3612.      , 203.       , 7729.    ,   1.    , STAR     , STAR    , 169.996122     ,  218.     },
	{106  , 65 , 171, "Tb","    x",  -43501.      , 801.       , 8028.    ,   5.    ,  6614.   ,  855.   , 170.953300     ,  860.     },
	{105  , 66 , 171, "Dy","    x",  -50114.      , 298.       , 8062.    ,   2.    ,  4410.   ,  670.   , 170.946200     ,  320.     },
	{104  , 67 , 171, "Ho","    +",  -54524.862   , 600.006    , 8083.642 ,   3.509 ,  3200.000,  600.000, 170.941465150  ,  644.133  },
	{103  , 68 , 171, "Er","     ",  -57724.862   ,   2.763    , 8097.781 ,   0.016 ,  1490.734,    1.241, 170.938029808  ,    2.966  },
	{102  , 69 , 171, "Tm","     ",  -59215.595   ,   2.584    , 8101.923 ,   0.015 ,    96.541,    0.972, 170.936429440  ,    2.774  },
	{101  , 70 , 171, "Yb","     ",  -59312.137   ,   2.400    , 8097.913 ,   0.014 , -1478.595,    1.918, 170.936325799  ,    2.576  },
	{100  , 71 , 171, "Lu","     ",  -57833.542   ,   2.767    , 8084.691 ,   0.016 , -2402.196,   29.009, 170.937913136  ,    2.970  },
	{ 99  , 72 , 171, "Hf","    x",  -55431.345   ,  28.876    , 8066.068 ,   0.169 , -3711.072,   40.184, 170.940492000  ,   31.000  },
	{ 98  , 73 , 171, "Ta","    x",  -51720.273   ,  27.945    , 8039.791 ,   0.163 , -4634.183,   39.520, 170.944476000  ,   30.000  },
	{ 97  , 74 , 171, "W ","    x",  -47086.091   ,  27.945    , 8008.115 ,   0.163 , -5835.810,   39.520, 170.949451000  ,   30.000  },
	{ 96  , 75 , 171, "Re","    x",  -41250.281   ,  27.945    , 7969.412 ,   0.163 , -6957.161,   33.650, 170.955716000  ,   30.000  },
	{ 95  , 76 , 171, "Os","     ",  -34293.120   ,  18.745    , 7924.152 ,   0.110 , -7862.948,   43.739, 170.963184819  ,   20.123  },
	{ 94  , 77 , 171, "Ir","   -a",  -26430.172   ,  39.519    , 7873.595 ,   0.231 , -8959.575,   96.671, 170.971626042  ,   42.425  },
	{ 93  , 78 , 171, "Pt","   -a",  -17470.596   ,  88.224    , 7816.624 ,   0.516 , -9905.823,   91.876, 170.981244542  ,   94.712  },
	{ 92  , 79 , 171, "Au","   IT",   -7564.773   ,  25.644    , 7754.121 ,   0.150 ,-11067.   ,  299.   , 170.991878881  ,   27.529  },
	{ 91  , 80 , 171, "Hg","    x",    3502.      , 298.       , 7685.    ,   2.    , STAR     , STAR    , 171.003760     ,  320.     },
	{106  , 66 , 172, "Dy","    x",  -47730.      , 401.       , 8049.    ,   2.    ,  3670.   ,  566.   , 171.948760     ,  430.     },
	{105  , 67 , 172, "Ho","    x",  -51400.      , 401.       , 8065.    ,   2.    ,  5090.   ,  401.   , 171.944820     ,  430.     },
	{104  , 68 , 172, "Er","     ",  -56489.417   ,   4.618    , 8090.444 ,   0.027 ,   890.573,    4.543, 171.939356113  ,    4.957  },
	{103  , 69 , 172, "Tm","     ",  -57379.990   ,   5.970    , 8091.073 ,   0.035 ,  1880.291,    5.502, 171.938400044  ,    6.409  },
	{102  , 70 , 172, "Yb","     ",  -59260.280   ,   2.398    , 8097.457 ,   0.014 , -2518.946,    2.373, 171.936381469  ,    2.574  },
	{101  , 71 , 172, "Lu","     ",  -56741.334   ,   2.978    , 8078.263 ,   0.017 ,  -337.790,   24.609, 171.939085669  ,    3.197  },
	{100  , 72 , 172, "Hf","    x",  -56403.544   ,  24.428    , 8071.751 ,   0.142 , -5073.567,   37.117, 171.939448301  ,   26.224  },
	{ 99  , 73 , 172, "Ta","    x",  -51329.977   ,  27.945    , 8037.705 ,   0.162 , -2232.791,   39.520, 171.944895000  ,   30.000  },
	{ 98  , 74 , 172, "W ","    x",  -49097.186   ,  27.945    , 8020.175 ,   0.162 , -7573.942,   60.784, 171.947292000  ,   30.000  },
	{ 97  , 75 , 172, "Re","   +a",  -41523.244   ,  53.979    , 7971.592 ,   0.314 , -4285.191,   55.915, 171.955422961  ,   57.948  },
	{ 96  , 76 , 172, "Os","   +a",  -37238.053   ,  14.586    , 7942.129 ,   0.085 , -9718.   ,  106.   , 171.960023303  ,   15.658  },
	{ 95  , 77 , 172, "Ir","   -a",  -27520.      , 105.       , 7881.    ,   1.    , -6419.   ,  105.   , 171.970456     ,  112.     },
	{ 94  , 78 , 172, "Pt","   -a",  -21101.014   ,  12.778    , 7839.212 ,   0.074 ,-11819.   ,  160.   , 171.977347128  ,   13.717  },
	{ 93  , 79 , 172, "Au","   -a",   -9282.      , 159.       , 7766.    ,   1.    , -8195.   ,  242.   , 171.990035     ,  171.     },
	{ 92  , 80 , 172, "Hg","   -a",   -1087.345   , 209.154    , 7713.757 ,   1.216 , STAR     , STAR    , 171.998832686  ,  224.535  },
	{107  , 66 , 173, "Dy","    x",  -43780.      , 503.       , 8026.    ,   3.    ,  5319.   ,  643.   , 172.953000     ,  540.     },
	{106  , 67 , 173, "Ho","    x",  -49099.      , 401.       , 8052.    ,   2.    ,  4555.   ,  446.   , 172.947290     ,  430.     },
	{105  , 68 , 173, "Er","    x",  -53654.      , 196.       , 8074.    ,   1.    ,  2605.   ,  196.   , 172.942400     ,  210.     },
	{104  , 69 , 173, "Tm","  p2n",  -56258.878   ,   5.096    , 8084.479 ,   0.029 ,  1297.403,    4.507, 172.939603607  ,    5.470  },
	{103  , 70 , 173, "Yb","     ",  -57556.282   ,   2.388    , 8087.456 ,   0.014 ,  -670.504,    1.656, 172.938210787  ,    2.563  },
	{102  , 71 , 173, "Lu","     ",  -56885.778   ,   2.420    , 8079.058 ,   0.014 , -1473.994,   28.049, 172.938930602  ,    2.598  },
	{101  , 72 , 173, "Hf","    x",  -55411.784   ,  27.945    , 8066.016 ,   0.162 , -3015.246,   39.520, 172.940513000  ,   30.000  },
	{100  , 73 , 173, "Ta","    x",  -52396.538   ,  27.945    , 8044.064 ,   0.162 , -3669.155,   39.520, 172.943750000  ,   30.000  },
	{ 99  , 74 , 173, "W ","    x",  -48727.383   ,  27.945    , 8018.333 ,   0.162 , -5173.518,   39.520, 172.947689000  ,   30.000  },
	{ 98  , 75 , 173, "Re","    x",  -43553.865   ,  27.945    , 7983.906 ,   0.162 , -6115.640,   31.697, 172.953243000  ,   30.000  },
	{ 97  , 76 , 173, "Os","     ",  -37438.225   ,  14.959    , 7944.033 ,   0.086 , -7166.290,   20.280, 172.959808409  ,   16.059  },
	{ 96  , 77 , 173, "Ir","   +a",  -30271.935   ,  13.693    , 7898.087 ,   0.079 , -8330.365,   57.640, 172.967501739  ,   14.700  },
	{ 95  , 78 , 173, "Pt","   -a",  -21941.570   ,  55.990    , 7845.413 ,   0.324 , -9121.772,   61.734, 172.976444754  ,   60.108  },
	{ 94  , 79 , 173, "Au","   +a",  -12819.798   ,  26.005    , 7788.163 ,   0.150 ,-10251.   ,  210.   , 172.986237380  ,   27.917  },
	{ 93  , 80 , 173, "Hg","   -a",   -2569.      , 208.       , 7724.    ,   1.    , STAR     , STAR    , 172.997242     ,  224.     },
	{107  , 67 , 174, "Ho","    x",  -45503.      , 503.       , 8032.    ,   3.    ,  6446.   ,  585.   , 173.951150     ,  540.     },
	{106  , 68 , 174, "Er","    x",  -51949.      , 298.       , 8064.    ,   2.    ,  1920.   ,  301.   , 173.944230     ,  320.     },
	{105  , 69 , 174, "Tm","    +",  -53869.598   ,  44.785    , 8070.672 ,   0.257 ,  3080.000,   44.721, 173.942168605  ,   48.078  },
	{104  , 70 , 174, "Yb","     ",  -56949.598   ,   2.388    , 8083.876 ,   0.014 , -1374.318,    1.616, 173.938862089  ,    2.563  },
	{103  , 71 , 174, "Lu","     ",  -55575.279   ,   2.405    , 8071.482 ,   0.014 ,   271.346,    2.143, 173.940337480  ,    2.581  },
	{102  , 72 , 174, "Hf","     ",  -55846.626   ,   2.806    , 8068.545 ,   0.016 , -4105.859,   28.085, 173.940046178  ,    3.012  },
	{101  , 73 , 174, "Ta","    x",  -51740.766   ,  27.945    , 8040.452 ,   0.161 , -1513.678,   39.520, 173.944454000  ,   30.000  },
	{100  , 74 , 174, "W ","    x",  -50227.088   ,  27.945    , 8027.256 ,   0.161 , -6553.992,   39.520, 173.946079000  ,   30.000  },
	{ 99  , 75 , 174, "Re","    x",  -43673.097   ,  27.945    , 7985.094 ,   0.161 , -3676.796,   30.083, 173.953115000  ,   30.000  },
	{ 98  , 76 , 174, "Os","   +a",  -39996.301   ,  11.139    , 7959.466 ,   0.064 , -9127.563,   29.824, 173.957062202  ,   11.957  },
	{ 97  , 77 , 174, "Ir","   -a",  -30868.738   ,  27.666    , 7902.513 ,   0.159 , -5549.583,   30.086, 173.966861045  ,   29.700  },
	{ 96  , 78 , 174, "Pt","   -a",  -25319.155   ,  11.822    , 7866.122 ,   0.068 ,-11124.   ,  103.   , 173.972818767  ,   12.691  },
	{ 95  , 79 , 174, "Au","   -a",  -14195.      , 102.       , 7798.    ,   1.    , -7548.   ,  102.   , 173.984761     ,  109.     },
	{ 94  , 80 , 174, "Hg","   -a",   -6647.425   ,  19.606    , 7749.821 ,   0.113 , STAR     , STAR    , 173.992863695  ,   21.047  },
	{108  , 67 , 175, "Ho","    x",  -42802.      , 596.       , 8016.    ,   3.    ,  5850.   ,  718.   , 174.954050     ,  640.     },
	{107  , 68 , 175, "Er","    x",  -48652.      , 401.       , 8045.    ,   2.    ,  3664.   ,  404.   , 174.947770     ,  430.     },
	{106  , 69 , 175, "Tm","    +",  -52315.634   ,  50.057    , 8061.795 ,   0.286 ,  2385.000,   50.000, 174.943836853  ,   53.738  },
	{105  , 70 , 175, "Yb","     ",  -54700.634   ,   2.388    , 8070.954 ,   0.014 ,   470.061,    1.267, 174.941276450  ,    2.563  },
	{104  , 71 , 175, "Lu","     ",  -55170.695   ,   2.187    , 8069.169 ,   0.012 ,  -686.849,    1.923, 174.940771819  ,    2.347  },
	{103  , 72 , 175, "Hf","     ",  -54483.847   ,   2.825    , 8060.774 ,   0.016 , -2075.199,   28.087, 174.941509181  ,    3.032  },
	{102  , 73 , 175, "Ta","    x",  -52408.647   ,  27.945    , 8044.445 ,   0.160 , -2775.852,   39.520, 174.943737000  ,   30.000  },
	{101  , 74 , 175, "W ","    x",  -49632.795   ,  27.945    , 8024.112 ,   0.160 , -4344.488,   39.520, 174.946717000  ,   30.000  },
	{100  , 75 , 175, "Re","    x",  -45288.307   ,  27.945    , 7994.816 ,   0.160 , -5183.611,   31.042, 174.951381000  ,   30.000  },
	{ 99  , 76 , 175, "Os","   +a",  -40104.697   ,  13.515    , 7960.725 ,   0.077 , -6676.074,   23.937, 174.956945835  ,   14.509  },
	{ 98  , 77 , 175, "Ir","     ",  -33428.622   ,  19.757    , 7918.105 ,   0.113 , -7738.532,   27.331, 174.964112895  ,   21.209  },
	{ 97  , 78 , 175, "Pt","     ",  -25690.090   ,  18.885    , 7869.415 ,   0.108 , -8247.033,   46.412, 174.972420552  ,   20.274  },
	{ 96  , 79 , 175, "Au","   -a",  -17443.057   ,  42.396    , 7817.818 ,   0.242 , -9453.885,  109.913, 174.981274107  ,   45.513  },
	{ 95  , 80 , 175, "Hg","   -a",   -7989.172   , 101.408    , 7759.325 ,   0.579 , STAR     , STAR    , 174.991423270  ,  108.865  },
	{108  , 68 , 176, "Er","    x",  -46500.      , 401.       , 8033.    ,   2.    ,  2874.   ,  413.   , 175.950080     ,  430.     },
	{107  , 69 , 176, "Tm","    +",  -49374.133   , 100.033    , 8045.137 ,   0.568 ,  4120.000,  100.000, 175.946994685  ,  107.389  },
	{106  , 70 , 176, "Yb","     ",  -53494.133   ,   2.571    , 8064.100 ,   0.015 ,  -106.774,    1.594, 175.942571683  ,    2.760  },
	{105  , 71 , 176, "Lu","     ",  -53387.359   ,   2.184    , 8059.049 ,   0.012 ,  1190.150,    0.761, 175.942686310  ,    2.344  },
	{104  , 72 , 176, "Hf","     ",  -54577.509   ,   2.216    , 8061.366 ,   0.013 , -3212.134,   30.819, 175.941408631  ,    2.379  },
	{103  , 73 , 176, "Ta","    x",  -51365.374   ,  30.739    , 8038.670 ,   0.175 ,  -723.771,   41.543, 175.944857000  ,   33.000  },
	{102  , 74 , 176, "W ","    x",  -50641.603   ,  27.945    , 8030.112 ,   0.159 , -5578.718,   39.520, 175.945634000  ,   30.000  },
	{101  , 75 , 176, "Re","    x",  -45062.886   ,  27.945    , 7993.970 ,   0.159 , -2964.945,   39.520, 175.951623000  ,   30.000  },
	{100  , 76 , 176, "Os","    x",  -42097.940   ,  27.945    , 7972.678 ,   0.159 , -8236.912,   34.564, 175.954806000  ,   30.000  },
	{ 99  , 77 , 176, "Ir","     ",  -33861.029   ,  20.340    , 7921.433 ,   0.116 , -4933.130,   24.938, 175.963648688  ,   21.836  },
	{ 98  , 78 , 176, "Pt","   +a",  -28927.898   ,  14.428    , 7888.958 ,   0.082 ,-10391.   ,  106.   , 175.968944622  ,   15.489  },
	{ 97  , 79 , 176, "Au","   -a",  -18537.      , 105.       , 7825.    ,   1.    , -6758.   ,  106.   , 175.980099     ,  113.     },
	{ 96  , 80 , 176, "Hg","   -a",  -11779.132   ,  14.176    , 7782.632 ,   0.081 ,-12329.   ,  196.   , 175.987354580  ,   15.218  },
	{ 95  , 81 , 176, "Tl","    x",     550.      , 196.       , 7708.    ,   1.    , STAR     , STAR    , 176.000590     ,  210.     },
	{109  , 68 , 177, "Er","    x",  -42802.      , 503.       , 8013.    ,   3.    ,  4667.   ,  585.   , 176.954050     ,  540.     },
	{108  , 69 , 177, "Tm","    x",  -47469.      , 298.       , 8035.    ,   2.    ,  3520.   ,  298.   , 176.949040     ,  320.     },
	{107  , 70 , 177, "Yb","   -n",  -50989.216   ,   2.581    , 8049.989 ,   0.015 ,  1399.818,    1.603, 176.945260822  ,    2.770  },
	{106  , 71 , 177, "Lu","     ",  -52389.034   ,   2.185    , 8053.478 ,   0.012 ,   500.589,    0.722, 176.943758055  ,    2.345  },
	{105  , 72 , 177, "Hf","     ",  -52889.623   ,   2.146    , 8051.886 ,   0.012 , -1166.000,    3.000, 176.943220651  ,    2.304  },
	{104  , 73 , 177, "Ta","    -",  -51723.623   ,   3.689    , 8040.878 ,   0.021 , -2021.897,   28.187, 176.944472403  ,    3.960  },
	{103  , 74 , 177, "W ","    x",  -49701.726   ,  27.945    , 8025.035 ,   0.158 , -3432.555,   39.520, 176.946643000  ,   30.000  },
	{102  , 75 , 177, "Re","    x",  -46269.170   ,  27.945    , 8001.222 ,   0.158 , -4319.640,   32.062, 176.950328000  ,   30.000  },
	{101  , 76 , 177, "Os","   +a",  -41949.530   ,  15.718    , 7972.397 ,   0.089 , -5902.109,   25.249, 176.954965324  ,   16.873  },
	{100  , 77 , 177, "Ir","    x",  -36047.421   ,  19.760    , 7934.632 ,   0.112 , -6676.932,   24.801, 176.961301500  ,   21.213  },
	{ 99  , 78 , 177, "Pt","     ",  -29370.489   ,  14.988    , 7892.489 ,   0.085 , -7820.289,   19.754, 176.968469481  ,   16.090  },
	{ 98  , 79 , 177, "Au","     ",  -21550.199   ,  12.869    , 7843.887 ,   0.073 , -8769.318,   76.161, 176.976864908  ,   13.814  },
	{ 97  , 80 , 177, "Hg","   -a",  -12780.882   ,  75.066    , 7789.922 ,   0.424 , -9452.920,   79.119, 176.986279158  ,   80.586  },
	{ 96  , 81 , 177, "Tl","   IT",   -3327.962   ,  24.999    , 7732.096 ,   0.141 , STAR     , STAR    , 176.996427286  ,   26.837  },
	{109  , 69 , 178, "Tm","    x",  -44116.      , 401.       , 8016.    ,   2.    ,  5583.   ,  401.   , 177.952640     ,  430.     },
	{108  , 70 , 178, "Yb","  -nn",  -49698.297   ,  10.325    , 8042.857 ,   0.058 ,   644.707,   10.301, 177.946646680  ,   11.084  },
	{107  , 71 , 178, "Lu","     ",  -50343.004   ,   2.889    , 8042.083 ,   0.016 ,  2101.257,    2.033, 177.945954559  ,    3.101  },
	{106  , 72 , 178, "Hf","     ",  -52444.262   ,   2.144    , 8049.493 ,   0.012 , -1937.000,   15.000, 177.943698766  ,    2.301  },
	{105  , 73 , 178, "Ta","    -",  -50507.262   ,  15.152    , 8034.216 ,   0.085 ,   -91.300,    2.000, 177.945778221  ,   16.266  },
	{104  , 74 , 178, "W ","    -",  -50415.962   ,  15.284    , 8029.308 ,   0.086 , -4762.509,   31.851, 177.945876236  ,   16.407  },
	{103  , 75 , 178, "Re","    x",  -45653.453   ,  27.945    , 7998.157 ,   0.157 , -2107.264,   32.420, 177.950989000  ,   30.000  },
	{102  , 76 , 178, "Os","   +a",  -43546.189   ,  16.436    , 7981.923 ,   0.092 , -7294.305,   25.702, 177.953251241  ,   17.644  },
	{101  , 77 , 178, "Ir","    x",  -36251.884   ,  19.760    , 7936.549 ,   0.111 , -4253.877,   22.530, 177.961082000  ,   21.213  },
	{100  , 78 , 178, "Pt","   +a",  -31998.007   ,  10.823    , 7908.255 ,   0.061 , -9671.885,   58.160, 177.965648724  ,   11.619  },
	{ 99  , 79 , 178, "Au","   -a",  -22326.122   ,  57.144    , 7849.524 ,   0.321 , -6009.276,   58.577, 177.976031920  ,   61.346  },
	{ 98  , 80 , 178, "Hg","   -a",  -16316.846   ,  12.878    , 7811.368 ,   0.072 ,-11563.   ,  114.   , 177.982483143  ,   13.825  },
	{ 97  , 81 , 178, "Tl","   -a",   -4754.      , 114.       , 7742.    ,   1.    , -8321.   ,  115.   , 177.994897     ,  122.     },
	{ 96  , 82 , 178, "Pb","   -a",    3567.800   ,  24.280    , 7690.866 ,   0.136 , STAR     , STAR    , 178.003830191  ,   26.065  },
	{110  , 69 , 179, "Tm","    x",  -41601.      , 503.       , 8002.    ,   3.    ,  4816.   ,  585.   , 178.955340     ,  540.     },
	{109  , 70 , 179, "Yb","    x",  -46416.      , 298.       , 8025.    ,   2.    ,  2648.   ,  298.   , 178.950170     ,  320.     },
	{108  , 71 , 179, "Lu","     ",  -49064.170   ,   5.458    , 8035.102 ,   0.030 ,  1407.766,    5.057, 178.947327443  ,    5.859  },
	{107  , 72 , 179, "Hf","     ",  -50471.936   ,   2.143    , 8038.596 ,   0.012 ,  -105.622,    0.409, 178.945816145  ,    2.301  },
	{106  , 73 , 179, "Ta","     ",  -50366.314   ,   2.173    , 8033.636 ,   0.012 , -1062.753,   15.624, 178.945929535  ,    2.332  },
	{105  , 74 , 179, "W ","   +n",  -49303.561   ,  15.506    , 8023.328 ,   0.087 , -2717.349,   28.934, 178.947070447  ,   16.646  },
	{104  , 75 , 179, "Re","    x",  -46586.212   ,  24.428    , 8003.776 ,   0.136 , -3566.110,   30.389, 178.949987641  ,   26.224  },
	{103  , 76 , 179, "Os","   +a",  -43020.103   ,  18.076    , 7979.483 ,   0.101 , -4942.739,   21.108, 178.953816017  ,   19.405  },
	{102  , 77 , 179, "Ir","   +a",  -38077.364   ,  10.899    , 7947.500 ,   0.061 , -5813.583,   14.193, 178.959122266  ,   11.700  },
	{101  , 78 , 179, "Pt","   +a",  -32263.781   ,   9.092    , 7910.651 ,   0.051 , -7311.677,   18.882, 178.965363404  ,    9.760  },
	{100  , 79 , 179, "Au","     ",  -24952.104   ,  16.549    , 7865.433 ,   0.092 , -8030.455,   31.931, 178.973212812  ,   17.766  },
	{ 99  , 80 , 179, "Hg","     ",  -16921.649   ,  27.308    , 7816.199 ,   0.153 , -8621.183,   51.090, 178.981833861  ,   29.315  },
	{ 98  , 81 , 179, "Tl","   -a",   -8300.467   ,  43.180    , 7763.666 ,   0.241 ,-10303.   ,  200.   , 178.991089082  ,   46.355  },
	{ 97  , 82 , 179, "Pb","    x",    2003.      , 196.       , 7702.    ,   1.    , STAR     , STAR    , 179.002150     ,  210.     },
	{110  , 70 , 180, "Yb","    x",  -44404.      , 401.       , 8014.    ,   2.    ,  2281.   ,  407.   , 179.952330     ,  430.     },
	{109  , 71 , 180, "Lu","    +",  -46685.398   ,  70.743    , 8022.088 ,   0.393 ,  3103.000,   70.711, 179.949881160  ,   75.946  },
	{108  , 72 , 180, "Hf","     ",  -49788.398   ,   2.147    , 8034.981 ,   0.012 ,  -852.203,    2.500, 179.946549953  ,    2.304  },
	{107  , 73 , 180, "Ta","     ",  -48936.195   ,   2.216    , 8025.900 ,   0.012 ,   708.282,    4.227, 179.947464831  ,    2.379  },
	{106  , 74 , 180, "W ","     ",  -49644.477   ,   3.931    , 8025.488 ,   0.022 , -3804.804,   21.750, 179.946704459  ,    4.219  },
	{105  , 75 , 180, "Re","    x",  -45839.673   ,  21.392    , 8000.004 ,   0.119 , -1480.814,   29.492, 179.950789084  ,   22.965  },
	{104  , 76 , 180, "Os","   +a",  -44358.859   ,  20.301    , 7987.431 ,   0.113 , -6381.333,   29.721, 179.952378803  ,   21.794  },
	{103  , 77 , 180, "Ir","    x",  -37977.526   ,  21.706    , 7947.633 ,   0.121 , -3541.568,   24.324, 179.959229446  ,   23.302  },
	{102  , 78 , 180, "Pt","   +a",  -34435.958   ,  10.978    , 7923.611 ,   0.061 , -8839.549,   23.704, 179.963031477  ,   11.784  },
	{101  , 79 , 180, "Au","     ",  -25596.408   ,  21.009    , 7870.156 ,   0.117 , -5351.685,   25.229, 179.972521124  ,   22.554  },
	{100  , 80 , 180, "Hg","     ",  -20244.723   ,  13.968    , 7836.078 ,   0.078 ,-10842.   ,  117.   , 179.978266394  ,   14.994  },
	{ 99  , 81 , 180, "Tl","   -a",   -9403.      , 116.       , 7771.    ,   1.    , -7464.   ,  118.   , 179.989906     ,  125.     },
	{ 98  , 82 , 180, "Pb","   -a",   -1939.209   ,  20.888    , 7725.688 ,   0.116 , STAR     , STAR    , 179.997918173  ,   22.424  },
	{111  , 70 , 181, "Yb","    x",  -40846.      , 401.       , 7994.    ,   2.    ,  3894.   ,  499.   , 180.956150     ,  430.     },
	{110  , 71 , 181, "Lu","    x",  -44740.      , 298.       , 8012.    ,   2.    ,  2672.   ,  298.   , 180.951970     ,  320.     },
	{109  , 72 , 181, "Hf","     ",  -47411.884   ,   2.148    , 8022.052 ,   0.012 ,  1029.751,    2.126, 180.949101246  ,    2.305  },
	{108  , 73 , 181, "Ta","     ",  -48441.634   ,   1.793    , 8023.418 ,   0.010 ,  -187.682,    4.547, 180.947995763  ,    1.924  },
	{107  , 74 , 181, "W ","     ",  -48253.952   ,   4.734    , 8018.059 ,   0.026 , -1742.516,   13.399, 180.948197248  ,    5.082  },
	{106  , 75 , 181, "Re","   4n",  -46511.436   ,  12.579    , 8004.110 ,   0.069 , -2958.502,   34.077, 180.950067916  ,   13.503  },
	{105  , 76 , 181, "Os","    x",  -43552.934   ,  31.671    , 7983.442 ,   0.175 , -4081.152,   40.741, 180.953244000  ,   34.000  },
	{104  , 77 , 181, "Ir","    x",  -39471.782   ,  25.627    , 7956.572 ,   0.142 , -5097.124,   29.625, 180.957625297  ,   27.512  },
	{103  , 78 , 181, "Pt","    x",  -34374.658   ,  14.863    , 7924.088 ,   0.082 , -6503.470,   24.899, 180.963097285  ,   15.956  },
	{102  , 79 , 181, "Au","   -a",  -27871.187   ,  19.976    , 7883.835 ,   0.110 , -7210.009,   25.212, 180.970079048  ,   21.445  },
	{101  , 80 , 181, "Hg","     ",  -20661.178   ,  15.383    , 7839.679 ,   0.085 , -7860.073,   18.004, 180.977819311  ,   16.513  },
	{100  , 81 , 181, "Tl","     ",  -12801.105   ,   9.357    , 7791.931 ,   0.052 , -9656.343,   90.678, 180.986257447  ,   10.045  },
	{ 99  , 82 , 181, "Pb","   -a",   -3144.762   ,  90.194    , 7734.258 ,   0.498 , STAR     , STAR    , 180.996623958  ,   96.826  },
	{111  , 71 , 182, "Lu","    x",  -41880.      , 196.       , 7996.    ,   1.    ,  4179.   ,  196.   , 181.955040     ,  210.     },
	{110  , 72 , 182, "Hf","  -nn",  -46058.563   ,   6.373    , 8014.886 ,   0.035 ,   374.691,    6.366, 181.950554096  ,    6.841  },
	{109  , 73 , 182, "Ta","     ",  -46433.254   ,   1.794    , 8012.647 ,   0.010 ,  1814.264,    1.669, 181.950151849  ,    1.925  },
	{108  , 74 , 182, "W ","     ",  -48247.518   ,   0.828    , 8018.316 ,   0.005 , -2800.000,  101.980, 181.948204156  ,    0.889  },
	{107  , 75 , 182, "Re","   IT",  -45447.518   , 101.984    , 7998.633 ,   0.560 ,  -838.444,  104.276, 181.951210080  ,  109.484  },
	{106  , 76 , 182, "Os","     ",  -44609.074   ,  21.745    , 7989.728 ,   0.119 , -5557.395,   30.207, 181.952110186  ,   23.344  },
	{105  , 77 , 182, "Ir","     ",  -39051.679   ,  20.967    , 7954.894 ,   0.115 , -2882.378,   26.146, 181.958076296  ,   22.509  },
	{104  , 78 , 182, "Pt","   +a",  -36169.301   ,  15.620    , 7934.758 ,   0.086 , -7868.533,   25.582, 181.961170656  ,   16.769  },
	{103  , 79 , 182, "Au","   -a",  -28300.768   ,  20.260    , 7887.226 ,   0.111 , -4724.622,   22.468, 181.969617874  ,   21.749  },
	{102  , 80 , 182, "Hg","    x",  -23576.146   ,   9.715    , 7856.968 ,   0.053 ,-10225.140,   76.549, 181.974689964  ,   10.428  },
	{101  , 81 , 182, "Tl","   -a",  -13351.007   ,  75.930    , 7796.487 ,   0.417 , -6524.872,   77.211, 181.985667104  ,   81.514  },
	{100  , 82 , 182, "Pb","   -a",   -6826.135   ,  14.007    , 7756.338 ,   0.077 , STAR     , STAR    , 181.992671842  ,   15.037  },
	{112  , 71 , 183, "Lu","    x",  -39523.      , 298.       , 7984.    ,   2.    ,  3763.   ,  300.   , 182.957570     ,  320.     },
	{111  , 72 , 183, "Hf","    +",  -43286.117   ,  30.054    , 8000.045 ,   0.164 ,  2010.000,   30.000, 182.953530439  ,   32.264  },
	{110  , 73 , 183, "Ta","   -n",  -45296.117   ,   1.805    , 8006.753 ,   0.010 ,  1070.906,    1.681, 182.951372616  ,    1.937  },
	{109  , 74 , 183, "W ","     ",  -46367.023   ,   0.824    , 8008.330 ,   0.005 ,  -556.000,    8.000, 182.950222951  ,    0.884  },
	{108  , 75 , 183, "Re","    -",  -45811.023   ,   8.042    , 8001.017 ,   0.044 , -2148.269,   50.442, 182.950819841  ,    8.633  },
	{107  , 76 , 183, "Os","    x",  -43662.754   ,  49.797    , 7985.002 ,   0.272 , -3465.489,   55.772, 182.953126102  ,   53.459  },
	{106  , 77 , 183, "Ir","     ",  -40197.266   ,  25.115    , 7961.790 ,   0.137 , -4424.825,   29.562, 182.956846458  ,   26.962  },
	{105  , 78 , 183, "Pt","     ",  -35772.441   ,  15.592    , 7933.336 ,   0.085 , -5585.547,   18.794, 182.961596703  ,   16.739  },
	{104  , 79 , 183, "Au","   +a",  -30186.894   ,  10.492    , 7898.538 ,   0.057 , -6387.075,   13.316, 182.967593034  ,   11.263  },
	{103  , 80 , 183, "Hg","     ",  -23799.819   ,   8.200    , 7859.361 ,   0.045 , -7212.522,   12.739, 182.974449841  ,    8.803  },
	{102  , 81 , 183, "Tl","     ",  -16587.297   ,   9.749    , 7815.674 ,   0.053 , -9018.564,   29.829, 182.982192802  ,   10.466  },
	{101  , 82 , 183, "Pb","   -a",   -7568.734   ,  28.191    , 7762.117 ,   0.154 , STAR     , STAR    , 182.991874629  ,   30.263  },
	{113  , 71 , 184, "Lu","    x",  -36412.      , 401.       , 7967.    ,   2.    ,  5089.   ,  403.   , 183.960910     ,  430.     },
	{112  , 72 , 184, "Hf","    +",  -41501.304   ,  39.708    , 7990.732 ,   0.216 ,  1340.000,   30.000, 183.955446515  ,   42.628  },
	{111  , 73 , 184, "Ta","    +",  -42841.304   ,  26.014    , 7993.763 ,   0.141 ,  2866.000,   26.000, 183.954007966  ,   27.927  },
	{110  , 74 , 184, "W ","     ",  -45707.304   ,   0.859    , 8005.087 ,   0.005 , -1480.673,    4.246, 183.950931188  ,    0.922  },
	{109  , 75 , 184, "Re","     ",  -44226.631   ,   4.332    , 7992.788 ,   0.024 ,    29.515,    4.151, 183.952520756  ,    4.650  },
	{108  , 76 , 184, "Os","     ",  -44256.145   ,   1.304    , 7988.696 ,   0.007 , -4645.294,   27.975, 183.952489071  ,    1.399  },
	{107  , 77 , 184, "Ir","    x",  -39610.851   ,  27.945    , 7959.198 ,   0.152 , -2278.668,   33.309, 183.957476000  ,   30.000  },
	{106  , 78 , 184, "Pt","     ",  -37332.183   ,  18.126    , 7942.562 ,   0.099 , -7013.473,   28.718, 183.959922251  ,   19.459  },
	{105  , 79 , 184, "Au","   -a",  -30318.710   ,  22.275    , 7900.194 ,   0.121 , -3969.587,   24.443, 183.967451524  ,   23.912  },
	{104  , 80 , 184, "Hg","     ",  -26349.123   ,  10.065    , 7874.368 ,   0.055 , -9464.046,   50.334, 183.971713051  ,   10.805  },
	{103  , 81 , 184, "Tl","     ",  -16885.078   ,  49.317    , 7818.681 ,   0.268 , -5839.738,   51.348, 183.981873122  ,   52.944  },
	{102  , 82 , 184, "Pb","     ",  -11045.339   ,  14.297    , 7782.692 ,   0.078 ,-12092.   ,  127.   , 183.988142339  ,   15.347  },
	{101  , 83 , 184, "Bi","   -a",    1047.      , 126.       , 7713.    ,   1.    , STAR     , STAR    , 184.001124     ,  136.     },
	{113  , 72 , 185, "Hf","    x",  -38359.      , 196.       , 7974.    ,   1.    ,  3037.   ,  196.   , 184.958820     ,  210.     },
	{112  , 73 , 185, "Ta","    +",  -41396.176   ,  14.171    , 7986.370 ,   0.077 ,  1993.500,   14.142, 184.955559375  ,   15.213  },
	{111  , 74 , 185, "W ","     ",  -43389.676   ,   0.904    , 7992.917 ,   0.005 ,   432.476,    0.867, 184.953419264  ,    0.970  },
	{110  , 75 , 185, "Re","     ",  -43822.152   ,   1.193    , 7991.026 ,   0.006 , -1012.797,    0.447, 184.952954982  ,    1.280  },
	{109  , 76 , 185, "Os","     ",  -42809.355   ,   1.274    , 7981.323 ,   0.007 , -2473.801,   27.974, 184.954042265  ,    1.367  },
	{108  , 77 , 185, "Ir","    x",  -40335.554   ,  27.945    , 7963.722 ,   0.151 , -3652.388,   49.606, 184.956698000  ,   30.000  },
	{107  , 78 , 185, "Pt","    x",  -36683.166   ,  40.986    , 7939.750 ,   0.222 , -4816.207,   48.552, 184.960619000  ,   44.000  },
	{106  , 79 , 185, "Au","   -a",  -31866.958   ,  26.028    , 7909.488 ,   0.141 , -5691.125,   30.312, 184.965789411  ,   27.942  },
	{105  , 80 , 185, "Hg","   -a",  -26175.833   ,  15.536    , 7874.496 ,   0.084 , -6420.061,   56.075, 184.971899086  ,   16.678  },
	{104  , 81 , 185, "Tl","   IT",  -19755.772   ,  53.880    , 7835.564 ,   0.291 , -8214.509,   56.255, 184.978791305  ,   57.842  },
	{103  , 82 , 185, "Pb","   -a",  -11541.263   ,  16.175    , 7786.932 ,   0.087 , -9329.   ,   56.   , 184.987609944  ,   17.364  },
	{102  , 83 , 185, "Bi","   IT",   -2213.      ,  53.       , 7732.    ,   0.    , STAR     , STAR    , 184.997625     ,   57.     },
	{114  , 72 , 186, "Hf","    x",  -36431.      , 298.       , 7964.    ,   2.    ,  2178.   ,  304.   , 185.960890     ,  320.     },
	{113  , 73 , 186, "Ta","    +",  -38608.542   ,  60.025    , 7971.840 ,   0.323 ,  3901.000,   60.000, 185.958552023  ,   64.440  },
	{112  , 74 , 186, "W ","     ",  -42509.542   ,   1.749    , 7988.607 ,   0.009 ,  -579.350,    1.504, 185.954364127  ,    1.877  },
	{111  , 75 , 186, "Re","     ",  -41930.192   ,   1.202    , 7981.286 ,   0.006 ,  1069.286,    0.866, 185.954986084  ,    1.290  },
	{110  , 76 , 186, "Os","     ",  -42999.479   ,   1.380    , 7982.829 ,   0.007 , -3826.527,   16.583, 185.953838158  ,    1.481  },
	{109  , 77 , 186, "Ir","    x",  -39172.952   ,  16.526    , 7958.050 ,   0.089 , -1308.478,   27.312, 185.957946104  ,   17.740  },
	{108  , 78 , 186, "Pt","     ",  -37864.474   ,  21.745    , 7946.809 ,   0.117 , -6149.622,   30.207, 185.959350813  ,   23.344  },
	{107  , 79 , 186, "Au","     ",  -31714.853   ,  20.967    , 7909.540 ,   0.113 , -3175.544,   23.793, 185.965952703  ,   22.509  },
	{106  , 80 , 186, "Hg","    x",  -28539.309   ,  11.247    , 7888.261 ,   0.060 , -8349.176,  184.778, 185.969361790  ,   12.074  },
	{105  , 81 , 186, "Tl","    x",  -20190.133   , 184.436    , 7839.167 ,   0.992 , -5508.804,  184.782, 185.978325000  ,  198.000  },
	{104  , 82 , 186, "Pb","   -a",  -14681.328   ,  11.298    , 7805.343 ,   0.061 ,-11512.037,   77.698, 185.984238945  ,   12.129  },
	{103  , 83 , 186, "Bi","   -a",   -3169.291   ,  76.873    , 7739.245 ,   0.413 , STAR     , STAR    , 185.996597625  ,   82.526  },
	{115  , 72 , 187, "Hf","    x",  -32984.      , 401.       , 7946.    ,   2.    ,  3782.   ,  446.   , 186.964590     ,  430.     },
	{114  , 73 , 187, "Ta","    x",  -36766.      , 196.       , 7963.    ,   1.    ,  3139.   ,  196.   , 186.960530     ,  210.     },
	{113  , 74 , 187, "W ","     ",  -39904.768   ,   1.748    , 7975.120 ,   0.009 ,  1310.945,    1.282, 186.957160466  ,    1.876  },
	{112  , 75 , 187, "Re","     ",  -41215.714   ,   1.409    , 7977.947 ,   0.008 ,     2.469,    0.004, 186.955753109  ,    1.513  },
	{111  , 76 , 187, "Os","     ",  -41218.183   ,   1.409    , 7973.776 ,   0.008 , -1502.409,    6.000, 186.955750458  ,    1.513  },
	{110  , 77 , 187, "Ir","    -",  -39715.774   ,   6.163    , 7961.558 ,   0.033 , -3002.800,   28.616, 186.957363361  ,    6.616  },
	{109  , 78 , 187, "Pt","    x",  -36712.973   ,  27.945    , 7941.317 ,   0.149 , -3707.851,   37.572, 186.960587000  ,   30.000  },
	{108  , 79 , 187, "Au","     ",  -33005.122   ,  25.115    , 7917.305 ,   0.134 , -4887.264,   28.717, 186.964567541  ,   26.962  },
	{107  , 80 , 187, "Hg","     ",  -28117.858   ,  13.924    , 7886.986 ,   0.074 , -5674.346,   16.112, 186.969814236  ,   14.947  },
	{106  , 81 , 187, "Tl","     ",  -22443.512   ,   8.107    , 7852.458 ,   0.043 , -7463.570,   11.592, 186.975905897  ,    8.702  },
	{105  , 82 , 187, "Pb","     ",  -14979.941   ,   8.286    , 7808.363 ,   0.044 , -8606.506,   17.447, 186.983918370  ,    8.895  },
	{104  , 83 , 187, "Bi","     ",   -6373.435   ,  15.354    , 7758.155 ,   0.082 , STAR     , STAR    , 186.993157835  ,   16.483  },
	{116  , 72 , 188, "Hf","    x",  -30879.      , 503.       , 7936.    ,   3.    ,  2934.   ,  540.   , 187.966850     ,  540.     },
	{115  , 73 , 188, "Ta","    x",  -33813.      , 196.       , 7947.    ,   1.    ,  4854.   ,  196.   , 187.963700     ,  210.     },
	{114  , 74 , 188, "W ","    +",  -38667.150   ,   3.317    , 7969.048 ,   0.018 ,   349.000,    3.000, 187.958489105  ,    3.560  },
	{113  , 75 , 188, "Re","   -n",  -39016.150   ,   1.414    , 7966.743 ,   0.008 ,  2120.276,    0.190, 187.958114438  ,    1.518  },
	{112  , 76 , 188, "Os","     ",  -41136.426   ,   1.414    , 7973.860 ,   0.008 , -2808.355,    6.885, 187.955838228  ,    1.518  },
	{111  , 77 , 188, "Ir","     ",  -38328.071   ,   6.994    , 7954.761 ,   0.037 ,  -505.122,    7.190, 187.958853121  ,    7.508  },
	{110  , 78 , 188, "Pt","     ",  -37822.950   ,   5.385    , 7947.912 ,   0.029 , -5522.148,   21.086, 187.959395391  ,    5.780  },
	{109  , 79 , 188, "Au","    x",  -32300.802   ,  20.387    , 7914.378 ,   0.108 , -2099.018,   23.422, 187.965323661  ,   21.886  },
	{108  , 80 , 188, "Hg","     ",  -30201.784   ,  11.532    , 7899.051 ,   0.061 , -7855.040,   34.588, 187.967577049  ,   12.379  },
	{107  , 81 , 188, "Tl","    x",  -22346.744   ,  32.609    , 7853.108 ,   0.173 , -4531.305,   34.297, 187.976009782  ,   35.007  },
	{106  , 82 , 188, "Pb","   -a",  -17815.439   ,  10.626    , 7824.844 ,   0.057 ,-10610.477,   50.932, 187.980874338  ,   11.407  },
	{105  , 83 , 188, "Bi","   -a",   -7204.962   ,  49.812    , 7764.244 ,   0.265 , -6666.603,   53.463, 187.992265154  ,   53.474  },
	{104  , 84 , 188, "Po","   -a",    -538.359   ,  19.419    , 7724.622 ,   0.103 , STAR     , STAR    , 187.999422048  ,   20.847  },
	{116  , 73 , 189, "Ta","    x",  -31829.      , 298.       , 7938.    ,   2.    ,  3649.   ,  359.   , 188.965830     ,  320.     },
	{115  , 74 , 189, "W ","    +",  -35477.935   , 200.172    , 7952.715 ,   1.059 ,  2500.000,  200.000, 188.961912868  ,  214.893  },
	{114  , 75 , 189, "Re","   +p",  -37977.935   ,   8.297    , 7961.804 ,   0.044 ,  1007.445,    8.167, 188.959229007  ,    8.906  },
	{113  , 76 , 189, "Os","     ",  -38985.380   ,   1.465    , 7962.995 ,   0.008 ,  -532.316,   12.686, 188.958147470  ,    1.572  },
	{112  , 77 , 189, "Ir","     ",  -38453.064   ,  12.743    , 7956.039 ,   0.067 , -1969.877,   13.943, 188.958718935  ,   13.680  },
	{111  , 78 , 189, "Pt","     ",  -36483.186   ,  11.175    , 7941.477 ,   0.059 , -2901.232,   22.981, 188.960833686  ,   11.997  },
	{110  , 79 , 189, "Au","    x",  -33581.955   ,  20.081    , 7921.987 ,   0.106 , -3951.163,   38.983, 188.963948286  ,   21.558  },
	{109  , 80 , 189, "Hg","     ",  -29630.792   ,  33.413    , 7896.942 ,   0.177 , -5028.571,   35.143, 188.968190034  ,   35.869  },
	{108  , 81 , 189, "Tl","   +a",  -24602.221   ,  10.891    , 7866.196 ,   0.058 , -6724.056,   36.145, 188.973588428  ,   11.692  },
	{107  , 82 , 189, "Pb","    x",  -17878.165   ,  34.465    , 7826.480 ,   0.182 , -7817.109,   64.022, 188.980807000  ,   37.000  },
	{106  , 83 , 189, "Bi","   -a",  -10061.055   ,  53.953    , 7780.980 ,   0.285 , -8645.708,   58.289, 188.989199012  ,   57.921  },
	{105  , 84 , 189, "Po","   -a",   -1415.347   ,  22.060    , 7731.096 ,   0.117 , STAR     , STAR    , 188.998480562  ,   23.681  },
	{117  , 73 , 190, "Ta","    x",  -28662.      , 401.       , 7922.    ,   2.    ,  5634.   ,  433.   , 189.969230     ,  430.     },
	{116  , 74 , 190, "W ","    +",  -34296.326   , 164.848    , 7947.121 ,   0.868 ,  1270.000,   70.000, 189.963181378  ,  176.971  },
	{115  , 75 , 190, "Re","    +",  -35566.326   , 149.248    , 7949.687 ,   0.786 ,  3140.000,  149.241, 189.961817977  ,  160.224  },
	{114  , 76 , 190, "Os","     ",  -38706.326   ,   1.472    , 7962.096 ,   0.008 , -1955.132,    1.176, 189.958447048  ,    1.580  },
	{113  , 77 , 190, "Ir","   +n",  -36751.194   ,   1.715    , 7947.688 ,   0.009 ,   572.229,    5.574, 189.960545968  ,    1.841  },
	{112  , 78 , 190, "Pt","     ",  -37323.422   ,   5.705    , 7946.582 ,   0.030 , -4442.000,   15.000, 189.959931655  ,    6.124  },
	{111  , 79 , 190, "Au","    -",  -32881.422   ,  16.048    , 7919.086 ,   0.084 , -1510.986,   22.602, 189.964700339  ,   17.228  },
	{110  , 80 , 190, "Hg","     ",  -31370.436   ,  15.919    , 7907.016 ,   0.084 , -7037.157,   51.936, 189.966322449  ,   17.089  },
	{109  , 81 , 190, "Tl","   +a",  -24333.279   ,  49.436    , 7865.860 ,   0.260 , -3916.344,   50.905, 189.973877149  ,   53.072  },
	{108  , 82 , 190, "Pb","   -a",  -20416.935   ,  12.139    , 7841.130 ,   0.064 , -9513.918,  184.902, 189.978081517  ,   13.032  },
	{107  , 83 , 190, "Bi","   -a",  -10903.017   , 184.504    , 7786.939 ,   0.971 , -6339.800,  184.990, 189.988295129  ,  198.072  },
	{106  , 84 , 190, "Po","   -a",   -4563.217   ,  13.410    , 7749.454 ,   0.071 , STAR     , STAR    , 189.995101185  ,   14.396  },
	{117  , 74 , 191, "W ","    x",  -31112.      , 196.       , 7931.    ,   1.    ,  3237.   ,  196.   , 190.966600     ,  210.     },
	{116  , 75 , 191, "Re","   +p",  -34348.616   ,  10.321    , 7943.949 ,   0.054 ,  2045.117,   10.222, 190.963125242  ,   11.080  },
	{115  , 76 , 191, "Os","     ",  -36393.733   ,   1.474    , 7950.560 ,   0.008 ,   312.677,    1.102, 190.960929718  ,    1.582  },
	{114  , 77 , 191, "Ir","     ",  -36706.409   ,   1.668    , 7948.101 ,   0.009 , -1008.449,    3.540, 190.960594046  ,    1.790  },
	{113  , 78 , 191, "Pt","     ",  -35697.960   ,   4.367    , 7938.725 ,   0.023 , -1888.664,   37.008, 190.961676661  ,    4.688  },
	{112  , 79 , 191, "Au","     ",  -33809.297   ,  37.032    , 7924.741 ,   0.194 , -3216.337,   40.049, 190.963704225  ,   39.755  },
	{111  , 80 , 191, "Hg","     ",  -30592.960   ,  22.590    , 7903.805 ,   0.118 , -4311.931,   23.825, 190.967157105  ,   24.251  },
	{110  , 81 , 191, "Tl","   +a",  -26281.028   ,   7.569    , 7877.134 ,   0.040 , -6035.006,   39.848, 190.971786154  ,    8.126  },
	{109  , 82 , 191, "Pb","    x",  -20246.022   ,  39.123    , 7841.441 ,   0.205 , -7005.878,   39.822, 190.978265000  ,   42.000  },
	{108  , 83 , 191, "Bi","     ",  -13240.145   ,   7.430    , 7800.665 ,   0.039 , -8186.311,   13.278, 190.985786119  ,    7.976  },
	{107  , 84 , 191, "Po","     ",   -5053.834   ,  11.004    , 7753.708 ,   0.058 , STAR     , STAR    , 190.994574485  ,   11.813  },
	{118  , 74 , 192, "W ","    x",  -29649.      , 596.       , 7924.    ,   3.    ,  2059.   ,  627.   , 191.968170     ,  640.     },
	{117  , 75 , 192, "Re","    x",  -31708.      , 196.       , 7931.    ,   1.    ,  4172.   ,  196.   , 191.965960     ,  210.     },
	{116  , 76 , 192, "Os","     ",  -35880.506   ,   2.556    , 7948.516 ,   0.013 , -1047.300,    2.297, 191.961480690  ,    2.743  },
	{115  , 77 , 192, "Ir","     ",  -34833.207   ,   1.669    , 7938.986 ,   0.009 ,  1459.658,    1.853, 191.962605012  ,    1.791  },
	{114  , 78 , 192, "Pt","     ",  -36292.864   ,   2.470    , 7942.514 ,   0.013 , -3516.341,   15.617, 191.961038005  ,    2.651  },
	{113  , 79 , 192, "Au","    -",  -32776.523   ,  15.812    , 7920.125 ,   0.082 ,  -765.105,   22.175, 191.964812953  ,   16.974  },
	{112  , 80 , 192, "Hg","    x",  -32011.418   ,  15.551    , 7912.065 ,   0.081 , -6139.172,   35.283, 191.965634327  ,   16.694  },
	{111  , 81 , 192, "Tl","    x",  -25872.246   ,  31.671    , 7876.016 ,   0.165 , -3316.278,   34.090, 191.972225000  ,   34.000  },
	{110  , 82 , 192, "Pb","   -a",  -22555.968   ,  12.612    , 7854.669 ,   0.066 , -9010.140,   35.319, 191.975785171  ,   13.539  },
	{109  , 83 , 192, "Bi","   -a",  -13545.828   ,  32.990    , 7803.666 ,   0.172 , -5474.572,   35.074, 191.985457954  ,   35.416  },
	{108  , 84 , 192, "Po","   -a",   -8071.257   ,  11.910    , 7771.078 ,   0.062 , STAR     , STAR    , 191.991335149  ,   12.786  },
	{118  , 75 , 193, "Re","    x",  -30302.      , 196.       , 7924.    ,   1.    ,  3091.   ,  196.   , 192.967470     ,  210.     },
	{117  , 76 , 193, "Os","     ",  -33392.604   ,   2.561    , 7936.261 ,   0.013 ,  1141.204,    2.301, 192.964151563  ,    2.749  },
	{116  , 77 , 193, "Ir","     ",  -34533.808   ,   1.672    , 7938.121 ,   0.009 ,   -56.794,    0.298, 192.962926430  ,    1.795  },
	{115  , 78 , 193, "Pt","     ",  -34477.014   ,   1.681    , 7933.773 ,   0.009 , -1082.689,   10.768, 192.962987401  ,    1.804  },
	{114  , 79 , 193, "Au","     ",  -33394.325   ,  10.648    , 7924.110 ,   0.055 , -2343.365,   14.067, 192.964149715  ,   11.431  },
	{113  , 80 , 193, "Hg","     ",  -31050.961   ,  15.378    , 7907.914 ,   0.080 , -3732.104,  111.909, 192.966665421  ,   16.508  },
	{112  , 81 , 193, "Tl","    x",  -27318.856   , 110.848    , 7884.523 ,   0.574 , -5124.367,  121.429, 192.970672000  ,  119.000  },
	{111  , 82 , 193, "Pb","    x",  -22194.490   ,  49.577    , 7853.918 ,   0.257 , -6321.619,   50.501, 192.976173234  ,   53.222  },
	{110  , 83 , 193, "Bi","    x",  -15872.871   ,   9.620    , 7817.110 ,   0.050 , -7512.969,   35.997, 192.982959771  ,   10.327  },
	{109  , 84 , 193, "Po","   -a",   -8359.902   ,  34.688    , 7774.129 ,   0.180 , -8213.762,   64.422, 192.991025275  ,   37.238  },
	{108  , 85 , 193, "At","   -a",    -146.140   ,  54.286    , 7727.518 ,   0.281 , STAR     , STAR    , 192.999843112  ,   58.278  },
	{119  , 75 , 194, "Re","    x",  -27554.      , 298.       , 7911.    ,   2.    ,  4879.   ,  298.   , 193.970420     ,  320.     },
	{118  , 76 , 194, "Os","    +",  -32432.681   ,   2.609    , 7932.010 ,   0.013 ,    96.600,    2.000, 193.965182083  ,    2.801  },
	{117  , 77 , 194, "Ir","   -n",  -32529.281   ,   1.676    , 7928.475 ,   0.009 ,  2233.840,    1.729, 193.965078378  ,    1.799  },
	{116  , 78 , 194, "Pt","     ",  -34763.121   ,   0.884    , 7935.957 ,   0.005 , -2501.059,   10.177, 193.962680253  ,    0.948  },
	{115  , 79 , 194, "Au","     ",  -32262.062   ,  10.203    , 7919.032 ,   0.053 ,   -69.079,   13.653, 193.965365250  ,   10.953  },
	{114  , 80 , 194, "Hg","     ",  -32192.983   ,  12.535    , 7914.643 ,   0.065 , -5365.955,  135.647, 193.965439409  ,   13.457  },
	{113  , 81 , 194, "Tl","    x",  -26827.027   , 135.067    , 7882.951 ,   0.696 , -2619.427,  136.191, 193.971200000  ,  145.000  },
	{112  , 82 , 194, "Pb","     ",  -24207.600   ,  17.466    , 7865.416 ,   0.090 , -8217.537,   52.192, 193.974012070  ,   18.750  },
	{111  , 83 , 194, "Bi","    x",  -15990.063   ,  49.183    , 7819.025 ,   0.254 , -4985.027,   50.764, 193.982833960  ,   52.800  },
	{110  , 84 , 194, "Po","   -a",  -11005.037   ,  12.569    , 7789.296 ,   0.065 , -9817.461,  186.055, 193.988185606  ,   13.493  },
	{109  , 85 , 194, "At","   -a",   -1187.575   , 185.630    , 7734.658 ,   0.957 , STAR     , STAR    , 193.998725085  ,  199.282  },
	{119  , 76 , 195, "Os","    +",  -29689.824   , 500.003    , 7918.658 ,   2.564 ,  2000.000,  500.000, 194.968126661  ,  536.775  },
	{118  , 77 , 195, "Ir","   -n",  -31689.824   ,   1.677    , 7924.902 ,   0.009 ,  1107.023,    1.729, 194.965979573  ,    1.800  },
	{117  , 78 , 195, "Pt","     ",  -32796.847   ,   0.877    , 7926.567 ,   0.005 ,  -226.824,    1.000, 194.964791134  ,    0.940  },
	{116  , 79 , 195, "Au","     ",  -32570.023   ,   1.329    , 7921.392 ,   0.007 , -1570.008,   23.165, 194.965034640  ,    1.427  },
	{115  , 80 , 195, "Hg","     ",  -31000.015   ,  23.145    , 7909.329 ,   0.119 , -2844.989,   26.903, 194.966720113  ,   24.847  },
	{114  , 81 , 195, "Tl","   +a",  -28155.026   ,  13.796    , 7890.727 ,   0.071 , -4441.098,   27.136, 194.969774335  ,   14.810  },
	{113  , 82 , 195, "Pb","    x",  -23713.927   ,  23.367    , 7863.940 ,   0.120 , -5690.205,   24.026, 194.974542050  ,   25.085  },
	{112  , 83 , 195, "Bi","    x",  -18023.722   ,   5.589    , 7830.748 ,   0.029 , -6948.938,   39.675, 194.980650737  ,    6.000  },
	{111  , 84 , 195, "Po","   -a",  -11074.785   ,  39.279    , 7791.100 ,   0.201 , -7598.541,   40.309, 194.988110728  ,   42.167  },
	{110  , 85 , 195, "At","   -a",   -3476.244   ,   9.056    , 7748.121 ,   0.046 , -8541.426,   51.991, 194.996268098  ,    9.721  },
	{109  , 86 , 195, "Rn","   -a",    5065.181   ,  51.197    , 7700.307 ,   0.263 , STAR     , STAR    , 195.005437696  ,   54.961  },
	{120  , 76 , 196, "Os","  +pp",  -28280.779   ,  40.121    , 7912.248 ,   0.205 ,  1157.652,   55.538, 195.969639333  ,   43.071  },
	{119  , 77 , 196, "Ir","    +",  -29438.431   ,  38.421    , 7914.163 ,   0.196 ,  3209.016,   38.411, 195.968396542  ,   41.246  },
	{118  , 78 , 196, "Pt","     ",  -32647.448   ,   0.868    , 7926.544 ,   0.004 , -1507.429,    2.984, 195.964951521  ,    0.931  },
	{117  , 79 , 196, "Au","     ",  -31140.018   ,   2.972    , 7914.861 ,   0.015 ,   686.664,    3.120, 195.966569813  ,    3.191  },
	{116  , 80 , 196, "Hg","     ",  -31826.683   ,   2.942    , 7914.373 ,   0.015 , -4330.052,   12.462, 195.965832649  ,    3.158  },
	{115  , 81 , 196, "Tl","    x",  -27496.631   ,  12.109    , 7888.289 ,   0.062 , -2135.877,   18.722, 195.970481151  ,   13.000  },
	{114  , 82 , 196, "Pb","    x",  -25360.754   ,  14.279    , 7873.400 ,   0.073 , -7351.723,   28.295, 195.972774109  ,   15.328  },
	{113  , 83 , 196, "Bi","    x",  -18009.031   ,  24.428    , 7831.900 ,   0.125 , -4534.579,   27.661, 195.980666509  ,   26.224  },
	{112  , 84 , 196, "Po","   -a",  -13474.451   ,  12.978    , 7804.773 ,   0.066 , -9551.071,   61.293, 195.985534580  ,   13.932  },
	{111  , 85 , 196, "At","   -a",   -3923.380   ,  59.903    , 7752.051 ,   0.306 , -5893.698,   61.763, 195.995788077  ,   64.308  },
	{110  , 86 , 196, "Rn","   -a",    1970.318   ,  15.042    , 7717.990 ,   0.077 , STAR     , STAR    , 196.002115223  ,   16.148  },
	{120  , 77 , 197, "Ir","   +p",  -28267.783   ,  20.241    , 7909.018 ,   0.103 ,  2154.642,   20.224, 196.969653285  ,   21.729  },
	{119  , 78 , 197, "Pt","     ",  -30422.425   ,   0.830    , 7915.984 ,   0.004 ,   718.666,    0.589, 196.967340182  ,    0.891  },
	{118  , 79 , 197, "Au","     ",  -31141.091   ,   0.602    , 7915.661 ,   0.003 ,  -600.112,    3.205, 196.966568662  ,    0.646  },
	{117  , 80 , 197, "Hg","     ",  -30540.979   ,   3.203    , 7908.643 ,   0.016 , -2199.819,   16.615, 196.967212908  ,    3.438  },
	{116  , 81 , 197, "Tl","   +a",  -28341.160   ,  16.304    , 7893.505 ,   0.083 , -3592.411,   17.236, 196.969574511  ,   17.503  },
	{115  , 82 , 197, "Pb","   IT",  -24748.749   ,   5.590    , 7871.298 ,   0.028 , -5061.115,   10.123, 196.973431124  ,    6.001  },
	{114  , 83 , 197, "Bi","   +a",  -19687.634   ,   8.439    , 7841.636 ,   0.043 , -6329.665,   50.456, 196.978864454  ,    9.060  },
	{113  , 84 , 197, "Po","   -a",  -13357.968   ,  49.745    , 7805.535 ,   0.253 , -7013.763,   71.184, 196.985659630  ,   53.403  },
	{112  , 85 , 197, "At","   -a",   -6344.205   ,  50.917    , 7765.960 ,   0.258 , -7820.019,   79.346, 196.993189215  ,   54.661  },
	{111  , 86 , 197, "Rn","   -a",    1475.814   ,  60.854    , 7722.294 ,   0.309 , STAR     , STAR    , 197.001584351  ,   65.329  },
	{121  , 77 , 198, "Ir","    x",  -25821.      , 196.       , 7897.    ,   1.    ,  4087.   ,  196.   , 197.972280     ,  210.     },
	{120  , 78 , 198, "Pt","   -n",  -29907.673   ,   3.113    , 7914.169 ,   0.016 ,  -325.569,    3.059, 197.967892790  ,    3.341  },
	{119  , 79 , 198, "Au","     ",  -29582.104   ,   0.596    , 7908.573 ,   0.003 ,  1372.343,    0.520, 197.968242303  ,    0.639  },
	{118  , 80 , 198, "Hg","     ",  -30954.447   ,   0.337    , 7911.553 ,   0.002 , -3460.000,   80.000, 197.966769032  ,    0.362  },
	{117  , 81 , 198, "Tl","    -",  -27494.447   ,  80.001    , 7890.127 ,   0.404 , -1444.248,   81.318, 197.970483495  ,   85.884  },
	{116  , 82 , 198, "Pb","    x",  -26050.199   ,  14.578    , 7878.882 ,   0.074 , -6680.712,   31.519, 197.972033959  ,   15.650  },
	{115  , 83 , 198, "Bi","    x",  -19369.486   ,  27.945    , 7841.189 ,   0.141 , -3896.082,   32.941, 197.979206000  ,   30.000  },
	{114  , 84 , 198, "Po","     ",  -15473.405   ,  17.440    , 7817.561 ,   0.088 , -8801.302,   52.232, 197.983388616  ,   18.723  },
	{113  , 85 , 198, "At","   -a",   -6672.103   ,  49.234    , 7769.159 ,   0.249 , -5441.286,   50.944, 197.992837202  ,   52.854  },
	{112  , 86 , 198, "Rn","   -a",   -1230.817   ,  13.091    , 7737.726 ,   0.066 , STAR     , STAR    , 197.998678663  ,   14.053  },
	{122  , 77 , 199, "Ir"," p-2n",  -24400.873   ,  41.118    , 7891.218 ,   0.207 ,  2991.483,   41.003, 198.973804583  ,   44.141  },
	{121  , 78 , 199, "Pt","   -n",  -27392.356   ,   3.153    , 7902.319 ,   0.016 ,  1702.679,    3.103, 198.970593094  ,    3.384  },
	{120  , 79 , 199, "Au","     ",  -29095.035   ,   0.604    , 7906.943 ,   0.003 ,   452.018,    0.577, 198.968765193  ,    0.648  },
	{119  , 80 , 199, "Hg","     ",  -29547.053   ,   0.365    , 7905.284 ,   0.002 , -1487.659,   27.947, 198.968279932  ,    0.392  },
	{118  , 81 , 199, "Tl","    x",  -28059.394   ,  27.945    , 7893.876 ,   0.140 , -2831.416,   38.459, 198.969877000  ,   30.000  },
	{117  , 82 , 199, "Pb","   +a",  -25227.978   ,  26.423    , 7875.717 ,   0.133 , -4429.544,   28.958, 198.972916650  ,   28.366  },
	{116  , 83 , 199, "Bi","   +a",  -20798.434   ,  11.847    , 7849.526 ,   0.060 , -5583.470,   26.278, 198.977671961  ,   12.717  },
	{115  , 84 , 199, "Po","   -a",  -15214.964   ,  23.456    , 7817.537 ,   0.118 , -6395.816,   55.510, 198.983666063  ,   25.180  },
	{114  , 85 , 199, "At","   -a",   -8819.148   ,  50.311    , 7781.466 ,   0.253 , -7301.090,   81.081, 198.990532254  ,   54.011  },
	{113  , 86 , 199, "Rn","   -a",   -1518.058   ,  63.583    , 7740.846 ,   0.320 , -8278.979,   76.100, 198.998370297  ,   68.259  },
	{112  , 87 , 199, "Fr","   -a",    6760.921   ,  41.814    , 7695.312 ,   0.210 , STAR     , STAR    , 199.007258147  ,   44.889  },
	{122  , 78 , 200, "Pt","  -nn",  -26602.838   ,  20.241    , 7899.216 ,   0.101 ,   666.046,   53.707, 199.971440677  ,   21.729  },
	{121  , 79 , 200, "Au","    +",  -27268.884   ,  49.748    , 7898.635 ,   0.249 ,  2235.253,   49.747, 199.970725647  ,   53.406  },
	{120  , 80 , 200, "Hg","     ",  -29504.137   ,   0.379    , 7905.899 ,   0.002 , -2456.040,    5.735, 199.968326004  ,    0.406  },
	{119  , 81 , 200, "Tl","    -",  -27048.096   ,   5.747    , 7889.707 ,   0.029 ,  -804.813,   12.349, 199.970962672  ,    6.169  },
	{118  , 82 , 200, "Pb","   4n",  -26243.283   ,  10.938    , 7881.771 ,   0.055 , -5873.213,   26.399, 199.971826675  ,   11.742  },
	{117  , 83 , 200, "Bi","   +a",  -20370.070   ,  24.027    , 7848.494 ,   0.120 , -3415.579,   28.020, 199.978131829  ,   25.794  },
	{116  , 84 , 200, "Po","   -a",  -16954.491   ,  14.417    , 7827.504 ,   0.072 , -7966.751,   28.399, 199.981798604  ,   15.477  },
	{115  , 85 , 200, "At","   -a",   -8987.739   ,  24.468    , 7783.758 ,   0.122 , -4981.664,   27.814, 199.990351264  ,   26.267  },
	{114  , 86 , 200, "Rn","   -a",   -4006.076   ,  13.226    , 7754.938 ,   0.066 ,-10128.311,   79.141, 199.995699300  ,   14.198  },
	{113  , 87 , 200, "Fr","   -a",    6122.235   ,  78.028    , 7700.385 ,   0.390 , STAR     , STAR    , 200.006572490  ,   83.766  },
	{123  , 78 , 201, "Pt","    +",  -23741.111   ,  50.102    , 7885.835 ,   0.249 ,  2660.000,   50.000, 200.974512868  ,   53.786  },
	{122  , 79 , 201, "Au","     ",  -26401.111   ,   3.193    , 7895.176 ,   0.016 ,  1262.148,    3.146, 200.971657240  ,    3.428  },
	{121  , 80 , 201, "Hg","     ",  -27663.259   ,   0.595    , 7897.564 ,   0.003 ,  -481.231,   15.047, 200.970302268  ,    0.638  },
	{120  , 81 , 201, "Tl","  +nn",  -27182.028   ,  15.054    , 7891.277 ,   0.075 , -1924.113,   26.951, 200.970818891  ,   16.160  },
	{119  , 82 , 201, "Pb","   +a",  -25257.915   ,  22.355    , 7877.812 ,   0.111 , -3841.971,   27.010, 200.972884511  ,   23.998  },
	{118  , 83 , 201, "Bi","   +a",  -21415.944   ,  15.160    , 7854.806 ,   0.075 , -4891.021,   16.249, 200.977009036  ,   16.275  },
	{117  , 84 , 201, "Po","   -a",  -16524.923   ,   5.848    , 7826.580 ,   0.029 , -5735.427,   10.140, 200.982259764  ,    6.278  },
	{116  , 85 , 201, "At","   +a",  -10789.496   ,   8.284    , 7794.153 ,   0.041 , -6717.316,   71.015, 200.988416999  ,    8.893  },
	{115  , 86 , 201, "Rn","   -a",   -4072.179   ,  70.531    , 7756.841 ,   0.351 , -7668.554,  100.335, 200.995628335  ,   75.717  },
	{114  , 87 , 201, "Fr","   -a",    3596.375   ,  71.362    , 7714.797 ,   0.355 , STAR     , STAR    , 201.003860867  ,   76.610  },
	{124  , 78 , 202, "Pt","    x",  -22598.      , 298.       , 7881.    ,   1.    ,  1802.   ,  341.   , 201.975740     ,  320.     },
	{123  , 79 , 202, "Au","    +",  -24399.705   , 166.411    , 7886.140 ,   0.824 ,  2946.154,  166.410, 201.973805838  ,  178.649  },
	{122  , 80 , 202, "Hg","     ",  -27345.859   ,   0.591    , 7896.852 ,   0.003 , -1362.587,   14.749, 201.970643011  ,    0.634  },
	{121  , 81 , 202, "Tl","     ",  -25983.272   ,  14.755    , 7886.234 ,   0.073 ,   -49.672,   14.716, 201.972105808  ,   15.839  },
	{120  , 82 , 202, "Pb","     ",  -25933.600   ,   8.178    , 7882.115 ,   0.040 , -5200.709,   21.966, 201.972159133  ,    8.779  },
	{119  , 83 , 202, "Bi","    x",  -20732.892   ,  20.387    , 7852.496 ,   0.101 , -2808.656,   25.120, 201.977742324  ,   21.886  },
	{118  , 84 , 202, "Po","   -a",  -17924.235   ,  14.677    , 7834.719 ,   0.073 , -7333.369,   31.594, 201.980757541  ,   15.756  },
	{117  , 85 , 202, "At","   -a",  -10590.867   ,  27.978    , 7794.542 ,   0.139 , -4315.850,   33.023, 201.988630236  ,   30.036  },
	{116  , 86 , 202, "Rn","   -a",   -6275.017   ,  17.543    , 7769.303 ,   0.087 , -9416.804,   52.508, 201.993263492  ,   18.832  },
	{115  , 87 , 202, "Fr","   -a",    3141.787   ,  49.491    , 7718.812 ,   0.245 , -6071.328,   79.799, 202.003372847  ,   53.130  },
	{114  , 88 , 202, "Ra","   -a",    9213.115   ,  62.598    , 7684.883 ,   0.310 , STAR     , STAR    , 202.009890686  ,   67.201  },
	{124  , 79 , 203, "Au","     ",  -23143.394   ,   3.058    , 7880.864 ,   0.015 ,  2125.724,    3.474, 202.975154542  ,    3.283  },
	{123  , 80 , 203, "Hg","     ",  -25269.119   ,   1.689    , 7887.482 ,   0.008 ,   492.074,    1.226, 202.972872484  ,    1.812  },
	{122  , 81 , 203, "Tl","     ",  -25761.192   ,   1.272    , 7886.052 ,   0.006 ,  -974.622,    6.418, 202.972344220  ,    1.365  },
	{121  , 82 , 203, "Pb","     ",  -24786.570   ,   6.528    , 7877.397 ,   0.032 , -3246.704,   22.220, 202.973390521  ,    7.007  },
	{120  , 83 , 203, "Bi","     ",  -21539.866   ,  21.633    , 7857.549 ,   0.107 , -4232.803,   33.782, 202.976876001  ,   23.224  },
	{119  , 84 , 203, "Po","    x",  -17307.062   ,  25.946    , 7832.844 ,   0.128 , -5143.599,   28.510, 202.981420103  ,   27.854  },
	{118  , 85 , 203, "At","     ",  -12163.464   ,  11.817    , 7803.652 ,   0.058 , -6003.202,   26.363, 202.986941984  ,   12.685  },
	{117  , 86 , 203, "Rn","   -a",   -6160.261   ,  23.567    , 7770.226 ,   0.116 , -7021.565,   28.393, 202.993386687  ,   25.299  },
	{116  , 87 , 203, "Fr","    x",     861.303   ,  15.835    , 7731.783 ,   0.078 , -7775.154,   82.423, 203.000924647  ,   17.000  },
	{115  , 88 , 203, "Ra","   -a",    8636.458   ,  80.888    , 7689.628 ,   0.398 , STAR     , STAR    , 203.009271619  ,   86.836  },
	{125  , 79 , 204, "Au","    +",  -20750.      , 200.       , 7870.    ,   1.    ,  3940.   ,  200.   , 203.977724     ,  215.     },
	{124  , 80 , 204, "Hg","     ",  -24690.242   ,   0.339    , 7885.545 ,   0.002 ,  -344.270,    1.270, 203.973493933  ,    0.364  },
	{123  , 81 , 204, "Tl","     ",  -24345.972   ,   1.251    , 7880.022 ,   0.006 ,   763.762,    0.177, 203.973863522  ,    1.343  },
	{122  , 82 , 204, "Pb","     ",  -25109.735   ,   1.244    , 7879.931 ,   0.006 , -4442.431,   25.960, 203.973043589  ,    1.335  },
	{121  , 83 , 204, "Bi","   +a",  -20667.303   ,  25.953    , 7854.320 ,   0.127 , -2333.752,   28.176, 203.977812736  ,   27.861  },
	{120  , 84 , 204, "Po","   -a",  -18333.551   ,  11.023    , 7839.045 ,   0.054 , -6458.239,   26.390, 203.980318121  ,   11.833  },
	{119  , 85 , 204, "At","     ",  -11875.313   ,  23.979    , 7803.552 ,   0.118 , -3891.235,   28.042, 203.987251326  ,   25.742  },
	{118  , 86 , 204, "Rn","   -a",   -7984.077   ,  14.540    , 7780.642 ,   0.071 , -8592.534,   28.569, 203.991428740  ,   15.609  },
	{117  , 87 , 204, "Fr","   -a",     608.456   ,  24.593    , 7734.687 ,   0.121 , -5445.946,   29.002, 204.000653204  ,   26.401  },
	{116  , 88 , 204, "Ra","   -a",    6054.402   ,  15.373    , 7704.156 ,   0.075 , STAR     , STAR    , 204.006499668  ,   16.503  },
	{126  , 79 , 205, "Au","    x",  -18751.      , 298.       , 7861.    ,   1.    ,  3537.   ,  298.   , 204.979870     ,  320.     },
	{125  , 80 , 205, "Hg","     ",  -22287.497   ,   3.644    , 7874.731 ,   0.018 ,  1533.095,    3.721, 204.976073386  ,    3.912  },
	{124  , 81 , 205, "Tl","     ",  -23820.592   ,   1.325    , 7878.393 ,   0.006 ,   -50.500,    0.488, 204.974427541  ,    1.422  },
	{123  , 82 , 205, "Pb","     ",  -23770.091   ,   1.241    , 7874.330 ,   0.006 , -2708.421,    7.071, 204.974481755  ,    1.332  },
	{122  , 83 , 205, "Bi","     ",  -21061.670   ,   7.179    , 7857.302 ,   0.035 , -3552.677,   21.148, 204.977389366  ,    7.706  },
	{121  , 84 , 205, "Po","    x",  -17508.993   ,  19.892    , 7836.156 ,   0.097 , -4537.457,   24.951, 204.981203322  ,   21.355  },
	{120  , 85 , 205, "At","   +a",  -12971.536   ,  15.062    , 7810.205 ,   0.073 , -5257.647,   52.546, 204.986074483  ,   16.170  },
	{119  , 86 , 205, "Rn","   -a",   -7713.889   ,  50.341    , 7780.742 ,   0.246 , -6404.172,   50.945, 204.991718799  ,   54.043  },
	{118  , 87 , 205, "Fr","    x",   -1309.717   ,   7.824    , 7745.686 ,   0.038 , -7148.854,   86.809, 204.998593960  ,    8.399  },
	{117  , 88 , 205, "Ra","   -a",    5839.136   ,  86.456    , 7706.997 ,   0.422 , STAR     , STAR    , 205.006268570  ,   92.813  },
	{126  , 80 , 206, "Hg","   +a",  -20945.512   ,  20.446    , 7869.170 ,   0.099 ,  1307.582,   20.409, 205.977514066  ,   21.949  },
	{125  , 81 , 206, "Tl","     ",  -22253.094   ,   1.370    , 7871.720 ,   0.007 ,  1532.346,    0.600, 205.976110320  ,    1.470  },
	{124  , 82 , 206, "Pb","     ",  -23785.440   ,   1.240    , 7875.361 ,   0.006 , -3757.508,    7.682, 205.974465278  ,    1.331  },
	{123  , 83 , 206, "Bi","    -",  -20027.931   ,   7.782    , 7853.323 ,   0.038 , -1846.193,   11.263, 205.978499130  ,    8.353  },
	{122  , 84 , 206, "Po","   -a",  -18181.739   ,   8.281    , 7840.563 ,   0.040 , -5762.163,   22.083, 205.980481099  ,    8.889  },
	{121  , 85 , 206, "At","   -a",  -12419.576   ,  20.471    , 7808.793 ,   0.099 , -3304.073,   25.243, 205.986667036  ,   21.976  },
	{120  , 86 , 206, "Rn","   -a",   -9115.503   ,  14.769    , 7788.956 ,   0.072 , -7872.952,   31.830, 205.990214104  ,   15.855  },
	{119  , 87 , 206, "Fr","   -a",   -1242.551   ,  28.196    , 7746.940 ,   0.137 , -4807.630,   33.468, 205.998666066  ,   30.270  },
	{118  , 88 , 206, "Ra","   -a",    3565.079   ,  18.030    , 7719.805 ,   0.088 , -9946.224,   72.625, 206.003827270  ,   19.355  },
	{117  , 89 , 206, "Ac","   -a",   13511.303   ,  70.352    , 7667.724 ,   0.342 , STAR     , STAR    , 206.014504980  ,   75.525  },
	{127  , 80 , 207, "Hg","    +",  -16218.666   , 150.101    , 7847.312 ,   0.725 ,  4815.000,  150.000, 206.982588545  ,  161.139  },
	{126  , 81 , 207, "Tl","     ",  -21033.666   ,   5.497    , 7866.793 ,   0.027 ,  1418.239,    5.428, 206.977419429  ,    5.901  },
	{125  , 82 , 207, "Pb","     ",  -22451.905   ,   1.243    , 7869.865 ,   0.006 , -2397.471,    2.116, 206.975896887  ,    1.334  },
	{124  , 83 , 207, "Bi","     ",  -20054.433   ,   2.445    , 7854.504 ,   0.012 , -2908.585,    6.580, 206.978470679  ,    2.624  },
	{123  , 84 , 207, "Po","     ",  -17145.849   ,   6.638    , 7836.673 ,   0.032 , -3903.266,   22.145, 206.981593173  ,    7.126  },
	{122  , 85 , 207, "At","     ",  -13242.582   ,  21.495    , 7814.037 ,   0.104 , -4611.569,   33.734, 206.985783502  ,   23.076  },
	{121  , 86 , 207, "Rn","   -a",   -8631.014   ,  25.998    , 7787.980 ,   0.126 , -5789.412,   56.983, 206.990734225  ,   27.910  },
	{120  , 87 , 207, "Fr","     ",   -2841.602   ,  50.707    , 7756.232 ,   0.245 , -6379.514,   75.010, 206.996949414  ,   54.435  },
	{119  , 88 , 207, "Ra","   -a",    3537.912   ,  55.276    , 7721.634 ,   0.267 , -7593.207,   76.198, 207.003798105  ,   59.340  },
	{118  , 89 , 207, "Ac","   -a",   11131.119   ,  52.448    , 7681.172 ,   0.253 , STAR     , STAR    , 207.011949748  ,   56.304  },
	{128  , 80 , 208, "Hg","    x",  -13097.      , 298.       , 7833.    ,   1.    ,  3653.   ,  298.   , 207.985940     ,  320.     },
	{127  , 81 , 208, "Tl","   +a",  -16749.473   ,   1.990    , 7847.180 ,   0.010 ,  4998.983,    1.722, 207.982018700  ,    2.136  },
	{126  , 82 , 208, "Pb","     ",  -21748.455   ,   1.244    , 7867.452 ,   0.006 , -2878.433,    2.012, 207.976652071  ,    1.335  },
	{125  , 83 , 208, "Bi","   +n",  -18870.022   ,   2.355    , 7849.852 ,   0.011 , -1400.506,    2.396, 207.979742196  ,    2.527  },
	{124  , 84 , 208, "Po","   -a",  -17469.516   ,   1.802    , 7839.357 ,   0.009 , -4978.160,   25.902, 207.981245702  ,    1.934  },
	{123  , 85 , 208, "At","   +a",  -12491.356   ,  25.863    , 7811.663 ,   0.124 , -2843.380,   28.142, 207.986589977  ,   27.764  },
	{122  , 86 , 208, "Rn","   -a",   -9647.976   ,  11.149    , 7794.231 ,   0.054 , -6982.770,   47.848, 207.989642470  ,   11.968  },
	{121  , 87 , 208, "Fr","     ",   -2665.206   ,  46.535    , 7756.899 ,   0.224 , -4379.100,   49.016, 207.997138783  ,   49.957  },
	{120  , 88 , 208, "Ra","   -a",    1713.894   ,  15.408    , 7732.084 ,   0.074 , -9046.307,   57.812, 208.001839940  ,   16.541  },
	{119  , 89 , 208, "Ac","   -a",   10760.201   ,  55.721    , 7684.831 ,   0.268 , STAR     , STAR    , 208.011551551  ,   59.818  },
	{129  , 80 , 209, "Hg","    x",   -8346.      , 196.       , 7812.    ,   1.    ,  5292.   ,  196.   , 208.991040     ,  210.     },
	{128  , 81 , 209, "Tl","   +a",  -13638.048   ,   7.901    , 7833.365 ,   0.038 ,  3976.391,    7.955, 208.985358952  ,    8.481  },
	{127  , 82 , 209, "Pb","     ",  -17614.440   ,   1.813    , 7848.647 ,   0.009 ,   644.022,    1.146, 208.981090120  ,    1.946  },
	{126  , 83 , 209, "Bi","     ",  -18258.461   ,   1.448    , 7847.985 ,   0.007 , -1892.517,    1.562, 208.980398734  ,    1.554  },
	{125  , 84 , 209, "Po","   -a",  -16365.944   ,   1.842    , 7835.187 ,   0.009 , -3486.311,    7.484, 208.982430435  ,    1.977  },
	{124  , 85 , 209, "At","     ",  -12879.634   ,   7.463    , 7814.763 ,   0.036 , -3951.024,   21.336, 208.986173143  ,    8.011  },
	{123  , 86 , 209, "Rn","   -a",   -8928.610   ,  19.988    , 7792.115 ,   0.096 , -5159.371,   24.767, 208.990414742  ,   21.458  },
	{122  , 87 , 209, "Fr","     ",   -3769.239   ,  14.625    , 7763.686 ,   0.070 , -5624.191,   52.544, 208.995953555  ,   15.700  },
	{121  , 88 , 209, "Ra","   -a",    1854.952   ,  50.467    , 7733.033 ,   0.241 , -6989.457,   71.471, 209.001991373  ,   54.178  },
	{120  , 89 , 209, "Ac","   -a",    8844.409   ,  50.608    , 7695.847 ,   0.242 , -7657.643,  111.963, 209.009494863  ,   54.330  },
	{119  , 90 , 209, "Th","   -a",   16502.052   ,  99.873    , 7655.464 ,   0.478 , STAR     , STAR    , 209.017715682  ,  107.217  },
	{130  , 80 , 210, "Hg","    x",   -5114.      , 298.       , 7798.    ,   1.    ,  4132.   ,  298.   , 209.994510     ,  320.     },
	{129  , 81 , 210, "Tl","   +a",   -9246.298   ,  11.638    , 7813.585 ,   0.055 ,  5481.994,   11.581, 209.990073689  ,   12.493  },
	{128  , 82 , 210, "Pb","     ",  -14728.292   ,   1.527    , 7835.964 ,   0.007 ,    63.486,    0.499, 209.984188527  ,    1.639  },
	{127  , 83 , 210, "Bi","     ",  -14791.778   ,   1.446    , 7832.541 ,   0.007 ,  1161.292,    0.764, 209.984120371  ,    1.552  },
	{126  , 84 , 210, "Po","     ",  -15953.071   ,   1.242    , 7834.345 ,   0.006 , -3981.240,    7.745, 209.982873673  ,    1.333  },
	{125  , 85 , 210, "At","   -a",  -11971.830   ,   7.843    , 7811.662 ,   0.037 , -2373.918,   11.510, 209.987147710  ,    8.420  },
	{124  , 86 , 210, "Rn","   -a",   -9597.913   ,   8.558    , 7796.632 ,   0.041 , -6251.743,   23.804, 209.989696216  ,    9.187  },
	{123  , 87 , 210, "Fr","     ",   -3346.170   ,  22.232    , 7763.136 ,   0.106 , -3807.239,   26.906, 209.996407738  ,   23.866  },
	{122  , 88 , 210, "Ra","   -a",     461.069   ,  15.195    , 7741.281 ,   0.072 , -8328.495,   59.379, 210.000494978  ,   16.311  },
	{121  , 89 , 210, "Ac","   -a",    8789.565   ,  57.402    , 7697.896 ,   0.273 , -5253.027,   62.614, 210.009435986  ,   61.624  },
	{120  , 90 , 210, "Th","   -a",   14042.591   ,  25.008    , 7669.156 ,   0.119 , STAR     , STAR    , 210.015075342  ,   26.847  },
	{130  , 81 , 211, "Tl","   +a",   -6076.      , 201.       , 7800.    ,   1.    ,  4415.   ,  201.   , 210.993477     ,  215.     },
	{129  , 82 , 211, "Pb","     ",  -10491.450   ,   2.661    , 7817.000 ,   0.013 ,  1366.971,    5.513, 210.988736964  ,    2.856  },
	{128  , 83 , 211, "Bi","     ",  -11858.421   ,   5.500    , 7819.770 ,   0.026 ,   574.086,    5.455, 210.987269460  ,    5.904  },
	{127  , 84 , 211, "Po","   -a",  -12432.507   ,   1.343    , 7818.783 ,   0.006 ,  -785.358,    2.537, 210.986653154  ,    1.442  },
	{126  , 85 , 211, "At","   -a",  -11647.148   ,   2.771    , 7811.354 ,   0.013 , -2891.592,    6.861, 210.987496271  ,    2.974  },
	{125  , 86 , 211, "Rn","   -a",   -8755.556   ,   6.793    , 7793.941 ,   0.032 , -4597.874,   21.825, 210.990600523  ,    7.292  },
	{124  , 87 , 211, "Fr","     ",   -4157.682   ,  21.101    , 7768.443 ,   0.100 , -4994.152,   33.674, 210.995536544  ,   22.652  },
	{123  , 88 , 211, "Ra","   -a",     836.470   ,  26.242    , 7741.066 ,   0.124 , -6368.483,   75.894, 211.000897987  ,   28.172  },
	{122  , 89 , 211, "Ac","   -a",    7204.953   ,  71.212    , 7707.176 ,   0.337 , -6700.775,  103.085, 211.007734835  ,   76.449  },
	{121  , 90 , 211, "Th","   -a",   13905.728   ,  74.534    , 7671.711 ,   0.353 , STAR     , STAR    , 211.014928413  ,   80.016  },
	{131  , 81 , 212, "Tl","   +a",   -1651.      , 300.       , 7780.    ,   1.    ,  5896.   ,  300.   , 211.998228     ,  322.     },
	{130  , 82 , 212, "Pb","     ",   -7547.389   ,   2.209    , 7804.312 ,   0.010 ,   569.906,    1.912, 211.991897543  ,    2.371  },
	{129  , 83 , 212, "Bi","     ",   -8117.295   ,   1.990    , 7803.310 ,   0.009 ,  2252.125,    1.720, 211.991285724  ,    2.136  },
	{128  , 84 , 212, "Po","     ",  -10369.420   ,   1.248    , 7810.243 ,   0.006 , -1748.230,    7.110, 211.988867969  ,    1.340  },
	{127  , 85 , 212, "At","   -a",   -8621.190   ,   7.214    , 7798.306 ,   0.034 ,    38.416,    7.688, 211.990744771  ,    7.744  },
	{126  , 86 , 212, "Rn","   -a",   -8659.606   ,   3.182    , 7794.797 ,   0.015 , -5122.020,   25.976, 211.990703529  ,    3.415  },
	{125  , 87 , 212, "Fr","     ",   -3537.587   ,  25.803    , 7766.946 ,   0.122 , -3346.165,   28.137, 211.996202244  ,   27.700  },
	{124  , 88 , 212, "Ra","   -a",    -191.422   ,  11.273    , 7747.472 ,   0.053 , -7469.951,   69.226, 211.999794499  ,   12.102  },
	{123  , 89 , 212, "Ac","   -a",    7278.529   ,  68.305    , 7708.546 ,   0.322 , -4812.532,   70.756, 212.007813822  ,   73.328  },
	{122  , 90 , 212, "Th","   -a",   12091.061   ,  18.474    , 7682.156 ,   0.087 , -9523.456,   77.111, 212.012980288  ,   19.833  },
	{121  , 91 , 212, "Pa","   -a",   21614.516   ,  74.865    , 7633.543 ,   0.353 , STAR     , STAR    , 212.023204138  ,   80.371  },
	{131  , 82 , 213, "Pb","   +a",   -3184.313   ,   7.796    , 7785.082 ,   0.037 ,  2046.336,    8.864, 212.996581499  ,    8.368  },
	{130  , 83 , 213, "Bi","     ",   -5230.649   ,   5.003    , 7791.016 ,   0.023 ,  1422.751,    5.394, 212.994384666  ,    5.370  },
	{129  , 84 , 213, "Po","     ",   -6653.400   ,   3.092    , 7794.023 ,   0.015 ,   -73.929,    5.464, 212.992857280  ,    3.319  },
	{128  , 85 , 213, "At","   -a",   -6579.472   ,   4.922    , 7790.003 ,   0.023 ,  -881.214,    7.308, 212.992936646  ,    5.283  },
	{127  , 86 , 213, "Rn","   -a",   -5698.258   ,   5.678    , 7782.192 ,   0.027 , -2148.410,    9.381, 212.993882668  ,    6.095  },
	{126  , 87 , 213, "Fr","     ",   -3549.848   ,   7.671    , 7768.433 ,   0.036 , -3907.504,   21.700, 212.996189081  ,    8.234  },
	{125  , 88 , 213, "Ra","   -a",     357.656   ,  20.299    , 7746.415 ,   0.095 , -5797.324,   55.910, 213.000383959  ,   21.791  },
	{124  , 89 , 213, "Ac","   -a",    6154.980   ,  52.095    , 7715.524 ,   0.245 , -5963.888,   88.096, 213.006607643  ,   55.926  },
	{123  , 90 , 213, "Th","   -a",   12118.868   ,  71.042    , 7683.852 ,   0.334 , -7544.357,  100.539, 213.013010140  ,   76.266  },
	{122  , 91 , 213, "Pa","   -a",   19663.224   ,  71.142    , 7644.760 ,   0.334 , STAR     , STAR    , 213.021109340  ,   76.374  },
	{132  , 82 , 214, "Pb","     ",    -181.261   ,   2.381    , 7772.386 ,   0.011 ,  1018.932,   11.283, 213.999805408  ,    2.555  },
	{131  , 83 , 214, "Bi","     ",   -1200.193   ,  11.229    , 7773.492 ,   0.052 ,  3269.720,   11.170, 213.998711539  ,   12.054  },
	{130  , 84 , 214, "Po","     ",   -4469.913   ,   1.528    , 7785.115 ,   0.007 , -1090.205,    4.107, 213.995201350  ,    1.640  },
	{129  , 85 , 214, "At","   -a",   -3379.708   ,   4.325    , 7776.365 ,   0.020 ,   940.044,   10.014, 213.996371733  ,    4.643  },
	{128  , 86 , 214, "Rn","   -a",   -4319.753   ,   9.199    , 7777.102 ,   0.043 , -3361.381,   12.585, 213.995362554  ,    9.875  },
	{127  , 87 , 214, "Fr","   -a",    -958.372   ,   8.766    , 7757.739 ,   0.041 , -1058.875,   12.621, 213.998971145  ,    9.410  },
	{126  , 88 , 214, "Ra","   -a",     100.503   ,   9.205    , 7749.135 ,   0.043 , -6328.481,   24.283, 214.000107894  ,    9.882  },
	{125  , 89 , 214, "Ac","   -a",    6428.984   ,  22.490    , 7715.907 ,   0.105 , -4282.983,   28.061, 214.006901798  ,   24.143  },
	{124  , 90 , 214, "Th","   -a",   10711.967   ,  16.817    , 7692.237 ,   0.079 , -8773.413,   77.961, 214.011499770  ,   18.053  },
	{123  , 91 , 214, "Pa","   -a",   19485.380   ,  76.125    , 7647.584 ,   0.356 , STAR     , STAR    , 214.020918417  ,   81.723  },
	{133  , 82 , 215, "Pb","   +a",    4477.      , 411.       , 7752.    ,   2.    ,  2829.   ,  411.   , 215.004807     ,  441.     },
	{132  , 83 , 215, "Bi","    x",    1648.537   ,  14.904    , 7761.627 ,   0.069 ,  2188.814,   15.120, 215.001769776  ,   16.000  },
	{131  , 84 , 215, "Po","     ",    -540.277   ,   2.547    , 7768.169 ,   0.012 ,   714.845,    6.854, 214.999419988  ,    2.734  },
	{130  , 85 , 215, "At","   -a",   -1255.123   ,   6.846    , 7767.855 ,   0.032 ,   -86.548,   10.182, 214.998652570  ,    7.349  },
	{129  , 86 , 215, "Rn","   -a",   -1168.574   ,   7.687    , 7763.814 ,   0.036 , -1486.677,   10.306, 214.998745483  ,    8.252  },
	{128  , 87 , 215, "Fr","   -a",     318.103   ,   7.082    , 7753.260 ,   0.033 , -2215.407,   10.054, 215.000341497  ,    7.602  },
	{127  , 88 , 215, "Ra","   -a",    2533.509   ,   7.594    , 7739.317 ,   0.035 , -3478.005,   22.380, 215.002719834  ,    8.153  },
	{126  , 89 , 215, "Ac","   -a",    6011.514   ,  21.406    , 7719.501 ,   0.100 , -4915.219,   34.369, 215.006453625  ,   22.980  },
	{125  , 90 , 215, "Th","   -a",   10926.733   ,  26.889    , 7693.001 ,   0.125 , -6944.786,   91.072, 215.011730330  ,   28.866  },
	{124  , 91 , 215, "Pa","   -a",   17871.519   ,  87.012    , 7657.061 ,   0.405 , STAR     , STAR    , 215.019185865  ,   93.411  },
	{133  , 83 , 216, "Bi","    x",    5873.948   ,  11.178    , 7743.499 ,   0.052 ,  4090.104,   11.393, 216.006305943  ,   12.000  },
	{132  , 84 , 216, "Po","     ",    1783.844   ,   2.203    , 7758.813 ,   0.010 ,  -473.406,    3.621, 216.001915035  ,    2.365  },
	{131  , 85 , 216, "At","     ",    2257.250   ,   3.647    , 7752.999 ,   0.017 ,  2001.676,    8.013, 216.002423257  ,    3.915  },
	{130  , 86 , 216, "Rn","   -a",     255.574   ,   7.312    , 7758.644 ,   0.034 , -2723.335,   15.873, 216.000274370  ,    7.849  },
	{129  , 87 , 216, "Fr","   -a",    2978.909   ,  14.196    , 7742.414 ,   0.066 ,  -312.093,   16.584, 216.003197990  ,   15.240  },
	{128  , 88 , 216, "Ra","   -a",    3291.002   ,   8.750    , 7737.347 ,   0.041 , -4831.697,   27.959, 216.003533035  ,    9.393  },
	{127  , 89 , 216, "Ac","   -a",    8122.698   ,  26.577    , 7711.356 ,   0.123 , -2181.596,   29.532, 216.008720075  ,   28.531  },
	{126  , 90 , 216, "Th","   -a",   10304.294   ,  12.923    , 7697.634 ,   0.060 , -7496.150,   71.114, 216.011062115  ,   13.873  },
	{125  , 91 , 216, "Pa","   -a",   17800.445   ,  69.932    , 7659.308 ,   0.324 , STAR     , STAR    , 216.019109564  ,   75.075  },
	{134  , 83 , 217, "Bi","    x",    8821.      , 196.       , 7731.    ,   1.    ,  2920.   ,  196.   , 217.009470     ,  210.     },
	{133  , 84 , 217, "Po","   +a",    5900.825   ,   6.646    , 7741.281 ,   0.031 ,  1505.270,    7.812, 217.006334796  ,    7.134  },
	{132  , 85 , 217, "At","     ",    4395.555   ,   4.917    , 7744.612 ,   0.023 ,   736.949,    6.063, 217.004718822  ,    5.278  },
	{131  , 86 , 217, "Rn","   -a",    3658.607   ,   4.226    , 7744.403 ,   0.019 ,  -656.028,    7.538, 217.003927675  ,    4.537  },
	{130  , 87 , 217, "Fr","   -a",    4314.635   ,   6.548    , 7737.774 ,   0.030 , -1572.712,   10.610, 217.004631951  ,    7.030  },
	{129  , 88 , 217, "Ra","   -a",    5887.347   ,   8.529    , 7726.921 ,   0.039 , -2819.248,   15.241, 217.006320327  ,    9.156  },
	{128  , 89 , 217, "Ac","   -a",    8706.595   ,  12.753    , 7710.324 ,   0.059 , -3509.323,   24.389, 217.009346914  ,   13.690  },
	{127  , 90 , 217, "Th","   -a",   12215.918   ,  20.789    , 7690.547 ,   0.096 , -4852.765,   56.269, 217.013114328  ,   22.317  },
	{126  , 91 , 217, "Pa","   -a",   17068.683   ,  52.288    , 7664.579 ,   0.241 , -5630.700,  101.395, 217.018323986  ,   56.133  },
	{125  , 92 , 217, "U ","   -a",   22699.383   ,  86.873    , 7635.026 ,   0.400 , STAR     , STAR    , 217.024368791  ,   93.262  },
	{135  , 83 , 218, "Bi","   +a",   13335.      , 359.       , 7712.    ,   2.    ,  4977.   ,  359.   , 218.014316     ,  385.     },
	{134  , 84 , 218, "Po","     ",    8358.331   ,   2.379    , 7731.521 ,   0.011 ,   259.609,   11.674, 218.008973037  ,    2.554  },
	{133  , 85 , 218, "At","   -a",    8098.722   ,  11.623    , 7729.124 ,   0.053 ,  2881.185,   11.709, 218.008694336  ,   12.477  },
	{132  , 86 , 218, "Rn","     ",    5217.537   ,   2.373    , 7738.751 ,   0.011 , -1841.625,    4.943, 218.005601256  ,    2.547  },
	{131  , 87 , 218, "Fr","   -a",    7059.162   ,   4.781    , 7726.715 ,   0.022 ,   408.080,   12.039, 218.007578322  ,    5.132  },
	{130  , 88 , 218, "Ra","   -a",    6651.082   ,  11.186    , 7724.998 ,   0.051 , -4192.862,   51.951, 218.007140230  ,   12.008  },
	{129  , 89 , 218, "Ac","   -a",   10843.944   ,  50.763    , 7702.176 ,   0.233 , -1530.488,   52.367, 218.011641453  ,   54.495  },
	{128  , 90 , 218, "Th","   -a",   12374.432   ,  12.952    , 7691.567 ,   0.059 , -6294.468,   27.797, 218.013284499  ,   13.904  },
	{127  , 91 , 218, "Pa","   -a",   18668.900   ,  24.613    , 7659.104 ,   0.113 , -3254.437,   39.192, 218.020041889  ,   26.423  },
	{126  , 92 , 218, "U ","   -a",   21923.337   ,  30.519    , 7640.587 ,   0.140 , STAR     , STAR    , 218.023535671  ,   32.763  },
	{135  , 84 , 219, "Po","   +a",   12802.      , 359.       , 7713.    ,   2.    ,  2405.   ,  359.   , 219.013744     ,  385.     },
	{134  , 85 , 219, "At","   +a",   10397.048   ,   3.883    , 7720.191 ,   0.018 ,  1566.295,    3.177, 219.011161691  ,    4.168  },
	{133  , 86 , 219, "Rn","     ",    8830.754   ,   2.531    , 7723.771 ,   0.012 ,   212.432,    7.091, 219.009480204  ,    2.716  },
	{132  , 87 , 219, "Fr","   -a",    8618.322   ,   7.084    , 7721.169 ,   0.032 ,  -775.869,   10.785, 219.009252149  ,    7.605  },
	{131  , 88 , 219, "Ra","   -a",    9394.190   ,   8.272    , 7714.054 ,   0.038 , -2175.328,   51.142, 219.010085078  ,    8.880  },
	{130  , 89 , 219, "Ac","   -a",   11569.518   ,  50.499    , 7700.548 ,   0.231 , -2903.007,   71.422, 219.012420389  ,   54.212  },
	{129  , 90 , 219, "Th","   -a",   14472.525   ,  50.573    , 7683.720 ,   0.231 , -4048.505,   74.168, 219.015536895  ,   54.292  },
	{128  , 91 , 219, "Pa","   -a",   18521.029   ,  54.390    , 7661.662 ,   0.248 , -4691.019,   78.621, 219.019883143  ,   58.389  },
	{127  , 92 , 219, "U ","   -a",   23212.048   ,  56.771    , 7636.669 ,   0.259 , STAR     , STAR    , 219.024919160  ,   60.946  },
	{136  , 84 , 220, "Po","   +a",   15465.      , 359.       , 7702.    ,   2.    ,  1113.   ,  363.   , 220.016602     ,  385.     },
	{135  , 85 , 220, "At","   -a",   14352.164   ,  51.234    , 7703.810 ,   0.233 ,  3738.738,   51.282, 220.015407682  ,   55.002  },
	{134  , 86 , 220, "Rn","     ",   10613.426   ,   2.203    , 7717.248 ,   0.010 ,  -869.479,    4.070, 220.011393981  ,    2.365  },
	{133  , 87 , 220, "Fr","     ",   11482.904   ,   4.093    , 7709.740 ,   0.019 ,  1210.031,    9.979, 220.012327405  ,    4.393  },
	{132  , 88 , 220, "Ra","   -a",   10272.874   ,   9.241    , 7711.684 ,   0.042 , -3478.753,   17.436, 220.011028384  ,    9.920  },
	{131  , 89 , 220, "Ac","   -a",   13751.627   ,  14.889    , 7692.315 ,   0.068 ,  -917.320,   26.649, 220.014762979  ,   15.983  },
	{130  , 90 , 220, "Th","   -a",   14668.946   ,  22.171    , 7684.589 ,   0.101 , -5707.768,   60.800, 220.015747762  ,   23.801  },
	{129  , 91 , 220, "Pa","   -a",   20376.714   ,  56.624    , 7655.089 ,   0.257 , -2652.   ,  208.   , 220.021875303  ,   60.788  },
	{128  , 92 , 220, "U ","   -a",   23029.      , 200.       , 7639.    ,   1.    , STAR     , STAR    , 220.024723     ,  215.     },
	{136  , 85 , 221, "At","    x",   16813.      , 196.       , 7694.    ,   1.    ,  2341.   ,  196.   , 221.018050     ,  210.     },
	{135  , 86 , 221, "Rn","   +a",   14472.420   ,   5.902    , 7701.388 ,   0.027 ,  1194.194,    7.100, 221.015536782  ,    6.335  },
	{134  , 87 , 221, "Fr","     ",   13278.226   ,   4.796    , 7703.252 ,   0.022 ,   314.309,    6.298, 221.014254762  ,    5.148  },
	{133  , 88 , 221, "Ra","   -a",   12963.917   ,   4.656    , 7701.134 ,   0.021 , -1559.237,   50.603, 221.013917338  ,    4.998  },
	{132  , 89 , 221, "Ac","   -a",   14523.155   ,  50.427    , 7690.539 ,   0.228 , -2414.829,   51.258, 221.015591248  ,   54.135  },
	{131  , 90 , 221, "Th","   -a",   16937.984   ,   9.357    , 7676.072 ,   0.042 , -3441.227,   52.413, 221.018183674  ,   10.045  },
	{130  , 91 , 221, "Pa","   -a",   20379.211   ,  51.601    , 7656.961 ,   0.233 , -4212.   ,  114.   , 221.021877983  ,   55.395  },
	{129  , 92 , 221, "U ","   -a",   24591.      , 102.       , 7634.    ,   0.    , STAR     , STAR    , 221.026399     ,  110.     },
	{137  , 85 , 222, "At","    x",   20800.      , 298.       , 7678.    ,   1.    ,  4427.   ,  298.   , 222.022330     ,  320.     },
	{136  , 86 , 222, "Rn","     ",   16373.558   ,   2.360    , 7694.491 ,   0.011 ,    24.226,   21.120, 222.017577738  ,    2.533  },
	{135  , 87 , 222, "Fr","     ",   16349.332   ,  21.223    , 7691.076 ,   0.096 ,  2028.049,   21.611, 222.017551730  ,   22.783  },
	{134  , 88 , 222, "Ra","     ",   14321.283   ,   4.571    , 7696.687 ,   0.021 , -2300.158,    6.687, 222.015374530  ,    4.907  },
	{133  , 89 , 222, "Ac","   -a",   16621.441   ,   5.197    , 7682.802 ,   0.023 ,  -581.504,   13.227, 222.017843851  ,    5.579  },
	{132  , 90 , 222, "Th","   -a",   17202.945   ,  12.288    , 7676.659 ,   0.055 , -4913.   ,   74.   , 222.018468121  ,   13.192  },
	{131  , 91 , 222, "Pa","   -a",   22116.      ,  73.       , 7651.    ,   0.    , -2184.   ,  124.   , 222.023742     ,   78.     },
	{130  , 92 , 222, "U ","   -a",   24299.      , 101.       , 7638.    ,   0.    , STAR     , STAR    , 222.026086     ,  108.     },
	{138  , 85 , 223, "At","    x",   23464.      , 401.       , 7668.    ,   2.    ,  3167.   ,  499.   , 223.025190     ,  430.     },
	{137  , 86 , 223, "Rn","    x",   20297.      , 298.       , 7679.    ,   1.    ,  1913.   ,  298.   , 223.021790     ,  320.     },
	{136  , 87 , 223, "Fr","   +a",   18383.833   ,   2.397    , 7683.658 ,   0.011 ,  1149.171,    0.848, 223.019735857  ,    2.573  },
	{135  , 88 , 223, "Ra","     ",   17234.662   ,   2.523    , 7685.303 ,   0.011 ,  -591.776,    7.161, 223.018502171  ,    2.708  },
	{134  , 89 , 223, "Ac","   -a",   17826.437   ,   7.154    , 7679.141 ,   0.032 , -1559.302,   11.575, 223.019137468  ,    7.680  },
	{133  , 90 , 223, "Th","   -a",   19385.739   ,   9.225    , 7668.640 ,   0.041 , -2934.975,   71.639, 223.020811448  ,    9.903  },
	{132  , 91 , 223, "Pa","   -a",   22320.714   ,  71.064    , 7651.971 ,   0.319 , -3517.627,  100.504, 223.023962273  ,   76.290  },
	{131  , 92 , 223, "U ","   -a",   25838.340   ,  71.117    , 7632.688 ,   0.319 , STAR     , STAR    , 223.027738600  ,   76.347  },
	{138  , 86 , 224, "Rn","    x",   22440.      , 298.       , 7671.    ,   1.    ,   783.   ,  302.   , 224.024090     ,  320.     },
	{137  , 87 , 224, "Fr","    +",   21657.190   ,  50.048    , 7670.775 ,   0.223 ,  2830.000,   50.000, 224.023249951  ,   53.729  },
	{136  , 88 , 224, "Ra","     ",   18827.190   ,   2.203    , 7679.917 ,   0.010 , -1407.530,    4.131, 224.020211821  ,    2.364  },
	{135  , 89 , 224, "Ac","   -a",   20234.720   ,   4.152    , 7670.140 ,   0.019 ,   238.435,   11.603, 224.021722866  ,    4.457  },
	{134  , 90 , 224, "Th","   -a",   19996.285   ,  10.952    , 7667.712 ,   0.049 , -3873.937,   18.936, 224.021466895  ,   11.757  },
	{133  , 91 , 224, "Pa","   -a",   23870.222   ,  15.546    , 7646.925 ,   0.069 , -1843.463,   29.656, 224.025625738  ,   16.689  },
	{132  , 92 , 224, "U ","   -a",   25713.685   ,  25.315    , 7635.203 ,   0.113 , STAR     , STAR    , 224.027604778  ,   27.176  },
	{139  , 86 , 225, "Rn","    x",   26492.      , 298.       , 7655.    ,   1.    ,  2678.   ,  300.   , 225.028440     ,  320.     },
	{138  , 87 , 225, "Fr","    +",   23814.031   ,  30.148    , 7662.970 ,   0.134 ,  1820.000,   30.000, 225.025565414  ,   32.365  },
	{137  , 88 , 225, "Ra","     ",   21994.031   ,   2.986    , 7667.581 ,   0.013 ,   355.811,    4.806, 225.023611564  ,    3.205  },
	{136  , 89 , 225, "Ac","     ",   21638.220   ,   4.660    , 7665.686 ,   0.021 ,  -672.013,    6.570, 225.023229585  ,    5.002  },
	{135  , 90 , 225, "Th","   -a",   22310.233   ,   5.116    , 7659.222 ,   0.023 , -2030.337,   71.170, 225.023951021  ,    5.492  },
	{134  , 91 , 225, "Pa","   -a",   24340.570   ,  71.013    , 7646.721 ,   0.316 , -3036.707,   71.930, 225.026130678  ,   76.235  },
	{133  , 92 , 225, "U ","   -a",   27377.277   ,  11.577    , 7629.747 ,   0.051 , -4213.349,   72.757, 225.029390717  ,   12.428  },
	{132  , 93 , 225, "Np","   -a",   31590.626   ,  71.851    , 7607.544 ,   0.319 , STAR     , STAR    , 225.033913933  ,   77.135  },
	{140  , 86 , 226, "Rn","    x",   28774.      , 401.       , 7646.    ,   2.    ,  1401.   ,  413.   , 226.030890     ,  430.     },
	{139  , 87 , 226, "Fr","    +",   27373.099   , 100.028    , 7649.028 ,   0.443 ,  3704.000,  100.000, 226.029386231  ,  107.383  },
	{138  , 88 , 226, "Ra","     ",   23669.099   ,   2.346    , 7661.956 ,   0.010 ,  -641.115,    3.282, 226.025409823  ,    2.518  },
	{137  , 89 , 226, "Ac","     ",   24310.214   ,   3.333    , 7655.658 ,   0.015 ,  1113.153,    4.694, 226.026098089  ,    3.578  },
	{136  , 90 , 226, "Th","     ",   23197.060   ,   4.707    , 7657.121 ,   0.021 , -2836.105,   12.239, 226.024903069  ,    5.053  },
	{135  , 91 , 226, "Pa","   -a",   26033.165   ,  11.430    , 7641.110 ,   0.051 , -1295.661,   17.252, 226.027947753  ,   12.270  },
	{134  , 92 , 226, "U ","   -a",   27328.826   ,  13.040    , 7631.916 ,   0.058 , -5409.   ,   89.   , 226.029338702  ,   13.999  },
	{133  , 93 , 226, "Np","   -a",   32738.      ,  88.       , 7605.    ,   0.    , STAR     , STAR    , 226.035145     ,   95.     },
	{141  , 86 , 227, "Rn","   +a",   32981.      , 423.       , 7630.    ,   2.    ,  3326.   ,  435.   , 227.035407     ,  454.     },
	{140  , 87 , 227, "Fr","    +",   29654.986   , 100.028    , 7640.836 ,   0.441 ,  2476.000,  100.000, 227.031835938  ,  107.384  },
	{139  , 88 , 227, "Ra","   -n",   27178.986   ,   2.362    , 7648.297 ,   0.010 ,  1328.045,    2.293, 227.029177842  ,    2.535  },
	{138  , 89 , 227, "Ac","     ",   25850.941   ,   2.393    , 7650.701 ,   0.011 ,    44.765,    0.830, 227.027752127  ,    2.569  },
	{137  , 90 , 227, "Th","     ",   25806.176   ,   2.521    , 7647.452 ,   0.011 , -1025.577,    7.469, 227.027704070  ,    2.706  },
	{136  , 91 , 227, "Pa","   -a",   26831.753   ,   7.462    , 7639.488 ,   0.033 , -2190.217,   18.379, 227.028805072  ,    8.011  },
	{135  , 92 , 227, "U ","   -a",   29021.970   ,  16.864    , 7626.393 ,   0.074 , -3540.070,   74.423, 227.031156367  ,   18.104  },
	{134  , 93 , 227, "Np","   -a",   32562.040   ,  72.508    , 7607.351 ,   0.319 , STAR     , STAR    , 227.034956789  ,   77.840  },
	{142  , 86 , 228, "Rn","   +a",   35384.      , 410.       , 7621.    ,   2.    ,  2102.   ,  456.   , 228.037986     ,  440.     },
	{141  , 87 , 228, "Fr","    +",   33282.      , 200.       , 7627.    ,   1.    ,  4340.   ,  200.   , 228.035729     ,  215.     },
	{140  , 88 , 228, "Ra","   +a",   28941.792   ,   2.434    , 7642.421 ,   0.011 ,    45.811,    0.667, 228.031070292  ,    2.612  },
	{139  , 89 , 228, "Ac","    -",   28895.981   ,   2.523    , 7639.191 ,   0.011 ,  2123.793,    2.688, 228.031021112  ,    2.709  },
	{138  , 90 , 228, "Th","     ",   26772.188   ,   2.201    , 7645.074 ,   0.010 , -2151.983,    4.383, 228.028741127  ,    2.363  },
	{137  , 91 , 228, "Pa","   -a",   28924.171   ,   4.400    , 7632.204 ,   0.019 ,  -300.528,   15.503, 228.031051376  ,    4.723  },
	{136  , 92 , 228, "U ","   -a",   29224.699   ,  14.952    , 7627.455 ,   0.066 , -4477.   ,  196.   , 228.031374006  ,   16.051  },
	{135  , 93 , 228, "Np","    x",   33701.      , 196.       , 7604.    ,   1.    , -2387.   ,  198.   , 228.036180     ,  210.     },
	{134  , 94 , 228, "Pu","   -a",   36088.247   ,  32.485    , 7590.489 ,   0.142 , STAR     , STAR    , 228.038742328  ,   34.873  },
	{142  , 87 , 229, "Fr","    x",   35816.157   ,  37.260    , 7617.691 ,   0.163 ,  3253.383,   41.693, 229.038450228  ,   40.000  },
	{141  , 88 , 229, "Ra","     ",   32562.774   ,  18.709    , 7628.482 ,   0.082 ,  1809.272,   32.092, 229.034957577  ,   20.085  },
	{140  , 89 , 229, "Ac","     ",   30753.502   ,  33.276    , 7632.966 ,   0.145 ,  1166.988,   33.290, 229.033015243  ,   35.723  },
	{139  , 90 , 229, "Th","     ",   29586.514   ,   2.821    , 7634.646 ,   0.012 ,  -311.457,    3.036, 229.031762430  ,    3.028  },
	{138  , 91 , 229, "Pa","     ",   29897.971   ,   2.749    , 7629.869 ,   0.012 , -1312.611,    6.401, 229.032096793  ,    2.951  },
	{137  , 92 , 229, "U ","   -a",   31210.582   ,   5.958    , 7620.721 ,   0.026 , -2568.939,   87.031, 229.033505939  ,    6.396  },
	{136  , 93 , 229, "Np","   -a",   33779.521   ,  86.850    , 7606.087 ,   0.379 , -3620.162,  100.866, 229.036263808  ,   93.237  },
	{135  , 94 , 229, "Pu","   -a",   37399.683   ,  51.323    , 7586.862 ,   0.224 , STAR     , STAR    , 229.040150212  ,   55.097  },
	{143  , 87 , 230, "Fr","   +a",   39598.      , 448.       , 7603.    ,   2.    ,  5080.   ,  448.   , 230.042510     ,  481.     },
	{142  , 88 , 230, "Ra","    x",   34517.809   ,  12.109    , 7621.907 ,   0.053 ,   710.000,  300.000, 230.037056394  ,   13.000  },
	{141  , 89 , 230, "Ac","    -",   33807.809   , 300.244    , 7621.593 ,   1.305 ,  2943.833,  300.250, 230.036294178  ,  322.325  },
	{140  , 90 , 230, "Th","     ",   30863.976   ,   1.792    , 7630.990 ,   0.008 , -1310.529,    2.841, 230.033133843  ,    1.924  },
	{139  , 91 , 230, "Pa","     ",   32174.506   ,   3.277    , 7621.891 ,   0.014 ,   559.800,    4.753, 230.034540754  ,    3.518  },
	{138  , 92 , 230, "U ","   -a",   31614.706   ,   4.761    , 7620.923 ,   0.021 , -3621.475,   51.481, 230.033939784  ,    5.110  },
	{137  , 93 , 230, "Np","   -a",   35236.181   ,  51.290    , 7601.776 ,   0.223 , -1697.451,   53.437, 230.037827597  ,   55.061  },
	{136  , 94 , 230, "Pu","   -a",   36933.632   ,  15.096    , 7590.994 ,   0.066 , STAR     , STAR    , 230.039649886  ,   16.206  },
	{144  , 87 , 231, "Fr","   +a",   42328.      , 467.       , 7593.    ,   2.    ,  3931.   ,  554.   , 231.045440     ,  502.     },
	{143  , 88 , 231, "Ra","    x",   38396.      , 298.       , 7607.    ,   1.    ,  2479.   ,  314.   , 231.041220     ,  320.     },
	{142  , 89 , 231, "Ac","    +",   35917.278   , 100.016    , 7614.407 ,   0.433 ,  2100.000,  100.000, 231.038558786  ,  107.371  },
	{141  , 90 , 231, "Th","     ",   33817.278   ,   1.800    , 7620.112 ,   0.008 ,   391.556,    1.481, 231.036304343  ,    1.932  },
	{140  , 91 , 231, "Pa","     ",   33425.722   ,   2.257    , 7618.420 ,   0.010 ,  -381.646,    2.034, 231.035883990  ,    2.422  },
	{139  , 92 , 231, "U ","   -a",   33807.368   ,   3.021    , 7613.381 ,   0.013 , -1817.700,   50.582, 231.036293704  ,    3.242  },
	{138  , 93 , 231, "Np","   -a",   35625.068   ,  50.554    , 7602.125 ,   0.219 , -2660.367,   57.027, 231.038245085  ,   54.271  },
	{137  , 94 , 231, "Pu","   -a",   38285.435   ,  26.432    , 7587.222 ,   0.114 , -4153.   ,  299.   , 231.041101107  ,   28.375  },
	{136  , 95 , 231, "Am","    x",   42439.      , 298.       , 7566.    ,   1.    , STAR     , STAR    , 231.045560     ,  320.     },
	{145  , 87 , 232, "Fr","   +a",   46363.      , 639.       , 7578.    ,   3.    ,  5714.   ,  698.   , 232.049772     ,  686.     },
	{144  , 88 , 232, "Ra","   +a",   40649.      , 280.       , 7599.    ,   1.    ,  1500.   ,  297.   , 232.043638     ,  300.     },
	{143  , 89 , 232, "Ac","    +",   39148.307   , 100.020    , 7602.450 ,   0.431 ,  3700.000,  100.000, 232.042027438  ,  107.375  },
	{142  , 90 , 232, "Th","     ",   35448.307   ,   1.991    , 7615.026 ,   0.009 ,  -499.530,    7.746, 232.038055325  ,    2.137  },
	{141  , 91 , 232, "Pa","    +",   35947.837   ,   7.748    , 7609.501 ,   0.033 ,  1337.103,    7.428, 232.038591592  ,    8.317  },
	{140  , 92 , 232, "U ","   -a",   34610.734   ,   2.203    , 7611.892 ,   0.010 , -2750.   ,  100.   , 232.037156152  ,    2.365  },
	{139  , 93 , 232, "Np","    -",   37361.      , 100.       , 7597.    ,   0.    , -1005.   ,  102.   , 232.040108     ,  107.     },
	{138  , 94 , 232, "Pu","   -a",   38365.534   ,  18.086    , 7588.963 ,   0.078 , -5033.   ,  299.   , 232.041187097  ,   19.415  },
	{137  , 95 , 232, "Am","    x",   43398.      , 298.       , 7564.    ,   1.    , STAR     , STAR    , 232.046590     ,  320.     },
	{145  , 88 , 233, "Ra","   +a",   44767.      , 468.       , 7584.    ,   2.    ,  3269.   ,  555.   , 233.048060     ,  502.     },
	{144  , 89 , 233, "Ac","    x",   41498.      , 298.       , 7594.    ,   1.    ,  2765.   ,  298.   , 233.044550     ,  320.     },
	{143  , 90 , 233, "Th","     ",   38733.238   ,   1.993    , 7602.886 ,   0.009 ,  1243.140,    1.405, 233.041581843  ,    2.139  },
	{142  , 91 , 233, "Pa","     ",   37490.098   ,   2.161    , 7604.864 ,   0.009 ,   570.140,    2.020, 233.040247277  ,    2.319  },
	{141  , 92 , 233, "U ","     ",   36919.958   ,   2.705    , 7603.953 ,   0.012 , -1029.617,   50.959, 233.039635207  ,    2.904  },
	{140  , 93 , 233, "Np","   -a",   37949.575   ,  50.948    , 7596.176 ,   0.219 , -2102.222,   71.618, 233.040740546  ,   54.695  },
	{139  , 94 , 233, "Pu","   -a",   40051.797   ,  50.354    , 7583.796 ,   0.216 , -3121.   ,  113.   , 233.042997375  ,   54.056  },
	{138  , 95 , 233, "Am","   -a",   43173.      , 102.       , 7567.    ,   0.    , -4120.   ,  124.   , 233.046348     ,  109.     },
	{137  , 96 , 233, "Cm","   -a",   47293.098   ,  71.652    , 7546.002 ,   0.308 , STAR     , STAR    , 233.050771232  ,   76.921  },
	{146  , 88 , 234, "Ra","   +a",   47230.      , 490.       , 7575.    ,   2.    ,  2128.   ,  633.   , 234.050704     ,  526.     },
	{145  , 89 , 234, "Ac","    x",   45103.      , 401.       , 7581.    ,   2.    ,  4489.   ,  401.   , 234.048420     ,  430.     },
	{144  , 90 , 234, "Th","   +a",   40614.285   ,   3.500    , 7596.849 ,   0.015 ,   273.088,    3.172, 234.043601230  ,    3.756  },
	{143  , 91 , 234, "Pa","   IT",   40341.197   ,   4.723    , 7594.673 ,   0.020 ,  2194.572,    4.489, 234.043308058  ,    5.070  },
	{142  , 92 , 234, "U ","     ",   38146.625   ,   1.827    , 7600.708 ,   0.008 , -1809.846,    8.321, 234.040952088  ,    1.960  },
	{141  , 93 , 234, "Np","    -",   39956.471   ,   8.519    , 7589.630 ,   0.036 ,  -393.126,   10.859, 234.042895038  ,    9.145  },
	{140  , 94 , 234, "Pu","   -a",   40349.597   ,   6.967    , 7584.607 ,   0.030 , -4184.   ,  208.   , 234.043317076  ,    7.479  },
	{139  , 95 , 234, "Am","   -a",   44534.      , 207.       , 7563.    ,   1.    , -2190.   ,  208.   , 234.047809     ,  223.     },
	{138  , 96 , 234, "Cm","   -a",   46723.592   ,  18.204    , 7550.681 ,   0.078 , STAR     , STAR    , 234.050159841  ,   19.543  },
	{146  , 89 , 235, "Ac","   +a",   47722.      , 358.       , 7572.    ,   2.    ,  3467.   ,  362.   , 235.051232     ,  384.     },
	{145  , 90 , 235, "Th"," +n2p",   44255.350   ,  50.036    , 7583.374 ,   0.213 ,  1924.894,   70.721, 235.047510074  ,   53.716  },
	{144  , 91 , 235, "Pa","    +",   42330.456   ,  50.033    , 7588.236 ,   0.213 ,  1410.000,   50.000, 235.045443615  ,   53.712  },
	{143  , 92 , 235, "U ","     ",   40920.456   ,   1.823    , 7590.907 ,   0.008 ,  -124.214,    0.854, 235.043929918  ,    1.957  },
	{142  , 93 , 235, "Np","     ",   41044.669   ,   1.994    , 7587.049 ,   0.008 , -1139.015,   20.501, 235.044063267  ,    2.140  },
	{141  , 94 , 235, "Pu","   -a",   42183.684   ,  20.570    , 7578.873 ,   0.088 , -2478.   ,  122.   , 235.045286050  ,   22.082  },
	{140  , 95 , 235, "Am","   -a",   44662.      , 120.       , 7565.    ,   1.    , -3249.   ,  235.   , 235.047946     ,  129.     },
	{139  , 96 , 235, "Cm","   -a",   47910.      , 202.       , 7548.    ,   1.    , -4794.   ,  448.   , 235.051434     ,  217.     },
	{138  , 97 , 235, "Bk","    x",   52704.      , 401.       , 7524.    ,   2.    , STAR     , STAR    , 235.056580     ,  430.     },
	{147  , 89 , 236, "Ac","   +a",   51508.      , 499.       , 7558.    ,   2.    ,  5054.   ,  536.   , 236.055296     ,  536.     },
	{146  , 90 , 236, "Th","    x",   46454.      , 196.       , 7576.    ,   1.    ,  1107.   ,  280.   , 236.049870     ,  210.     },
	{145  , 91 , 236, "Pa","    +",   45346.325   , 200.008    , 7577.504 ,   0.847 ,  2900.000,  200.000, 236.048681284  ,  214.717  },
	{144  , 92 , 236, "U ","     ",   42446.325   ,   1.826    , 7586.477 ,   0.008 ,  -932.978,   50.416, 236.045568006  ,    1.960  },
	{143  , 93 , 236, "Np","   IT",   43379.304   ,  50.437    , 7579.209 ,   0.214 ,   476.585,   50.389, 236.046569600  ,   54.146  },
	{142  , 94 , 236, "Pu","   -a",   42902.718   ,   2.205    , 7577.913 ,   0.009 , -3280.   ,  100.   , 236.046057964  ,    2.366  },
	{141  , 95 , 236, "Am","    -",   46183.      , 100.       , 7561.    ,   0.    , -1708.   ,  224.   , 236.049579     ,  107.     },
	{140  , 96 , 236, "Cm","   -a",   47890.      , 201.       , 7550.    ,   1.    , -5512.   ,  448.   , 236.051413     ,  216.     },
	{139  , 97 , 236, "Bk","    x",   53403.      , 401.       , 7523.    ,   2.    , STAR     , STAR    , 236.057330     ,  430.     },
	{147  , 90 , 237, "Th","   +a",   50202.      , 359.       , 7562.    ,   2.    ,  2560.   ,  373.   , 237.053894     ,  385.     },
	{146  , 91 , 237, "Pa","    +",   47641.875   , 100.018    , 7569.902 ,   0.422 ,  2250.000,  100.000, 237.051145659  ,  107.373  },
	{145  , 92 , 237, "U ","     ",   45391.875   ,   1.882    , 7576.094 ,   0.008 ,   518.600,    0.504, 237.048730184  ,    2.019  },
	{144  , 93 , 237, "Np","     ",   44873.275   ,   1.833    , 7574.982 ,   0.008 ,  -220.032,    1.298, 237.048173444  ,    1.967  },
	{143  , 94 , 237, "Pu","     ",   45093.307   ,   2.236    , 7570.752 ,   0.009 , -1477.   ,   59.   , 237.048409658  ,    2.400  },
	{142  , 95 , 237, "Am","   -a",   46571.      ,  59.       , 7561.    ,   0.    , -2706.   ,  215.   , 237.049996     ,   64.     },
	{141  , 96 , 237, "Cm","   -a",   49277.      , 206.       , 7546.    ,   1.    , -3821.   ,  305.   , 237.052901     ,  221.     },
	{140  , 97 , 237, "Bk","   -a",   53098.      , 224.       , 7527.    ,   1.    , -4720.   ,  551.   , 237.057003     ,  241.     },
	{139  , 98 , 237, "Cf","    x",   57818.      , 503.       , 7504.    ,   2.    , STAR     , STAR    , 237.062070     ,  540.     },
	{148  , 90 , 238, "Th","   +a",   52625.      , 283.       , 7554.    ,   1.    ,  1856.   ,  290.   , 238.056496     ,  304.     },
	{147  , 91 , 238, "Pa","    +",   50768.948   ,  60.030    , 7558.870 ,   0.252 ,  3460.000,   60.000, 238.054502710  ,   64.445  },
	{146  , 92 , 238, "U ","     ",   47308.948   ,   1.904    , 7570.120 ,   0.008 ,  -147.324,    1.205, 238.050788247  ,    2.044  },
	{145  , 93 , 238, "Np","   -n",   47456.272   ,   1.844    , 7566.214 ,   0.008 ,  1291.527,    0.446, 238.050946405  ,    1.979  },
	{144  , 94 , 238, "Pu","     ",   46164.745   ,   1.834    , 7568.354 ,   0.008 , -2258.342,   50.688, 238.049559894  ,    1.968  },
	{143  , 95 , 238, "Am","   -a",   48423.087   ,  50.720    , 7555.578 ,   0.213 ,  -972.827,   62.538, 238.051984324  ,   54.450  },
	{142  , 96 , 238, "Cm","   -a",   49395.914   ,  36.629    , 7548.203 ,   0.154 , -4893.   ,  290.   , 238.053028697  ,   39.322  },
	{141  , 97 , 238, "Bk","   -a",   54288.      , 288.       , 7524.    ,   1.    , -2915.   ,  493.   , 238.058281     ,  309.     },
	{140  , 98 , 238, "Cf","    x",   57203.      , 401.       , 7509.    ,   2.    , STAR     , STAR    , 238.061410     ,  430.     },
	{148  , 91 , 239, "Pa","    x",   53337.      , 196.       , 7550.    ,   1.    ,  2763.   ,  196.   , 239.057260     ,  210.     },
	{147  , 92 , 239, "U ","   -n",   50573.883   ,   1.912    , 7558.557 ,   0.008 ,  1261.498,    1.557, 239.054293299  ,    2.052  },
	{146  , 93 , 239, "Np","     ",   49312.385   ,   2.077    , 7560.561 ,   0.009 ,   722.508,    0.992, 239.052939025  ,    2.229  },
	{145  , 94 , 239, "Pu","     ",   48589.877   ,   1.827    , 7560.311 ,   0.008 ,  -802.108,    1.664, 239.052163381  ,    1.961  },
	{144  , 95 , 239, "Am","   -a",   49391.985   ,   2.444    , 7553.681 ,   0.010 , -1800.   ,  100.   , 239.053024479  ,    2.624  },
	{143  , 96 , 239, "Cm","    -",   51192.      , 100.       , 7543.    ,   0.    , -3095.   ,  254.   , 239.054957     ,  107.     },
	{142  , 97 , 239, "Bk","   -a",   54287.      , 233.       , 7527.    ,   1.    , -3859.   ,  314.   , 239.058279     ,  251.     },
	{141  , 98 , 239, "Cf","   -a",   58145.      , 209.       , 7507.    ,   1.    , STAR     , STAR    , 239.062422     ,  225.     },
	{149  , 91 , 240, "Pa","    x",   56803.      , 298.       , 7538.    ,   1.    ,  4087.   ,  298.   , 240.060980     ,  320.     },
	{148  , 92 , 240, "U ","   +a",   52715.098   ,   5.154    , 7551.771 ,   0.021 ,   400.361,   15.793, 240.056591988  ,    5.533  },
	{147  , 93 , 240, "Np","    +",   52314.736   ,  15.139    , 7550.180 ,   0.063 ,  2187.741,   15.029, 240.056162182  ,   16.252  },
	{146  , 94 , 240, "Pu","     ",   50126.995   ,   1.825    , 7556.036 ,   0.008 , -1384.790,   13.788, 240.053813545  ,    1.958  },
	{145  , 95 , 240, "Am","   +n",   51511.785   ,  13.908    , 7547.006 ,   0.058 ,  -213.648,   13.900, 240.055300179  ,   14.930  },
	{144  , 96 , 240, "Cm","   -a",   51725.434   ,   2.285    , 7542.856 ,   0.010 , -3940.   ,  150.   , 240.055529539  ,    2.452  },
	{143  , 97 , 240, "Bk","    -",   55665.      , 150.       , 7523.    ,   1.    , -2369.   ,  251.   , 240.059759     ,  161.     },
	{142  , 98 , 240, "Cf","   -a",   58034.      , 201.       , 7510.    ,   1.    , -6164.   ,  448.   , 240.062302     ,  216.     },
	{141  , 99 , 240, "Es","    x",   64199.      , 401.       , 7481.    ,   2.    , STAR     , STAR    , 240.068920     ,  430.     },
	{149  , 92 , 241, "U ","    x",   56197.      , 298.       , 7539.    ,   1.    ,  1935.   ,  306.   , 241.060330     ,  320.     },
	{148  , 93 , 241, "Np","    +",   54261.791   ,  70.734    , 7544.263 ,   0.294 ,  1305.000,   70.711, 241.058252431  ,   75.936  },
	{147  , 94 , 241, "Pu","     ",   52956.791   ,   1.825    , 7546.432 ,   0.008 ,    20.783,    0.128, 241.056851456  ,    1.959  },
	{146  , 95 , 241, "Am","     ",   52936.008   ,   1.829    , 7543.272 ,   0.008 ,  -767.417,    1.172, 241.056829144  ,    1.963  },
	{145  , 96 , 241, "Cm","     ",   53703.425   ,   2.170    , 7536.841 ,   0.009 , -2400.   ,  200.   , 241.057653001  ,    2.329  },
	{144  , 97 , 241, "Bk","    -",   56103.      , 200.       , 7524.    ,   1.    , -3257.   ,  324.   , 241.060230     ,  215.     },
	{143  , 98 , 241, "Cf","   -a",   59361.      , 255.       , 7507.    ,   1.    , -4482.   ,  342.   , 241.063726     ,  274.     },
	{142  , 99 , 241, "Es","   -a",   63843.      , 227.       , 7485.    ,   1.    , STAR     , STAR    , 241.068538     ,  244.     },
	{150  , 92 , 242, "U ","   +a",   58620.      , 201.       , 7532.    ,   1.    ,  1202.   ,  283.   , 242.062931     ,  215.     },
	{149  , 93 , 242, "Np","    +",   57418.390   , 200.009    , 7533.397 ,   0.826 ,  2700.000,  200.000, 242.061641180  ,  214.718  },
	{148  , 94 , 242, "Pu","     ",   54718.390   ,   1.860    , 7541.321 ,   0.008 ,  -751.295,    0.704, 242.058742611  ,    1.996  },
	{147  , 95 , 242, "Am","   -n",   55469.685   ,   1.832    , 7534.984 ,   0.008 ,   664.467,    0.402, 242.059549159  ,    1.966  },
	{146  , 96 , 242, "Cm","   -a",   54805.218   ,   1.835    , 7534.497 ,   0.008 , -2930.   ,  200.   , 242.058835824  ,    1.970  },
	{145  , 97 , 242, "Bk","    -",   57735.      , 200.       , 7519.    ,   1.    , -1602.   ,  203.   , 242.061981     ,  215.     },
	{144  , 98 , 242, "Cf","   -a",   59337.614   ,  36.854    , 7509.302 ,   0.152 , -5629.   ,  328.   , 242.063701552  ,   39.564  },
	{143  , 99 , 242, "Es","   -a",   64967.      , 326.       , 7483.    ,   1.    , -3433.   ,  516.   , 242.069745     ,  349.     },
	{142  ,100 , 242, "Fm","    x",   68400.      , 401.       , 7465.    ,   2.    , STAR     , STAR    , 242.073430     ,  430.     },
	{150  , 93 , 243, "Np","   IT",   59875.      ,  32.       , 7525.    ,   0.    ,  2120.   ,   32.   , 243.064279     ,   34.     },
	{149  , 94 , 243, "Pu","     ",   57755.509   ,   3.188    , 7531.004 ,   0.013 ,   579.401,    2.925, 243.062003092  ,    3.422  },
	{148  , 95 , 243, "Am","     ",   57176.109   ,   2.293    , 7530.169 ,   0.009 ,    -7.484,    1.713, 243.061381080  ,    2.461  },
	{147  , 96 , 243, "Cm","   -a",   57183.593   ,   2.083    , 7526.918 ,   0.009 , -1507.583,    4.507, 243.061389114  ,    2.235  },
	{146  , 97 , 243, "Bk","   -a",   58691.176   ,   4.745    , 7517.495 ,   0.020 , -2254.   ,  142.   , 243.063007572  ,    5.094  },
	{145  , 98 , 243, "Cf","   -a",   60945.      , 142.       , 7505.    ,   1.    , -3839.   ,  273.   , 243.065427     ,  152.     },
	{144  , 99 , 243, "Es","   -a",   64783.      , 234.       , 7486.    ,   1.    , -4476.   ,  318.   , 243.069548     ,  251.     },
	{143  ,100 , 243, "Fm","   -a",   69259.      , 215.       , 7464.    ,   1.    , STAR     , STAR    , 243.074353     ,  231.     },
	{151  , 93 , 244, "Np","    x",   63202.      , 298.       , 7514.    ,   1.    ,  3396.   ,  298.   , 244.067850     ,  320.     },
	{150  , 94 , 244, "Pu","     ",   59805.555   ,   5.053    , 7524.817 ,   0.021 ,   -75.396,    4.849, 244.064203907  ,    5.424  },
	{149  , 95 , 244, "Am","    +",   59880.951   ,   2.081    , 7521.301 ,   0.009 ,  1427.300,    1.000, 244.064284847  ,    2.234  },
	{148  , 96 , 244, "Cm","   -a",   58453.651   ,   1.825    , 7523.944 ,   0.007 , -2261.850,   14.356, 244.062752578  ,    1.959  },
	{147  , 97 , 244, "Bk","   -a",   60715.501   ,  14.472    , 7511.468 ,   0.059 ,  -763.746,   14.578, 244.065180774  ,   15.536  },
	{146  , 98 , 244, "Cf","   -a",   61479.247   ,   2.920    , 7505.132 ,   0.012 , -4547.   ,  181.   , 244.066000689  ,    3.135  },
	{145  , 99 , 244, "Es","   -a",   66027.      , 181.       , 7483.    ,   1.    , -2982.   ,  337.   , 244.070883     ,  195.     },
	{144  ,100 , 244, "Fm","   -a",   69009.      , 284.       , 7468.    ,   1.    , STAR     , STAR    , 244.074084     ,  304.     },
	{151  , 94 , 245, "Pu","   -n",   63106.068   ,  14.417    , 7513.576 ,   0.059 ,  1206.322,   14.612, 245.067747154  ,   15.477  },
	{150  , 95 , 245, "Am","   +a",   61899.746   ,   3.467    , 7515.306 ,   0.014 ,   895.040,    2.773, 245.066452114  ,    3.721  },
	{149  , 96 , 245, "Cm","   -a",   61004.706   ,   2.081    , 7515.766 ,   0.008 ,  -810.742,    1.729, 245.065491249  ,    2.233  },
	{148  , 97 , 245, "Bk","   -a",   61815.448   ,   2.306    , 7509.264 ,   0.009 , -1571.427,    2.607, 245.066361616  ,    2.475  },
	{147  , 98 , 245, "Cf","   -a",   63386.875   ,   2.856    , 7499.657 ,   0.012 , -3051.   ,  200.   , 245.068048612  ,    3.065  },
	{146  , 99 , 245, "Es","   -a",   66438.      , 200.       , 7484.    ,   1.    , -3783.   ,  340.   , 245.071324     ,  215.     },
	{145  ,100 , 245, "Fm","   -a",   70221.      , 275.       , 7465.    ,   1.    , -5071.   ,  424.   , 245.075385     ,  295.     },
	{144  ,101 , 245, "Md","   IT",   75292.      , 323.       , 7441.    ,   1.    , STAR     , STAR    , 245.080829     ,  346.     },
	{152  , 94 , 246, "Pu","     ",   65395.190   ,  15.255    , 7506.538 ,   0.062 ,   400.550,   13.754, 246.070204627  ,   16.377  },
	{151  , 95 , 246, "Am","   IT",   64994.640   ,  18.176    , 7504.986 ,   0.074 ,  2376.200,   18.074, 246.069774619  ,   19.512  },
	{150  , 96 , 246, "Cm","     ",   62618.439   ,   2.061    , 7511.465 ,   0.008 , -1350.000,   60.000, 246.067223662  ,    2.212  },
	{149  , 97 , 246, "Bk","    -",   63968.439   ,  60.035    , 7502.797 ,   0.244 ,  -123.294,   60.020, 246.068672947  ,   64.450  },
	{148  , 98 , 246, "Cf","   -a",   64091.733   ,   2.090    , 7499.115 ,   0.009 , -3810.   ,  224.   , 246.068805309  ,    2.243  },
	{147  , 99 , 246, "Es","   -a",   67902.      , 224.       , 7480.    ,   1.    , -2239.   ,  227.   , 246.072896     ,  240.     },
	{146  ,100 , 246, "Fm","   -a",   70140.589   ,  38.678    , 7468.166 ,   0.157 , -6136.   ,  332.   , 246.075299023  ,   41.522  },
	{145  ,101 , 246, "Md","   -a",   76276.      , 329.       , 7440.    ,   1.    , STAR     , STAR    , 246.081886     ,  354.     },
	{153  , 94 , 247, "Pu","    x",   68996.      , 298.       , 7494.    ,   1.    ,  1842.   ,  314.   , 247.074070     ,  320.     },
	{152  , 95 , 247, "Am","    +",   67154.      , 100.       , 7499.    ,   0.    ,  1620.   ,  100.   , 247.072093     ,  107.     },
	{151  , 96 , 247, "Cm","     ",   65533.901   ,   4.364    , 7501.928 ,   0.018 ,    43.277,    6.522, 247.070353540  ,    4.684  },
	{150  , 97 , 247, "Bk","   -a",   65490.624   ,   5.501    , 7498.936 ,   0.022 ,  -646.000,    6.000, 247.070307080  ,    5.905  },
	{149  , 98 , 247, "Cf","    -",   66136.624   ,   8.140    , 7493.153 ,   0.033 , -2473.   ,   31.   , 247.071000589  ,    8.738  },
	{148  , 99 , 247, "Es","   -a",   68610.      ,  30.       , 7480.    ,   0.    , -2973.   ,  146.   , 247.073656     ,   33.     },
	{147  ,100 , 247, "Fm","   -a",   71583.      , 143.       , 7465.    ,   1.    , -4460.   ,  354.   , 247.076847     ,  153.     },
	{146  ,101 , 247, "Md","   IT",   76043.      , 324.       , 7444.    ,   1.    , STAR     , STAR    , 247.081635     ,  348.     },
	{153  , 95 , 248, "Am","    +",   70562.      , 200.       , 7487.    ,   1.    ,  3170.   ,  200.   , 248.075752     ,  215.     },
	{152  , 96 , 248, "Cm","     ",   67392.202   ,   5.055    , 7496.731 ,   0.020 ,  -687.   ,   71.   , 248.072348508  ,    5.426  },
	{151  , 97 , 248, "Bk","   IT",   68080.      ,  71.       , 7491.    ,   0.    ,   840.   ,   71.   , 248.073086     ,   76.     },
	{150  , 98 , 248, "Cf","   -a",   67239.766   ,   5.323    , 7491.036 ,   0.021 , -3061.   ,   53.   , 248.072184861  ,    5.714  },
	{149  , 99 , 248, "Es","   -a",   70301.      ,  52.       , 7476.    ,   0.    , -1606.   ,   54.   , 248.075471     ,   56.     },
	{148  ,100 , 248, "Fm","   -a",   71906.414   ,  11.695    , 7465.910 ,   0.047 , -5242.   ,  238.   , 248.077194714  ,   12.555  },
	{147  ,101 , 248, "Md","   -a",   77149.      , 237.       , 7442.    ,   1.    , -3515.   ,  383.   , 248.082823     ,  255.     },
	{146  ,102 , 248, "No","   -a",   80664.      , 301.       , 7424.    ,   1.    , STAR     , STAR    , 248.086596     ,  323.     },
	{154  , 95 , 249, "Am","    x",   73104.      , 298.       , 7479.    ,   1.    ,  2354.   ,  298.   , 249.078480     ,  320.     },
	{153  , 96 , 249, "Cm","   -n",   70750.150   ,   5.061    , 7485.552 ,   0.020 ,   900.528,    5.107, 249.075953413  ,    5.433  },
	{152  , 97 , 249, "Bk","    +",   69849.622   ,   2.612    , 7486.027 ,   0.010 ,   124.000,    1.414, 249.074986657  ,    2.803  },
	{151  , 98 , 249, "Cf","   -a",   69725.622   ,   2.195    , 7483.383 ,   0.009 , -1451.   ,   30.   , 249.074853537  ,    2.356  },
	{150  , 99 , 249, "Es","   -a",   71176.      ,  30.       , 7474.    ,   0.    , -2443.   ,  106.   , 249.076411     ,   32.     },
	{149  ,100 , 249, "Fm","   -a",   73619.      , 101.       , 7461.    ,   0.    , -3706.   ,  246.   , 249.079034     ,  109.     },
	{148  ,101 , 249, "Md","   -a",   77326.      , 224.       , 7443.    ,   1.    , -4490.   ,  407.   , 249.083013     ,  241.     },
	{147  ,102 , 249, "No","   -a",   81816.      , 340.       , 7422.    ,   1.    , STAR     , STAR    , 249.087833     ,  365.     },
	{154  , 96 , 250, "Cm","  -nn",   72989.038   ,  11.205    , 7478.940 ,   0.045 ,    37.668,   11.579, 250.078356959  ,   12.029  },
	{153  , 97 , 250, "Bk","   +a",   72951.370   ,   3.968    , 7475.961 ,   0.016 ,  1779.577,    3.386, 250.078316520  ,    4.260  },
	{152  , 98 , 250, "Cf","   -a",   71171.793   ,   2.070    , 7479.950 ,   0.008 , -2055.   ,  100.   , 250.076406066  ,    2.222  },
	{151  , 99 , 250, "Es","    -",   73227.      , 100.       , 7469.    ,   0.    ,  -847.   ,  101.   , 250.078612     ,  107.     },
	{150  ,100 , 250, "Fm","   -a",   74073.581   ,  11.933    , 7462.084 ,   0.048 , -4563.   ,  301.   , 250.079521264  ,   12.810  },
	{149  ,101 , 250, "Md","   -a",   78636.      , 301.       , 7441.    ,   1.    , -2879.   ,  363.   , 250.084420     ,  323.     },
	{148  ,102 , 250, "No","   -a",   81516.      , 204.       , 7426.    ,   1.    , STAR     , STAR    , 250.087510     ,  219.     },
	{155  , 96 , 251, "Cm","    +",   76647.617   ,  22.804    , 7466.724 ,   0.091 ,  1420.000,   20.000, 251.082284605  ,   24.481  },
	{154  , 97 , 251, "Bk","    +",   75227.617   ,  10.956    , 7469.264 ,   0.044 ,  1093.000,   10.000, 251.080760172  ,   11.762  },
	{153  , 98 , 251, "Cf","   -a",   74134.617   ,   4.477    , 7470.502 ,   0.018 ,  -377.585,    7.082, 251.079586788  ,    4.806  },
	{152  , 99 , 251, "Es","   -a",   74512.202   ,   6.072    , 7465.881 ,   0.024 , -1474.438,    6.828, 251.079992142  ,    6.519  },
	{151  ,100 , 251, "Fm","   -a",   75986.640   ,   8.382    , 7456.890 ,   0.033 , -3040.   ,  203.   , 251.081575017  ,    8.998  },
	{150  ,101 , 251, "Md","   -a",   79027.      , 203.       , 7442.    ,   1.    , -3887.   ,  268.   , 251.084839     ,  218.     },
	{149  ,102 , 251, "No","   -a",   82914.      , 175.       , 7423.    ,   1.    , -4982.   ,  345.   , 251.089012     ,  188.     },
	{148  ,103 , 251, "Lr","    x",   87896.      , 298.       , 7400.    ,   1.    , STAR     , STAR    , 251.094360     ,  320.     },
	{156  , 96 , 252, "Cm","    x",   79056.      , 298.       , 7460.    ,   1.    ,   522.   ,  359.   , 252.084870     ,  320.     },
	{155  , 97 , 252, "Bk","    +",   78534.      , 200.       , 7459.    ,   1.    ,  2500.   ,  200.   , 252.084310     ,  215.     },
	{154  , 98 , 252, "Cf","   -a",   76033.987   ,   5.055    , 7465.349 ,   0.020 , -1260.000,   50.000, 252.081625846  ,    5.426  },
	{153  , 99 , 252, "Es","    -",   77293.987   ,  50.255    , 7457.244 ,   0.199 ,   476.605,   50.513, 252.082978512  ,   53.950  },
	{152  ,100 , 252, "Fm","   -a",   76817.382   ,   5.686    , 7456.031 ,   0.023 , -3813.   ,  196.   , 252.082466855  ,    6.104  },
	{151  ,101 , 252, "Md","    x",   80630.      , 196.       , 7438.    ,   1.    , -2251.   ,  196.   , 252.086560     ,  210.     },
	{150  ,102 , 252, "No","   -a",   82881.097   ,  12.993    , 7425.760 ,   0.052 , -5956.   ,  249.   , 252.088976521  ,   13.948  },
	{149  ,103 , 252, "Lr","   -a",   88837.      , 248.       , 7399.    ,   1.    , STAR     , STAR    , 252.095371     ,  267.     },
	{156  , 97 , 253, "Bk","   -a",   80929.      , 359.       , 7451.    ,   1.    ,  1628.   ,  359.   , 253.086880     ,  385.     },
	{155  , 98 , 253, "Cf","   -a",   79301.015   ,   6.174    , 7454.831 ,   0.024 ,   287.318,    6.212, 253.085133145  ,    6.627  },
	{154  , 99 , 253, "Es","   -a",   79013.697   ,   2.612    , 7452.874 ,   0.010 ,  -335.840,    3.317, 253.084824697  ,    2.804  },
	{153  ,100 , 253, "Fm","   -a",   79349.538   ,   3.718    , 7448.455 ,   0.015 , -1951.   ,  205.   , 253.085185236  ,    3.990  },
	{152  ,101 , 253, "Md","    x",   81301.      , 205.       , 7438.    ,   1.    , -3165.   ,  229.   , 253.087280     ,  220.     },
	{151  ,102 , 253, "No","   -a",   84466.      , 102.       , 7422.    ,   0.    , -4222.   ,  246.   , 253.090678     ,  109.     },
	{150  ,103 , 253, "Lr","   -a",   88687.      , 224.       , 7402.    ,   1.    , -5103.   ,  506.   , 253.095210     ,  241.     },
	{149  ,104 , 253, "Rf","   -a",   93791.      , 453.       , 7379.    ,   2.    , STAR     , STAR    , 253.100689     ,  487.     },
	{157  , 97 , 254, "Bk","    x",   84393.      , 298.       , 7440.    ,   1.    ,  3053.   ,  298.   , 254.090600     ,  320.     },
	{156  , 98 , 254, "Cf","   -a",   81340.767   ,  12.303    , 7449.228 ,   0.048 ,  -651.218,   12.733, 254.087322909  ,   13.207  },
	{155  , 99 , 254, "Es","   -a",   81991.986   ,   4.242    , 7443.584 ,   0.017 ,  1087.800,    3.202, 254.088022021  ,    4.554  },
	{154  ,100 , 254, "Fm","   -a",   80904.186   ,   2.783    , 7444.786 ,   0.011 , -2610.   ,  100.   , 254.086854220  ,    2.988  },
	{153  ,101 , 254, "Md","    -",   83514.      , 100.       , 7431.    ,   0.    , -1210.   ,  102.   , 254.089656     ,  107.     },
	{152  ,102 , 254, "No","   -a",   84724.274   ,  17.644    , 7423.586 ,   0.069 , -5122.   ,  337.   , 254.090955253  ,   18.941  },
	{151  ,103 , 254, "Lr","   -a",   89847.      , 336.       , 7400.    ,   1.    , -3474.   ,  441.   , 254.096454     ,  361.     },
	{150  ,104 , 254, "Rf","   -a",   93320.      , 285.       , 7384.    ,   1.    , STAR     , STAR    , 254.100184     ,  306.     },
	{157  , 98 , 255, "Cf","    +",   84809.      , 200.       , 7438.    ,   1.    ,   720.   ,  200.   , 255.091046     ,  215.     },
	{156  , 99 , 255, "Es","   -a",   84088.873   ,  11.038    , 7437.822 ,   0.043 ,   289.620,   10.247, 255.090273122  ,   11.850  },
	{155  ,100 , 255, "Fm","   -a",   83799.253   ,   4.821    , 7435.890 ,   0.019 , -1043.742,    7.770, 255.089962202  ,    5.175  },
	{154  ,101 , 255, "Md","   -a",   84842.994   ,   6.625    , 7428.729 ,   0.026 , -2010.561,    9.468, 255.091082705  ,    7.112  },
	{153  ,102 , 255, "No","   -a",   86853.555   ,  10.308    , 7417.776 ,   0.040 , -3204.   ,  206.   , 255.093241131  ,   11.066  },
	{152  ,103 , 255, "Lr","   -a",   90057.      , 206.       , 7402.    ,   1.    , -4340.   ,  270.   , 255.096681     ,  221.     },
	{151  ,104 , 255, "Rf","   -a",   94397.      , 175.       , 7382.    ,   1.    , -5644.   ,  458.   , 255.101340     ,  188.     },
	{150  ,105 , 255, "Db","   -a",  100041.      , 423.       , 7357.    ,   2.    , STAR     , STAR    , 255.107398     ,  454.     },
	{158  , 98 , 256, "Cf","    x",   87039.      , 298.       , 7432.    ,   1.    ,  -147.   ,  314.   , 256.093440     ,  320.     },
	{157  , 99 , 256, "Es","    +",   87186.      , 100.       , 7428.    ,   0.    ,  1700.   ,  100.   , 256.093598     ,  108.     },
	{156  ,100 , 256, "Fm","   -a",   85486.109   ,   7.166    , 7431.783 ,   0.028 , -2129.309,   52.820, 256.091773117  ,    7.693  },
	{155  ,101 , 256, "Md","   -a",   87615.418   ,  52.818    , 7420.409 ,   0.206 ,  -208.321,   53.343, 256.094059025  ,   56.702  },
	{154  ,102 , 256, "No","   -a",   87823.739   ,   7.877    , 7416.539 ,   0.031 , -4049.   ,  220.   , 256.094282666  ,    8.456  },
	{153  ,103 , 256, "Lr","   -a",   91872.      , 220.       , 7398.    ,   1.    , -2363.   ,  221.   , 256.098629     ,  236.     },
	{152  ,104 , 256, "Rf","   -a",   94235.704   ,  24.117    , 7385.381 ,   0.094 , -6484.   ,  292.   , 256.101166194  ,   25.890  },
	{151  ,105 , 256, "Db","   -a",  100720.      , 291.       , 7357.    ,   1.    , STAR     , STAR    , 256.108127     ,  312.     },
	{158  , 99 , 257, "Es","   -a",   89403.      , 411.       , 7422.    ,   2.    ,   814.   ,  411.   , 257.095979     ,  441.     },
	{157  ,100 , 257, "Fm","   -a",   88589.481   ,   6.334    , 7422.196 ,   0.025 ,  -406.732,    6.449, 257.095104724  ,    6.799  },
	{156  ,101 , 257, "Md","   -a",   88996.213   ,   2.797    , 7417.569 ,   0.011 , -1244.310,   21.658, 257.095541368  ,    3.002  },
	{155  ,102 , 257, "No","   -a",   90240.522   ,  21.700    , 7409.683 ,   0.084 , -2494.   ,  208.   , 257.096877190  ,   23.295  },
	{154  ,103 , 257, "Lr","   -a",   92735.      , 207.       , 7397.    ,   1.    , -3199.   ,  231.   , 257.099555     ,  223.     },
	{153  ,104 , 257, "Rf","   -a",   95934.      , 103.       , 7381.    ,   0.    , -4408.   ,  247.   , 257.102990     ,  110.     },
	{152  ,105 , 257, "Db","   -a",  100342.      , 225.       , 7361.    ,   1.    , STAR     , STAR    , 257.107722     ,  241.     },
	{159  , 99 , 258, "Es","    x",   92702.      , 298.       , 7412.    ,   1.    ,  2277.   ,  359.   , 258.099520     ,  320.     },
	{158  ,100 , 258, "Fm","   -a",   90426.      , 200.       , 7418.    ,   1.    , -1263.   ,  200.   , 258.097076     ,  215.     },
	{157  ,101 , 258, "Md","   -a",   91688.184   ,   4.631    , 7409.669 ,   0.018 ,   209.   ,  200.   , 258.098431319  ,    4.971  },
	{156  ,102 , 258, "No","   -a",   91479.      , 200.       , 7407.    ,   1.    , -3360.   ,  224.   , 258.098207     ,  215.     },
	{155  ,103 , 258, "Lr","   -a",   94839.      , 102.       , 7391.    ,   0.    , -1560.   ,  225.   , 258.101814     ,  110.     },
	{154  ,104 , 258, "Rf","   -a",   96399.      , 201.       , 7382.    ,   1.    , -5348.   ,  398.   , 258.103489     ,  216.     },
	{153  ,105 , 258, "Db","   -a",  101748.      , 344.       , 7359.    ,   1.    , -3668.   ,  538.   , 258.109231     ,  369.     },
	{152  ,106 , 258, "Sg","   -a",  105415.      , 414.       , 7341.    ,   2.    , STAR     , STAR    , 258.113168     ,  445.     },
	{159  ,100 , 259, "Fm","   -a",   93704.      , 283.       , 7407.    ,   1.    ,    80.   ,  346.   , 259.100595     ,  304.     },
	{158  ,101 , 259, "Md","   -a",   93624.      , 200.       , 7405.    ,   1.    ,  -486.   ,  224.   , 259.100509     ,  215.     },
	{157  ,102 , 259, "No","   -a",   94109.      , 100.       , 7400.    ,   0.    , -1742.   ,  123.   , 259.101031     ,  108.     },
	{156  ,103 , 259, "Lr","   -a",   95852.      ,  71.       , 7390.    ,   0.    , -2548.   ,  101.   , 259.102901     ,   76.     },
	{155  ,104 , 259, "Rf","   -a",   98400.      ,  72.       , 7377.    ,   0.    , -3701.   ,  224.   , 259.105637     ,   77.     },
	{154  ,105 , 259, "Db","   -a",  102101.      , 212.       , 7360.    ,   1.    , -4555.   ,  277.   , 259.109610     ,  228.     },
	{153  ,106 , 259, "Sg","   -a",  106656.      , 177.       , 7339.    ,   1.    , STAR     , STAR    , 259.114500     ,  191.     },
	{160  ,100 , 260, "Fm","   -a",   95644.      , 499.       , 7403.    ,   2.    ,  -907.   ,  591.   , 260.102678     ,  536.     },
	{159  ,101 , 260, "Md","   -a",   96551.      , 316.       , 7396.    ,   1.    ,   940.   ,  374.   , 260.103652     ,  340.     },
	{158  ,102 , 260, "No","   -a",   95611.      , 200.       , 7397.    ,   1.    , -2665.   ,  231.   , 260.102643     ,  215.     },
	{157  ,103 , 260, "Lr","   -a",   98276.      , 115.       , 7383.    ,   0.    ,  -873.   ,  231.   , 260.105504     ,  123.     },
	{156  ,104 , 260, "Rf","   -a",   99149.      , 200.       , 7377.    ,   1.    , -4527.   ,  306.   , 260.106440     ,  215.     },
	{155  ,105 , 260, "Db","   -a",  103676.      , 231.       , 7357.    ,   1.    , -2908.   ,  234.   , 260.111300     ,  248.     },
	{154  ,106 , 260, "Sg","   -a",  106583.474   ,  38.859    , 7342.424 ,   0.149 , -7031.   ,  580.   , 260.114422071  ,   41.716  },
	{153  ,107 , 260, "Bh","   -a",  113614.      , 578.       , 7312.    ,   2.    , STAR     , STAR    , 260.121970     ,  621.     },
	{160  ,101 , 261, "Md","   -a",   98478.      , 647.       , 7391.    ,   2.    ,   -26.   ,  713.   , 261.105721     ,  695.     },
	{159  ,102 , 261, "No","   -a",   98504.      , 300.       , 7388.    ,   1.    , -1057.   ,  361.   , 261.105749     ,  322.     },
	{158  ,103 , 261, "Lr","   -a",   99561.      , 200.       , 7381.    ,   1.    , -1754.   ,  202.   , 261.106883     ,  215.     },
	{157  ,104 , 261, "Rf","   -a",  101315.395   ,  28.750    , 7371.396 ,   0.110 , -3064.   ,  233.   , 261.108766556  ,   30.864  },
	{156  ,105 , 261, "Db","   -a",  104379.      , 231.       , 7357.    ,   1.    , -3783.   ,  263.   , 261.112056     ,  248.     },
	{155  ,106 , 261, "Sg","   -a",  108162.      , 125.       , 7339.    ,   0.    , -5167.   ,  262.   , 261.116117     ,  135.     },
	{154  ,107 , 261, "Bh","   -a",  113329.      , 230.       , 7316.    ,   1.    , STAR     , STAR    , 261.121664     ,  247.     },
	{161  ,101 , 262, "Md","   -a",  101407.      , 582.       , 7383.    ,   2.    ,  1457.   ,  734.   , 262.108865     ,  625.     },
	{160  ,102 , 262, "No","   -a",   99951.      , 447.       , 7385.    ,   2.    , -2173.   ,  490.   , 262.107301     ,  480.     },
	{159  ,103 , 262, "Lr","   -a",  102123.      , 200.       , 7374.    ,   1.    ,  -271.   ,  346.   , 262.109634     ,  215.     },
	{158  ,104 , 262, "Rf","   -a",  102394.      , 283.       , 7370.    ,   1.    , -3875.   ,  336.   , 262.109925     ,  304.     },
	{157  ,105 , 262, "Db","   -a",  106269.      , 182.       , 7352.    ,   1.    , -2155.   ,  337.   , 262.114084     ,  195.     },
	{156  ,106 , 262, "Sg","   -a",  108424.      , 283.       , 7341.    ,   1.    , -6049.   ,  446.   , 262.116398     ,  304.     },
	{155  ,107 , 262, "Bh","   -a",  114473.      , 345.       , 7315.    ,   1.    , STAR     , STAR    , 262.122892     ,  370.     },
	{161  ,102 , 263, "No","   -a",  102979.      , 490.       , 7376.    ,   2.    ,  -690.   ,  608.   , 263.110552     ,  526.     },
	{160  ,103 , 263, "Lr","   -a",  103669.      , 361.       , 7371.    ,   1.    , -1168.   ,  404.   , 263.111293     ,  387.     },
	{159  ,104 , 263, "Rf","   -a",  104837.      , 183.       , 7363.    ,   1.    , -2274.   ,  248.   , 263.112547     ,  196.     },
	{158  ,105 , 263, "Db","   -a",  107111.      , 168.       , 7352.    ,   1.    , -3105.   ,  209.   , 263.114988     ,  181.     },
	{157  ,106 , 263, "Sg","   IT",  110216.      , 124.       , 7337.    ,   0.    , -4390.   ,  388.   , 263.118322     ,  133.     },
	{156  ,107 , 263, "Bh","   -a",  114606.      , 367.       , 7317.    ,   1.    , -5145.   ,  506.   , 263.123035     ,  394.     },
	{155  ,108 , 263, "Hs","   -a",  119751.      , 349.       , 7295.    ,   1.    , STAR     , STAR    , 263.128558     ,  374.     },
	{162  ,102 , 264, "No","   -a",  104649.      , 639.       , 7373.    ,   2.    , -1577.   ,  774.   , 264.112345     ,  686.     },
	{161  ,103 , 264, "Lr","   -a",  106226.      , 436.       , 7364.    ,   2.    ,    50.   ,  624.   , 264.114038     ,  468.     },
	{160  ,104 , 264, "Rf","   -a",  106176.      , 447.       , 7361.    ,   2.    , -3185.   ,  503.   , 264.113985     ,  480.     },
	{159  ,105 , 264, "Db","   -a",  109361.      , 231.       , 7346.    ,   1.    , -1423.   ,  365.   , 264.117404     ,  248.     },
	{158  ,106 , 264, "Sg","   -a",  110784.      , 283.       , 7338.    ,   1.    , -5284.   ,  395.   , 264.118931     ,  304.     },
	{157  ,107 , 264, "Bh","   -a",  116068.      , 276.       , 7315.    ,   1.    , -3531.   ,  280.   , 264.124604     ,  297.     },
	{156  ,108 , 264, "Hs","   -a",  119599.066   ,  43.846    , 7298.239 ,   0.166 , STAR     , STAR    , 264.128394885  ,   47.070  },
	{162  ,103 , 265, "Lr","   -a",  107903.      , 713.       , 7360.    ,   3.    ,  -806.   ,  830.   , 265.115839     ,  766.     },
	{161  ,104 , 265, "Rf","   -a",  108709.      , 424.       , 7354.    ,   2.    , -1767.   ,  510.   , 265.116704     ,  456.     },
	{160  ,105 , 265, "Db","   -a",  110476.      , 283.       , 7344.    ,   1.    , -2342.   ,  289.   , 265.118601     ,  304.     },
	{159  ,106 , 265, "Sg","   -a",  112817.611   ,  57.676    , 7332.652 ,   0.218 , -3756.   ,  383.   , 265.121114693  ,   61.917  },
	{158  ,107 , 265, "Bh","   -a",  116574.      , 379.       , 7316.    ,   1.    , -4599.   ,  402.   , 265.125147     ,  407.     },
	{157  ,108 , 265, "Hs","   -a",  121173.      , 135.       , 7295.    ,   1.    , -5651.   ,  481.   , 265.130085     ,  145.     },
	{156  ,109 , 265, "Mt","   -a",  126824.      , 462.       , 7271.    ,   2.    , STAR     , STAR    , 265.136151     ,  495.     },
	{163  ,103 , 266, "Lr","   -a",  111132.      , 655.       , 7351.    ,   2.    ,  1257.   ,  848.   , 266.119305     ,  703.     },
	{162  ,104 , 266, "Rf","   -a",  109876.      , 539.       , 7352.    ,   2.    , -2863.   ,  648.   , 266.117956     ,  578.     },
	{161  ,105 , 266, "Db","   -a",  112738.      , 361.       , 7339.    ,   1.    ,  -965.   ,  459.   , 266.121029     ,  387.     },
	{160  ,106 , 266, "Sg","   -a",  113703.      , 285.       , 7332.    ,   1.    , -4543.   ,  349.   , 266.122065     ,  306.     },
	{159  ,107 , 266, "Bh","   -a",  118246.      , 201.       , 7312.    ,   1.    , -2939.   ,  348.   , 266.126942     ,  216.     },
	{158  ,108 , 266, "Hs","   -a",  121185.      , 284.       , 7298.    ,   1.    , -6709.   ,  447.   , 266.130097     ,  305.     },
	{157  ,109 , 266, "Mt","   -a",  127893.      , 345.       , 7270.    ,   1.    , STAR     , STAR    , 266.137299     ,  371.     },
	{163  ,104 , 267, "Rf","   -a",  113204.      , 575.       , 7343.    ,   2.    ,  -790.   ,  742.   , 267.121529     ,  617.     },
	{162  ,105 , 267, "Db","   -a",  113994.      , 469.       , 7337.    ,   2.    , -1908.   ,  542.   , 267.122377     ,  504.     },
	{161  ,106 , 267, "Sg","   -a",  115901.      , 271.       , 7327.    ,   1.    , -3004.   ,  377.   , 267.124425     ,  291.     },
	{160  ,107 , 267, "Bh","   -a",  118906.      , 263.       , 7312.    ,   1.    , -3855.   ,  282.   , 267.127650     ,  282.     },
	{159  ,108 , 267, "Hs","   -a",  122761.      , 103.       , 7295.    ,   0.    , -5140.   ,  553.   , 267.131789     ,  111.     },
	{158  ,109 , 267, "Mt","   -a",  127901.      , 543.       , 7273.    ,   2.    , -6552.   ,  655.   , 267.137307     ,  583.     },
	{157  ,110 , 267, "Ea","   -a",  134453.      , 366.       , 7245.    ,   1.    , STAR     , STAR    , 267.144341     ,  393.     },
	{164  ,104 , 268, "Rf","   -a",  115174.      , 706.       , 7338.    ,   3.    , -1677.   ,  883.   , 268.123644     ,  758.     },
	{163  ,105 , 268, "Db","   -a",  116851.      , 529.       , 7329.    ,   2.    ,  -150.   ,  755.   , 268.125445     ,  568.     },
	{162  ,106 , 268, "Sg","   -a",  117001.      , 539.       , 7325.    ,   2.    , -3865.   ,  658.   , 268.125606     ,  578.     },
	{161  ,107 , 268, "Bh","   -a",  120866.      , 378.       , 7308.    ,   1.    , -2243.   ,  560.   , 268.129755     ,  406.     },
	{160  ,108 , 268, "Hs","   -a",  123108.      , 412.       , 7297.    ,   2.    , -6116.   ,  519.   , 268.132162     ,  443.     },
	{159  ,109 , 268, "Mt","   -a",  129224.      , 315.       , 7271.    ,   1.    , -4719.   ,  593.   , 268.138728     ,  338.     },
	{158  ,110 , 268, "Ea","   -a",  133944.      , 502.       , 7250.    ,   2.    , STAR     , STAR    , 268.143795     ,  539.     },
	{164  ,105 , 269, "Db","   -a",  118728.      , 774.       , 7325.    ,   3.    , -1206.   , 1014.   , 269.127460     ,  831.     },
	{163  ,106 , 269, "Sg","   -a",  119934.      , 656.       , 7317.    ,   2.    , -1807.   ,  775.   , 269.128755     ,  704.     },
	{162  ,107 , 269, "Bh","   -a",  121741.      , 412.       , 7308.    ,   2.    , -3131.   ,  428.   , 269.130694     ,  443.     },
	{161  ,108 , 269, "Hs","   -a",  124872.      , 117.       , 7293.    ,   0.    , -4657.   ,  563.   , 269.134056     ,  125.     },
	{160  ,109 , 269, "Mt","   -a",  129529.      , 551.       , 7273.    ,   2.    , -5654.   ,  567.   , 269.139055     ,  591.     },
	{159  ,110 , 269, "Ea","   -a",  135183.      , 137.       , 7249.    ,   1.    , STAR     , STAR    , 269.145124     ,  147.     },
	{165  ,105 , 270, "Db","   -a",  121757.      , 720.       , 7316.    ,   3.    ,   357.   ,  948.   , 270.130712     ,  773.     },
	{164  ,106 , 270, "Sg","   -a",  121400.      , 617.       , 7315.    ,   2.    , -3063.   ,  775.   , 270.130329     ,  662.     },
	{163  ,107 , 270, "Bh","   -a",  124463.      , 469.       , 7300.    ,   2.    ,  -963.   ,  549.   , 270.133616     ,  504.     },
	{162  ,108 , 270, "Hs","   -a",  125426.      , 286.       , 7294.    ,   1.    , -5595.   ,  610.   , 270.134650     ,  307.     },
	{161  ,109 , 270, "Mt","   -a",  131021.      , 539.       , 7270.    ,   2.    , -3785.   ,  611.   , 270.140657     ,  579.     },
	{160  ,110 , 270, "Ea","   -a",  134806.      , 289.       , 7253.    ,   1.    , STAR     , STAR    , 270.144720     ,  310.     },
	{165  ,106 , 271, "Sg","   -a",  124329.      , 648.       , 7307.    ,   2.    , -1590.   ,  854.   , 271.133472     ,  696.     },
	{164  ,107 , 271, "Bh","   -a",  125919.      , 557.       , 7298.    ,   2.    , -2308.   ,  651.   , 271.135179     ,  598.     },
	{163  ,108 , 271, "Hs","   -a",  128226.      , 337.       , 7286.    ,   1.    , -3244.   ,  658.   , 271.137657     ,  361.     },
	{162  ,109 , 271, "Mt","   -a",  131470.      , 565.       , 7272.    ,   2.    , -4585.   ,  574.   , 271.141139     ,  606.     },
	{161  ,110 , 271, "Ea","   -a",  136056.      , 105.       , 7252.    ,   0.    , STAR     , STAR    , 271.146062     ,  113.     },
	{166  ,106 , 272, "Sg","   -a",  125898.      , 767.       , 7304.    ,   3.    , -2677.   ,  979.   , 272.135158     ,  824.     },
	{165  ,107 , 272, "Bh","   -a",  128576.      , 608.       , 7291.    ,   2.    ,  -950.   ,  837.   , 272.138032     ,  653.     },
	{164  ,108 , 272, "Hs","   -a",  129526.      , 575.       , 7284.    ,   2.    , -4365.   ,  750.   , 272.139052     ,  617.     },
	{163  ,109 , 272, "Mt","   -a",  133891.      , 483.       , 7266.    ,   2.    , -2403.   ,  808.   , 272.143738     ,  518.     },
	{162  ,110 , 272, "Ea","   -a",  136293.      , 648.       , 7254.    ,   2.    , -6798.   ,  728.   , 272.146317     ,  696.     },
	{161  ,111 , 272, "Eb","   -a",  143091.      , 331.       , 7226.    ,   1.    , STAR     , STAR    , 272.153615     ,  355.     },
	{167  ,106 , 273, "Sg","    x",  128751.      , 661.       , 7296.    ,   2.    , -1302.   , 1061.   , 273.138220     ,  710.     },
	{166  ,107 , 273, "Bh","   -a",  130053.      , 830.       , 7288.    ,   3.    , -2206.   , 1170.   , 273.139618     ,  891.     },
	{165  ,108 , 273, "Hs","   -a",  132259.      , 825.       , 7277.    ,   3.    , -2727.   ,  970.   , 273.141986     ,  885.     },
	{164  ,109 , 273, "Mt","   -a",  134986.      , 510.       , 7264.    ,   2.    , -3679.   ,  525.   , 273.144913     ,  547.     },
	{163  ,110 , 273, "Ea","   -a",  138665.      , 127.       , 7248.    ,   0.    , -4489.   ,  618.   , 273.148863     ,  136.     },
	{162  ,111 , 273, "Eb","   -a",  143154.      , 605.       , 7229.    ,   2.    , STAR     , STAR    , 273.153682     ,  649.     },
	{167  ,107 , 274, "Bh","   -a",  132682.      , 780.       , 7282.    ,   3.    ,  -643.   , 1014.   , 274.142440     ,  838.     },
	{166  ,108 , 274, "Hs","   -a",  133325.      , 648.       , 7276.    ,   2.    , -4063.   ,  854.   , 274.143131     ,  696.     },
	{165  ,109 , 274, "Mt","   -a",  137388.      , 557.       , 7259.    ,   2.    , -1863.   ,  743.   , 274.147492     ,  598.     },
	{164  ,110 , 274, "Ea","   -a",  139251.      , 492.       , 7249.    ,   2.    , -5795.   ,  789.   , 274.149492     ,  528.     },
	{163  ,111 , 274, "Eb","   -a",  145046.      , 617.       , 7225.    ,   2.    , STAR     , STAR    , 274.155713     ,  662.     },
	{168  ,107 , 275, "Bh","    x",  134368.      , 652.       , 7278.    ,   2.    , -1585.   ,  967.   , 275.144250     ,  700.     },
	{167  ,108 , 275, "Hs","   -a",  135953.      , 714.       , 7270.    ,   3.    , -2510.   ,  927.   , 275.145952     ,  767.     },
	{166  ,109 , 275, "Mt","   -a",  138463.      , 592.       , 7258.    ,   2.    , -3288.   ,  744.   , 275.148647     ,  635.     },
	{165  ,110 , 275, "Ea","   -a",  141751.      , 451.       , 7243.    ,   2.    , -3694.   ,  826.   , 275.152176     ,  484.     },
	{164  ,111 , 275, "Eb","   -a",  145445.      , 692.       , 7227.    ,   3.    , STAR     , STAR    , 275.156142     ,  743.     },
	{168  ,108 , 276, "Hs","   -a",  137123.      , 824.       , 7268.    ,   3.    , -3677.   , 1067.   , 276.147208     ,  885.     },
	{167  ,109 , 276, "Mt","   -a",  140801.      , 678.       , 7252.    ,   2.    , -1750.   ,  911.   , 276.151156     ,  728.     },
	{166  ,110 , 276, "Ea","   -a",  142551.      , 608.       , 7243.    ,   2.    , -5085.   ,  874.   , 276.153034     ,  653.     },
	{165  ,111 , 276, "Eb","   -a",  147636.      , 627.       , 7222.    ,   2.    , STAR     , STAR    , 276.158493     ,  673.     },
	{169  ,108 , 277, "Hs","   -a",  139576.      , 726.       , 7262.    ,   3.    , -2402.   , 1143.   , 277.149841     ,  780.     },
	{168  ,109 , 277, "Mt","   -a",  141978.      , 883.       , 7251.    ,   3.    , -3006.   , 1307.   , 277.152420     ,  947.     },
	{167  ,110 , 277, "Ea","   -a",  144984.      , 964.       , 7237.    ,   3.    , -3607.   , 1146.   , 277.155647     , 1035.     },
	{166  ,111 , 277, "Eb","   -a",  148591.      , 618.       , 7221.    ,   2.    , -4121.   ,  632.   , 277.159519     ,  664.     },
	{165  ,112 , 277, "Ec","   -a",  152712.      , 130.       , 7204.    ,   0.    , STAR     , STAR    , 277.163943     ,  140.     },
	{169  ,109 , 278, "Mt","   -a",  144207.      , 836.       , 7246.    ,   3.    , -1543.   , 1077.   , 278.154812     ,  897.     },
	{168  ,110 , 278, "Ea","   -a",  145750.      , 678.       , 7237.    ,   2.    , -4783.   ,  927.   , 278.156469     ,  728.     },
	{167  ,111 , 278, "Eb","   -a",  150533.      , 632.       , 7217.    ,   2.    , -2523.   ,  826.   , 278.161604     ,  679.     },
	{166  ,112 , 278, "Ec","   -a",  153056.      , 531.       , 7206.    ,   2.    , STAR     , STAR    , 278.164312     ,  570.     },
	{170  ,109 , 279, "Mt","   -a",  145493.      , 718.       , 7244.    ,   3.    , -2485.   , 1032.   , 279.156193     ,  771.     },
	{169  ,110 , 279, "Ea","   -a",  147978.      , 742.       , 7232.    ,   3.    , -3360.   ,  995.   , 279.158861     ,  796.     },
	{168  ,111 , 279, "Eb","   -a",  151338.      , 663.       , 7218.    ,   2.    , -3798.   ,  827.   , 279.162468     ,  712.     },
	{167  ,112 , 279, "Ec","   -a",  155136.      , 493.       , 7201.    ,   2.    , STAR     , STAR    , 279.166546     ,  530.     },
	{170  ,110 , 280, "Ea","   -a",  148848.      , 848.       , 7232.    ,   3.    , -4357.   , 1126.   , 280.159795     ,  910.     },
	{169  ,111 , 280, "Eb","   -a",  153206.      , 742.       , 7214.    ,   3.    , -2390.   ,  980.   , 280.164473     ,  796.     },
	{168  ,112 , 280, "Ec","   -a",  155596.      , 640.       , 7203.    ,   2.    , STAR     , STAR    , 280.167039     ,  687.     },
	{171  ,110 , 281, "Ea","   -a",  150959.      , 728.       , 7228.    ,   3.    , -3084.   , 1183.   , 281.162061     ,  781.     },
	{170  ,111 , 281, "Eb","   -a",  154043.      , 932.       , 7214.    ,   3.    , -3646.   , 1356.   , 281.165372     , 1001.     },
	{169  ,112 , 281, "Ec","   -a",  157689.      , 985.       , 7198.    ,   4.    , STAR     , STAR    , 281.169286     , 1057.     },
	{171  ,111 , 282, "Eb","   -a",  156012.      , 888.       , 7210.    ,   3.    , -2123.   , 1135.   , 282.167486     ,  953.     },
	{170  ,112 , 282, "Ec","   -a",  158135.      , 707.       , 7200.    ,   3.    , STAR     , STAR    , 282.169765     ,  759.     },
	{172  ,111 , 283, "Eb","   -a",  156878.      , 778.       , 7210.    ,   3.    , -3145.   , 1093.   , 283.168415     ,  835.     },
	{171  ,112 , 283, "Ec","   -a",  160023.      , 768.       , 7196.    ,   3.    , -4340.   , 1058.   , 283.171792     ,  825.     },
	{170  ,113 , 283, "Ed","   -a",  164363.      , 728.       , 7178.    ,   3.    , STAR     , STAR    , 283.176451     ,  782.     },
	{172  ,112 , 284, "Ec","   -a",  160574.      , 849.       , 7197.    ,   3.    , -5306.   , 1167.   , 284.172384     ,  912.     },
	{171  ,113 , 284, "Ed","   -a",  165881.      , 800.       , 7176.    ,   3.    , STAR     , STAR    , 284.178080     ,  859.     },
	{173  ,112 , 285, "Ec","   -a",  162177.      , 730.       , 7195.    ,   3.    , -4311.   , 1221.   , 285.174105     ,  783.     },
	{172  ,113 , 285, "Ed","   -a",  166488.      , 979.       , 7177.    ,   3.    , -4626.   , 1421.   , 285.178732     , 1051.     },
	{171  ,114 , 285, "Ee","   -a",  171114.      ,1030.       , 7158.    ,   4.    , STAR     , STAR    , 285.183698     , 1105.     },
	{173  ,113 , 286, "Ed","   -a",  168117.      , 937.       , 7174.    ,   3.    , -3143.   , 1212.   , 286.180481     , 1006.     },
	{172  ,114 , 286, "Ee","   -a",  171260.      , 768.       , 7161.    ,   3.    , STAR     , STAR    , 286.183855     ,  825.     },
	{174  ,113 , 287, "Ed","   -a",  168643.      , 834.       , 7176.    ,   3.    , -4241.   , 1135.   , 287.181045     ,  895.     },
	{173  ,114 , 287, "Ee","   -a",  172884.      , 770.       , 7158.    ,   3.    , -5204.   , 1101.   , 287.185599     ,  826.     },
	{172  ,115 , 287, "Ef","   -a",  178088.      , 787.       , 7137.    ,   3.    , STAR     , STAR    , 287.191186     ,  845.     },
	{174  ,114 , 288, "Ee","   -a",  172968.      , 851.       , 7161.    ,   3.    , -6338.   , 1206.   , 288.185689     ,  913.     },
	{173  ,115 , 288, "Ef","   -a",  179305.      , 854.       , 7136.    ,   3.    , STAR     , STAR    , 288.192492     ,  917.     },
	{175  ,114 , 289, "Ee","   -a",  174449.      , 731.       , 7159.    ,   3.    , -5064.   , 1258.   , 289.187279     ,  785.     },
	{174  ,115 , 289, "Ef","   -a",  179513.      ,1024.       , 7139.    ,   4.    , -5726.   , 1494.   , 289.192715     , 1099.     },
	{173  ,116 , 289, "Eg","   -a",  185239.      ,1087.       , 7116.    ,   4.    , STAR     , STAR    , 289.198862     , 1167.     },
	{175  ,115 , 290, "Ef","   -a",  180842.      , 984.       , 7137.    ,   3.    , -4143.   , 1297.   , 290.194141     , 1057.     },
	{174  ,116 , 290, "Eg","   -a",  184985.      , 844.       , 7120.    ,   3.    , STAR     , STAR    , 290.198590     ,  906.     },
	{176  ,115 , 291, "Ef","   -a",  181068.      , 886.       , 7140.    ,   3.    , -5241.   , 1225.   , 291.194384     ,  951.     },
	{175  ,116 , 291, "Eg","   -a",  186309.      , 846.       , 7119.    ,   3.    , -6104.   , 1223.   , 291.200011     ,  908.     },
	{174  ,117 , 291, "Eh","   -a",  192413.      , 883.       , 7096.    ,   3.    , STAR     , STAR    , 291.206564     ,  948.     },
	{176  ,116 , 292, "Eg","   -a",  186100.      , 852.       , 7123.    ,   3.    , -7231.   , 1271.   , 292.199786     ,  915.     },
	{175  ,117 , 292, "Eh","   -a",  193330.      , 943.       , 7096.    ,   3.    , STAR     , STAR    , 292.207549     , 1013.     },
	{175  ,118 , 293, "Ei","   -a",  199964.      ,1197.       , 7074.    ,   4.    , STAR     , STAR    , 293.214670     , 1285.     }
};

const int N_isotopes=sizeof(isotopes)/sizeof(isotope);


isotope* isotope_find(int Z, int N)
{
	int A=Z+N;
	int p=0;
	int k=N_isotopes;
	while(k-p>1)
	{
		int s=(p+k)/2;
		if(isotopes[s].A<A || (isotopes[s].A==A && isotopes[s].Z<=Z) )
			p=s;
		else
			k=s;
	}
	return &isotopes[p];
}
